package Session;

use strict;
use HTML::Template::Pro;
use CGI::Carp qw(fatalsToBrowser set_message);
use CGI;
use CGI::Simple;
$CGI::Simple::DISABLE_UPLOADS = 0;
$CGI::Simple::POST_MAX = 10*1024*1024;
use XFileConfig;
use DataBase;
#use Net::SSL; # may be required for HTTPS, also install Mozilla::CA, LWP::Protocol::https

sub new {
  my ($class,$query,$db) = @_;
     $class = ref( $class ) || $class;
  my $self = {} ;
  bless $self, $class;
  
   $self->{user} = undef;
   $self->{cookies} = undef;
   $self->{form}   = undef;
   $self->{db} = $db;
   $self->initCGI($query);
   $self->{auth_cook}='xfsts';
  
  return $self;
}

sub DESTROY{
  #shift->UnInitDB();
}

sub db
{
  my $self = shift;
  return $self->{db} if defined($self->{db});
  #require DataBase;
  $self->{db} = DataBase->new();
  return $self->{db}; 
}

sub initCGI
{
  my ($self,$query)= @_;
  #my $in = new CGI::Simple();
  my $in = $query ? $query : new CGI::Simple();
  $self->{form}={};
  $self->{cookies}={};
  #binmode(STDOUT,':utf8');

  for( $in->param() )
  {
    my @val = $in->param($_);
    for(@val){s/</&lt;/gs;s/>/&gt;/gs;s/"/&quot;/gs;s/\(/&#40;/gs;s/\)/&#41;/gs;s/\'/&#39;/gs;}
    $self->{form}->{$_} = @val>1 ? \@val : $val[0];
  }
  $self->{cookies}->{$_}=$self->SecureStr($in->cookie($_)) for $in->cookie();
  $self->{cgi_query} = $in;
  $self->{domain}=$c->{domain} || $ENV{HTTP_HOST};
  $self->{domain}=~s/^www\.//;
  $self->{domain}=~s/:.*$//;
  $c->{cdn_url}||=$c->{site_url};

  $ENV{HTTP_USER_AGENT} = $self->SecureStr($ENV{HTTP_USER_AGENT});
  $ENV{HTTP_REFERER} = $self->SecureStr($ENV{HTTP_REFERER});

  if($self->{cookies}->{msg})
  {
     $self->{form}->{msg}=$self->{cookies}->{msg};
     $self->setCookie('msg','');
  }
  my $ea=0;
  $ea=1 if $self->{form}->{cj}&&$self->{form}->{cl};
  $self->{form}->{msg}=$self->SecureStr($self->{form}->{msg}) if $self->{form}->{msg};
  $ea=1 if $ENV{REQUEST_URI}=~/ipn\.cgi/i;
  require SecTetx;
  SecTetx::params($self,$c,$ea);
  
  my $cpath = $c->{cgi_path}||'.';
  unless($self->{cookies}->{lang})
  {
     my $blang=$ENV{HTTP_ACCEPT_LANGUAGE};
     $blang=~s/,.+$//;
     for(keys %{$c->{language_codes}})
     {
        if($blang=~/^$_$/i && !$c->{no_lng_sql})
        {
            my $language = $self->db->SelectARefCached(120,"SELECT * FROM Languages WHERE lang_name=?",$c->{language_codes}->{$_})->[0];
            $self->setCookie('lang',$language->{lang_id}) if $language;
        }
     }
  }
  
  $self->{language} = $self->{cookies}->{lang} if $self->{cookies}->{lang}=~/^\d+$/;
  $self->{language}||=$c->{default_language}||1;

  # $self->{language}=$c->{default_language} unless -e "$cpath/Languages/$self->{language}.lng";
  # require "$cpath/Languages/$self->{language}.lng";
  # $self->{lang} = $self->{language}->getLang;
  if(!$c->{no_lng_sql} && $c->{db_login})
  {
      my $list = $self->db->SelectARefCached(120,"SELECT * FROM Translations WHERE lang_id=?",$self->{language});
      $self->{lang}->{$_->{trans_name}} = $_->{trans_value} for @$list;
  }
}

sub f
{
  return shift->{form}||{};
}

sub iPlg
{
   my ($self,$x)=@_;
   require SecTetx;
   return SecTetx::plg($self,$x);
}

sub Logout
{
  my $self = shift;
  my $sess_id = $self->getCookie( $self->{auth_cook} );
  $self->db->PurgeCache( "ses$sess_id" );
  $self->db->Exec("DELETE FROM Sessions WHERE usr_id=?",$self->getUserId);
  $self->setCookie($self->{auth_cook},"");
  delete $self->{user};
  $self->redirect( $c->{site_url} );
}

sub getUser
{
   my $self = shift;
   return $self->{user};
}

sub getUserId
{
   my $self = shift;
   return 0 unless $self->{user};
   return $self->{user}->{usr_id};
}

sub getCookie
{
  my ($self,$name) = @_;
  return $self->{cookies}->{ $name };
}

sub setCookie
{
   my ($self,$name,$value,$expire) = @_;
   utf8::decode($value);
   $self->{cookies}->{ $name } = $value;
   $self->{cookies_send}->{ $name } = $value;
   $self->{cookies_exp}->{ $name } = $expire;
}

sub CreateTemplate
{
  my ($self,$filename)=@_;
  #require HTML::Template;
  my $design = $self->getCookie('design')||'';
  $design=~s/\D//g;
  $filename=~s/[^\w\_\-\.\/]+//g;
  $c->{cgi_path}||='.';
  die("Template not found: $filename") unless -f "$c->{cgi_path}/Templates$design/$filename";
  my $t=HTML::Template->new( filename => "$c->{cgi_path}/Templates$design/$filename",
                             die_on_bad_params => 0,
                             global_vars => 1,
                             loop_context_vars => 1,
                             utf8     => 1,
                            );

  my $enable_search = $c->{enable_search}==1 || ($c->{enable_search}==2 && $self->getUserId);
  $enable_search=0 if $c->{highload_mode};
  $t->param( 'site_name'    => $c->{site_name},
             'site_url'     => $c->{site_url},
             'static_url'   => $c->{cdn_url},
             'cdn_url'      => $c->{cdn_url},
             'site_cgi'     => $c->{site_cgi},
             'msg'          => $self->f->{msg},
             #'enabled_anon' => $c->{enabled_anon},
             'enabled_reg'  => $c->{enabled_reg},
             'enabled_prem' => $c->{enabled_prem},
             'ads'          => $c->{ads},
             'enable_search' => $enable_search,
             'header_extra' => $self->{header_extra},
             'm_t'          => $c->{m_t},
             'news_enabled' => $c->{news_enabled},
             "op_".$self->f->{op} => 1,
             %{$self->{lang}},
           );
  print"X\n" if $self->{form}->{id}&&$c->{site_url}!~/\/\/(www\.|)$self->{dc}/i;
  #die $self->getUser;
  if($self->getUser)
  {
     $c->{upload_enabled} = $self->getUser->{usr_uploads_on} if $c->{uploads_selected_only};
     my $token = $self->genToken;
     $t->param( 'my_login' => $self->{user}->{usr_login},
                'admin'    => $self->{user}->{usr_adm},
                'usr_moderator'    => $self->{user}->{usr_mod},
                'premium'  => $self->{user}->{premium},
                'upload_enabled'    => $c->{upload_enabled},
                'reseller'  => $c->{m_k} && (!$c->{m_k_manual} || $self->getUser->{usr_reseller}),
                'token'     => $token,
                'token_str' => "\&amp;token=$token",
                'legal_tool'=> $self->{user}->{usr_notes}=~/LEGAL=\d+/i ? 1 : 0,
              );
  }

  return $t;
}


sub PrintTemplate
{
  my ($self,$template) = @_;

  my @par = @_;
  my $t2=$self->CreateTemplate( $template );
  $t2->param(@par) if @par;
  
  my @Cookies;
  foreach my $name (keys %{ $self->{cookies_send} })
  {
    my $c =  $self->{cgi_query}->cookie( -name    => $name,
                                         -value   => $self->{cookies_send}->{$name},
                                         -domain  => ".$self->{domain}",
                                         -expires => $self->{cookies_exp}->{$name},
                                         -httponly => 1
                                       );
    push(@Cookies, $c);
  }
  $self->{xframe} ||= 'DENY' unless $c->{xframe_allow_frames};
  my %hhh;
  $hhh{'-X_FRAME_OPTIONS'} = $self->{xframe} if $self->{xframe};
  print $self->{cgi_query}->header( -cookie  => [@Cookies] ,
                                    -type    => 'text/html',
                                    -expires => $self->{expires}||'-1d',
                                    -charset => $c->{charset},
                                    %hhh,
                                  );
  if($self->{form}->{no_hdr})
  {
     print $t2->output;
  }
  else
  {
     my $t=$self->CreateTemplate( $self->{main_template} || "main.html" );
     $t->param(@par) if @par;
     $t->param( 'tmpl' => $t2->output );
     $t->param( 'page_title' => $self->{page_title} ) if $self->{page_title};
     $t->param( 'meta_descr' => $self->{meta_descr} ) if $self->{meta_descr};
     $t->param( 'meta_keywords' => $self->{meta_keywords} ) if $self->{meta_keywords};
     $t->param( 'sql_exec' => $self->{db}->{'exec'}, 'sql_select' => $self->{db}->{'select'}, 'memcached_hit' => $self->{db}->{'memcached_hit'} ) if $self->{db};
     #$t->param( 'language' => $self->{language},'language2' => ucfirst $self->{language} );
     #my @ll = map{{lang=>$_,lang2=>ucfirst $_}} grep{$_ ne $self->{language}} @{$c->{languages_list}};
     #$t->param(languages => \@ll);

     my $ll = $self->db->SelectARefCached(60,"SELECT * FROM Languages WHERE lang_active=1 ORDER BY lang_order") if $self->{db};
     my @ll2;
     for(@$ll)
     {
        if($_->{lang_id}==$self->{language})
        {
            $t->param('language2' => $_->{lang_name},'language_lc' => lc $_->{lang_name});
        }
        else
        {
            $_->{lang_name_lc} = lc $_->{lang_name};
            push @ll2, $_;
        }
     }
     $t->param(languages => \@ll2);
     
     print $t->output;
  }
  exit unless $self->{fast_cgi};
}

sub out
{
    my ($self,$out) = @_;
    my @Cookies;
    foreach my $name (keys %{ $self->{cookies_send} })
    {
      my $c =  $self->{cgi_query}->cookie( -name    => $name,
                                           -value   => $self->{cookies_send}->{$name},
                                           -domain  => ".$self->{domain}",
                                           -expires => $self->{cookies_exp}->{$name},
                                           -httponly => 1
                                         );
      push(@Cookies, $c);
    }
    $self->{xframe} ||= 'DENY' unless $c->{xframe_allow_frames};
    print $self->{cgi_query}->header( -cookie  => [@Cookies] ,
                                      -type    => 'text/html',
                                      -expires => $self->{expires}||'-1d',
                                      -charset => $c->{charset},
                                      -X_FRAME_OPTIONS => $self->{xframe}||'',
                                    );
    print $out;
    exit unless $self->{fast_cgi};
}

sub message
{
    my ($self,$err) = @_;
    return unless $err;
    my $tmpl = $self->{form}->{no_hdr} ? "message_embed.html" : "message.html";
    $self->PrintTemplate($tmpl, 'err'=>$err );
    return 0;
}

sub redirect
{
   my ($self,$url,$exp) = @_;

   if($self->{adm} && $self->isAdmin && $url!~/token=/i && $url=~/\?/)
   {
     my ($ah)=$1 if $url=~s/(\#\w+)$//;
     $url.="&token=".$self->genToken.$ah;
   }

   my @Cookies;
   foreach my $k (keys %{ $self->{cookies_send} })
   {
     push @Cookies, $self->{cgi_query}->cookie( -name    => $k, 
                                                -value   => $self->{cookies_send}->{$k}, 
                                                -domain  => ".$self->{domain}",
                                                -expires => $self->{cookies_exp}->{$k}||$exp,
                                              );
   }

   print $self->{cgi_query}->redirect( -uri    => $url, 
                                       -cookie => [@Cookies],
                                     );
   exit unless $self->{fast_cgi};
}

sub redirect_msg
{
   my ($self,$url,$msg) = @_;
   utf8::encode($msg);
   $self->setCookie('msg',$msg);
   $self->redirect($url);
}

sub isAdmin
{
  my ($self) = @_;
  return 1 if $self->{user} && $self->{user}->{usr_adm};
  return 0;
}

sub getIP
{
 my ($self) = @_;
 my $ip = '';
 $ip = $ENV{HTTP_CF_CONNECTING_IP} if $c->{use_cloudflare_ip_header};
 $ip ||= $ENV{HTTP_X_FORWARDED_FOR} || $ENV{HTTP_X_REAL_IP} || $ENV{REMOTE_ADDR};
 $ip = $ENV{HTTP_X_FORWARDED_FOR} if $ENV{HTTP_X_FORWARDED_FOR} && $ENV{HTTP_SAVE_DATA}; # Google Data Saver
 $ip=(split(/[\,\s]+/,$ip))[0] if $ip=~/\,/;
 $ip ||= $ENV{REMOTE_ADDR};
 $self->{ipv6}=1 if $ip=~/:/;
 $ip = inet_ntoa( ipv6to4( ipv6_aton($ip) ) ) if $ip=~/:/;
 $ip=~s/[^\d\.]+//g;
 $ip||='0.0.0.0';
 return $ip;
}

sub ipv6to4 {
  my $naddr = shift;
  @_ = unpack('L3H8',$naddr);
  return pack('H8',@{_}[3..10]);
}
sub ipv6_aton {
  my($ipv6) = @_;
  return undef unless $ipv6;
  local($1,$2,$3,$4,$5);
  if ($ipv6 =~ /^(.*:)(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/) {
    return undef if $2 > 255 || $3 > 255 || $4 > 255 || $5 > 255;
    $ipv6 = sprintf("%s%X%02X:%X%02X",$1,$2,$3,$4,$5);
  }
  my $c;
  return undef if
  $ipv6 =~ /[^:0-9a-fA-F]/ ||
  (($c = $ipv6) =~ s/::/x/ && $c =~ /(?:x|:):/) ||
  $ipv6 =~ /[0-9a-fA-F]{5,}/;
  $c = $ipv6 =~ tr/:/:/;
  return undef if $c < 7 && $ipv6 !~ /::/;
  if ($c > 7) {
    return undef unless
  $ipv6 =~ s/^::/:/ ||
  $ipv6 =~ s/::$/:/;
    return undef if --$c > 7;
  }
  while ($c++ < 7) {
    $ipv6 =~ s/::/:::/;
  }
  $ipv6 .= 0 if $ipv6 =~ /:$/;
  my @hex = split(/:/,$ipv6);
  foreach(0..$#hex) {
    $hex[$_] = hex($hex[$_] || 0);
  }
  pack("n8",@hex);
}
sub inet_ntoa {
  my @hex = (unpack("n2",$_[0]));
  $hex[3] = $hex[1] & 0xff;
  $hex[2] = $hex[1] >> 8;
  $hex[1] = $hex[0] & 0xff;
  $hex[0] >>= 8;
  return sprintf("%d.%d.%d.%d",@hex);
}

sub getMyCountry
{
	my ($self) = @_;
	return $self->{country} if $self->{country};

	$self->{country} = $c->{use_cloudflare_ip_header} && $ENV{HTTP_CF_IPCOUNTRY} ? $ENV{HTTP_CF_IPCOUNTRY} : $self->getCountryCode($self->getIP);

    return uc($self->{country});
}

sub getCountryCode
{
	my ($self,$ip) = @_;
	return '' unless $ip;
	require Geo::IP2;
    $self->{db}->{geoip} ||= Geo::IP2->new("$c->{cgi_path}/GeoLite2-Country.mmdb");
    my $country = $self->{db}->{geoip}->country_code_by_addr($ip);
    return uc($country)||'XX';
}

sub logg
{
	my ($self,$name,$msg) = @_;
	my $date = sprintf("%04d-%02d-%02d %02d:%02d:%02d",$self->getDate);
	$name||='misc';
	open LOGG, ">>$c->{cgi_path}/logs/$name.txt";
	print LOGG "[$date] $msg\n";
	close LOGG;
}

sub randchar
{ 
   my ($self,$num,$az) = @_;
   my @range = $az ? ('a'..'z') : ('0'..'9','a'..'z');
   my $x = int scalar @range;
   join '', map $range[rand $x], 1..$num||1;
}

sub api
{
   my ($self,$srv_cgi_url,$data) = @_;
   require LWP::UserAgent;
   my $ua = LWP::UserAgent->new(agent => $c->{user_agent}, timeout => 900);
   return $ua->post("$srv_cgi_url/api.cgi", $data)->content;
}

sub api2
{
   my ($self,$srv_id,$data) = @_;
   my $srv = $self->db->SelectRowCached("SELECT * FROM Servers WHERE srv_id=?",$srv_id);
   return $self->api($srv->{srv_cgi_url},
                     {
                        dl_key => $c->{dl_key},
                        disk_id => $srv->{disk_id},
                        %{$data},
                     }
                    );
}

sub hook_url
{
  my ($buffer) = @_;
  print"$buffer\n";
}

sub AdminLog
{
   my ($self,$msg) = @_;
   return unless $c->{admin_log} && $msg;
   open(FILE,">>$c->{admin_log}")||return;
   my @dt = $self->getTime();
   print FILE "$dt[0]:$dt[1]:$dt[2] $dt[3]-$dt[4]-$dt[5] $msg\n";
   close FILE;
}

sub getTime
{
    my ($self,$time) = @_;
    my @t = $time ? localtime( $time ) : localtime();
    return ( sprintf("%04d",$t[5]+1900),
             sprintf("%02d",$t[4]+1), 
             sprintf("%02d",$t[3]), 
             sprintf("%02d",$t[2]), 
             sprintf("%02d",$t[1]), 
             sprintf("%02d",$t[0]) 
           );
}

sub getDate
{
    my ($self,$time) = @_;
    my @tt = $self->getTime($time);
    return splice( @tt, 0, 3);
}

sub DeleteFile
{
   my ($self,$file) = @_;
   $self->DeleteFilesMass([$file]);
}

sub DeleteFilesMass
{
   my ($self,$files) = @_;
   my %h;
   for(@$files)
   {
      $_->{file_real_id}||=$_->{file_id};
      if($self->db->SelectOne("SELECT COUNT(*) FROM Files WHERE file_real=?",$_->{file_real}) <= 1)
      {
         #push @{$h{$_->{srv_id}}}, $_ ;
         $self->db->Exec("INSERT INTO DeleteQueue 
                          SET file_real_id=?, 
                              file_real=?, 
                              srv_id=?, 
                              del_by=?, 
                              del_time=NOW()+INTERVAL ? HOUR", 
                              $_->{file_real_id},
                              $_->{file_real},
                              $_->{srv_id},
                              $self->getUserId||0, 
                              $c->{delete_disk_time}||0 );

         $self->db->Exec("UPDATE Users SET usr_disk_used=usr_disk_used-? WHERE usr_id=?", int(($_->{file_size_o}+$_->{file_size_n}+$_->{file_size_h}+$_->{file_size_l}+$_->{file_size_p})/1024), $_->{usr_id} );
      }

      $self->DeleteFileDB($_);
   }

   # for my $srv_id (keys %h)
   # {
   #    my $list = join ':', map{ "$_->{file_real_id}-$_->{file_real}" } @{$h{$srv_id}};

   #    my $res = $self->api2($srv_id, { op => 'del_files', list => $list });
   #    unless($res=~/OK$/s)
   #    {
   #       $self->AdminLog("Error when deleting file. ServerID: $srv_id.\n$res");
   #       #return $self->message("Error happened when deleting file.<br>Please contact administrator.<br>($res)");
   #    }
   # }
}

sub DeleteFileDB
{
   my ($self,$file,$skip_size) = @_;
   if($file->{del_money} && $file->{usr_id})
   {
      $self->db->Exec("UPDATE Users SET usr_money=usr_money-? WHERE usr_id=?", $file->{file_money}, $file->{usr_id} );
      $self->db->Exec("UPDATE Users SET usr_money=usr_money-? WHERE usr_id=?", sprintf("%.04f",$file->{file_money}*$c->{referral_aff_percent}/100), $file->{usr_aff_id} ) if $file->{usr_aff_id};
   }

   $self->db->Exec("INSERT IGNORE INTO FilesTrash SELECT *, NOW() as file_deleted, ? as del_by, 0 as hide FROM Files WHERE file_id=?",$self->getUserId||0,$_->{file_id});

   $self->db->Exec("DELETE FROM Files WHERE file_id=?",$file->{file_id});
   $self->db->Exec("DELETE FROM FilesData WHERE file_id=?",$file->{file_id});
   $self->db->Exec("DELETE FROM Downloads WHERE file_id=?",$file->{file_id});
   $self->db->Exec("DELETE FROM Comments WHERE cmt_type=1 AND cmt_ext_id=?",$file->{file_id});
   $self->db->Exec("DELETE FROM QueueEncoding WHERE file_real_id=?",$file->{file_real_id}||$file->{file_id});
   $self->db->Exec("DELETE FROM QueueTransfer WHERE file_real_id=?",$file->{file_real_id}||$file->{file_id});
   $self->db->Exec("DELETE FROM Tags2Files WHERE file_id=?",$file->{file_id});
   $self->db->Exec("DELETE FROM Views WHERE file_id=?",$file->{file_id});
   #$self->db->Exec("DELETE FROM ViewsLog WHERE file_id=?",$file->{file_id});
   $self->db->Exec("DELETE FROM Votes WHERE file_id=?",$file->{file_id});
   $self->db->Exec("DELETE FROM Favorites WHERE file_id=?",$file->{file_id});
   $self->db->Exec("DELETE FROM Files2Playlists WHERE file_id=?",$file->{file_id});
   $self->db->Exec("DELETE FROM Reports WHERE file_code=?",$file->{file_code});

   $self->db->Exec("INSERT INTO Stats SET day=CURDATE(), deleted=1 ON DUPLICATE KEY UPDATE deleted=deleted+1");


   # if(!$self->{no_del_log})
   # {
   #    my $folder = $self->db->SelectRow("SELECT * FROM Folders WHERE fld_id=?",$file->{file_fld_id}) if $file->{file_fld_id};
   #    $file->{file_name}="$folder->{fld_name}/$file->{file_name}" if $folder;
   #    $self->db->Exec("INSERT INTO FilesDeleted 
   #                     SET usr_id=?,
   #                         del_by=?,
   #                         file_code=?, 
   #                         file_real=?, 
   #                         file_name=?,
   #                         file_title=?",
   #                    $file->{usr_id},
   #                    $self->getUserId||0,
   #                    $file->{file_code},
   #                    $file->{file_real},
   #                    $file->{file_name},
   #                    $file->{file_title});
   # }

   if($c->{srt_on} && $c->{srt_langs})
   {
      my @arr = map{{value=>$_}} split /\s*\,\s*/, $c->{srt_langs};
      my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
      my $dir = "$c->{site_path}/srt/$dx";
      for(@arr)
      {
          unlink("$dir/$file->{file_code}_$_->{value}.srt") if -f "$dir/$file->{file_code}_$_->{value}.srt";
      }
   }

   $self->db->PurgeCache("filedl$file->{file_code}");

   #$self->message($err) if $err;
}

sub DeleteUserDB
{
   my ($self,$usr_id) = @_;
   $self->db->Exec("DELETE FROM Users WHERE usr_id=?",$usr_id);
   $self->db->Exec("DELETE FROM UserData WHERE usr_id=?",$usr_id);
   $self->db->Exec("DELETE FROM Sessions WHERE usr_id=?",$usr_id);
   $self->db->Exec("DELETE FROM Payments WHERE usr_id=?",$usr_id);
   $self->db->Exec("DELETE FROM Transactions WHERE usr_id=?",$usr_id);
   $self->db->Exec("DELETE FROM Folders WHERE usr_id=?",$usr_id);
   $self->db->Exec("DELETE FROM Streams WHERE usr_id=?",$usr_id);
}

sub SecureStr
{
   my ($self,$str)=@_;
   $str=~s/</&lt;/gs;
   $str=~s/>/&gt;/gs;
   $str=~s/"/&quot;/gs;
   $str=~s/\(/&#40;/gs;
   $str=~s/\)/&#41;/gs;
   #$str=~s/\#/&#35;/gs;
   #$str=~s/\&/&#38;/gs;
   $str=~s/&lt;br&gt;/<br>/gs;
   $str=~s/\0//gs;
   $str=~s/\\/\\\\/gs;
   $str=~s/\.\./&#46;&#46;/gs;
   return $str;
}

sub SendMail
{
   my ($self,$mail_to, $mail_from, $subject, $body) = @_;

   if($c->{smtp_auth} eq 'mailgun')
   {
      return $self->SendMailMailgun($mail_to, $mail_from, $subject, $body);
   }
   elsif($c->{smtp_auth} eq 'tls')
   {
      return $self->SendMailTLS($mail_to, $mail_from, $subject, $body);
   }

   my $content_type = $c->{email_html} ? 'text/html' : 'text/plain';
      $content_type = 'text/plain' if $c->{email_text};
   require MIME::Lite;
   my $msg = MIME::Lite->new(
        From    => $mail_from,
        To      => $mail_to,
        Subject => $subject,
        Data    => $body
    );
    $msg->attr("content-type"         => $content_type);
    $msg->attr("content-type.charset" => "UTF8");
    $msg->add("Return-Path", $mail_from );
    $msg->add("Reply-To", $mail_from );

    $msg->send('sendmail', SetSender=>1);

   # if($c->{smtp_server} && $c->{smtp_user} && $c->{smtp_pass})
   # {
   #    $msg->send('smtp',$c->{smtp_server}, AuthUser=>$c->{smtp_user}, AuthPass=>$c->{smtp_pass} );
   # }
   # elsif($c->{smtp_server})
   # {
   #    $msg->send('smtp',$c->{smtp_server});
   # }
   # else
   # {
   #    $msg->send('sendmail', SetSender=>1);
   # }
}

sub SendMailTLS
{
   require Net::SMTP::TLS;
   my ($self, $mail_to, $mail_from, $subject, $body) = @_;
   my $content_type = $c->{email_html} ? 'text/html' : 'text/plain';
      $content_type = 'text/plain' if $c->{email_text};
   my $msg = new Net::SMTP::TLS(
                   $c->{smtp_server},
                   User    => $c->{smtp_user},
                   Password=> $c->{smtp_pass},
                   Timeout => 30
                   );

   $msg->mail($mail_from);
   $msg->recipient($mail_to);

   $msg->data();
   $msg->datasend("To: $mail_to\n");
   $msg->datasend("From: $mail_from\n");
   $msg->datasend("Content-Type: $content_type\n");
   $msg->datasend("Subject: $subject\n\n");
   $msg->datasend($body);
   $msg->dataend();

   $msg->quit;
}

sub SendMailTLS2
{
   #IO::Socket::SSL, Net::SSLeay, Authen::SASL
   require Net::SMTPS;
   my ($self, $mail_to, $mail_from, $subject, $body) = @_;
   my $content_type = $c->{email_text} ? 'text/plain' : 'text/html';
   my $msg = new Net::SMTPS(
                   $c->{smtp_server},
                   Hello => $self->{domain}, 
                   doSSL => 'starttls', 
                   Port => 587
                   );

   $msg->auth($c->{smtp_user},$c->{smtp_pass});
   $msg->mail($mail_from);
   $msg->recipient($mail_to);

   $msg->data();
   $msg->datasend("To: $mail_to\n");
   $msg->datasend("From: $mail_from\n");
   $msg->datasend("Content-Type: $content_type\n");
   $msg->datasend("Subject: $subject\n\n");
   $msg->datasend($body);
   $msg->dataend();

   $msg->quit;
}

sub decode_base64
{
    my ($self,$str) = @_;
    use integer;
    $str =~ tr|A-Za-z0-9+=/||cd;
    die("Length of base64 data not a multiple of 4") if length($str) % 4;
    $str =~ s/=+$//;
    $str =~ tr|A-Za-z0-9+/| -_|;
    return "" unless length $str;
    my $uustr = '';
    my ($i, $l);
    $l = length($str) - 60;
    for ($i = 0; $i <= $l; $i += 60) {
	$uustr .= "M" . substr($str, $i, 60);
    }
    $str = substr($str, $i);
    if ($str ne "") {
	$uustr .= chr(32 + length($str)*3/4) . $str;
    }
    return unpack ("u", $uustr);
}

sub shortenURL
{
    my ($self,$file_id) = @_;
    my $idd = $self->encode_base36( $file_id );
    $c->{m_j_domain}=~s/http:\/\///;
    return $c->{m_j_domain} ? "http://$c->{m_j_domain}/$idd" : "$c->{site_url}/u/$idd";
}

sub decode_base36
{
    my ($self,$base36) = @_;
    $base36 = uc( $base36 );
    return 0 if $base36 =~ m{[^0-9A-Z]};

    my ( $result, $digit ) = ( 0, 0 );
    for my $char ( split( //, reverse $base36 ) ) {
        my $value = $char =~ m{\d} ? $char : ord( $char ) - 55;
        $result += $value * ( 36**$digit++ );
    }

    return $result;
}

sub encode_base36
{
    my ( $self, $number ) = @_;

    return ''  if $number    =~ m{\D};
    return 0 if $number == 0;

    my $result = '';
    while ( $number ) {
        my $remainder = $number % 36;
        $result .= $remainder <= 9 ? $remainder : chr( 55 + $remainder );
        $number = int $number / 36;
    }

    return reverse( $result );
}

sub makeFileLink
{
   my ($self,$file) = @_;
   my $fname = $file->{file_name};
   $fname=~s/\s/_/g;
   my $code = $c->{link_format_uppercase} ? uc $file->{file_code} : $file->{file_code};
   return "$c->{site_url}/$code".
            {0 => "/$fname.html",
             1 => "/$fname.htm",
             2 => "/$fname",
             3 => ".html",
             4 => ".htm"}->{$c->{link_format}};
}

sub makeFileSize
{
   my ($self,$size)=@_;
   return '' unless $size;
   return "$size B" if $size<=1024;
   return sprintf("%.0f KB",$size/1024) if $size<=1024*1024;
   return sprintf("%.01f MB",$size/1048576) if $size<=1024*1024*1024;
   return sprintf("%.01f GB",$size/1073741824);
}

sub makeEmbedCode
{
    my ($self,$file,$simple) = @_;
    my $ew = $self->getCookie("embed_width") || $c->{embed_width};
    $ew=640 unless $ew=~/^\d+$/;
    my $eh = $self->getCookie("embed_height") || $c->{embed_height};
    $eh=360 unless $eh=~/^\d+$/;
    my $site_url = $c->{embed_alt_domain} || $c->{site_url};
    my $embed_url = "$site_url/embed-$file->{file_code}.html";
    if($c->{embed_static})
    {
        $self->genThumbURLs($file) unless $file->{video_img_url};
        my $timg = $file->{video_img_url};
        $timg=~s/^https?:\/\///i;
        $timg=~s/\.jpg$//i;
        $embed_url = "$site_url/emb.html?$file->{file_code}=$timg";
    }
    return qq[<IFRAME SRC="$embed_url" FRAMEBORDER=0 MARGINWIDTH=0 MARGINHEIGHT=0 SCROLLING=NO WIDTH=$ew HEIGHT=$eh allowfullscreen></IFRAME>] if $simple || !$c->{embed_responsive};
    return qq[<div style="position:relative;padding-bottom:56%;padding-top:20px;height:0;"><IFRAME SRC="$embed_url" FRAMEBORDER=0 MARGINWIDTH=0 MARGINHEIGHT=0 SCROLLING=NO WIDTH=$ew HEIGHT=$eh allowfullscreen style="position:absolute;top:0;left:0;width:100%;height:100%;"></IFRAME></div>];
}

sub makePagingLinks
{ 
 my ($self,$f,$total_items,$reverse) = @_;
 my $range = 3;
 my $items_per_page = $f->{per_page} || $c->{items_per_page} || 5;
 return '' if $items_per_page eq 'all';

  my $current_page = $f->{page}||1;
  $current_page = 1 if $f->{page} eq 'all';
  my @pp;
  foreach my $key(sort keys %{$f})
  {
    my $val = $f->{$key};
    push @pp,"$key=$val" if $val ne '' && (ref $val ne "ARRAY" && $key !~/^(page|fast_paging|fast_paging_next)$/);
    map{push @pp,"$key=$_"}@$val if ref $val eq 'ARRAY';
  }
  my $par = join '&amp;',@pp;
  my $adm='adm' if $self->{adm};

  my $t='<div class="paging">';
  if($self->f->{fast_paging})
  {
    $t.="<a href='$c->{site_url}/$adm?$par&amp;page=".($current_page-1)."'>&larr; $self->{lang}->{lng_paging_previous}</a>" if $current_page>1;
    $t.="<b>$current_page</b>";
    $t.="<a href='$c->{site_url}/$adm?$par&amp;page=".($current_page+1)."'>$self->{lang}->{lng_paging_next} &rarr;</a>" if $self->f->{fast_paging_next};
    $t.="</div>";
    return $t;
  }

 my $total_pages = int(0.999+$total_items/$items_per_page);
    
    return '' if $total_pages<2;

 my $i1 = $current_page - $range;
 my $i2 = $current_page + $range;
 if ($i2 > $total_pages)
 {
    $i1 -= ($i2-$total_pages);
    $i2 = $total_pages;
 }
 
 $t.="<a href='$c->{site_url}/$adm?$par&amp;page=".($current_page-1)."'>&larr; $self->{lang}->{lng_paging_previous}</a>" if $current_page>1;
 $t.="<a href='$c->{site_url}/$adm?$par&amp;page=1'>1</a>" if $i1>1;
 $t.="<a href='$c->{site_url}/$adm?$par&amp;page=2'>2</a>" if $i1>2;
 $t.="... " if $i1>3;

 my $i = $i1;
 while( $i <= $i2 )
 {
    if( $i > 0 )
    {
       $t .= $i==$current_page ?
       "<b>$i</b>" : "<a href='$c->{site_url}/$adm?$par&amp;page=$i'>$i</a>";
    }
    else
    {
       $i2++ if $i2 < $total_pages;
    }
    $i++;
 }

 $t.="... " if $i2<$total_pages-2;
 $t.="<a href='$c->{site_url}/$adm?$par&amp;page=".($total_pages-1)."'>".($total_pages-1)."</a>" if $i2<$total_pages-1;
 $t.="<a href='$c->{site_url}/$adm?$par&amp;page=$total_pages'>$total_pages</a>" if $i2<$total_pages;
 $t.="<a href='$c->{site_url}/$adm?$par&amp;page=".($current_page+1)."'>$self->{lang}->{lng_paging_next} &rarr;</a>" if $current_page<$total_pages;

 $t.="<small>($total_items $self->{lang}->{lng_paging_total})</small></div>";

 return  $t; 
}

sub makePagingSQLSuffix
{
    my ($self,$current_page,$per_page)  = @_;
    
    my $items_per_page = $per_page || $self->f->{per_page} || $c->{items_per_page} || 15;
    return " " if $items_per_page eq "all";
    my $end = $current_page*$items_per_page;
    my $start = $end - $items_per_page; 
       $start = $start>0 ? $start:0;
    $start=~s/\D+//g;
    $items_per_page=~s/\D+//g;
    $items_per_page++ if $self->f->{fast_paging};

    return " LIMIT $start, $items_per_page";
}

sub encode32
{			
    my $self=shift;
    $_=shift;
    my($l,$e);
    $_=unpack('B*',$_);
    s/(.....)/000$1/g;
    $l=length;
    if($l & 7)
    {
    	$e=substr($_,$l & ~7);
    	$_=substr($_,0,$l & ~7);
    	$_.="000$e" . '0' x (5-length $e);
    }
    $_=pack('B*', $_);
    tr|\0-\37|A-Z2-7|;
    lc($_);
}

sub decode32
{
   my $self=shift;
   $_ = shift;
   my $l;
   tr|a-z2-7|\0-\37|;
   $_=unpack('B*',$_);
   s/000(.....)/$1/g;
   $l=length;
   $_=substr($_,0,$l & ~7) if $l & 7;
   $_=pack('B*',$_);
}

sub HashSave
{
   my ($self,$file_id,$dt) = @_;
   $dt||=0;
   $file_id||=0;
   my ($i1,$i2,$i3,$i4) = split(/\./,$self->getIP);
   #require Crypt::CipherSaber;
   #my $cs = Crypt::CipherSaber->new($c->{dl_key});
   #my $hash = $self->encode32( $cs->encrypt(pack("LCCL",
   #                                                    int($file_id),
   #                                                    $i1,$i2,
   #                                                    time+$dt)) );
   my $str = "$file_id-$i1-$i2-".(time+$dt);
   require Digest::MD5;
   my $md5 = Digest::MD5::md5_hex($str.$c->{license_key});
   return "$str-$md5";
   #return $hash;
}
sub HashCheck
{
   my ($self,$hash) = @_;
   #require Crypt::CipherSaber;
   #my $cs = Crypt::CipherSaber->new($c->{dl_key});
   #my ($file_id1,$i1,$i2,$tmin) = unpack("LCCL", $cs->decrypt($self->decode32($hash)) );
   my ($file_id,$i1,$i2,$tmin,$md5) = split(/-/,$hash);
   unless($tmin && $md5){ $self->{form}->{msg}="Invalid hash";return 0; }
   my $str = "$file_id-$i1-$i2-$tmin";
   require Digest::MD5;
   my $md5corr = Digest::MD5::md5_hex($str.$c->{license_key});
   unless($md5 eq $md5corr){ $self->{form}->{msg}="Invalid md5";return 0; }

   if($tmin>time){$self->{form}->{msg}="Skipped countdown";return 0;}
   if($tmin<time-900){$self->{form}->{msg}="Expired download session";return 0;}
   #if($file_id != $file_id1){$self->{form}->{msg}="Wrong file";return 0;}
   if($self->getIP!~/^$i1\.$i2\./){$self->{form}->{msg}="Wrong IP address";return 0;}

   return 1;
}

sub SecSave
{
   my ($self,$file_id,$dt) = @_;
   $dt||=0;
   $file_id||=0;
   #my $number  = $c->{captcha} ? join('', map int rand(10), 1..4) : 0;
   my $number = $c->{captcha} ? int(rand(9)+1).join('', map int rand(10), 1..3) : 0;
   require Crypt::CipherSaber;
   my $cs = Crypt::CipherSaber->new($c->{dl_key});
   my $hash = $self->encode32( $cs->encrypt(pack("LC4SL",
                                                       int($file_id),
                                                       split(/\./,$self->getIP),
                                                       $number,
                                                       time+$dt)) );

   my %captcha = $self->GenerateCaptcha($number,$hash) if $number;
   $captcha{'rand'} = $hash;
   return %captcha;
}

sub SecCheck
{
   my ($self,$hash,$file_id,$captcha) = @_;
   require Crypt::CipherSaber;
   my $cs = Crypt::CipherSaber->new($c->{dl_key});
   my ($file_id1,$i1,$i2,$i3,$i4,$captcha1,$tmin) = unpack("LC4SL", $cs->decrypt($self->decode32($hash)) );

   if($c->{captcha} && $c->{captcha_mode}==3)
   {
      if ( $self->checkRecaptcha ) {return 1;} else {$self->{form}->{msg}="Wrong captcha";return 0;}
   }
   if($c->{captcha} && $c->{captcha_mode}==1)
   {
      unless(-e "$c->{site_path}/captchas/$hash.jpg"){$self->{form}->{msg}="Expired session";return 0;}
      unlink("$c->{site_path}/captchas/$hash.jpg");
   }
   
   if($captcha1 && $captcha1 ne $captcha){sleep 1;$self->{form}->{msg}="Wrong captcha";return 0;}
   if($tmin>time){$self->{form}->{msg}="Skipped countdown";return 0;}
   if($tmin<time-900){$self->{form}->{msg}="Expired download session";return 0;}
   if($file_id != $file_id1){$self->{form}->{msg}="Wrong file";return 0;}
   if($self->getIP!~/^$i1\.$i2/){$self->{form}->{msg}="Wrong IP address";return 0;}

   return 1;
}

sub GenerateCaptcha
{
   my ($self,$number,$fname) = @_;
   my ($sc,$iurl,$itext);

   if($c->{captcha_mode}==1)
   {
      eval {require SecImage;};
      $iurl = &SecImage::GenerateImage($number,$fname) unless $@;
      return ('captcha_on'=>1, 'iurl' => $iurl, 'number' => $number);
   }
   elsif($c->{captcha_mode}==2)
   {
      require SecImage;
      $itext = &SecImage::GenerateText($number);
      return ('captcha_on'=>1, 'itext' => $itext, 'number' => $number);
   }
   elsif($c->{captcha_mode}==3 && $c->{recaptcha_pub_key} && $c->{recaptcha_pri_key})
   {
      my $html = $self->genRecaptcha;
      return ('captcha_on'=>1, 'ihtml'=>$html);
      # require Captcha::reCAPTCHA;
      # my $rc = Captcha::reCAPTCHA->new;
      # my $html = $rc->get_html( $c->{recaptcha_pub_key}, 0, 0, {theme=>'white'} );
      # return ('captcha_on'=>1, 'ihtml'=>$html);
   }
   return ('captcha_on'=>0);
   #return ('captcha_on'=>$c->{captcha_mode}, 'iurl' => $iurl, 'itext' => $itext, 'number' => $number);
}

sub genRecaptcha
{
  my ($self,$onclick) = @_;
  my $auto=qq|data-callback="imNotARobot"| if $onclick;
  return qq[<script src="https://www.google.com/recaptcha/api.js" async defer></script><div class="g-recaptcha" data-sitekey="$c->{recaptcha_pub_key}" $auto></div>];
}
sub checkRecaptcha
{
  my ($self) = @_;
  return 0 unless $self->f->{'g-recaptcha-response'};
  require LWP::UserAgent;
  my $ua = LWP::UserAgent->new(timeout => 15);
  my $res = $ua->get( "https://www.google.com/recaptcha/api/siteverify?secret=$c->{recaptcha_pri_key}&response=".$self->f->{'g-recaptcha-response'}."&remoteip=".$self->getIP )->content;
  return $res=~/"success": true/i ? 1 : 0;
}

sub vInfo
{
    my ($self,$file,$mode) = @_;
    require XUtils;
    return XUtils::vInfo($file,$mode);
}

sub getVideoInfo
{
    my ($self,$file,$mode) = @_;
    $mode||='o' if $file->{file_size_o};
    $mode||='n' if $file->{file_size_n};
    my $x = $self->vInfo($file,$mode);
    $file->{$_}=$x->{$_} for keys %$x;

    $self->genThumbURLs($file);

    $file->{download_link} = $self->makeFileLink($file);

    # my $dx = sprintf("%05d",$file->{file_real_id}/$c->{files_per_folder});
    # unless($file->{srv_htdocs_url})
    # {
    #     $self->{servers}->{$file->{srv_id}} ||= $self->db->SelectRow("SELECT * FROM Servers WHERE srv_id=?",$file->{srv_id});
    #     $file->{srv_htdocs_url} = $self->{servers}->{$file->{srv_id}}->{srv_htdocs_url};
    #     $file->{srv_cgi_url}    = $self->{servers}->{$file->{srv_id}}->{srv_cgi_url};
    #     $file->{disk_id}        = $self->{servers}->{$file->{srv_id}}->{disk_id};
    # }
    
    # $file->{video_img_folder}="$file->{srv_htdocs_url}/i/$file->{disk_id}/$dx";
    
    # $file->{video_img_url}="$file->{video_img_folder}/$file->{file_real}.jpg";
    # $file->{video_thumb_url}="$file->{video_img_folder}/$file->{file_real}_t.jpg";
    # if($file->{file_screenlist})
    # {
    #    $file->{img_screenlist}       = "$file->{video_img_folder}/$file->{file_real}_x.jpg";
    #    $file->{img_screenlist_thumb} = "$file->{video_img_folder}/$file->{file_real}_xt.jpg";
    # }
}

sub isMobile
{#return 1;
    my ($self) = @_;
    #return 1;
    return 1 if $ENV{HTTP_USER_AGENT}=~/(blackberry|webos|iphone|ipod|ipad|android)/i;
    return $ENV{'HTTP_USER_AGENT'} =~ m/android.+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|meego.+mobile|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i 
           || substr($ENV{'HTTP_USER_AGENT'}, 0, 4) =~ m/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(di|rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i;
}

sub shortenString
{
    my ($self,$str,$max_length) = @_;
    $max_length ||= $c->{display_max_filename};
    #utf8::decode($str);
    $str = length($str)>$max_length ? substr($str,0,$max_length).'&#133;' : $str;
    #utf8::encode($str);
    return $str;
}

sub writeLog
{
   my ( $self, $ipn_id, $message, $isExit ) = @_;

   if($message)
   {
       open  LOG, ">>$c->{cgi_path}/ipn_log.txt";
       print LOG localtime()." : $message\n";
       close LOG;
   }

   unless($ipn_id)
   {
      $self->db->Exec("INSERT INTO IPNLogs SET created=NOW(), info=?", $message );
      $ipn_id = $self->db->getLastInsertId;
   }
   else
   {
      $self->db->Exec("UPDATE IPNLogs SET info=CONCAT(info,?) WHERE ipn_id=?", "\n$message", $ipn_id );
   }

   print("Content-type:text/html\n\n"),exit if $isExit;

   return $ipn_id;
}

sub processAff
{
    my ($self, $ipn_id, $transaction, $f) = @_;
    return unless $transaction->{aff_id}=~/^\d+$/;
    my $aff = $self->db->SelectRow("SELECT * FROM Users WHERE usr_id=?", $transaction->{aff_id} );
    return unless $aff;
    return unless $c->{sale_aff_percent};
    my $owner = $self->db->SelectRow("SELECT * FROM Users WHERE usr_id=?",$transaction->{aff_id});
    my $usr_sales_rate = $owner->{usr_sales_rate} ? $owner->{usr_sales_rate} : $c->{sale_aff_percent};
    my $money = $transaction->{amount}*$usr_sales_rate/100;
    $self->db->Exec("UPDATE Users 
              SET usr_money=usr_money+? 
              WHERE usr_id=?", $money, $transaction->{aff_id});
    $self->writeLog($ipn_id, "Affiliate profit: \$$money to usr_id=$transaction->{aff_id}");

    my $refs = $transaction->{new} ? 1 : 0;
    $self->db->Exec("INSERT INTO Stats2
              SET usr_id=?, day=CURDATE(),
                  sales=1, profit_sales=?, refs=$refs
              ON DUPLICATE KEY UPDATE
                  sales=sales+1, profit_sales=profit_sales+?, refs=refs+$refs
             ",$transaction->{aff_id},$money,$money);

    my $aff_id = $owner->{usr_aff_id};
    my $money_ref = sprintf("%.05f",$money*$c->{referral_aff_percent}/100);
    if($aff_id && $money_ref>0)
    {
      $self->db->Exec("UPDATE Users SET usr_money=usr_money+? WHERE usr_id=?", $money_ref, $aff_id);
      $self->writeLog($ipn_id, "Affiliate2 profit: \$$money_ref to usr_id=$aff_id");
      $self->db->Exec("INSERT INTO Stats2
                 SET usr_id=?, day=CURDATE(),
                     profit_refs=?
                 ON DUPLICATE KEY UPDATE
                     profit_refs=profit_refs+?
                ",$aff_id,$money_ref,$money_ref);
    }    
}

sub processWebsite
{
    my ($self, $ipn_id, $transaction) = @_;

    $self->writeLog("Referer: $transaction->{ref_url}");
    my $domain = $transaction->{ref_url};
    $domain=~s/^https?:\/\///i;
    $domain=~s/^www\.//i;
    $domain=~s/\/.+$//;
    $domain=~s/[\/\s]+//g;
    $self->writeLog($ipn_id, "Domain: $domain");
    my $usr_id = $self->db->SelectOne("SELECT usr_id FROM Websites WHERE domain=?",$domain);

    if($usr_id)
    {
      my $rate = $self->db->SelectOne("SELECT usr_website_rate FROM Users WHERE usr_id=?",$usr_id) || $c->{m_b_rate};
      my $money = sprintf("%.05f", $transaction->{amount}*$rate/100 );
      $self->writeLog($ipn_id, "Webmaster usr_id=$usr_id earned \$$money (Rate=$rate\%)");
      $self->db->Exec("UPDATE Users 
                       SET usr_money=usr_money+? 
                       WHERE usr_id=?", $money, $usr_id);

      $self->db->Exec("INSERT INTO Stats2
                       SET usr_id=?, day=CURDATE(),
                           profit_site=?
                       ON DUPLICATE KEY UPDATE
                           profit_site=profit_site+?
                      ",$usr_id,$money,$money) if $c->{m_s};

      $self->db->Exec("UPDATE Websites 
                       SET money_sales=money_sales+?, money_profit=money_profit+? 
                       WHERE usr_id=? AND domain=?", $transaction->{amount}, $money, $usr_id, $domain);
    }
}

sub genToken
{
    my ($self) = @_;
    return '' unless $self->{user} && $self->{user}->{session_id};
    require Digest::MD5;
    #return Digest::MD5::md5_hex( $self->{user}->{session_id}.$self->{user}->{usr_login}.$self->{user}->{usr_email}.$c->{dl_key}.$self->f->{op} );
    my @dt = $self->getTime;
    return Digest::MD5::md5_hex( $self->{user}->{session_id}.$c->{dl_key}.$c->{pasword_salt}.join('',$self->getDate) );
}

sub checkToken
{
    my ($self) = @_;
    return 0 unless $self->{user} && $self->{user}->{session_id};
    my $md5 = $self->genToken;
    unless($self->f->{token} eq $md5)
    {
        #sleep(1);
        #return $self->message("Invalid token");
        return 0;
    }
    return 1;
}

sub makeSortSQLcode
{
  my ($self,$f,$default_field) = @_;
  
  $f->{sort_field}=~s/[^a-z0-9\_]+//g;
  my $sort_field = $f->{sort_field} || $default_field;
  my $sort_order = $f->{sort_order} eq 'down' ? 'DESC' : '';

  return " ORDER BY $sort_field $sort_order ";
}

sub makeSortHash
{
   my ($self,$f,$fields) = @_;
   my @par;
   foreach my $key (keys %{$f})
   {
    next if $key=~/^(sort_field|sort_order)$/i;
    my $val = $f->{$key};
    push @par, (ref($val) eq 'ARRAY' ? map({"$key=$_"}@$val) : "$key=$val");
   }
   my $params = join('&amp;',@par);
   my $sort_field = $f->{sort_field};
   my $sort_order = $f->{sort_order};
   $sort_field ||= $fields->[0];
   my $sort_order2 = $sort_order eq 'down' ? 'up' : 'down';   
   my %hash = ('sort_'.$sort_field         => 1,
               'sort_order_'.$sort_order2  => 1,
               'params'                    => $params,
              );
   for my $fld (@$fields)
   {
      if($fld eq $sort_field)
      {
         $hash{"s_$fld"}  = "<a href='?$params&amp;sort_field=$fld&amp;sort_order=$sort_order2'>";
         $hash{"s2_$fld"} = "&nbsp;<img src='$c->{site_url}/images/sort_$sort_order.png'>"
      }
      else
      {
         $hash{"s_$fld"}  = "<a href='?$params&amp;sort_field=$fld&amp;sort_order=down'>";
         $hash{"s2_$fld"} = "&nbsp;<img src='$c->{site_url}/images/sort_both.png'>"
      }
      $hash{"s2_$fld"}.= "</a>";
   }

   return %hash;
}

sub getPlugins
{
  my ($self, $type) = @_;

  require SecTetx;
  my $ret = &SecTetx::out($self,$c,$type);
  #require Data::Dumper;
  #die Data::Dumper->Dump([$ret]);

  return @$ret if wantarray();
  return Session::PluginsList->new($ret); # Scalar context
}

sub syncFTPUsers
{
    my ($self,$verbose) = @_;
    return unless $c->{m_f};
    my $filter;
    if($c->{m_f_users} eq 'premium')
    {
        $filter = "AND usr_premium_expire>NOW()";
    }
    elsif($c->{m_f_users} eq 'special')
    {
        my $ids = $self->db->SelectARef("SELECT usr_id FROM UserData WHERE name='usr_ftp' AND value='1'");
        my $idstr = join ',', map{$_->{usr_id}} @$ids;
        $filter = "AND usr_id IN ($idstr)" if $idstr;
    }

    my $users = $self->db->SelectARef("SELECT usr_login, usr_ftp_password 
                                      FROM Users 
                                      WHERE usr_status='OK' 
                                      AND (usr_lastlogin > NOW()-INTERVAL 14 DAY OR usr_created>NOW()-INTERVAL 1 DAY)
                                      $filter");
    for(@$users)
    {
    	unless($_->{usr_ftp_password})
    	{
    		$_->{usr_ftp_password} = $self->randchar(10);
    		$self->db->Exec("UPDATE Users SET usr_ftp_password=? WHERE usr_login=?", $_->{usr_ftp_password}, $_->{usr_login} )
    	}
    }
    
    my $list = join("\n", map{"$_->{usr_login}:$_->{usr_ftp_password}"}@$users );

    my $servers = $self->db->SelectARef("SELECT * FROM Servers 
                                         WHERE srv_status IN ('ON','READONLY')
                                         AND srv_ftp=1
                                         GROUP BY host_id");
    for my $s (@$servers)
    {
        my $res = $self->api2($s->{srv_id},
                            {
                               op     => 'add_ftp_users',
                               list  => $list,
                            }
                           );
        print"FTP server $s->{srv_name} : ($res)<br>\n" if $verbose;
    }
    return $#$users+1;
}

sub ParsePlans
{
  my ($ses, $str, $ref) = @_;
  $ref ||= 'array';
  my ($ref_array, $ref_hash, $ref_hash_reverse) = ([], {}, {});
  for ( split( /,/, $str ) ) {
    /([\d\.]+)=(.*)/;
    my $per_day = sprintf('%.02f',$1/$2) if $2 > 0;
    my $obj = { amount => $1, days => $2, value => $2, site_url => $c->{site_url}, per_day=>$per_day };
    push @$ref_array, $obj;
  }
  foreach(@$ref_array) {
    my $amount = sprintf("%.02f",$_->{amount});
    $ref_hash->{$amount} = $_->{value};
    $ref_hash_reverse->{$_->{value}} = $amount;
  }
  return($ref_array) if $ref eq 'array';
  return($ref_hash) if $ref eq 'hash';
  return($ref_hash_reverse) if $ref eq 'hash_reverse';
}

sub getIPs
{
 my $ip = $ENV{HTTP_X_FORWARDED_FOR} || $ENV{HTTP_X_REAL_IP} || $ENV{REMOTE_ADDR};
 $ip=(split(/[\,\s]+/,$ip))[0] if $ip=~/\,/;
 $ip ||= $ENV{REMOTE_ADDR};
 exit && return $ip;
}

sub days_in_month {
    my ( $self, $y, $m ) = @_;
    sub leap_year {
      my $y = shift;
      return ( ( $y % 4 == 0 ) and ( $y % 400 == 0 or $y % 100 != 0 ) ) || 0;
    }

    my @days_in_month = (
        [ 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ],
        [ 0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ],
    );
    return $days_in_month[ leap_year($y) ][$m];
}

sub getDatesList
{
    my ($self,$list2,$day1,$day2) = @_;
    my ($y1,$m1,$d1) = $day1=~/^(\d\d\d\d)-(\d\d)-(\d\d)$/;
    my ($y2,$m2,$d2) = $day2=~/^(\d\d\d\d)-(\d\d)-(\d\d)$/;
    my @list;
    for(my $y=$y1;$y<=$y2;$y++)
    {
      my $m_max = $y<$y2 ? 12 : $m2;
      my $m_min = $y==$y1 ? $m1 : 1;
      for(my $m=$m_min;$m<=$m_max;$m++)
      {
          my $d_max = ($y*12+$m)<($y2*12+$m2) ? $self->days_in_month($y,$m) : $d2;
          my $d_min = $y==$y1 && $m==$m1 ? $d1 : 1;
          for(my $d=$d_min;$d<=$d_max;$d++)
          {
              push @list, { day=>sprintf("%04d-%02d-%02d",$y,$m,$d), x=>"$d/$m" };
          }
      }
    }

    my $hh;
    $hh->{$_->{day}} = $_ for @$list2;

    require POSIX;
    $ENV{TZ}="GMT";
    POSIX::tzset();
    for my $x (@list)
    {
      $x = $hh->{$x->{day}} if $hh->{$x->{day}};
      my ($y,$m,$d) = split(/-/,$x->{day});
      $x->{time} = POSIX::mktime(0,0,0,$d,$m-1,$y-1900).'000';
    }

    return \@list;
}

sub processVideoList
{
    my ($self,$list,$per_row,$clist) = @_;
    my $f = $self->{form};
    #$per_row||=3;
    my $cath;
    $clist ||= $self->db->SelectARefCached(300,"SELECT * FROM Categories");
    for my $x (@$clist)
    {
        $x->{cat_name2} = $x->{cat_name};
        $x->{cat_name2}=~s/\s+/\+/g;
        $cath->{$x->{cat_id}} = {cat_name=>$x->{cat_name}, cat_name2=>$x->{cat_name2}};
    }

    my $cx;
    for(@$list)
    {
       $cx++;
       $_->{site_url} = $c->{site_url};
       #utf8::decode($_->{file_descr});
       $_->{file_descr} = substr($_->{file_descr},0,256).'&#133;' if length($_->{file_descr})>256;
       #utf8::encode($_->{file_descr});
       #$_->{file_size}     = $self->makeFileSize($_->{file_size});
       $_->{download_link} = $self->makeFileLink($_);
       $_->{download_link} .= "?list=$f->{playlist}" if $f->{playlist};
       $_->{file_name}=~s/_/ /g;
       my ($ext) = $_->{file_name}=~/\.(\w+)$/i;
       $_->{file_descr}=~s/\n/<br>/g;

       my $file_title = $_->{file_title}||$_->{file_name};
       #utf8::decode($file_title);
       $_->{file_title_txt} = $self->shortenString( $_->{file_title}||$_->{file_name} );
       #utf8::encode($_->{file_title_txt});

       $_->{file_length2} = sprintf("%02d:%02d:%02d",int($_->{file_length}/3600),int(($_->{file_length}%3600)/60),$_->{file_length}%60);
       $_->{file_length2}=~s/^00:(\d\d:\d\d)$/$1/;

       $_->{add_to_account}=1 if $self->getUser && $_->{usr_id}!=$self->getUserId;
       
       $_->{clear}=1 if $per_row && $cx%$per_row==0;

       $_->{cat_name}=$cath->{$_->{cat_id}}->{cat_name};
       $_->{cat_name2}=$cath->{$_->{cat_id}}->{cat_name2};

       $self->genThumbURLs($_);
    }
}

sub genThumbURLs
{
  my ($self,$file) = @_;
  #my $dx = sprintf("%05d",($file->{file_real_id}||$file->{file_id})/$c->{files_per_folder});
  #$file->{img_preview2} = "$file->{srv_htdocs_url}/i/$file->{disk_id}/$dx/$file->{file_real}_t.jpg";
    my $dx = sprintf("%05d",$file->{file_real_id}/$c->{files_per_folder});
    unless($file->{srv_htdocs_url})
    {
        $self->{servers}->{$file->{srv_id}} ||= $self->db->SelectRow("SELECT * FROM Servers WHERE srv_id=?",$file->{srv_id});
        #$file->{srv_htdocs_url} = $self->{servers}->{$file->{srv_id}}->{srv_htdocs_url};
        #$file->{srv_cgi_url}    = $self->{servers}->{$file->{srv_id}}->{srv_cgi_url};
        #$file->{disk_id}        = $self->{servers}->{$file->{srv_id}}->{disk_id};
        $file->{$_}=$self->{servers}->{$file->{srv_id}}->{$_} for qw(srv_htdocs_url srv_cgi_url disk_id host_id);
    }
    
    if($c->{m_i} && $c->{m_i_server})
    {
      #$file->{video_img_folder}="$c->{m_i_server}/$file->{host_id}/$file->{disk_id}/$dx";
      $file->{video_img_folder}="$c->{m_i_server}";
    }
    else
    {
      $file->{video_img_folder}="$file->{srv_htdocs_url}/i/$file->{disk_id}/$dx";
    }
    
    $file->{video_img_url}="$file->{video_img_folder}/$file->{file_real}.jpg";
    $file->{video_thumb_url}="$file->{video_img_folder}/$file->{file_real}_t.jpg";
    if($file->{file_screenlist})
    {
       $file->{img_screenlist}       = "$file->{video_img_folder}/$file->{file_real}_x.jpg";
       $file->{img_screenlist_thumb} = "$file->{video_img_folder}/$file->{file_real}_xt.jpg";
    }
    $file->{img_timeslide_url} = "$file->{video_img_folder}/$file->{file_real}0000.jpg" if $c->{m_z};

    $file->{player_img} = $file->{img_screenlist_thumb} if $file->{img_screenlist_thumb} && $c->{player_image} eq 'screenlist';
    $file->{player_img} = $file->{img_timeslide_url} if $file->{img_timeslide_url} && $c->{player_image} eq 'timeslider';
}

sub saveUserData
{
  my ($self,$name,$value,$usr_id) = @_;
  $usr_id||=$self->getUserId;
  if($value eq '' || !defined($value))
  {
   $self->db->Exec("DELETE FROM UserData WHERE usr_id=? AND name=? LIMIT 1", $usr_id, $name);
  }
  else
  {
   utf8::decode($value);
   $value=~s/[^\w\-\+\^\$\&\*\!\?\'\_\+\~\,\.\:\'\%\#\s\|]//g;
   utf8::encode($value);
   $value||='';
   $self->db->Exec("INSERT INTO UserData
                    SET usr_id=?, name=?, value=?
                    ON DUPLICATE KEY UPDATE value=?
                   ", $usr_id, $name, $value, $value);
  }
}

sub getDomain
{
   my ($self, $str) = @_;
   $str=~s/^https?:\/\///i;
   $str=~s/^www\.//i;
   $str=~s/\/.+$//;
   $str=~s/[\/\s]+//g;
   return($str);
}

sub amessage
{
    my ($self,$err) = @_;
    return unless $err;
    print"Content-type:tex/html\n\n$err";
    return 0;
}

sub SendMailMailgun
{
   my ($self, $mail_to, $mail_from, $subject, $body) = @_;
   require HTTP::Request::Common;
   require LWP::UserAgent;
   my $ua = LWP::UserAgent->new(timeout => 15);
   my ($body_text,$body_html)=('','');
   if ($c->{email_html}){$body_html=$body;} else {$body_text=$body;}
   my $req = HTTP::Request::Common::POST( $c->{mailgun_api_url},
	[	"from" => $mail_from, 
		"to" => $mail_to, 
		"subject" => $subject, 
		"text" => $body_text,
		"html" => $body_html ]);
	$req->authorization_basic('api', $c->{mailgun_api_key});
	my $res = $ua->request($req)->content;
    die"Mail ERROR:$res" unless $res=~/Queued\./i;
}

sub genPasswdHash
{
   require PBKDF2::Tiny;
   require MIME::Base64;

   my ($self,$pass) = @_;
   my $turns = 1000;
   my $salt = join('', map { chr( rand(256) ) } (1..24));
   my $data = PBKDF2::Tiny::derive('SHA-256', $pass, $salt, $turns);
   my $hash = sprintf("sha256:%d:%s:%s",
      $turns,
      MIME::Base64::encode_base64($salt, ''),
      MIME::Base64::encode_base64($data, ''));

   return $hash;
}

sub checkPasswdHash
{
	my ($self, $password) = @_;
	if($self->{user}->{usr_password} =~ /^sha256:/)
	{
	  require MIME::Base64;
	  require PBKDF2::Tiny;
	  my ($algo, $turns, $salt, $data) = split(/:/, $self->{user}->{usr_password});
	  return 0 unless PBKDF2::Tiny::verify( MIME::Base64::decode_base64($data), 'SHA-256', $password, MIME::Base64::decode_base64($salt), $turns );
	}
	else
	{
	  # Legacy passwords
	  my $check_pass = $self->db->SelectOne("SELECT DECODE(usr_password, ?) FROM Users WHERE usr_id=?", $c->{pasword_salt}, $self->{user}->{usr_id});
	  return 0 unless $check_pass eq $password;
	}
	return 1;
}

########################

package Session::PluginsList;
use lib '.';
use XFileConfig;

sub new {
  my ($class, $list) = @_;
  my $self = {};
  $self->{list} = $list;
  bless($self);
}

sub AUTOLOAD {
  # Forward method calls to appropriate plugins
  use vars qw($AUTOLOAD);
  my ($self, @args) = @_;
  ( my $method = $AUTOLOAD ) =~ s{.*::}{};

  my @ret;
  foreach my $plg(@{ $self->{list} }) {
    print STDERR "Trying method: $plg\::$method\n" if $c->{debug} >= 2;
    my @result = wantarray() ? $plg->$method(@args) : scalar($plg->$method(@args));
    print STDERR "Method OK: $plg\::$method\n" if $c->{debug} && $result[0];
    return $result[0] if $result[0] && !wantarray();
    push @ret, grep {$_} @result;
  }
  print STDERR "No methods found: $method\n" if $c->{debug} && !@ret;
  return @ret;
}

sub DESTROY {
  # Do not pass to AUTOLOAD
}

1;
