package Plugins::Player::Flow;
use strict;
use XFileConfig;
use vars qw($ses $c);

sub makePlayerCode
{
	my ($self, $f, $file, $c, $player ) = @_;
	return if $player ne 'flow';

     my $name_n=$c->{vid_resize_n};
     my $name_h=$c->{vid_resize_h};
     my $name_l=$c->{vid_resize_l};
     $name_n=~s/^.*\x//i;
     $name_h=~s/^.*\x//i;
     $name_l=~s/^.*\x//i;
  my @sources=();
 if($file->{hls_direct})
 {
    push @sources, qq[<source src="$file->{hls_direct}" type='application/x-mpegURL' />];
 }
 if($file->{dash_direct})
 {
    push @sources, qq[<source src="$file->{dash_direct}" type='application/dash+xml' />];
 }
  push @sources, qq[<source src="$file->{direct_link_hd}" type='video/mp4' label='$name_h' res='$name_h' />] if $file->{direct_link_hd};
  push @sources, qq[<source src="$file->{direct_link}" type='video/mp4' label='$name_n' res='$name_n' />];
  push @sources, qq[<source src="$file->{direct_link_lq}" type='video/mp4' label='$name_l' res='$name_l' />] if $file->{direct_link_lq};

  
  my $srchtml = join "\n", @sources;

#<source type="application/x-mpegurl" src="$file->{hls_direct}">

 my @srts=();
 my $defused;
 if($c->{srt_on} && $c->{srt_langs})
 {
    my @arr = split /\s*\,\s*/, $c->{srt_langs};
    my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
    my $dir = "$c->{site_path}/srt/$dx";
    for(@arr)
    {
        #push @list,$_ if -f "$dir/$file->{file_code}_$_.vtt";
        my $default = $defused ? '' : 'default';
        $defused=1;
        push @srts, qq[<track kind="subtitles" $default label="$_" src="$c->{site_url}/srt/$dx/$file->{file_code}_$_.vtt">] if -f "$dir/$file->{file_code}_$_.vtt";
    }
 }
 my $srthtml = join "\n", @srts;

 my $vtime = int $file->{vid_length}*$c->{track_views_percent}/100; 

# my $trackhtml;
# if($c->{srt_on} && $c->{srt_langs})
# {
#    my @arr = split /\s*\,\s*/, $c->{srt_langs};
#    my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
#    my $dir = "$c->{site_path}/srt/$dx";
#    my $srt_cook = $ses->getCookie("srt_cook");
#    my @list;
#    for(@arr)
#    {
#      push @tracks, qq[<track kind="subtitles" srclang="$_" label="$_" src="$c->{site_url}/srt/$dx/$file->{file_code}_$_.vtt">] if -f "$dir/$file->{file_code}_$_.vtt";
#      #push @tracks, qq[{file: "$c->{site_url}/srt/$dx/$file->{file_code}_$_\_$srt_cook.vtt", label: "My: $_", kind: "captions"}] if -f "$dir/$file->{file_code}_$_\_$srt_cook.vtt";
#    }
#    $trackhtml = join "\n", @tracks;
# }

  my $html=<<ENP
   <!-- player skin -->
   <link rel="stylesheet" href="/flow/skin/skin.css">
<style>
/* hide standard time tool tip */
.flowplayer .fp-timestamp {
  display: none !important;
}
 
/* the preview canvas */
.flowplayer canvas {
  outline: 4px solid #fff;
  position: absolute;
  display: none;
}
</style>

   <!-- for video tag based installs flowplayer depends on jQuery 1.7.2+ -->
   <!--script src="https://code.jquery.com/jquery-1.11.2.min.js"></script-->


   <!-- include flowplayer -->
   <script src="/flow/flowplayer.min.js"></script>


<!-- hls & dash js -->
    <script src="//releases.flowplayer.org/hlsjs/flowplayer.hlsjs.min.js"></script>
    <script src="//releases.flowplayer.org/dashjs/flowplayer.dashjs.min.js"></script>

<div id="vplayer" class="flowplayer is-splash" style="width:$file->{play_w}px;height:$file->{play_h}px;text-align:center;background-image:url('$file->{video_img_url}');" data-key="\$488419729438104" data-ratio="0.4167">

   <video preload="none" controls data-title="$file->{file_title}" >

      $srchtml

      $srthtml

   </video>
   

   <!-- make video embed full screen without scrollbar-->

     <!--style>*{outline:0!important;}.flowplayer,#complete{height:100%;width:100%;overflow:hidden;background-color:#000;}body{height:100%;width:100%;overflow:hidden;margin:0;;margin:0;background-color:#000;}html{height:100%;background-color:#000;}</style-->
<script>
flowplayer(function (api, root) {
   api.on("load", function (e) { 

  window.setTimeout( function (){ 
  	\$.get( '$c->{site_url}/dl?op=view2&file_code=$file->{file_code}&hash=$file->{ophash}&p=flow', function(data){} ); 
  		}, $vtime*1000 );

 } );

   api.on("ready", function (e, api, video) {
      var thumbheight = Math.round(\$(root).height() / 8);
      \$(root).append(\$("<canvas/>").attr({
         height: thumbheight,
         width: Math.round(thumbheight * video.width / video.height)
      }));
   });
});
 

\$(function() {
 
  var withThumbnail = function (fpVideo, callback) {
     var thumb = \$("video.fp-thumbnail");
     if (!thumb.length) {
        thumb = fpVideo.clone().addClass("fp-thumbnail").appendTo(\$("body")).css({
           position: "absolute",
           left: -9999
        }).on("loadedmetadata", function () {
           callback(thumb);
        });
        thumb[0].muted = true;
        thumb[0].load();
     } else if (thumb[0].readyState !== 4) {
        thumb.on("loadedmetadata", function () {
           callback(thumb);
        });
     } else {
        callback(thumb);
     }
  }
 
  \$(".fp-timeline").on("mousemove", function (ev) {
     var timelineOffset = \$(".fp-timeline").offset(),
         percentage = (ev.pageX - timelineOffset.left) / \$(".fp-timeline").width(),
         canv = \$(".flowplayer canvas"),
         canvWidth = canv.width(),
         canvHeight = canv.height(),
         fpVideo = \$(".flowplayer video");
 
     canv.show().css({
        left: Math.round(ev.pageX - (flowplayer().isFullscreen ? canvWidth / 2 : canvWidth + 4 * 2)),
        bottom: Math.round(\$(".flowplayer .fp-controls").height() + 4 * 2)
     });
     withThumbnail(fpVideo, function (thumb) {
        thumb[0].currentTime = fpVideo[0].duration * percentage;
        thumb.one("seeked", function () {
           var canvas = canv[0],
               ctx = canvas.getContext("2d");
           ctx.drawImage(thumb[0], 0, 0, canvWidth, canvHeight);
        });
     })
  }).on("mouseleave", function () {
     \$(".flowplayer canvas").hide();
  });
});

</script>
</div>
ENP
;

  my $js=<<EOP

EOP
;


	return($html,$js);
}

1;
