package Plugins::Player::JW6;
use strict;
use XFileConfig;
use vars qw($ses $c);

sub makePlayerCode
{
	my ($self, $f, $file, $c, $player ) = @_;
	return if $player ne 'jw6';

    my (@plugins,@tracks,$extra);

    if($c->{m_z} && $c->{time_slider})
    {
        #$extra.=qq|,tracks: [{ 
        #    file: "$c->{site_url}/dl?op=get_slides&file_code=$file->{file_code}", kind: "thumbnails"
        #}]|;
        #push @tracks, qq[{file: "$c->{site_url}/dl?op=get_slides&file_code=$file->{file_code}", kind: "thumbnails"}];
        push @tracks, qq[{file: "$c->{site_url}/dl?op=get_slides&length=$file->{vid_length}&url=$file->{img_timeslide_url}", kind: "thumbnails"}];
    }


 #http://support.jwplayer.com/customer/portal/articles/1407438-adding-closed-captions
 #http://support.jwplayer.com/customer/portal/articles/1482067-styling-captions-for-fcc-compliance
 if($c->{srt_on} && $c->{srt_langs})
 {
    my @arr = split /\s*\,\s*/, $c->{srt_langs};
    my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
    my $dir = "$c->{site_path}/srt/$dx";
    my @list;
    for(@arr)
    {
      push @tracks, qq[{file: "$c->{site_url}/srt/$dx/$file->{file_code}_$_.vtt", label: "$_", kind: "captions"}] if -f "$dir/$file->{file_code}_$_.vtt";
      push @tracks, qq[{file: "$c->{site_url}/srt/$dx/$file->{file_code}_$_.srt", label: "$_", kind: "captions"}] if -f "$dir/$file->{file_code}_$_.srt";
    }
    my $bgopacity = $c->{srt_back} ? 100 : 0;
    $extra.=qq[,captions: {color: '#$c->{srt_color}', fontSize: $c->{srt_size}, fontFamily:"$c->{srt_font}", backgroundOpacity: $bgopacity}];
 }

 if($c->{player_sharing})
 {
    require URL::Encode;
    my $embed_code = URL::Encode::url_encode( qq[<IFRAME SRC="$c->{site_url}/embed-$file->{file_code}.html" FRAMEBORDER=0 MARGINWIDTH=0 MARGINHEIGHT=0 SCROLLING=NO allowfullscreen="true" WIDTH=$file->{play_w} HEIGHT=$file->{play_h}></IFRAME>] );
    $embed_code=~s/\+/ /g;
    $file->{download_link}||=$ses->makeFileLink($file);
    $extra .= qq[,"sharing": {code: "$embed_code", link: "$file->{download_link}"}];
 }

 if($c->{player_lightsout})
 {
    push @plugins, qq["$c->{cdn_url}/player6/lightsout.js":{}];
 }

 $c->{player_overlay_text}=~s/\'/\\'/g;
 push @plugins, qq["$c->{cdn_url}/player6/overlay.js":{text: '$c->{player_overlay_text}', hide:1}] if $c->{player_overlay_text};

 my $plugins_code = ',plugins: {'.join(",\n",@plugins).'}' if @plugins;
 my $tracks_code = ',tracks: ['.join(",\n",@tracks).']';

my $download_button_code=qq|jwplayer().addButton(
    "/images/download2.png",
    "Watch on site", 
    function() {
        window.top.location.href = '$file->{download_link}';
    },
    "download11"
);| if $f->{embed} && $c->{player_embed_dl_button};

my $show_box_after_limit=qq[ \$('#play_limit_box').show(); ] if $c->{video_time_limit};
my $time_fadein=$c->{player_ads_fadein}||0;
my $vtime = int $file->{vid_length}*$c->{track_views_percent}/100;
my $x2time = int $vtime/2;

my $stop_code='';
if($c->{video_time_limit})
{
  $stop_code=<<ENS
  window.setTimeout( function (){ 
  	jwplayer().stop(); $show_box_after_limit 
  }, $c->{video_time_limit}*1000 );
ENS
;
}

my $js_code=<<ENP
var vvplay,vvad,x2ok=0;
jwplayer().onTime(function(x) { 
    if($time_fadein>0 && x.position>=$time_fadein && vvad!=1){vvad=1;\$('div.video_ad_fadein').fadeIn('slow');}
    if(x2ok==0 && x.position>=$x2time && x.position<=($x2time+2)){x2ok=x.position;}
});
jwplayer().onPlay(function(x) { doPlay(x); });
jwplayer().onComplete(function() { \$('div.video_ad').show(); });
function doPlay(x)
{
  \$('div.video_ad').hide();
  if(vvplay)return;
  vvplay=1;
  adb=0;
  if( window.cRAds === undefined ){ adb=1; }
  \$.get('$c->{site_url}/dl?op=view&file_code=$file->{file_code}&hash=$file->{ophash}&embed=$f->{embed}&adb='+adb, function(data) {\$('#fviews').html(data);} );

    window.setTimeout( function (){ 
  	if(x2ok!=0 && jwplayer().getState().toUpperCase()=='PLAYING')
  	{ 
  		\$.get( '$c->{site_url}/dl?op=view2&file_code=$file->{file_code}&hash=$file->{ophash}&p=jw6&x2='+x2ok, function(data){} ); 
  	} 
  		}, $vtime*1000 );

  	$stop_code
}

$download_button_code
ENP
;

 if($file->{preview})
 {
     $plugins_code='';
     $js_code=qq[jwplayer().onComplete(function() { \$('#over_player_msg').show(); });];
     $file->{vid_length}='';
     $file->{preview_message} = $file->{preview_message};
 }

 my @sources;
 if($c->{m_q} && $file->{smil}) # RTMP mod is ON and .smil file was generated
 {
     push @sources, qq[{file: "$file->{direct_link}"}];
     push @sources, qq[{file: "$file->{http_fallback}"}] if $file->{http_fallback};
     $extra.=",rtmp: {bufferlength: 5}";                  
 }
 elsif($c->{m_q} && $file->{rtmp})
 {
     my $srv_url = $file->{srv_htdocs_url};
     $srv_url=~s/:(\d+)$//;
     $srv_url=~s/http:\/\///;
     push @sources, qq[{file: "rtmp://$srv_url:$c->{m_q_port}/vod/$file->{direct_link}"}];
     push @sources, qq[{file: "$file->{http_fallback}"}] if $file->{http_fallback};
     $extra.=",rtmp: {bufferlength: 5}";
 }
 else
 {
     my $name_n=$c->{vid_resize_n};
     my $name_h=$c->{vid_resize_h};
     my $name_l=$c->{vid_resize_l};
     $name_n=~s/$\x//i;
     $name_h=~s/$\x//i;
     $name_l=~s/$\x//i;
     push @sources, qq[{file:"$file->{direct_link_hd}",label:"$name_h"}] if $file->{direct_link_hd};
     push @sources, qq[{file:"$file->{direct_link}",label:"$name_n"}];
     push @sources, qq[{file:"$file->{direct_link_lq}",label:"$name_l"}] if $file->{direct_link_lq};
     # push @sources, qq[{file:"$file->{direct_link}",label:"SD"}];
     # push @sources, qq[{file:"$file->{direct_link_hd}",label:"HD"}] if $file->{direct_link_hd};
     # push @sources, qq[{file:"$file->{direct_link_lq}",label:"LQ"}] if $file->{direct_link_lq};
 }
 if($file->{hls_direct})
 {
     unshift @sources, qq[{file:"$file->{hls_direct}"}];
     #@sources = qq[{file:"$file->{hls_direct}"}];
 }
 my $sources_code = join(',',@sources);

 if($c->{jw6_skin})
 {
    $extra.=qq[,skin: "$c->{cdn_url}/player6/skins/$c->{jw6_skin}.xml"];
 }

$file->{vid_length} = $c->{video_time_limit} if $c->{video_time_limit};
my ($iw,$ih) = ("$file->{play_w}px","$file->{play_h}px");
if($file->{embed})
{
    $file->{play_w}=$file->{play_h}=$iw=$ih='100%';
    #$extra.=",stretching:'fill'";
    $extra.=qq[,title:"$file->{file_title}", displaytitle:true] if $file->{usr_embed_title};
}

$extra.=qq[,related: {file:"$c->{site_url}/dl?op=related&code=$file->{file_code}"}] if $c->{player_related};

$extra.=qq[,abouttext:"$c->{site_name}", aboutlink:"$c->{site_url}"] if $c->{jw6_key};

$file->{player_img} ||= $file->{video_img_url};

#height: "$file->{play_h}",
#$file->{play_w}
#aspectratio: "16:9",
my $code=<<ENP
  jwplayer("vplayer").setup({
    sources: [$sources_code],
    image: "$file->{player_img}",
    stretching: "$c->{player_image_stretching}",
    duration:"$file->{vid_length}",
    width: "$file->{play_w}",
    height: "$file->{play_h}",
    primary:"html5",
    androidhls: "true",
    startparam: "start"
    $plugins_code
    $tracks_code
    $extra
  });
$js_code
ENP
;

my $extra_html=qq[<script src="$c->{cdn_url}/js/pop.js"></script>] if $c->{adb_no_money};

	my $html=qq[<script type='text/javascript' src='$c->{cdn_url}/player6/jwplayer.js'></script>
                <script type="text/javascript">jwplayer.key="$c->{jw6_key}";</script>
                $extra_html
                <span id='vplayer' style="width:$iw;height:$ih;"><img src="$file->{video_img_url}" style="width:$iw;height:$ih;"></span>];

	return($html,$code);
}

1;
