package Plugins::Player::JW7;
use strict;
use XFileConfig;
use vars qw($ses $c);

sub makePlayerCode
{
	my ($self, $f, $file, $c, $player ) = @_;
	return if $player ne 'jw7';

    my (@plugins,@tracks,$extra,$extra_html_pre,$extra_html,$extra_js,$extra_onready);

    if($c->{m_z} && $c->{time_slider})
    {
        #$extra.=qq|,tracks: [{ 
        #    file: "$c->{site_url}/dl?op=get_slides&file_code=$file->{file_code}", kind: "thumbnails"
        #}]|;
        #push @tracks, qq[{file: "$c->{site_url}/dl?op=get_slides&file_code=$file->{file_code}", kind: "thumbnails"}];
        push @tracks, qq[{file: "$c->{site_url}/dl?op=get_slides&length=$file->{vid_length}&url=$file->{img_timeslide_url}", kind: "thumbnails"}];
    }


 #http://support.jwplayer.com/customer/portal/articles/1407438-adding-closed-captions
 #http://support.jwplayer.com/customer/portal/articles/1482067-styling-captions-for-fcc-compliance
 if($c->{srt_on} && $c->{srt_langs})
 {
    my @arr = split /\s*\,\s*/, $c->{srt_langs};
    my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
    my $dir = "$c->{site_path}/srt/$dx";
    my $srt_cook = $ses->getCookie("srt_cook");
    my @list;
    my $srtauto=',"default": true' if $c->{srt_auto_enable};
    for(@arr)
    {
      push @tracks, qq[{file: "$c->{site_url}/srt/$dx/$file->{file_code}_$_.vtt", label: "$_", kind: "captions"$srtauto}] if -f "$dir/$file->{file_code}_$_.vtt";
      push @tracks, qq[{file: "$c->{site_url}/srt/$dx/$file->{file_code}_$_.srt", label: "$_", kind: "captions"}] if -f "$dir/$file->{file_code}_$_.srt";
      push @tracks, qq[{file: "$c->{site_url}/srt/$dx/$file->{file_code}_$_\_$srt_cook.vtt", label: "My: $_", kind: "captions"}] if -f "$dir/$file->{file_code}_$_\_$srt_cook.vtt";
      $srtauto='';
    }
    my $bgopacity = 0;
    $c->{srt_opacity}||=100;
    $extra.=qq[,captions: {color: '#$c->{srt_color}', fontSize: $c->{srt_size}, fontFamily:"$c->{srt_font}", backgroundOpacity: $bgopacity, edgeStyle: '$c->{srt_edge_style}', fontOpacity: $c->{srt_opacity}}];
 }

 if($c->{srt_allow_anon_upload})
 {
 	#push @tracks, qq[{file: "$c->{site_url}/srt/empty.srt", label: "Upload", kind: "captions"}];
 	push @tracks, qq[{file: "$c->{site_url}/srt/empty.srt", label: "Upload SRT", kind: "captions"}];
 	$extra_onready.=qq[\$( "li:contains('xyx')" ).remove();];
$extra_js.=<<ENP
jwplayer().on('captionsChanged', function (e){
	if(e.track==0)return;
	if(e.track==e.tracks.length-1)
	{
		showCCform();
		jwplayer().setCurrentCaptions(0);
		jwplayer().pause(true);
	}
} );

function showCCform()
{
var \$dd=	\$("<div />").css({
   position: "absolute",
    width: "100%",
    height: "100%",
    left: 0,
    top: 0,
    zIndex: 1000000,
    background: "rgba(10%, 10%, 10%, 0.4)",
    "text-align": "center"
});
\$("<iframe />").css({
    width: "60%",
    height: "60%",
    zIndex: 1000001,
    "margin-top": "50px"
}).prop({'src':'$c->{site_url}/?op=upload_srt&file_code=$file->{file_code}', 'frameborder':'0', 'scrolling':'no'}).appendTo(\$dd);

 \$dd.click(function (){ \$(this).remove(); jwplayer().play(); });
 \$dd.appendTo( \$('#vplayer') );
}
ENP
;
 }

 if($c->{player_sharing})
 {
    #$ses->{cgi_query}->url_encode
    require URL::Encode;
    #my $embed_code = URL::Encode::url_encode( qq[<IFRAME SRC="$c->{site_url}/embed-$file->{file_code}.html" FRAMEBORDER=0 MARGINWIDTH=0 MARGINHEIGHT=0 SCROLLING=NO allowfullscreen="true" WIDTH=$file->{play_w} HEIGHT=$file->{play_h}></IFRAME>] );
    my $embed_code = URL::Encode::url_encode( $file->{embed_code} );
    $embed_code=~s/\+/ /g;
    $file->{download_link}||=$ses->makeFileLink($file);
    $extra .= qq[,"sharing": {code: "$embed_code", link: "$file->{download_link}"}];
 }

  if($c->{player_lightsout})
  {
     push @plugins, qq["$c->{cdn_url}/player7/lightsout.js":{}];
  }

  $c->{player_overlay_text}=~s/\'/\\'/g;
  push @plugins, qq["$c->{cdn_url}/player7/overlay.js":{text: '$c->{player_overlay_text}', hide:1}] if $c->{player_overlay_text};

 my $plugins_code = ',plugins: {'.join(",\n",@plugins).'}' if @plugins;
 my $tracks_code = ',tracks: ['.join(",\n",@tracks).']';

 #$extra_onready.="jwplayer().resize( \$(window).width(), \$(window).height() );" if $f->{embed};

$extra_js.=qq|jwplayer().onDisplayClick(function() { jwplayer().setFullscreen(true); });| if $ses->isMobile; # autofullscreen on click for mobiles
$extra_js.=qq|jwplayer().addButton(
    "/images/download2.png",
    "Watch on site", 
    function() {
        window.top.location.href = '$file->{download_link}';
    },
    "download11"
);| if $f->{embed} && $c->{player_embed_dl_button};


my $show_box_after_limit=qq[ \$('#play_limit_box').show(); ] if $c->{video_time_limit};
my $time_fadein=$c->{player_ads_fadein}||0;
my $vtime = int $file->{vid_length}*$c->{track_views_percent}/100;
my $x2time = int $vtime/2;

my $stop_code='';
if($c->{video_time_limit})
{
  $stop_code=<<ENS
  window.setTimeout( function (){ 
  	jwplayer().stop(); $show_box_after_limit 
  }, $c->{video_time_limit}*1000 );
ENS
;
}

  # window.setTimeout( function (){ 
  # 	if(x2ok!=0 && jwplayer().getState().toUpperCase()=='PLAYING')
  # 	{ 
  # 		\$.get( '$c->{site_url}/dl?op=view2&file_code=$file->{file_code}&hash=$file->{ophash}&p=jw7&x2='+x2ok, function(data){} ); 
  # 	} 
  # 		}, $vtime*1000 );

my $js_code=<<ENP
var vvplay,vvad,x2ok=0;
jwplayer().onTime(function(x) { 
    if($time_fadein>0 && x.position>=$time_fadein && vvad!=1){vvad=1;\$('div.video_ad_fadein').fadeIn('slow');}
    if(x2ok==0 && x.position>=$x2time && x.position<=($x2time+2)){x2ok=x.position;}
});
jwplayer().onPlay(function(x) { doPlay(x); });
jwplayer().onComplete(function() { \$('div.video_ad').show(); $show_box_after_limit });

function doPlay(x)
{
  \$('div.video_ad').hide();
  if(vvplay)return;
  vvplay=1;
  adb=0;
  if( window.cRAds === undefined ){ adb=1; }
  \$.get('$c->{site_url}/dl?op=view&file_code=$file->{file_code}&hash=$file->{ophash}&embed=$f->{embed}&adb='+adb, function(data) {\$('#fviews').html(data);} );

  	$stop_code
}
    jwplayer().onReady(function(){
    		$extra_onready

            //var mybtn=\$("<div style='padding-left: 5px; margin-right: 5px; margin-top: 10px; background-image: url(/images/ico.png);background-repeat: no-repeat;' class='jw-icon jw-icon-inline jw-button-color jw-reset jw-icon-logo'></div>");
            //mybtn.click(showCCform);
            //\$(".jw-controlbar-right-group").append(mybtn);
    });

$extra_js

ENP
;

 if($file->{preview})
 {
     $plugins_code='';
     $js_code=qq[jwplayer().onComplete(function() { \$('#over_player_msg').show(); });];
     $file->{vid_length}='';
     $file->{preview_message} = $file->{preview_message};
 }

 my @sources;
 if($file->{direct_link_hd} || $file->{direct_link} || $file->{direct_link_lq})
 {
     my $name_n=$c->{vid_resize_n};
     my $name_h=$c->{vid_resize_h};
     my $name_l=$c->{vid_resize_l};
	 $name_n="$1p" if $name_n=~/x(\d+)$/i;
     $name_h="$1p" if $name_h=~/x(\d+)$/i;
     $name_l="$1p" if $name_l=~/x(\d+)$/i;
     push @sources, qq[{file:"$file->{direct_link_hd}",label:"$name_h"}] if $file->{direct_link_hd};
     push @sources, qq[{file:"$file->{direct_link}",label:"$name_n"}];
     push @sources, qq[{file:"$file->{direct_link_lq}",label:"$name_l"}] if $file->{direct_link_lq};
     $extra_html_pre.="<script>localStorage.setItem('jwplayer.qualityLabel', '$name_n');</script>" if $file->{direct_link} && $c->{player_default_quality} eq 'n';
     $extra_html_pre.="<script>localStorage.setItem('jwplayer.qualityLabel', '$name_h');</script>" if $file->{direct_link_hd} && $c->{player_default_quality} eq 'h';
     $extra_html_pre.="<script>localStorage.setItem('jwplayer.qualityLabel', '$name_l');</script>" if $file->{direct_link_lq} && $c->{player_default_quality} eq 'l';
 }
 @sources=() if @sources && $c->{m_r} && $c->{m_r_no_mp4};
 if($file->{dash_direct})
 {
    #@sources=();
    unshift @sources, qq[{file:"$file->{dash_direct}"}];
    $extra.=qq[,dash: true];
 }
 if($file->{hls_direct})
 {
    my @arr;
    for my $q ('h','n','l')
    {
     my $t = $ses->vInfo($file,$q);
     next unless $t;
     #push @arr, qq["$t->{vid_bitrate}":"].{'h'=>'High','n'=>'Normal','l'=>'Low'}->{$q}.'"';
     push @arr, qq["$t->{vid_bitrate}":"$t->{vid_height}p"];
    }
    $extra.=',hlslabels:{'.join(',',@arr).'}';

    unshift @sources, qq[{file:"$file->{hls_direct}"}];
    $extra_html_pre.="<script>localStorage.setItem('jwplayer.qualityLabel', '".$ses->vInfo($file,$c->{player_default_quality})->{vid_height}."p');</script>" if $c->{player_default_quality} && $file->{"hash_$c->{player_default_quality}"};
 }
 my $sources_code = join(',',@sources);

 if($c->{jw7_skin})
 {
    $extra.=qq[,skin: "$c->{jw7_skin}"];
    $extra_html.=qq[<link rel="stylesheet" type="text/css" href="$c->{cdn_url}/player7/skins/$c->{jw7_skin}.css"></link>];
 }

$file->{vid_length} = $c->{video_time_limit} if $c->{video_time_limit};
if($file->{embed})
{
    #$file->{play_w}=$file->{play_h}='100';
    #
}
else
{
	#$extra.=qq[,width: "$file->{play_w}", height: "$file->{play_h}"];
}

$extra.=qq[,title:"$file->{file_title}", displaytitle:true] if $f->{embed} && $file->{usr_embed_title};

$c->{player_about_link}||=$c->{site_url};
$extra.=qq[,abouttext:"$c->{player_about_text}", aboutlink:"$c->{player_about_link}"];

$extra.=qq[,related: {file:"$c->{site_url}/dl?op=related&code=$file->{file_code}", onclick:"link"}] if $c->{player_related};

my $logohide=',hide: true' if $c->{player_logo_hide};
$extra.=qq[,logo: {file:"$c->{player_logo_url}", link:"$c->{player_logo_link}", position:"$c->{player_logo_position}", margin:"$c->{player_logo_padding}"$logohide}] if $c->{player_logo_url};

$extra.=qq[,autostart: true] if $file->{autostart};

$extra.=qq[,cast: {}] if $c->{player_chromecast};

if($file->{p2p} && $file->{hls_direct})
{
	if($c->{p2p_provider} eq 'streamroot')
	{
		$extra.=qq[,p2pConfig:{ streamrootKey: '$c->{streamroot_key}', contentId: '$file->{file_code}', cacheSize: '250', mobileBrowserEnabled: false }];
		$extra_html.='<script src="//cdn.streamroot.io/jw7-hlsjs-provider/stable/jw7-hlsjs-provider.js"></script>';
	}
	elsif($c->{p2p_provider} eq 'peer5')
	{
		 $extra_html_pre.=qq|<script src="//api.peer5.com/peer5.js?id=$c->{p2p_peer5_key}"></script>
 							 <script src="//api.peer5.com/peer5.jwplayer7.plugin.js"></script>
 							 <script>
								peer5.configure({
								  contentIdReplacer: function(url) 
								  {
								   var aa = url.split(/\\//);
								   var hash = aa[4];
								   if (hash === '$file->{hash_n}') {
								      return url.replace(hash,'$file->{file_real}-n'); 
								   } else if ('$file->{hash_h}' && hash === '$file->{hash_h}') {
								      return url.replace(hash,'$file->{file_real}-h'); 
								   } else if ('$file->{hash_l}' && hash === '$file->{hash_l}') {
								      return url.replace(hash,'$file->{file_real}-l');
								   }
								   return url;
								  }
								});
		 				     </script>\n|;

	}
}


$file->{player_img} ||= $file->{video_img_url};

#function jwp(a){return a.replace(/[a-zA-Z]/g, function(c){return String.fromCharCode((c <= "Z" ? 90 : 122) >= (c = c.charCodeAt(0) + 13) ? c : c - 26);})}
#$file->{direct_link} =~ tr/A-Za-z/N-ZA-Mn-za-m/;
#$file->{http_fallback} =~ tr/ab/ba/;
#var xch = {'a':'b','b':'a'}; var ctrans = /[ab]/g; function jvp(a){  return a.replace(ctrans, m => xch[m]); }

#height: "$file->{play_h}",
#aspectratio: "16:9",
#    primary:"flash",
my $code=<<ENP
  jwplayer("vplayer").setup({
    sources: [$sources_code],
    image: "$file->{player_img}",
    width: "100%", 
    height: "100%",
    stretching: "$c->{player_image_stretching}",
    duration: "$file->{vid_length}",
    //aspectratio: "16:9",
    preload: '$c->{mp4_preload}',
    androidhls: "true",
    hlshtml: "true",
    primary: "html5",
    startparam: "start"
    $plugins_code
    $tracks_code
    $extra
  });
$js_code
ENP
;

$extra_html.=qq[<script src="$c->{cdn_url}/js/pop.js"></script>] if $c->{adb_no_money};

	my $html=qq[$extra_html_pre<script type='text/javascript' src='$c->{cdn_url}/player7/jwplayer.js'></script>
                <script type="text/javascript">jwplayer.key="$c->{jw7_key}";</script>
                $extra_html
                <div id='vplayer' style="width:100%;height:100%;text-align:center;"><img src="$file->{player_img}" style="width:100%;height:100%;"></div>];

	return($html,$code);
}

1;
