package Plugins::Player::VideoJS;
use strict;
use XFileConfig;
use vars qw($ses $c);

sub makePlayerCode
{
	my ($self, $f, $file, $c, $player ) = @_;
	return if $player ne 'vjs';

    my ($extra_settings,$extra_html,$extra_js,@tracks,$extra_html_pre,@plugins,$extra_onready,$extra_onplay);

    if($c->{srt_on} && $c->{srt_langs})
	{
	    my @arr = split /\s*\,\s*/, $c->{srt_langs};
	    my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
	    my $dir = "$c->{site_path}/srt/$dx";
	    my $srt_cook = $ses->getCookie("srt_cook");
	    my @list;
	    for(@arr)
	    {
	      push @tracks, qq[<track kind="captions" src="$c->{site_url}/srt/$dx/$file->{file_code}_$_.vtt" srclang="en" label="$_" default>] if -f "$dir/$file->{file_code}_$_.vtt";
	      push @tracks, qq[<track kind="captions" src="$c->{site_url}/srt/$dx/$file->{file_code}_$_\_$srt_cook.vtt" srclang="en" label="My: $_" default>] if -f "$dir/$file->{file_code}_$_\_$srt_cook.vtt";
    	}
    }
    if($c->{srt_allow_anon_upload})
 	{
 		push @tracks, qq[<track kind="captions" src="$c->{site_url}/srt/empty.vtt" srclang="en" label="Upload SRT" id="x182">];
 		$extra_onplay.=qq|\$('.vjs-captions-menu-item:last').click(function() { showCCform(); });|;
 	}

my $show_box_after_limit=qq[ \$('#play_limit_box').show(); ] if $c->{video_time_limit};
my $time_fadein=$c->{player_ads_fadein}||0;
my $vtime = int $file->{vid_length}*$c->{track_views_percent}/100;
my $x2time = int $vtime/2;

my $js_code=<<ENP
var vvplay,vvad;

player.on('play', function(){ doPlay(); });
player.on('ended', function(){ \$('div.video_ad').show(); $show_box_after_limit });
player.on('timeupdate',function() { 
    if($time_fadein>0 && player.currentTime()>=$time_fadein && vvad!=1){vvad=1;\$('div.video_ad_fadein').fadeIn('slow');}
});
function doPlay()
{
  \$('div.video_ad').hide();
  if(vvplay)return;
  vvplay=1;
  adb=0;
  if( window.cRAds === undefined ){ adb=1; }
  \$.get('$c->{site_url}/dl?op=view&file_code=$file->{file_code}&hash=$file->{ophash}&embed=$f->{embed}&adb='+adb, function(data) {\$('#fviews').html(data);} );

  $extra_onplay
}

function showCCform()
{
videojs('vjsplayer').pause();

var \$dd=	\$("<div />").css({
   position: "absolute",
    width: "100%",
    height: "100%",
    left: 0,
    top: 0,
    zIndex: 1000000,
    background: "rgba(10%, 10%, 10%, 0.4)",
    "text-align": "center"
});
\$("<iframe />").css({
    width: "60%",
    height: "60%",
    zIndex: 1000001,
    "margin-top": "50px"
}).prop({'src':'$c->{site_url}/?op=upload_srt&file_code=$file->{file_code}', 'frameborder':'0', 'scrolling':'no'}).appendTo(\$dd);

 \$dd.click(function (){ \$(this).remove(); player.play(); });
 \$dd.appendTo( \$('#vplayer') );
}

$extra_js

ENP
;

if($c->{player_logo_url})
{
	$js_code.="\nplayer.watermark({'image' : '$c->{player_logo_url}'});";
	$extra_html.='<script src="/playerjs/videojs-watermark.js"></script><link rel="stylesheet" href="/playerjs/videojs-watermark.css">';
}

 my (@sources, $sources_code);

	 my ($name_n,$res_n)=("$1",$1) if $c->{vid_resize_n}=~/x(\d+)$/i;
	 my ($name_h,$res_h)=("$1",$1) if $c->{vid_resize_h}=~/x(\d+)$/i;
	 my ($name_l,$res_l)=("$1",$1) if $c->{vid_resize_l}=~/x(\d+)$/i;
     #$name_h="$1p" if $name_h=~/x(\d+)$/i;
     #$name_l="$1p" if $name_l=~/x(\d+)$/i;

     push @sources, qq[{src: "$file->{direct_link_hd}", type: "video/mp4", res: $res_h, label: "$name_h"}] if $file->{direct_link_hd};
     push @sources, qq[{src: "$file->{direct_link}", type: "video/mp4", res: $res_n, label: "$name_n"}];
     push @sources, qq[{src: "$file->{direct_link_lq}", type: "video/mp4", res: $res_l, label: "$name_l"}] if $file->{direct_link_lq};
     $sources_code = 'player.updateSrc(['.join(', ', @sources).']);';
 
 @sources=() if @sources && $c->{m_r} && $c->{m_r_no_mp4};
 if($file->{dash_direct})
 {
    $sources_code = qq|player.src({src: "$file->{dash_direct}", type: "application/dash+xml"});|;
    $extra_html.=qq[<script src="$c->{cdn_url}/playerjs/dash.all.min.js"></script>
    				<script src="$c->{cdn_url}/playerjs/videojs-dash.min.js"></script>];
 }
 if($file->{hls_direct})
 {
    $extra_html.=qq[<script src="$c->{cdn_url}/playerjs/videojs-contrib-hls.min.js"></script>];
    $sources_code = qq[player.updateSrc({src: "$file->{hls_direct}", type: "application/x-mpegURL"}, {hls: true});];
 }

 my $tracks_code = join "\n", @tracks;

 if($file->{p2p} && $file->{hls_direct})
 {
	if($c->{p2p_provider} eq 'streamroot')
	{
		$extra_settings.=qq[,html5: {
            p2pConfig:{streamrootKey: '$c->{streamroot_key}', contentId: '$file->{file_code}'},
            hlsjsConfig: {}
        }];
		$extra_html.='<script src="//cdn.streamroot.io/videojs5-hlsjs-source-handler/stable/videojs5-hlsjs-source-handler.js"></script>';
	}
	elsif($c->{p2p_provider} eq 'peer5')
	{
		 $extra_html_pre.=qq|<script src="//api.peer5.com/peer5.js?id=$c->{p2p_peer5_key}"></script>
 				     <script src="//api.peer5.com/peer5.videojs5.plugin.js"></script>
 				     <script>
						peer5.configure({
						  contentIdReplacer: function(url) 
						  {
						   var aa = url.split(/\\//);
						   var hash = aa[4];
						   if (hash === '$file->{hash_n}') {
						      return url.replace(hash,'$file->{file_real}-n'); 
						   } else if ('$file->{hash_h}' && hash === '$file->{hash_h}') {
						      return url.replace(hash,'$file->{file_real}-h'); 
						   } else if ('$file->{hash_l}' && hash === '$file->{hash_l}') {
						      return url.replace(hash,'$file->{file_real}-l');
						   }
						   return url;
						  }
						});
 				     </script>\n|;
	}
 }


$file->{vid_length} = $c->{video_time_limit} if $c->{video_time_limit};
if($file->{embed})
{
    #$file->{play_w}=$file->{play_h}='100%';
    #$extra.=",stretching:'fill'";
}
else
{
	#$extra.=qq[,width: "$file->{play_w}", height: "$file->{play_h}"];
}

$file->{player_img} ||= $file->{video_img_url};


if($c->{m_z} && $c->{time_slider})
{
	$extra_html.=qq[<link  href="$c->{cdn_url}/playerjs/videojs.thumbnails.css" rel="stylesheet">
    				<script src="$c->{cdn_url}/playerjs/videojs.thumbnails.js" type="text/javascript"></script>];
	push @plugins, qq[thumbnails:{ vtt:'$c->{site_url}/dl?op=get_slides&length=$file->{vid_length}&url=$file->{file_real}0000.jpg', basePath : "$file->{video_img_folder}/" }];
}
#push @plugins, qq[videoJsResolutionSwitcher: {default: 'high', dynamicLabel: true }];
my $plugins_code = join ',', @plugins;
my $autoplay = $file->{autostart} ? 'autoplay' : '';

my $code=<<ENP
ENP
;
$extra_html.=qq[<script src="$c->{cdn_url}/js/pop.js"></script>] if $c->{adb_no_money};
#<script type="text/javascript" src="$c->{cdn_url}/playerjs/videojs.watermark.js"></script>
#<link href="/VideoJS/videojs.watermark.css" rel="stylesheet">

my $html=qq[$extra_html_pre<link href="$c->{cdn_url}/playerjs/video-js.min.css" rel="stylesheet">
			<link href="$c->{cdn_url}/playerjs/videojs-resolution-switcher.css" rel="stylesheet">
                
                <div id='vplayer' style="width:100%;height:100%;text-align:center;">
                
                
                <video id="vjsplayer"
				    class="video-js vjs-default-skin vjs-big-play-centered"
				    width="$file->{play_w}" height="$file->{play_h}"
				    controls="true"
				    preload="$c->{mp4_preload}"
				    poster="$file->{player_img}">
				    $tracks_code
				    $autoplay
				</video></div>

<script src="$c->{cdn_url}/playerjs/video.min.js"></script>
<script type="text/javascript" src="$c->{cdn_url}/playerjs/videojs-resolution-switcher.js"></script>

$extra_html

<script>
var player = videojs('vjsplayer',{
								//"fluid": true,
								plugins:{
										 $plugins_code
										}
								$extra_settings
								});

player.ready(function() {
	$sources_code
	$extra_onready
});

$js_code

videojs('vjsplayer').videoJsResolutionSwitcher({dynamicLabel: true, default: 'low'});
</script>

<style>
.video-js {
	width:100%;
	height:100%;
}
.vjs-texttrack-settings {
  display: none;
}
</style>
];
       
#$file->{img_timeslide_url}
#window.HELP_IMPROVE_VIDEOJS = false;
	return($html,$code);
}

1;
