#!/usr/bin/perl
use strict;
use lib '.';
use XFileConfig;
use CGI::Simple;
$CGI::Simple::POST_MAX=-1;
use DataBase;
use JSON;

use CGI::Carp qw(fatalsToBrowser);

die"111" unless $ENV{REQUEST_METHOD} eq 'POST';

my $q = new CGI::Simple;
my $f;
$f->{$_}=$q->param($_) for $q->param;

my $REMOTE_ADDR = &getIP;

if($f->{op} eq 'test')
{
   print"Content-type:text/html\n\nOK:".$REMOTE_ADDR;
   exit;
}

unless($f->{op}=~/torrent/i)
{
  die"222($ENV{HTTP_USER_AGENT})" unless $ENV{HTTP_USER_AGENT} eq $c->{user_agent};
  die"333" unless $f->{dl_key} eq $c->{dl_key};
}


my $db = DataBase->new();

die"badip:$REMOTE_ADDR" if $c->{file_server_ip_check} && !($db->SelectOneCached("SELECT host_id FROM Hosts WHERE host_ip=?",$REMOTE_ADDR) || $REMOTE_ADDR eq '127.0.0.1');

&Stats if $f->{op} eq 'stats';

##################

$f->{usr_id} = $db->SelectOne("SELECT usr_id
                               FROM Sessions
                               WHERE session_id=?",$f->{sess_id}) if $f->{sess_id} && !$f->{usr_id};

if($f->{sid})
{
   my $tt = $db->SelectRow("SELECT * FROM Torrents WHERE sid=?",$f->{sid});
   if($tt)
   {
	   $f->{usr_id} = $tt->{usr_id};
	   $f->{file_public} = $tt->{file_public};
	   $f->{cat_id} = $tt->{cat_id};
	   for(split(/\n/,$tt->{extras}))
	   {
	     /^(.+?)=(.*)$/;
	     $f->{$1} = $2;
	   }
	   $db->Exec("UPDATE Torrents SET status='DONE' WHERE sid=?",$tt->{sid});
   }
}

my $user = $db->SelectRow("SELECT *, UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec
                           FROM Users u 
                           WHERE u.usr_id=?",$f->{usr_id}) if $f->{usr_id};

$user = $db->SelectRow("SELECT *, UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec
                        FROM Users u 
                        WHERE u.usr_login=?",$f->{usr_login}) if !$user && $f->{usr_login};

$user ||= $db->SelectRow("SELECT u.*, UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec
                        FROM Streams s, Users u 
                        WHERE s.stream_code=?
                        AND s.usr_id=u.usr_id",$f->{name}) if !$user && $f->{app} && $f->{name}; # Stream

if(!$user && $f->{api_key})
{
  my ($uid,$api_key) = $f->{api_key}=~/^(\d+)(\w{16})$/;
  $user = $db->SelectRow("SELECT *, UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec 
			FROM Users 
			WHERE usr_id=? 
			AND usr_api_key=?",$uid,$api_key);
}

my $utype = $user ? ($user->{exp_sec}>0 ? 'prem' : 'reg') : 'anon';
$c->{$_}=$c->{"$_\_$utype"} for qw(disk_space max_upload_filesize max_rs_leech torrent_dl_slots upload_enabled);


my $sub={
         check_codes    => \&CheckCodes,

         del_torrent    => \&TorrentDel,
         add_torrent    => \&TorrentAdd,
         torrent_stats  => \&TorrentStats,
         torrent_done   => \&TorrentDone,

         queue_enc_done => \&QueueEncDone,
         queue_transfer_done  => \&QueueTransferDone,
         queue_url_done   => \&QueueURLDone,

         enc_error        => \&EncError,
         upload_error     => \&UploadError,
         transfer_error   => \&TransferError,
         
         delete_file_db   => \&DeleteFileDB,
         atop             => \&ATop,
         next_ftp_server  => \&NextFTPServer,
         update_file_data => \&UpdateFileData,

         streams			=> \&Streams,
	     }->{ $f->{op} };
if($sub)
{
   &$sub;
}
else
{
   &SaveFile if $f->{file_name};
}

sub CheckCodes
{
   my @codes = split(/\,/,$f->{codes});
   print("Content-type:text/html\n\nOK:"),exit unless @codes;
   my @codes2 = grep{/^\w{12}$/} map{/^(\w{12}})_/;$1} @codes;
   #my $ok = $db->SelectARef("SELECT file_real FROM Files WHERE file_real IN (".join(',', map{"'$_'"}@codes2 ).")");
   my $ok=[];
   if($f->{host_id}=~/^\d+$/)
   {
	$ok = $db->SelectARef("SELECT file_real 
							FROM Files f, Servers s 
							WHERE f.file_real IN (".join(',', map{"'$_'"}@codes2 ).") 
							AND f.srv_id=s.srv_id
							AND s.host_id=$f->{host_id}");
   }
   else
   {
	$ok = $db->SelectARef("SELECT file_real 
							FROM Files 
							WHERE file_real IN (".join(',', map{"'$_'"}@codes2 ).")");
   }
   my %h;
   $h{$_->{file_real}}=1 for @$ok;
   my @bad;
   for my $cc (@codes)
   {
      my ($x) = $cc=~/^(\w+)_/;
      push @bad,$cc unless $h{$x};
   }
   sendBack( "OK:".join(',',@bad) );
}

sub TorrentDel
{
   $db->Exec("DELETE FROM Torrents WHERE sid=?",$f->{sid});
   sendBack("OK");
}

sub TorrentAdd
{
   sendBack("ERROR:This torrent already working") if $db->SelectOne("SELECT sid FROM Torrents WHERE sid=? AND status='WORKING'",$f->{sid});
   sendBack("ERROR:This type of users is not allowed to upload torrents") unless $c->{torrent_dl_slots};
   sendBack("ERROR:You're already using $c->{torrent_dl_slots} torrent slots") 
      if $c->{torrent_dl_slots} && $db->SelectOne("SELECT COUNT(*) FROM Torrents WHERE usr_id=? AND status='WORKING'",$user->{usr_id})>=$c->{torrent_dl_slots};
   my $server = $db->SelectRow("SELECT * FROM Servers WHERE srv_id=? AND disk_id=?", $f->{srv_id}, $f->{disk_id} );
   $f->{total_size}=~s/\D+//g;
   $db->Exec("INSERT INTO Torrents 
              SET sid=?, 
                  usr_id=?, 
                  srv_id=?, 
                  files=?, 
                  progress='0:$f->{total_size}:0:0:0:0',
                  extras=?,
                  created=NOW()",
              $f->{sid}, $user->{usr_id}, $f->{srv_id}, $f->{files}, $f->{extras}||''
            );
   sendBack("OK");
}

sub TorrentStats
{
   my $torrents = JSON::decode_json($f->{data});
   for(@$torrents)
   {
      $_->{download_rate} = int $_->{download_rate}/1024;
      $_->{upload_rate} = int $_->{upload_rate}/1024;
      $db->Exec("UPDATE Torrents SET progress=?, name=?, files=? WHERE sid=? AND status='WORKING'",
         "$_->{total_done}:$_->{total_wanted}:$_->{download_rate}:$_->{upload_rate}",
         $_->{name}||'',
         JSON::encode_json($_->{files}||[]),
         $_->{info_hash});
   }
   print"Content-type:text/html\n\nOK";
}

sub TorrentDone
{
   sendBack("No sid") if !$f->{sid};
   my $torrent = $db->SelectRow("SELECT * FROM Torrents WHERE sid=?", $f->{sid});
   $torrent = { usr_id => 1 };
   sendBack("No torrent") if !$torrent;

   my $server = $db->SelectRow("SELECT * FROM Servers WHERE host_id=? AND srv_torrent=1 ORDER BY RAND() LIMIT 1", $f->{fs_key} );

   my $res = api2($server->{srv_id},
   {
      op => 'torrent_done',
      sid => $f->{sid},
      usr_id => $torrent->{usr_id},
      disk_id => $server->{disk_id},
   });
   print STDERR "Server return: $res\n";

   $db->Exec("DELETE FROM Torrents WHERE sid=?",$f->{sid});

   sendBack('OK');
}

sub api2
{
   my ($srv_id,$data) = @_;
   my $srv = $db->SelectRowCached("SELECT * FROM Servers WHERE srv_id=?",$srv_id);
   require LWP::UserAgent;
   my $ua = LWP::UserAgent->new(agent => $c->{user_agent}, timeout => 900);
   return $ua->post("$srv->{srv_cgi_url}/api.cgi", {
                                                      dl_key => $c->{dl_key},
                                                      disk_id => $srv->{disk_id},
                                                      %{$data},
                                                   })->content;
}

sub saveFileError
{
    my ($msg) = @_;
    sendBack("0:0:0:$msg");
}

sub SaveFile
{
   my $server = $db->SelectRow("SELECT * FROM Servers WHERE host_id=? AND disk_id=?", $f->{host_id}, $f->{disk_id} ) if $f->{host_id} && $f->{disk_id};
   $server ||= $db->SelectRow("SELECT * FROM Servers WHERE host_id=? AND srv_status='ON' AND srv_disk <= srv_disk_max ORDER BY RAND() LIMIT 1",$f->{host_id});
   saveFileError("server/disk not found for $f->{host_id} / $f->{disk_id}") unless $server;
   $f->{disk_id}||=$server->{disk_id};

   my $size  = $f->{file_size}||0;
   my $filename = $f->{file_name};
   my $descr = $f->{file_descr}||'';
   my $md5 = $f->{file_md5}||'';

   if($f->{'retry'})
   {
      my $ff = $db->SelectRow("SELECT * FROM Files WHERE file_size=? AND file_md5=? AND file_created>NOW()-INTERVAL 3 MINUTE ORDER BY file_id LIMIT 1",$size,$md5);
      sendBack("$ff->{file_id}:$ff->{file_code}:$ff->{file_real}:$utype:OK\nscreenlist=$ff->{file_screenlist}") if $ff;
   }
   
   
   unless($f->{no_limits})
   {
      if( $c->{video_extensions} && $filename!~/\.($c->{video_extensions})$/i )
      {
         saveFileError("unallowed extension");
      }

      $c->{max_upload_filesize}=0 if $user && $user->{usr_adm};
      if( $c->{max_upload_filesize} && $size>$c->{max_upload_filesize}*1024*1024 )
      {
         saveFileError("file is too big");
      }

      my $disk_space_max = $user->{usr_disk_space} || $c->{disk_space};
      #$c->{disk_space}=0 if $user && $user->{usr_adm};
      if($disk_space_max)
      {
         #$user->{total_size} = $db->SelectOneCached(60*30,"SELECT SUM(file_size_o+file_size_n+file_size_h+file_size_l+file_size_p) FROM Files WHERE usr_id=? AND file_code=file_real",$user->{usr_id});
         if($user->{usr_disk_used}+$size/1024 > $disk_space_max*1024**2)
         {
            saveFileError("not enough disk space on your account");
         }
      }
   }
   
   if($f->{upload_mode} eq 'url' && $f->{url_id})
   {
      my $uu = $db->SelectRow("SELECT * FROM QueueUpload WHERE id=?",$f->{url_id});
      for(split(/\n/,$uu->{extras}))
      {
          /^(.+?)=(.*)$/;
          $f->{$1} = $2;
      }
      $f->{file_code} = $uu->{file_code} if $uu->{file_code};
      $f->{fld_id} = $uu->{fld_id} if $uu->{fld_id};
   }
   
   $filename=~s/%(\d\d)/chr(hex($1))/egs;
   $filename=~s/%/_/gs;
   $filename=~s/\s{2,}/ /gs;
   $filename=~s/[\#\"\0]+/_/gs;
   $filename=~s/[^\w\d\.-]+/_/g if $c->{sanitize_filename};
   $filename=~s/$c->{fnames_not_allowed}//gi if $c->{fnames_not_allowed};
   
   $descr=~s/</&lt;/gs;
   $descr=~s/>/&gt;/gs;
   $descr=~s/"/&quot;/gs;
   $descr=~s/\(/&#40;/gs;
   $descr=~s/\)/&#41;/gs;

   $f->{file_title}||=$filename;
   $f->{file_title}=~s/\.($c->{video_extensions})$//i;
   $f->{file_title}=~s/_+/ /g;
   $f->{file_title}=~s/\.+/ /g;
   $f->{file_title}=~s/\s+(x264|h264|divx|xvid)\s+/ /i;
   $f->{file_title}=~s/[\<\>\#\"\0]+/ /gs;
   $f->{file_title}=~s/$c->{fnames_not_allowed}//gi if $c->{fnames_not_allowed};
   $f->{file_title}=~s/[^\w\d\.\_\-]+/_/g if $c->{sanitize_filename};
   $f->{file_title}=~s/\s+$//g;
   $f->{file_title}=~s/^\s+//g;

   $filename=~s/\.(\w+)$/"$c->{add_filename_postfix}\.$1"/e if $c->{add_filename_postfix};

   my $usr_id = $user ? $user->{usr_id} : 0;
   $usr_id||=0;
   if($c->{uploads_selected_only})
   {
       saveFileError("You are not allowed to upload files") unless $user->{usr_uploads_on};
   }
   else
   {
       saveFileError("You are not allowed to upload files") unless $c->{upload_enabled};
   }
   if($f->{fld_name} && $usr_id)
   {
      $f->{fld_id}=0;
      for my $fld ( split(/\//,$f->{fld_name}) )
      {
        $fld=~s/\.($c->{video_extensions})$//i;
        my $fld_id = $db->SelectOne("SELECT fld_id FROM Folders WHERE usr_id=? AND fld_parent_id=? AND fld_name=?",$usr_id,$f->{fld_id},$fld);
        unless($fld_id)
        {
          my $fcode = &randchar(10);
          while($db->SelectOne("SELECT fld_id FROM Folders WHERE fld_code=?",$fcode)){$fcode = &randchar(10);}
          $db->Exec("INSERT INTO Folders SET usr_id=?, fld_parent_id=?, fld_name=?, fld_code=?",$usr_id,$f->{fld_id}||0,$fld,$fcode);
          $fld_id = $db->getLastInsertId;
        }
        $f->{fld_id}=$fld_id;
      }
   }
   
   my $code = $f->{file_code} || randchar(12);
   while($db->SelectOne("SELECT file_id FROM Files WHERE file_code=? OR file_real=?",$code,$code)){$code = randchar(12);}
   my $del_id = &randchar(10);
   
   # if($db->SelectOne("SELECT id FROM Reports WHERE ban_size=? AND ban_md5=? LIMIT 1",$size,$md5))
   # {
   #    print"Content-type:text/html\n\n";
   #    print"0:0:0:this file is banned by administrator";
   #    exit;
   # }
   
   my $ex = $db->SelectRow("SELECT * FROM Files WHERE file_size=? AND file_md5=? AND (file_size_l>0 OR file_size_n>0 OR file_size_h>0) ORDER BY file_id LIMIT 1",$size,$md5)
            if $c->{anti_dupe_system};
   #my $size_o = $size;
   my ($real,$real_id);
   if($ex)
   {
       $real = $ex->{file_real};
       $real_id = $ex->{file_real_id} || $ex->{file_id};
       $size=$ex->{file_size_o};
       $server->{srv_id} = $ex->{srv_id};
   }

   $real ||= $code;
   $f->{file_category}=0 unless $c->{categories}->{$f->{file_category}};

   if($c->{approve_required})
   {
      $f->{file_status}='PENDING';
      $f->{file_status}='OK' if $c->{approve_required_first} && $db->SelectOne("SELECT COUNT(*) FROM Files WHERE usr_id=? AND file_status='OK'",$usr_id)>=$c->{approve_required_first};
      $f->{file_status}='OK' if $c->{approve_required} && $db->SelectOne("SELECT value FROM UserData WHERE usr_id=? AND name='usr_autoapprove'",$usr_id);
   }
   $f->{file_status}||='OK';
   my $screenlist=1 if $c->{m_x} && !($c->{m_x_prem_only} && $utype ne 'prem');

   my $file_premium_only = $user->{usr_premium_only} && $db->SelectOne("SELECT value FROM UserData WHERE usr_id=? AND name='files_auto_po'",$usr_id) ? 1 : 0;
   #$f->{file_public}=0 if $user->{usr_private};

   $f->{file_ip} = inet_ntoa( ipv6to4( ipv6_aton($f->{file_ip}) ) ) if $f->{file_ip}=~/:/;
   
   $db->Exec("INSERT INTO Files 
              SET file_name=?, 
                  usr_id=?, 
                  srv_id=?,
                  file_title=?, 
                  file_descr=?, 
                  file_fld_id=?, 
                  file_public=?, 
                  file_code=?, 
                  file_real=?, 
                  file_real_id=?, 
                  file_size=?,
                  file_size_o=?,
                  file_size_n=?, 
                  file_size_h=?,
                  file_size_l=?,
                  file_size_p=?,
                  file_ip=INET_ATON(?), 
                  file_md5=?, 
                  file_spec_txt=?,
                  file_spec_o=?,
                  file_spec_n=?,
                  file_spec_h=?,
                  file_spec_l=?,
                  file_spec_p=?,
                  file_length=?,
                  cat_id=?,
                  file_status=?,
                  file_src=?,
                  file_screenlist=?,
                  file_premium_only=?, 
                  file_adult=?,
                  file_created=NOW(), 
                  file_last_download=NOW()",
               $filename,
               $usr_id,
               $server->{srv_id},
               $f->{file_title},
               $descr,
               $f->{fld_id}||0,
               $f->{file_public}||0,
               $code,
               $real,
               $real_id||0,
               $size,
               $ex->{file_size_o}||$size,
               $ex->{file_size_n}||0,
               $ex->{file_size_h}||0,
               $ex->{file_size_l}||0,
               $ex->{file_size_p}||0,
               $f->{file_ip}||'1.1.1.1',
               $md5,
               $ex->{file_spec_txt}||$f->{file_spec_txt}||'',
               $ex->{file_spec_o}||$f->{file_spec}||'',
               $ex->{file_spec_n}||$f->{file_spec_n}||'',
               $ex->{file_spec_h}||$f->{file_spec_h}||'',
               $ex->{file_spec_l}||$f->{file_spec_l}||'',
               $ex->{file_spec_p}||$f->{file_spec_p}||'',
               $f->{file_length}||0,
               $f->{cat_id}||0,
               $f->{file_status},
               $f->{file_src},
               $screenlist||0,
               $file_premium_only,
               $f->{file_adult}||0,
             );
   
   my $file_id = $db->getLastInsertId;
   $db->Exec("UPDATE Files SET file_real_id=? WHERE file_id=?",$file_id,$file_id) unless $real_id;

   $db->Exec("UPDATE Users SET usr_disk_used=usr_disk_used+? WHERE usr_id=?", int($size/1024), $usr_id ) unless $real_id;

   $size=0 unless $code eq $real;

   if($f->{file_title}=~/^(.+?)[\s\-\_]+S\d\d?E\d\d?/i)
   {
     $f->{tags}.=",$1";
   }
   require XUtils;
   XUtils::addTagsToFile( $db, $f->{tags}, $file_id );

   XUtils::addExtraFileData( $db, $f, $file_id ) if $c->{file_data_fields};

   if($c->{srt_on} && $c->{srt_auto} && $f->{data_srt})
   {
      my $lng_hash;
      $lng_hash->{$1}=$2 while $c->{srt_auto_langs}=~/(\w+)=(\w+)/g;
      for(split(/\^\^\^/,$f->{data_srt}))
      {
          my ($lng,$data) = split(/\|\|\|/,$_);
          $lng = lc $lng;
          next unless $lng_hash->{$lng};
          $data=~s/[\s\n\r]$//gis;
          $data=~s/ size="\d+"//gis;
          $data=~s/ face="\w+"//gis;

          my $dx = sprintf("%05d",$file_id/$c->{files_per_folder});
          my $dir = "$c->{site_path}/srt/$dx";
          mkdir($dir,0777) unless -d $dir;

          next if  -e "$dir/$code\_$lng_hash->{$lng}.vtt";
          open FILE, ">$dir/$code\_$lng_hash->{$lng}.vtt";
          print FILE $data;
          close FILE;
      }
   }

   my $edata; # extra data for XUpload.pm
   if($code eq $real)
   {
     my $no_encoding;
     my $prem = $utype eq 'prem' ? 1 : 0;
     my $file = {file_real_id => $real_id||$file_id, 
                 file_real    => $real||$code,
                 file_id      => $file_id, 
                 srv_id       => $server->{srv_id},
                 srv_type     => $server->{srv_type},
                 file_spec    => $f->{file_spec},
                 file_spec_o  => $f->{file_spec},
                 file_name    => $filename,
                 usr_id       => $usr_id,
                };
     # if( ($c->{no_reencoding_mp4} && $filename=~/\.mp4$/i && $f->{file_spec}=~/h264/i) || ($c->{no_reencoding_flv} && $filename=~/\.flv$/i) )
     # {
     #    $no_encoding = 1;
     #    my $sym_orig = ", file_original=0, file_size_o=0" unless $c->{vid_keep_orig};
     #    $db->Exec("UPDATE Files 
     #                SET file_size_n=$size, 
     #                    file_spec_n=file_spec_o
     #                    $sym_orig
     #                WHERE file_id=?", $file_id );
     #    $edata->{newmode}='n';
     #    $edata->{symorig}=1 if $c->{vid_keep_orig};
     # }

     #$no_encoding=1 if $server->{srv_type} eq 'UPLOADER'  && !$server->{srv_encode};

     if($no_encoding) # mp4/flv file already
     {
        if($server->{srv_type} eq 'UPLOADER')
        {
            my $srv_id2 = findServerToTransfer($prem);

            $db->Exec("INSERT IGNORE INTO QueueTransfer
                       SET file_real_id=?, 
                           file_real=?, 
                           file_id=?,
                           premium=?, 
                           srv_id1=?,
                           srv_id2=?,
                           created=NOW()", 
                           $file->{file_real_id}, 
                           $file->{file_real}, 
                           $file->{file_id}, 
                           $prem, 
                           $file->{srv_id},
                           $srv_id2
                     ) if $srv_id2;
        }
        else
        {
            # file is on STORAGE already
        }
     }
     else
     {
         if($server->{srv_encode})
         {
             # Encode first if any Encoding server
             AddEncodeQueue( $file, $utype );
         }
         elsif($server->{srv_type} eq 'UPLOADER' || $server->{srv_type} eq 'STORAGE')
         {
            # Transfer to encoding server
            my $srv_id2 = findServerEncoder();

            $db->Exec("INSERT IGNORE INTO QueueTransfer
                       SET file_real_id=?, 
                           file_real=?, 
                           file_id=?,
                           premium=?, 
                           srv_id1=?,
                           srv_id2=?,
                           created=NOW()", $file->{file_real_id}, 
                                           $file->{file_real}, 
                                           $file->{file_id}, 
                                           $prem, 
                                           $file->{srv_id},
                                           $srv_id2
                                            ) if $srv_id2;
         }
         else
         {
             ### Seems this is STORAGE with no Encoding
             ### Just leave the original there then
         }
     }
     
   }

   $db->Exec("UPDATE LOW_PRIORITY Servers 
              SET srv_files=srv_files+1, 
                  srv_disk=srv_disk+?, 
                  srv_last_upload=NOW() 
              WHERE srv_id=?", $size, $server->{srv_id} );
   
   $db->Exec("INSERT INTO Stats SET day=CURDATE(), uploads=1 ON DUPLICATE KEY UPDATE uploads=uploads+1");

   $size = sprintf("%.0f",$size/1024**2);
   $db->Exec("INSERT INTO Stats2
              SET usr_id=?, day=CURDATE(),
                  uploads=1, uploads_mb=?
              ON DUPLICATE KEY UPDATE
                  uploads=uploads+1, uploads_mb=uploads_mb+?
             ",$usr_id,$size,$size);

   
   $edata->{screenlist}=1 if $screenlist;
   $edata->{disk_id}=$f->{disk_id};
   my $extra_data = join "\n", map{"$_=$edata->{$_}"} sort keys %$edata;

   sendBack("$file_id:$code:$real:$utype:OK\n$extra_data");
}

sub findServerToTransfer
{
    my ($prem) = @_;
    my $filter_prem = $prem ? "AND srv_allow_premium=1" : "AND srv_allow_regular=1";
    my $filter_load = $c->{overload_no_transfer} ? "AND host_out <= host_net_speed*0.9" : "";
    my $srv_id2 = $db->SelectOne("SELECT s.srv_id 
                                  FROM Servers s, Hosts h
                                  WHERE srv_type='STORAGE'
                                  AND srv_status<>'OFF'
                                  AND srv_status<>'READONLY'
                                  AND srv_status<>'READONLY2'
                                  AND srv_name NOT LIKE '%cold%'
                                  AND srv_disk<srv_disk_max*0.95
                                  AND s.host_id=h.host_id
                                  $filter_prem
                                  $filter_load
                                  ORDER BY RAND()
                                  LIMIT 1");
    return $srv_id2;
}

sub findServerEncoder
{
   # try to find ENCODER
   my $srv_ids2 = $db->SelectARef("SELECT srv_id 
                                 FROM Servers 
                                 WHERE srv_type='ENCODER'
                                 AND srv_status<>'OFF'
                                 AND srv_status<>'READONLY2'
                                 AND srv_disk<srv_disk_max*0.95
                                 ORDER BY RAND()
                                 ");

   # try to find STORAGE with encoding
   if($#$srv_ids2==-1)
   {
      $srv_ids2 = $db->SelectARef("SELECT srv_id 
                                 FROM Servers 
                                 WHERE srv_type='STORAGE'
                                 AND srv_encode=1
                                 AND srv_status<>'OFF'
                                 AND srv_status<>'READONLY2'
                                 AND srv_disk<srv_disk_max*0.96
                                 ORDER BY RAND()
                                 ");
   }

   # maybe just STORAGE?
   if($#$srv_ids2==-1)
   {
      $srv_ids2 = $db->SelectARef("SELECT srv_id 
                                 FROM Servers 
                                 WHERE srv_type='STORAGE'
                                 AND srv_encode=1
                                 AND srv_status<>'OFF'
                                 AND srv_status<>'READONLY2'
                                 AND srv_disk<srv_disk_max*0.96
                                 ORDER BY RAND()
                                 ");
   }

   return 0 if $#$srv_ids2==-1;
   my $ids = join ',', map{$_->{srv_id}} @$srv_ids2;

   # Current encode jobs
   my $idi2 = $db->SelectARef("SELECT q.srv_id, SUM(f.file_length * ABS(100-q.progress)/100 * (CASE quality  WHEN 'n' THEN 1  WHEN 'h' THEN 2  WHEN 'l' THEN 0.5  WHEN 'p' THEN 0.3  END)) as ss
                               FROM QueueEncoding q, Files f
                               WHERE q.srv_id IN ($ids)
                               AND q.file_id = f.file_id
                               AND q.error=''
                               GROUP BY srv_id
                               ORDER BY ss
                              ");
   # Current transfer jobs
   my $idt2 = $db->SelectARef("SELECT q.srv_id2, SUM(f.file_length) as ss
                               FROM QueueTransfer q, Files f
                               WHERE q.srv_id2 IN ($ids)
                               AND q.file_id = f.file_id
                               AND q.status='PENDING'
                               GROUP BY srv_id2
                               ORDER BY ss
                              ");
   my $ht;
   $ht->{$_->{srv_id2}} = $_->{ss} for @$idt2;

   my $hh;
   $hh->{$_->{srv_id}} = $_->{ss} for @$idi2;

   for(@$srv_ids2)
   {
      $_->{ss} = $hh->{$_->{srv_id}} + $ht->{$_->{srv_id}};
   }

   # Choose server with minimal encode/transfer jobs
   my @idsort = sort{$a->{ss} <=> $b->{ss}} @$srv_ids2;

   return $idsort[0]->{srv_id};
}

sub AddEncodeQueue
{
    #my ($file_real_id, $file_real, $file_id, $srv_id, $utype) = @_;
    my ($file, $utype) = @_;

    my ($file_real_id, $file_real, $file_id, $srv_id) = ($file->{file_real_id},$file->{file_real},$file->{file_id},$file->{srv_id});

    #getVideoInfo($file);
    #if($f->{file_spec}=~/h264/i)
    require XUtils;
    my $vi = XUtils::vInfo($file,'o'); # vid_bitrate vid_audio_bitrate vid_codec vid_audio_codec
    
    # Priority transcoding jobs
    my ($prem_n,$prem_h, $extra_n,$extra_h);
    my $audio_codec_pass=1 if $vi->{vid_audio_codec} eq 'AAC';
    my $video_codec_pass=1 if $vi->{vid_codec} eq 'H264';
    return if $file->{usr_id} && $video_codec_pass && $audio_codec_pass && $db->SelectOne("SELECT value FROM UserData WHERE usr_id=? AND name='usr_no_encoding'",$file->{usr_id});
    if( $c->{vid_transcode_max_bitrate_n} && $video_codec_pass && $vi->{vid_bitrate}<=$c->{vid_transcode_max_bitrate_n} && $vi->{vid_bitrate})
    {
        $prem_n = 4;
        $extra_n='transcode_video=1';
        $extra_n.='|transcode_audio=1' if $c->{vid_transcode_max_abitrate_n} && $audio_codec_pass && $vi->{vid_audio_bitrate}<=$c->{vid_transcode_max_abitrate_n};
    }
    if( $c->{vid_transcode_max_bitrate_h} && $video_codec_pass && $vi->{vid_bitrate}<=$c->{vid_transcode_max_bitrate_h} && $vi->{vid_bitrate})
    {
        $prem_h = 4;
        $extra_h='transcode_video=1';
        $extra_h.='|transcode_audio=1' if $c->{vid_transcode_max_abitrate_h} && $audio_codec_pass && $vi->{vid_audio_bitrate}<=$c->{vid_transcode_max_abitrate_h};
    }

    my $prem = $utype eq 'prem' && $c->{enc_queue_premium_priority} ? 1 : 0;
    $prem++ if $c->{enc_queue_notmp4_priority} && $file->{file_name}!~/\.mp4$/i;

    if($c->{m_p} && $c->{m_p_parts})
    {
        # preview encoding
        addEncodeQueueDB($file, $prem, 'p');
    }

    unless($c->{m_h}) # no HD mod
    {
        # regular encoding
        addEncodeQueueDB($file, $prem_n||$prem, 'n', $extra_n) if $c->{"vid_enc_n_$utype"};
    }
    else
    {
        # Normal / High  / Low quality mod
        if($c->{"vid_enc_n_$utype"})
        {
            # Always encode N
            #my $vsize = $c->{vid_resize_side_n} eq 'width' ? $vi->{vid_width} : $vi->{vid_height};
            # if $vsize>=$c->{vid_resize_n};
            addEncodeQueueDB($file, $prem_n||$prem, 'n', $extra_n);
        }
        if($c->{"vid_enc_h_$utype"} && $c->{m_h_hd} && !($prem_n && $prem_h))
        {
            #my $vsize = $c->{vid_resize_side_h} eq 'width' ? $vi->{vid_width} : $vi->{vid_height};
            my ($wh,$hh) = $c->{vid_resize_h}=~/^(\d*)x(\d*)$/;
            my ($wn,$hn) = $c->{vid_resize_n}=~/^(\d*)x(\d*)$/;
            addEncodeQueueDB($file, $prem_h||$prem, 'h', $extra_h) 
                if (($wh && $vi->{vid_width}>=$wh) || ($hh && $vi->{vid_height}>=$hh)) || 
                   (($wn && $vi->{vid_width}>=$wn*1.2) || ($hn && $vi->{vid_height}>=$hn*1.2));
        }
        if($c->{"vid_enc_l_$utype"} && $c->{m_h_lq})
        {
            addEncodeQueueDB($file, $prem, 'l');
        }
    }
}

sub addEncodeQueueDB
{
    my ($file, $premium, $quality, $extra) = @_;
#$file_real_id, $file_real, $file_id, $srv_id
    $extra = "$extra|$f->{effects}" if $f->{effects};

    $db->Exec("INSERT IGNORE INTO QueueEncoding
               SET file_real_id=?, 
                   file_real=?, 
                   file_id=?,
                   srv_id=?,
                   usr_id=?,
                   premium=?, 
                   quality=?,
                   extra=?,
                   created=NOW()", 
               $file->{file_real_id},
               $file->{file_real},
               $file->{file_id},
               $file->{srv_id},
               $file->{usr_id}||0,
               $premium,
               $quality,
               $extra,
             );
}

sub Stats22
{
   $|++;
   print"Content-type:text/html\n\n";
   my ($bandwidth_sum,$iphash,$filehash);
   my $list = $db->SelectARefCached("SELECT DISTINCT host_ip FROM Hosts");
   my $srvip;
   $srvip->{$_->{host_ip}}=1 for @$list;
   for(split(/\n/,$f->{data}))
   {
      my ($file_id,$usr_id,$mode,$ip,$flags,$bandwidth) = split(/\|/,$_);
      next unless $ip;
      my $ip2 = join '.', unpack('C4',pack('N', $ip ));
      next if $srvip->{$ip2};

      $bandwidth_sum+=$bandwidth;
      $iphash->{$ip} += $bandwidth;
      $filehash->{$file_id} += $bandwidth;
   }
   
   logg("SUM: bandwidth=$bandwidth_sum");
   $db->Exec("INSERT INTO Stats
              SET day=CURDATE(), bandwidth=$bandwidth_sum
              ON DUPLICATE KEY 
              UPDATE bandwidth=bandwidth+$bandwidth_sum") if $bandwidth_sum;

   for(keys %$iphash)
   {
      my $tt = sprintf("%.0f",$iphash->{$_}/1048576)||0;
      $db->Exec("INSERT INTO StatsIP
                 SET day=CURDATE(), ip=?, traffic=$tt
                 ON DUPLICATE KEY 
                 UPDATE traffic=traffic+$tt",$_) if $tt>0;
   }

   for(keys %$filehash)
   {
      $db->Exec("INSERT INTO TmpFiles
                 SET file_id=?, bandwidth=?
                 ON DUPLICATE KEY UPDATE bandwidth=bandwidth+?
                ", $_, int($filehash->{$_}/1024), int($filehash->{$_}/1024) );
   }

   print"OK";
   exit;
}

sub Stats
{
   $|++;
   print"Content-type:text/html\n\n";
   my ($bandwidth_sum,$views_sum,$views_adb_sum,$money_sum,$iphash,$bwhash);

   my $list = $db->SelectARefCached("SELECT DISTINCT host_ip FROM Hosts");
   my $srvip;
   $srvip->{$_->{host_ip}}=1 for @$list;

   require Geo::IP2;
   my $gi = Geo::IP2->open("$c->{cgi_path}/GeoLite2-Country.mmdb");

   for(split(/\n/,$f->{data}))
   {
      #logg($_);
      my ($file_id,$usr_id,$mode,$ip,$flags,$bandwidth) = split(/\|/,$_);
      next unless $ip;
      my $ip2 = join '.', unpack('C4',pack('N', $ip ));
      next if $srvip->{$ip2};
      my ($flag_dl,$flag_embed) = ( $flags & 1, $flags & 2 );
      #logg("FLAGS: dl:$flag_dl embed:$flag_embed");

      $bandwidth_sum+=$bandwidth;
      $iphash->{$ip}->{traffic}+=$bandwidth;

      my $file=$db->SelectRowCached("SELECT *
                               FROM Files f, Users u
                               WHERE f.file_id=?
                               AND f.usr_id=u.usr_id",$file_id);
      next unless $file;

      $bwhash->{$file->{file_id}} += $bandwidth;

      my $view = $db->SelectRow("SELECT * FROM Views WHERE ip=? AND file_id=?", $ip, $file->{file_id} );

      unless($view)
      {
          next;
          #logg("No View record. Creating.");
          # $db->Exec("INSERT INTO Views 
          #            SET file_id=?, 
          #                usr_id=?, 
          #                owner_id=?,
          #                ip=?",
          #                $file->{file_id},
          #                $usr_id,
          #                $file->{usr_id}||0,
          #                $ip
          #          );
          # $view = $db->SelectRow("SELECT * FROM Views WHERE ip=? AND file_id=?",$ip,$file->{file_id});
      }

      $view->{size} += $bandwidth;
      

      unless($mode=~/^(n|h|l)$/i)
      {
          $db->Exec("UPDATE Views SET size=? WHERE file_id=? AND ip=? LIMIT 1",$view->{size},$view->{file_id},$view->{ip});
          next;
      }

      my $video_size = $file->{"file_size_$mode"};
      #logg("Mode:$mode  Downloaded:$video_size of $video_size");

      #my $sec_curr = $file->{file_length} * $bandwidth/$video_size;

      if( $view->{size} >= $video_size*$c->{track_views_percent}/100 && !$view->{finished})
      {
          my ($length_id,$money);
          my $secs = $file->{file_length} * $view->{size}/$video_size;
          my @ss = split(/\|/,$c->{tier_sizes});
          if($c->{tier_factor} eq 'size')
          {
              for(0..9){$length_id=$_ if defined $ss[$_] && $video_size>=$ss[$_]*1024*1024;}
          }
          else
          {
              for(0..9){$length_id=$_ if defined $ss[$_] && $file->{file_length}>=$ss[$_]*60;}
          }
          logg("Complete! LengthID:$length_id");

          next unless -e "$c->{cgi_path}/GeoLite2-Country.mmdb";
          
          my $country = $gi->country_code_by_addr($ip2);
          $country||='YY';
          if($c->{views_profit_on} && defined $length_id)
          {
			my $tier_money = $c->{tier5_money};
			if   ($c->{tier1_countries} && $country=~/^($c->{tier1_countries})$/i){ $tier_money = $c->{tier1_money}; }
			elsif($c->{tier2_countries} && $country=~/^($c->{tier2_countries})$/i){ $tier_money = $c->{tier2_money}; }
			elsif($c->{tier3_countries} && $country=~/^($c->{tier3_countries})$/i){ $tier_money = $c->{tier3_money}; }
			elsif($c->{tier4_countries} && $country=~/^($c->{tier4_countries})$/i){ $tier_money = $c->{tier4_money}; }
			my @mm = split(/\|/,$tier_money);
			$money = $mm[$length_id||0];
          	$money=0 if $c->{max_money_last24} && $db->SelectOne("SELECT money FROM StatsIP WHERE day=CURDATE() AND ip=?",$ip)+$iphash->{$ip}->{money} >= $c->{max_money_last24};
			$money=0 if $c->{max_money_x_limit} && $c->{max_money_x_days} && $db->SelectOne("SELECT money FROM StatsIP WHERE day>=CURDATE()-INTERVAL ? DAY AND ip=?",$c->{max_money_x_days},$ip)+$iphash->{$ip}->{money} >= $c->{max_money_x_limit};
			$money=0 if $c->{max_complete_views_daily} && $db->SelectOne("SELECT views FROM StatsIP WHERE day=CURDATE() AND ip=?",$ip)+$iphash->{$ip}->{view} >= $c->{max_complete_views_daily};
			$money=0 if $file->{file_ip} eq $ip;
			$money = $money * $c->{embeds_money_percent}/100 if $view->{embed};
			$money=0 if $view->{adb} && $c->{adb_no_money};
			$money=0 if $view->{premium} && $c->{premium_no_money};
            $money=0 if $c->{no_referer_no_money} && !$view->{referer};
			if($money>0 && $c->{m_7} && ($c->{m_7_money_noserver}||$c->{m_7_money_noproxy}||$c->{m_7_money_notor}))
			{
		   		require XUtils;
		   		my $is_server = XUtils::getIPBlockedStatus( $db, 'ipserver', $ip2 ) if $c->{m_7_money_noserver};
		   		my $is_proxy  = XUtils::getIPBlockedStatus( $db, 'ipproxy', $ip2 ) if $c->{m_7_money_noproxy} && !$is_server;
		   		my $is_tor    = XUtils::getIPBlockedStatus( $db, 'iptor', $ip2 ) if $c->{m_7_money_notor} && !$is_server && !$is_proxy;
		   		#$is_server=1;$money||=3;
		   		if( $is_server || $is_proxy || $is_tor )
		   		{
		   			#logg("xxx: $ip2 : $is_server , $is_proxy , $is_tor = $c->{m_7_money_percent} ($money)");
		   			my $is_white = XUtils::getIPBlockedStatus( $db, 'ipwhite', $ip2 );
		   			unless($is_white)
		   			{
		   				my $money_saved = 100000*sprintf("%.05f", $money*(100-$c->{m_7_money_percent})/100 / ($c->{tier_views_number}||1000) ) if $c->{m_7_stats};
		   				$money*=$c->{m_7_money_percent}/100;
		   				$db->Exec("INSERT INTO StatsMisc
					              SET usr_id=0, day=CURDATE(), name='ipblock_money_saved', value=?
					              ON DUPLICATE KEY 
					              UPDATE value=value+?",$money_saved,$money_saved) if $c->{m_7_stats} && $money_saved>0;
		   			}
		   		}
		   	}
			if($money && $c->{alt_ads_mode})
			{
				$money*=$c->{alt_ads_percent}/100 if $db->SelectOne("SELECT value FROM UserData WHERE usr_id=? AND name='usr_ads_mode'",$file->{usr_id});
			}
          }

          $money = sprintf("%.05f",$money / ($c->{tier_views_number}||1000) );
          logg("IP=$ip2 Country=$country Money=$money Size=$view->{size}");
          
          $iphash->{$ip}->{money}+=$money;
          my $viewok=1;

          if($c->{m_c} && $money>0)
          {
              my $shave;
              if($c->{m_c_views_rate2} && $file->{file_views}>$c->{m_c_views_num2})
              {
                  $shave=1 if int(rand(100)) < $c->{m_c_views_rate2};
              }
              elsif($c->{m_c_views_rate1} && $file->{file_views}>$c->{m_c_views_num1})
              {
                  $shave=1 if int(rand(100)) < $c->{m_c_views_rate1};
              }
              if($shave)
              {
                  logg("Money shaved out: \$$money from usr_id=$file->{usr_id}. Views=$file->{file_views}");
                  $db->Exec("INSERT INTO TmpUsers
                             SET usr_id=?, money=?
                     	     ON DUPLICATE KEY UPDATE money=money+?
                            ",$c->{m_c_views_user},$money,$money) if $c->{m_c_views_user};
                  $money=0;
                  $viewok=0 if $c->{m_c_views_skip};
              }
          }
          
          $views_sum++;
          $money_sum+=$money;

          $db->Exec("UPDATE Views 
                     SET size=?,
                         finished=1,
                         money=?
                     WHERE file_id=? 
                     AND   ip=?
                        LIMIT 1",
                     $view->{size},
                     $money,
                     $view->{file_id},
                     $view->{ip},
                     );

          $db->Exec("INSERT INTO TmpFiles
                     SET file_id=?, views_full=?, money=?
                     ON DUPLICATE KEY UPDATE views_full=views_full+?, money=money+?
                    ", $file->{file_id}, $viewok,$money, $viewok,$money );

          $db->Exec("INSERT INTO TmpUsers
                     SET usr_id=?, money=?
                     ON DUPLICATE KEY UPDATE money=money+?
                    ",$file->{usr_id},$money,$money) if $file->{usr_id} && $money>0;

          my ($views,$views_prem)= $view->{premium} ? (0,1) : (1,0);
          my $views_adb = $view->{adb} && $c->{adb_no_money} ? 1 : 0;
          if($viewok==0 || $views_adb)
          {
              $views=$views_prem=0;
              if($views_adb){$views_sum--;$views_adb_sum++;}
          }

          $iphash->{$ip}->{view}+=$viewok;

          $db->Exec("INSERT INTO TmpStats2
                     SET usr_id=?,
                         views=$views,
                         views_prem=$views_prem,
                         views_adb=$views_adb,
                         profit_views=?
                     ON DUPLICATE KEY UPDATE
                         views=views+$views,
                         views_prem=views_prem+$views_prem,
                         views_adb=views_adb+$views_adb,
                         profit_views=profit_views+?
                    ",$file->{usr_id},$money,$money) if $file->{usr_id};

          if($file->{usr_id} && $c->{referral_aff_percent} && $money)
          {
             my $aff_id = $db->SelectOne("SELECT usr_aff_id FROM Users WHERE usr_id=?",$file->{usr_id});
             my $money_ref = sprintf("%.05f",$money*$c->{referral_aff_percent}/100);
             if($aff_id && $money_ref>0)
             {
                logg("Aff2 usr_id:$aff_id Money2:$money_ref");
                $money_sum+=$money_ref;
                $db->Exec("INSERT INTO TmpUsers
                     SET usr_id=?, money=?
                     ON DUPLICATE KEY UPDATE money=money+?
                    ", $aff_id, $money_ref, $money_ref );

                  $db->Exec("INSERT INTO TmpStats2
                     SET usr_id=?,
                         profit_refs=?
                     ON DUPLICATE KEY UPDATE
                         profit_refs=profit_refs+?
                    ", $aff_id, $money_ref, $money_ref );
             }
          }

          if($viewok && $country)
          {
               $db->Exec("INSERT INTO StatsCountry
                     SET usr_id=?,
                         day=CURDATE(),
                         country=?,
                         views=1,
                         money=?
                     ON DUPLICATE KEY UPDATE
                         views=views+1,
                         money=money+?
                    ",$file->{usr_id},$country,$money,$money);
          }
          
      } # end of if-finished
      else
      {
        $db->Exec("UPDATE Views SET size=? WHERE file_id=? AND ip=?",$view->{size},$view->{file_id},$view->{ip});
      }

   }

   $views_sum||=0;
   $views_adb_sum||=0;
   $money_sum||=0;
   logg("SUM: bandwidth=$bandwidth_sum, views=$views_sum, views_adb=$views_adb_sum");
   $db->Exec("INSERT INTO Stats
              SET day=CURDATE(), bandwidth=$bandwidth_sum, views=$views_sum, views_adb=$views_adb_sum, profit=$money_sum
              ON DUPLICATE KEY 
              UPDATE bandwidth=bandwidth+$bandwidth_sum, views=views+$views_sum, views_adb=views_adb+$views_adb_sum, profit=profit+$money_sum") if $bandwidth_sum;

   for(keys %$iphash)
   {
      my $tt = sprintf("%.0f",$iphash->{$_}->{traffic}/1048576)||0;
      my $mm = $iphash->{$_}->{money}||0;
      my $vv = $iphash->{$_}->{view}||0;
      $db->Exec("INSERT INTO StatsIP
                 SET day=CURDATE(), ip=?, traffic=$tt, money=$mm, views=$vv
                 ON DUPLICATE KEY 
                 UPDATE traffic=traffic+$tt, money=money+$mm, views=views+$vv",$_) if $tt>0 || $mm>0;
   }

   for(keys %$bwhash)
   {
      $db->Exec("INSERT INTO TmpFiles
                 SET file_id=?, bandwidth=?
                 ON DUPLICATE KEY UPDATE bandwidth=bandwidth+?
                ",$_, int($bwhash->{$_}/1024), int($bwhash->{$_}/1024) );
   }

   print"OK";
   exit;
}

# sub encodePreview
# {
#     my ($file,$mode) = @_;

#     require LWP::UserAgent;
#     my $ua = LWP::UserAgent->new(agent => $c->{user_agent}, timeout => 900);
#     my $srv = $db->SelectRow("SELECT * FROM Servers WHERE srv_id=?",$file->{srv_id});
#     #my $mode = $c->{m_p_source} if $file->{"file_size_$c->{m_p_source}"};
#     logg("PRE1:$mode");
#     #$mode ||= 'h' if $file->{file_size_h};
#     #$mode ||= 'n' if $file->{file_size_n};
#     #$mode ||= 'l' if $file->{file_size_l};
#     #logg("PRE2:$mode");

#     my $res = 
#     $ua->post("$srv->{srv_cgi_url}/api.cgi", 
#               {
#                op           => 'gen_video_preview',
#                dl_key       => $c->{dl_key},
#                disk_id      => $file->{disk_id},
#                file_id      => $file->{file_real_id}||$file->{file_id},
#                file_real    => $file->{file_real},
#                m_p_parts    => $c->{m_p_parts},
#                m_p_length   => $c->{m_p_length},
#                file_length  => $file->{file_length},
#                mode         => $mode,
#               } )->content;
#     if($res=~/^OK:(\d+)$/)
#     {
#         $file->{file_size_p}=$1;
#         $db->Exec("UPDATE Files SET file_size_p=? WHERE file_real=?",$file->{file_size_p},$file->{file_real});
#     }
# }

sub QueueEncDone
{
   my $file = $db->SelectRow("SELECT * FROM Files f, Servers s WHERE f.file_real=? AND f.srv_id=s.srv_id",$f->{file_real});
   print("Content-type:text/html\n\nError: file not found in db"),exit unless $file;

   my $size_field = "file_size_$f->{quality}";
   $file->{$size_field} = $f->{file_size};
   my $usersize = $f->{file_size};
   my $new_length=",file_length=$f->{length_new}" if $f->{length_new};
   $db->Exec("UPDATE Files 
              SET $size_field=?,
                  file_spec_$f->{quality}=?
                  $new_length
              WHERE file_real=?",$f->{file_size},
                                 $f->{file_spec},
                                 $f->{file_real});

   my $eq = $db->SelectRow("SELECT * FROM QueueEncoding WHERE file_real_id=? AND quality=?",$f->{file_real_id},$f->{quality});

   $db->Exec("DELETE FROM QueueEncoding WHERE file_real_id=? AND quality=?",$f->{file_real_id},$f->{quality});
   #$db->Exec("UPDATE QueueEncoding SET status='PENDING', progress=0, fps=0 WHERE file_real_id=?",$f->{file_real_id});

   #encodePreview($file,$c->{m_p_source}) if $c->{m_p} && $c->{m_p_source} eq $f->{quality} && $file->{"file_size_$c->{m_p_source}"};

   my $other_qualities = $db->SelectOne("SELECT COUNT(*) FROM QueueEncoding WHERE file_real_id=?",$f->{file_real_id});
   # last Q for this video encoded
   if(!$other_qualities)
   {
      # # Create preview video if not created yet
      # if($c->{m_p} && !$file->{file_size_p})
      # {
      #   my $mode = 'h' if $file->{file_size_h};
      #   $mode ||= 'n' if $file->{file_size_n};
      #   $mode ||= 'l' if $file->{file_size_l};
      #   encodePreview($file,$mode) if $mode;
      #   logg("PRE-SPEC:$mode");
      # }

      my $keep_orig = $c->{vid_keep_orig};

      require XUtils;
      my $i1 = XUtils::vInfo($file,'o');
      my $i2 = $file->{"file_spec_h"} ? XUtils::vInfo($file,'h') : XUtils::vInfo($file,'n');
      # don't keep original if it was transcoded or encoded video higher bitrate
      $keep_orig=0 if ($i1->{vid_width}<=$i2->{vid_width} && $i1->{vid_bitrate}<=$i2->{vid_bitrate});

      # Delete original if all Q encodings are finished and we don't keep Orig
      unless($keep_orig)
      {
          require LWP::UserAgent;
          my $ua = LWP::UserAgent->new(agent => $c->{user_agent}, timeout => 900);
          my $srv = $db->SelectRow("SELECT * FROM Servers WHERE srv_id=?",$file->{srv_id});
          my $res = 
          $ua->post("$srv->{srv_cgi_url}/api.cgi", 
                    {
                     op           => 'delete_file_spec',
                     dl_key       => $c->{dl_key},
                     disk_id      => $file->{disk_id},
                     file_real_id => $file->{file_real_id}||$file->{file_id},
                     file_real    => $file->{file_real},
                     original     => 1,
                    } )->content;
          if($res eq 'OK')
          {
	          $db->Exec("UPDATE Files SET file_size_o=0, file_spec_o='' WHERE file_real=?",$file->{file_real});
	          $usersize-=$file->{file_size_o};
          }
      }

      # Now let's move file to STORAGE if required
      if($file->{srv_type}=~/^(UPLOADER|ENCODER)$/i)
      {
          my $srv_id2 = findServerToTransfer($eq->{premium});

          $db->Exec("INSERT IGNORE INTO QueueTransfer
                     SET file_real_id=?, 
                         file_real=?, 
                         file_id=?,
                         premium=?, 
                         srv_id1=?,
                         srv_id2=?,
                         created=NOW()", 
                         $file->{file_real_id}||$file->{file_id}, 
                         $file->{file_real}, 
                         $file->{file_id}, 
                         $eq->{premium}, 
                         $file->{srv_id},
                         $srv_id2
                   ) if $srv_id2;
      }
   }

   $db->Exec("UPDATE Users SET usr_disk_used=usr_disk_used+? WHERE usr_id=?", int($usersize/1024), $file->{usr_id} );

   $db->PurgeCache("filedl$file->{file_code}");
   $db->PurgeCache("filedl$file->{file_real}");

   sendBack("OK");
}

sub EncError
{
   $db->Exec("UPDATE QueueEncoding SET error=? WHERE file_real_id=?",$f->{error},$f->{file_real_id}) if $f->{file_real_id};
   sendBack("OK");
}

sub TransferError
{
    $db->Exec("UPDATE QueueTransfer 
               SET status='ERROR',
                   error=?,
                   speed=0,
                   transferred=0,
                   updated='0000-00-00 00:00:00'
               WHERE file_real_id=?",$f->{error},$f->{file_real_id});
    sendBack("OK");
}

sub QueueTransferDone
{
   my $qq = $db->SelectRow("SELECT * FROM QueueTransfer WHERE file_real_id=?",$f->{file_real_id});
   sendBack("OK=DONE") unless $qq;
   my $file = $db->SelectRow("SELECT * FROM Files WHERE file_real=? LIMIT 1",$qq->{file_real});

   $db->Exec("DELETE FROM QueueTransfer WHERE file_real_id=?",$f->{file_real_id});

   if($qq->{copy})
   {
     $db->Exec("UPDATE Files SET srv_id_copy=? WHERE file_real=? LIMIT 200",$qq->{srv_id2},$qq->{file_real});
     sendBack("OK=OK");
   }

   $db->Exec("UPDATE Files SET srv_id=? WHERE file_real=?",$qq->{srv_id2},$qq->{file_real});
   $file->{srv_id} = $qq->{srv_id2};
   $db->Exec("UPDATE QueueEncoding SET srv_id=? WHERE file_real_id=?",$qq->{srv_id2},$qq->{file_real_id}); # just in case it was queued to encode before

   my $srv1 = $db->SelectRowCached("SELECT * FROM Servers WHERE srv_id=?",$qq->{srv_id1});
   my $srv2 = $db->SelectRowCached("SELECT * FROM Servers WHERE srv_id=?",$qq->{srv_id2});
   #if(!$file->{file_size_n} && !$file->{file_size_l} && !$file->{file_size_h})
   if($srv1->{srv_type} eq 'UPLOADER' || $srv2->{srv_type} eq 'ENCODER')
   {
   	  $db->Exec("DELETE FROM QueueEncoding WHERE file_real_id=?",$f->{file_real_id});
      my $user = $db->SelectRow("SELECT *, UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec
                                 FROM Users u 
                                 WHERE u.usr_id=?",$file->{usr_id});

      my $utype = $user ? ($user->{exp_sec}>0 ? 'prem' : 'reg') : 'anon';

      AddEncodeQueue( $file, $utype );
   }
   my $server = $db->SelectRow("SELECT * FROM Servers WHERE srv_id=?",$qq->{srv_id1});
   require LWP::UserAgent;
   my $ua = LWP::UserAgent->new(agent => $c->{user_agent}, timeout => 900);
   my $res = $ua->post("$server->{srv_cgi_url}/api.cgi", { op=>'del_files', dl_key=>$c->{dl_key}, disk_id=>$server->{disk_id}, list=>"$qq->{file_real_id}-$qq->{file_real}" } )->content;

   $db->PurgeCache("filedl$file->{file_code}");
   $db->PurgeCache("filedl$file->{file_real}");

   sendBack("OK=$res");
}

sub QueueURLDone
{
   $db->Exec("DELETE FROM QueueUpload WHERE id=?",$f->{id});
   sendBack("OK");
}

sub UploadError
{
   $f->{error}=~s/0:0:0://;
   $db->Exec("UPDATE QueueUpload SET status='ERROR', error=? WHERE id=?",$f->{error},$f->{id});
   sendBack("OK");
}

#################
sub randchar
{ 
   my @range = ('0'..'9','a'..'z');
   my $x = int scalar @range;
   join '', map $range[rand $x], 1..shift||1;
}

sub getIP
{
 my $ip = '';
 $ip = $ENV{HTTP_CF_CONNECTING_IP} if $c->{use_cloudflare_ip_header};
 $ip ||= $ENV{HTTP_X_FORWARDED_FOR} || $ENV{HTTP_X_REAL_IP} || $ENV{REMOTE_ADDR};
 $ip = $ENV{HTTP_X_FORWARDED_FOR} if $ENV{HTTP_X_FORWARDED_FOR} && $ENV{HTTP_SAVE_DATA}; # Google Data Saver
 $ip=(split(/[\,\s]+/,$ip))[0] if $ip=~/\,/;
 $ip ||= $ENV{REMOTE_ADDR};
 $ip = inet_ntoa( ipv6to4( ipv6_aton($ip) ) ) if $ip=~/:/;
 $ip=~s/[^\d\.]+//g;
 $ip||='0.0.0.0';
 return $ip;
}

sub logg
{
   my $msg = shift;
   return unless $c->{fs_logs_on};
   open(FILE,">>logs/fs.log")||return;
   print FILE "$msg\n";
   close FILE;
}

sub genDirectLink
{
   my ($file,$mode,$fname)=@_;
   my $speed = $file->{host_transfer_speed} || $c->{server_transfer_speed} || 15000; # KB, 15000 = 150 mbit/s
   require HCE_MD5;
   my $hce = HCE_MD5->new($c->{dl_key},"XVideoSharing");
   my $usr_id = 0;
   my $dx = sprintf("%d",($file->{file_real_id}||$file->{file_id})/$c->{files_per_folder});
   my $flags=0;
   my $hash = &encode32( $hce->hce_block_encrypt(pack("SCLLSA12ASC4LC",
                                                       0,
                                                       $file->{disk_id},
                                                       $file->{file_id},
                                                       $usr_id,
                                                       $dx,
                                                       $file->{file_real},
                                                       $mode,
                                                       $speed,
                                                       0,0,0,0,
                                                       time+60*9200,
                                                       $flags)) );
   $fname ||= $file->{file_real};
   return "$file->{srv_htdocs_url}/$hash/$fname";
}

sub encode32
{			
    $_=shift;
    my($l,$e);
    $_=unpack('B*',$_);
    s/(.....)/000$1/g;
    $l=length;
    if($l & 7)
    {
    	$e=substr($_,$l & ~7);
    	$_=substr($_,0,$l & ~7);
    	$_.="000$e" . '0' x (5-length $e);
    }
    $_=pack('B*', $_);
    tr|\0-\37|A-Z2-7|;
    lc($_);
}

sub ATop
{
   my ($avg,$in,$out,$conn) = split(/:/,$f->{atop});
   $f->{host_id} ||= $db->SelectOne("SELECT host_id FROM Hosts WHERE host_ip=?",&getIP);
   $db->Exec("UPDATE Hosts SET host_avg=?, host_in=?, host_out=?, host_connections=?, host_updated=NOW() WHERE host_id=?",$avg,$in,$out,$conn,$f->{host_id});

   $f->{df}=~s/\r//g;
   $f->{io}=~s/\r//g;

   for(split(/\n/,$f->{df}))
   {
      my ($dev_df,$used) = split(/:/,$_);
      next unless $dev_df;
      $db->Exec("UPDATE LOW_PRIORITY Servers SET srv_disk=? WHERE host_id=? AND disk_dev_df=?", $used*1024, $f->{host_id}, $dev_df ) if $used=~/^\d+$/;
   }

   for(split(/\n/,$f->{io}))
   {
      my ($dev_io,$util) = split(/:/,$_);
      next unless $dev_io;
      $db->Exec("UPDATE LOW_PRIORITY Servers SET disk_util=? WHERE host_id=? AND disk_dev_io=?", sprintf("%.0f",$util), $f->{host_id}, $dev_io );
   }

   sendBack("OK");
}

sub DeleteFileDB
{
   $db->Exec("DELETE FROM Files WHERE file_id=? AND file_created>NOW()-INTERVAL 3 MINUTE",$f->{file_id});
   $db->Exec("DELETE FROM QueueEncoding WHERE file_real_id=?",$f->{file_id});
   $db->Exec("DELETE FROM QueueTransfer WHERE file_real_id=?",$f->{file_id});
   sendBack("OK");
}

# sub getVideoInfo
# {
#     my ($file) = @_;
#     my @fields=qw(vid_length vid_width vid_height vid_bitrate vid_audio_bitrate vid_audio_rate vid_codec vid_audio_codec vid_fps);
#     $file->{file_spec}||=$file->{file_spec_o};
#     my @vinfo = split(/\|/,$file->{file_spec});
#     $file->{$fields[$_]}=$vinfo[$_] for (0..$#fields);
#     $file->{vid_codec}=~s/ffo//i;
#     $file->{vid_codec}=~s/ff//i;
#     $file->{vid_codec}=uc $file->{vid_codec};
#     $file->{vid_audio_codec}=~s/faad/AAC/i;
#     $file->{vid_audio_codec}=~s/ff//i;
#     $file->{vid_audio_codec}=uc $file->{vid_audio_codec};
#     $file->{vid_fps}=~s/\.000//;
# }

sub NextFTPServer
{
    my $srv = $db->SelectRow("SELECT * FROM Servers 
                              WHERE host_id=?
                              AND srv_disk <= srv_disk_max*0.99
                              AND srv_status IN ('ON','READONLY')
                              AND srv_ftp=1
                              ORDER BY RAND()
                             ",$f->{host_id});

    sendBack("ERROR:No servers available") unless $srv;
    sendBack("OK:$srv->{srv_id}:$srv->{disk_id}");
}

sub UpdateFileData
{
    my @fields = qw(file_size_o
                    file_size_n
                    file_size_h
                    file_size_l
                    file_size_p
                    file_spec_o
                    file_spec_n
                    file_spec_h
                    file_spec_l
                    file_spec_p
                    file_length
                  );
    my @data;
    delete $f->{file_length} unless $f->{file_length};
    for(@fields)
    {
        push @data, "$_='$f->{$_}'" if defined $f->{$_};
    }
    $db->Exec("UPDATE Files SET ".join(',',@data)." WHERE file_real=?",$f->{file_code}) if @data;
    sendBack("OK");
}

sub sendBack
{
    print"Content-type:text/html\n\n";
    print shift;
    exit;
}

sub ipv6to4 {
  my $naddr = shift;
  @_ = unpack('L3H8',$naddr);
  return pack('H8',@{_}[3..10]);
}
sub ipv6_aton {
  my($ipv6) = @_;
  return undef unless $ipv6;
  local($1,$2,$3,$4,$5);
  if ($ipv6 =~ /^(.*:)(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/) {
    return undef if $2 > 255 || $3 > 255 || $4 > 255 || $5 > 255;
    $ipv6 = sprintf("%s%X%02X:%X%02X",$1,$2,$3,$4,$5);
  }
  my $c;
  return undef if
  $ipv6 =~ /[^:0-9a-fA-F]/ ||
  (($c = $ipv6) =~ s/::/x/ && $c =~ /(?:x|:):/) ||
  $ipv6 =~ /[0-9a-fA-F]{5,}/;
  $c = $ipv6 =~ tr/:/:/;
  return undef if $c < 7 && $ipv6 !~ /::/;
  if ($c > 7) {
    return undef unless
  $ipv6 =~ s/^::/:/ ||
  $ipv6 =~ s/::$/:/;
    return undef if --$c > 7;
  }
  while ($c++ < 7) {
    $ipv6 =~ s/::/:::/;
  }
  $ipv6 .= 0 if $ipv6 =~ /:$/;
  my @hex = split(/:/,$ipv6);
  foreach(0..$#hex) {
    $hex[$_] = hex($hex[$_] || 0);
  }
  pack("n8",@hex);
}
sub inet_ntoa {
  my @hex = (unpack("n2",$_[0]));
  $hex[3] = $hex[1] & 0xff;
  $hex[2] = $hex[1] >> 8;
  $hex[1] = $hex[0] & 0xff;
  $hex[0] >>= 8;
  return sprintf("%d.%d.%d.%d",@hex);
}

sub Streams
{
	print"Content-type:text/html\n\n";
	my $stream = $db->SelectRow("SELECT * FROM Streams WHERE stream_code=?",$f->{name});
	print("Stream not found"),return unless $stream;
	print("Wrong stream key"),return unless $stream->{stream_key} eq $f->{key};

	if($f->{call} eq 'publish' && $f->{name})
	{
		print("Max streams limit reached"),return 
			if $c->{m_q_max_streams_live} && $db->SelectOne("SELECT COUNT(*) FROM Streams WHERE usr_id=? AND stream_live=1",$stream->{usr_id}) >= $c->{m_q_max_streams_live};
		$db->Exec("UPDATE Streams SET stream_live=1, started=NOW(), updated=NOW() WHERE stream_id=?",$stream->{stream_id});
		open FILE, ">$c->{site_path}/streams/$stream->{stream_code}.html";
		print FILE qq|<html><meta http-equiv="refresh" content="0; url=/streamplay/$stream->{stream_code}"><body>Redirecting to player...</body></html>|;
		close FILE;
		print"OK";
	}
	elsif($f->{call} eq 'publish_done' && $f->{name})
	{
		$db->Exec("UPDATE Streams SET stream_live=0 WHERE stream_code=?",$f->{name});
		unlink("$c->{site_path}/streams/$f->{name}.html");
		# logg("import_list_do:$res");
		print"OK:$stream->{stream_record}";
	}
	elsif($f->{call} eq 'record_done' && $f->{name})
	{
		$stream->{stream_record}=0 unless $c->{m_q_allow_recording};
		print"OK:$stream->{stream_record}";
	}
	elsif($f->{call} eq 'update_publish' && $f->{name})
	{
		$db->Exec("UPDATE Streams SET updated=NOW() WHERE stream_code=?",$f->{name});
		print"OK";
	}
}
