package index_dl;

use strict;
#use warnings;
use XFileConfig;
use Session;
use XUtils;
use CGI::Carp qw(fatalsToBrowser);

my ($ses,$f,$db,$ipt);

$c->{ip_not_allowed}=~s/\./\\./g;

sub run
{
   my ($query,$dbc) = @_;

   #Module::Refresh->refresh;
   #Module::Reload->check;

   if($c->{ip_not_allowed} && $ENV{REMOTE_ADDR}=~/$c->{ip_not_allowed}/)
   {
      print"Content-type:text/html\n\n";
      print"Your IP was banned by administrator";
      return;
   }

   $ses = Session->new($query,$dbc);
   $ses->{fast_cgi} = $c->{fast_cgi};

   return $ses->message($c->{maintenance_full_msg}||"The website is under maintenance.","Site maintenance") if $c->{maintenance_full};

    if($c->{banned_countries})
    {
        my $country = $ses->getMyCountry;
        return $ses->message("Your country is not allowed on this site") if $country=~/^($c->{banned_countries})$/i;
    }
   
   $f = $ses->f;
   $f->{op}||='';
   #$f->{op}||='download1' if $ses->getCookie('id');

   return GetSlides() if $f->{op} eq 'get_slides';

   $db ||= $ses->db;
   #CheckAuth();
   XUtils::CheckAuth($ses);
     

   return $ses->message($ses->{error}) if $ses->{error};

   $ses->{utype} = $ses->getUser ? ($ses->getUser->{premium} ? 'prem' : 'reg') : 'anon';
   
   $c->{$_}=$c->{"$_\_$ses->{utype}"} for qw( download_countdown
                                              captcha
                                              ads
                                              bw_limit
                                              down_speed
                                              add_download_delay
                                              max_download_filesize
                                              video_embed
                                              file_dl_delay
                                              download
                                              download_orig
                                              pre_download
                                              max_watch_time
                                              video_time_limit
                                              time_slider
                                              video_player
                                              upload_enabled
                                              vid_play_h
                                              m_p_show
                                              m_q_streaming
                                              download_o
                                            );
   
   my $sub={
       download1     => \&Download1,
       download_orig => \&DownloadOriginal,
       embed         => \&Embed,
       #embed2        => \&Embed2,
       x1            => \&X1,
       enc_status    => \&EncStatus,
       get_vid_versions => \&getVideoVersions,
       deurl         => \&DeURL,
       view          => \&View,
       view2         => \&View2,
       #get_slides    => \&GetSlides,
       smil          => \&genRTMPsmil,
       related       => \&Related,
       pair			 => \&Pair,
       stream_page	 => \&StreamPage,
       stream_player => \&StreamPlayer,
       stream_ping   => \&StreamPing,
       iproxy 		 => \&IProxy,

            }->{ $f->{op} };
   return &$sub if $sub;

   my $sub2={
       queue_enc_next   => \&QueueEncNext,
       queue_url_next   => \&QueueURLNext,
       queue_transfer_next  => \&QueueTransferNext,

       enc_progress     => \&EncProgress,
       upload_progress  => \&UploadProgress,
       transfer_progress=> \&TransferProgress,
            }->{ $f->{op} };
    if($sub2)
    {
    	return $ses->message("111") unless $ENV{REQUEST_METHOD} eq 'POST';
    	return $ses->message("222") unless $ENV{HTTP_USER_AGENT} eq $c->{user_agent};
  		return $ses->message("333") unless $f->{dl_key} eq $c->{dl_key};
  		my $REMOTE_ADDR = $ses->getIP;
  		return $ses->message("badip:$REMOTE_ADDR") unless ($db->SelectOneCached("SELECT host_id FROM Hosts WHERE host_ip=?",$REMOTE_ADDR) || $REMOTE_ADDR eq '127.0.0.1' || $REMOTE_ADDR=~/^0\.0\./);
  		return &$sub2;
    }
   
   IndexPage();
   #return $ses->redirect($c->{site_url});
}

###################################

sub X1
{
  return $ses->message("IP:".$ses->getIP);
}

sub IndexPage
{
    $ses->{expires}="+$c->{caching_expire}s" if $c->{caching_expire};
    $ses->PrintTemplate("index_page.html",
                        index_featured_on    => $c->{index_featured_on},
                        index_most_viewed_on => $c->{index_most_viewed_on},
                        index_most_rated_on  => $c->{index_most_rated_on},
                        index_just_added_on  => $c->{index_just_added_on},
                        index_live_streams_on => $c->{index_live_streams_on},
                        'm_z'        => $c->{m_z},
                        'm_z_cols'   => $c->{m_z_cols},
                        'm_z_rows'   => $c->{m_z_rows},
                       );
}

sub Login
{
  ($f->{login}, $f->{password}) = split(':',$ses->decode_base64($ENV{HTTP_CGI_AUTHORIZATION}));
  $ses->{user} = $db->SelectRow("SELECT *, UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec 
                                 FROM Users 
                                 WHERE usr_login=? 
                                 AND usr_password=ENCODE(?,?)", $f->{login}, $f->{password}, $c->{pasword_salt} );
  unless($ses->{user})
  {
     #sleep 1;
     $ses->{error}="Invalid user";
     return undef;
  }
  
  $ses->{user}->{premium}=1 if $ses->{user}->{exp_sec}>0;
  if($ses->{user}->{usr_status} eq 'PENDING')
  {
     delete $ses->{user};
     $ses->{error}="Account not confirmed";
     return;
  }
  if($ses->{user}->{usr_status} eq 'BANNED')
  {
     delete $ses->{user};
     $ses->{error}="Banned account";
     return;
  }
};

# sub CheckAuth
# {
#   my $sess_id = $ses->getCookie( $ses->{auth_cook} );

#   return undef unless $sess_id;

#   $ses->{user} = $db->SelectARefCachedKey("ses$sess_id", 120, "SELECT u.*,
#                                         UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec,
#                                         UNIX_TIMESTAMP()-UNIX_TIMESTAMP(last_time) as dtt
#                                  FROM Users u, Sessions s 
#                                  WHERE s.session_id=? 
#                                  AND s.usr_id=u.usr_id",$sess_id)->[0];
#   unless($ses->{user})
#   {
#      sleep 1;
#      return undef;
#   }
#   if($ses->{user}->{usr_status} eq 'BANNED')
#   {
#      delete $ses->{user};
#      $ses->{error} = "Your account was banned by administrator.";
#      return;
#   }
#   if($ses->{user}->{dtt}>180)
#   {
#      $db->Exec("UPDATE Sessions SET last_time=NOW() WHERE session_id=?",$sess_id);
#      $db->Exec("UPDATE Users SET usr_lastlogin=NOW(), usr_lastip=INET_ATON(?) WHERE usr_id=?", $ses->getIP, $ses->{user}->{usr_id} );
#   }
#   $ses->{user}->{premium}=1 if $ses->{user}->{exp_sec}>0;
#   if($c->{m_d} && $ses->{user}->{usr_mod})
#   {
#       $ses->{lang}->{usr_mod}=1;
#       $ses->{lang}->{m_d_f}=$c->{m_d_f};
#       $ses->{lang}->{m_d_a}=$c->{m_d_a};
#       $ses->{lang}->{m_d_c}=$c->{m_d_c};
#   }

#   return $ses->{user};
# }

sub Download1Checks
{
   my ($file) = @_;

   $file->{message} = "$ses->{lang}->{lng_download_for_premium_users_only}<br><a href='$c->{site_url}/premium.html'>$ses->{lang}->{lng_download_upgrade_to_premium_now}</a>" if $file->{usr_premium_dl_only} && $ses->{utype} ne 'prem';

   if(!$c->{video_player})
   {
       my $link = $ses->getUser ? "$c->{site_url}/premium.html" : "$c->{site_url}/?op=registration";
       $file->{message} = "$ses->{lang}->{lng_download_cant_watch_free_account}<br><a href='$link'>$ses->{lang}->{lng_download_upgrade_your_account}</a> $ses->{lang}->{lng_download_to_watch_no_limits}";
   }

   if($file->{file_size_p} && $c->{m_p_show} && $c->{m_p})
   {
       #$file->{video_preview_url} = DownloadGenLink($file,"v.mp4",'p');
       $file->{preview}=1;
       $file->{preview_message} = "$ses->{lang}->{lng_download_can_watch_preview_only}<br><a href='$c->{site_url}/premium.html'>$ses->{lang}->{lng_download_upgrade_your_account}</a> $ses->{lang}->{lng_download_to_watch_no_limits}";
       $file->{file_title}.=" ($ses->{lang}->{lng_download_preview})";
   }

   if($file->{file_status} ne 'OK' && !($ses->getUser && $ses->getUser->{usr_adm}))
   {
       $file->{message} = $file->{file_status} eq 'PENDING' ? $ses->{lang}->{lng_download_file_is_pending} : $ses->{lang}->{lng_download_file_is_locked};
       $file->{no_dl_btn} = 1;
   }

   if($file->{file_premium_only} && $ses->{utype} ne 'prem')
   {
       $file->{message} = "$ses->{lang}->{lng_download_for_premium_users_only}<br><a href='$c->{site_url}/premium.html'>$ses->{lang}->{lng_download_upgrade_to_premium_now}</a>";
       $file->{no_dl_btn} = 1;
   }

   if($file->{cat_premium} && $ses->{utype} ne 'prem')
   {
       $file->{message} = "$ses->{lang}->{lng_download_for_premium_users_only}<br><br><a href='$c->{site_url}/premium.html'>$ses->{lang}->{lng_download_upgrade_to_premium_now}</a>";
       $file->{no_dl_btn} = 1;
   }

   if($c->{bad_referers} && $ENV{HTTP_REFERER})
   {
       $file->{message}="Video temporarily not available" if $ENV{HTTP_REFERER}=~/$c->{bad_referers}/i;
   }

   if($c->{bad_agents} && $ENV{HTTP_USER_AGENT})
   {
       $file->{message}="Video not available" if $ENV{HTTP_USER_AGENT}=~/$c->{bad_agents}/i;
   }

   return $file;
}

sub DownloadOriginalChecks
{
   my ($file) = @_;

   $f->{mode}||='n';
   $file->{message}="This version is not available for this video" unless $file->{"file_size_$f->{mode}"};
   $file->{message}="You are not able to download original videos" if $f->{mode} eq 'o' && !$c->{download_orig};
   $file->{message}="You are not able to download HD videos" if $f->{mode} eq 'h' && !$c->{vid_play_h};
   $file->{message}="You are not able to download videos" unless $c->{download};
   $file->{no_dl_btn}=1 if $file->{message};

   #$file->{message}="Security error" unless $ENV{REQUEST_METHOD} eq 'POST';
   $file->{message}="Security error" unless $ses->HashCheck($f->{hash},$file->{file_id});

   return $file if $file->{message};


   if($file->{usr_premium_dl_only} && $ses->{utype} ne 'prem')
   {
       $file->{message} = "$ses->{lang}->{lng_download_for_premium_users_only}<br><a href='$c->{site_url}/premium.html'>$ses->{lang}->{lng_download_upgrade_to_premium_now}</a>";
       $file->{no_dl_btn}=1;
   }
   

   if($c->{max_download_filesize} && ($file->{"file_size_$f->{mode}"} > $c->{max_download_filesize}*1048576))
   {
      $file->{message} = "$ses->{lang}->{lng_download_can_download_files_up_to} $c->{max_download_filesize} MB.<br><a href='$c->{site_url}/?op=payments'>$ses->{lang}->{lng_download_upgrade_to_premium_now}</a> $ses->{lang}->{lng_download_to_download_bigger_files}.";
   }

   if($c->{file_dl_delay})
   {
      my $cond = $ses->getUser ? "usr_id=".$ses->getUserId : "ip=INET_ATON('".$ses->getIP."')";
      my $last = $db->SelectRow("SELECT *, UNIX_TIMESTAMP()-UNIX_TIMESTAMP(created) as dt 
                                 FROM Downloads WHERE $cond 
                                 ORDER BY created DESC LIMIT 1");
      my $wait = $c->{file_dl_delay} - $last->{dt};
      if($last->{dt} && $wait>0)
      {
         require Time::Elapsed;
         my $et = new Time::Elapsed;
         my $elapsed = $et->convert($wait);
         $file->{message}  = "$ses->{lang}->{lng_download_you_have_to_wait} $elapsed $ses->{lang}->{lng_download_untill_next_dl}";
         $file->{message} .= "<br><br>$ses->{lang}->{lng_download_dl_files_instantly_with_premium}" if $c->{enabled_prem};
      }
   }

   if($c->{add_download_delay})
   {
      my $cond = $ses->getUser ? "usr_id=".$ses->getUserId : "ip=INET_ATON('".$ses->getIP."')";
      my $last = $db->SelectRow("SELECT *, UNIX_TIMESTAMP()-UNIX_TIMESTAMP(created) as dt 
                                 FROM Downloads WHERE $cond 
                                 ORDER BY created DESC LIMIT 1");
      my $wait = int($c->{add_download_delay}*$last->{size}/(100*1048576)) - $last->{dt};
      if($wait>0)
      {
         require Time::Elapsed;
         my $et = new Time::Elapsed;
         my $elapsed = $et->convert($wait);
         $file->{message}  = "$ses->{lang}->{lng_download_you_have_to_wait} $elapsed $ses->{lang}->{lng_download_untill_next_dl}";
         $file->{message} .= "<br><br>$ses->{lang}->{lng_download_dl_files_instantly_with_premium}" if $c->{enabled_prem};
      }
   }

   if($c->{bw_limit})
   {
      my $cond = $ses->getUser ? "usr_id=".$ses->getUserId : "ip=INET_ATON('".$ses->getIP."')";
      my $bw = $db->SelectOne("SELECT SUM(size) FROM Downloads WHERE $cond AND created > NOW()-INTERVAL ? DAY",$c->{bw_limit_days});
      $file->{message} = "$ses->{lang}->{lng_download_reached_dl_limit}: $c->{bw_limit} MB $ses->{lang}->{lng_download_for_last} $c->{bw_limit_days} $ses->{lang}->{lng_download_days}"
         if ($bw > $c->{bw_limit}*1024**3);
   }

   if($file->{file_status} ne 'OK')
   {
       $file->{message} = $file->{file_status} eq 'PENDING' ? $ses->{lang}->{lng_download_file_is_pending} : $ses->{lang}->{lng_download_file_is_locked};
   }

   return $file;
}

sub SSD_P2P_Logic
{
	my ($file) = @_;
	my (undef,undef,undef,$hh,undef,undef) = $ses->getTime;
   if($c->{m_y} && $file->{srv_id_copy} && $c->{ssd_hours} && $hh=~/^($c->{ssd_hours})$/)
   {
     my $ssd = $db->SelectRowCached("SELECT * FROM Servers s, Hosts h WHERE s.srv_id=? AND s.host_id=h.host_id AND s.srv_status<>'OFF'",$file->{srv_id_copy});
     $file->{$_}=$ssd->{$_} for keys %$ssd;
   }

   if($c->{p2p_on} && $c->{m_r} && $c->{m_r_hls})
   {
     my $p2p=1;
     $p2p=0 if $c->{p2p_min_views} && $file->{file_views} < $c->{p2p_min_views};
     $p2p=0 if $c->{p2p_min_host_out} && $file->{host_out} < $c->{p2p_min_host_out};
     $p2p=0 if $c->{p2p_only_srvname_with} && $file->{srv_name}!~/$c->{p2p_only_srvname_with}/i;
     $p2p=0 if $c->{p2p_min_views_30m} && $p2p && $db->SelectOne("SELECT COUNT(*) FROM Views WHERE file_id=? AND created>NOW()-INTERVAL 30 MINUTE",$file->{file_id}) < $c->{p2p_min_views_30m};
     $p2p=0 if $c->{p2p_hours} && $hh!~/^($c->{p2p_hours})$/;
     $file->{p2p} = $p2p;
   }
}

sub Download1
{
   return $ses->message($c->{maintenance_download_msg}||"Downloads are temporarily disabled due to site maintenance","Site maintenance") if $c->{maintenance_download};
   return $ses->message("Video pages disabled") if $c->{video_page_disabled};
   # my ($fname) = $ENV{QUERY_STRING}=~/&fname=(.+)$/;
   # $fname||=$f->{fname};
   # $fname=~s/\.html?$//i;
   # $fname=~s/\///;
   # $fname=~s/\?.+$//;
   if($c->{m_7} && $c->{m_7_video_download1} && ($c->{m_7_video_noserver}||$c->{m_7_video_noproxy}||$c->{m_7_video_notor}))
   {
   		my $is_server = XUtils::getIPBlockedStatus( $ses->db, 'ipserver', $ses->getIP ) if $c->{m_7_video_noserver};
   		my $is_proxy  = XUtils::getIPBlockedStatus( $ses->db, 'ipproxy', $ses->getIP ) if $c->{m_7_video_noproxy} && !$is_server;
   		my $is_tor    = XUtils::getIPBlockedStatus( $ses->db, 'iptor', $ses->getIP ) if $c->{m_7_video_notor} && !$is_server && !$is_proxy;
   		if( $is_server || $is_proxy || $is_tor )
   		{
   			my $is_white = XUtils::getIPBlockedStatus( $ses->db, 'ipwhite', $ses->getIP );
   			$db->Exec("INSERT INTO StatsMisc
		              SET usr_id=0, day=CURDATE(), name='ipblock_blocked', value=1
		              ON DUPLICATE KEY 
		              UPDATE value=value+1") if $c->{m_7_stats} && !$is_white;
   			if($is_white)
   			{
   				# do nothing
   				#return $ses->message('white');
   			}
   			elsif($c->{m_7_video_action} eq 'redirect')
   			{
   				return $ses->redirect($c->{site_url});
   			}
   			elsif($c->{m_7_video_action} eq 'message' && $c->{m_7_video_action_message_txt})
   			{
   				return $ses->message($c->{m_7_video_action_message_txt});
   			}
   			elsif($c->{m_7_video_action} eq 'badlink')
   			{
   				$ses->{badlink}=1;
   			}
   		}
   }

   if($c->{watch_require_recaptcha})
   {
   	 unless(checkRecaptchaHash())
   	 {
   	 	return $ses->PrintTemplate("download1_recaptcha.html", id => $f->{id}, recaptcha => $ses->genRecaptcha('auto') );
   	 }
   }

   $f->{referer}||= $ses->getCookie('referer') || $ENV{HTTP_REFERER};

   if($c->{m_a} && $c->{m_a_hide_redirect} && $f->{id} && !$f->{hash})
   {
   		$ses->setCookie('id',$f->{id},'+1m');
   		$ses->setCookie('referer',$f->{referer},'+1m');
   		my $code = $ses->randchar(13);
   		$ses->redirect("/$code.html");
   }

   $f->{id}||=$ses->getCookie('id');

   my $premium = $ses->getUser && $ses->getUser->{premium};

   my $file = $db->SelectARefCachedKey("filedl$f->{id}",120,
                                       "SELECT f.*, s.*, h.*, u.usr_login as file_usr_login, u.*,
                                               DATE_FORMAT(file_created,'%b %e, %Y') as file_created_txt
                                        FROM (Files f, Servers s, Hosts h)
                                        LEFT JOIN Users u ON f.usr_id = u.usr_id
                                        WHERE f.file_code=?
                                        AND f.srv_id=s.srv_id
                                        AND s.host_id=h.host_id",$f->{id})->[0];

   my $fname2 = lc $file->{file_name} if $file;
   #$fname=~s/\s/_/g;
   $fname2=~s/\s/_/g;
   #$fname=~s/\.\w{2,5}$//;$fname=~s/\.\w{2,5}$//;
   $fname2=~s/\.\w{2,5}$//;$fname2=~s/\.\w{2,5}$//;
   
   #return $ses->redirect("$c->{site_url}/?op=del_file&id=$f->{id}&del_id=$1") if $ENV{REQUEST_URI}=~/\?killcode=(\w+)$/i;
   #return $ses->message("No such file with this filename") if $file && $fname && $fname2 ne lc $fname;

   my $reason;
   unless($file)
   {
      $reason = $db->SelectRowCached(300,"SELECT * FROM DelReasons WHERE file_code=?",$f->{id});
      $db->Exec("UPDATE DelReasons SET last_access=NOW() WHERE file_code=?",$reason->{file_code}) if $reason;
   }

   my $fname=$file->{file_title} if $file;
   $fname=$reason->{file_name} if $reason;
   $fname=~s/[_\.-]+/ /g;
   $fname=~s/([a-z])([A-Z][a-z])/$1 $2/g;
   my @fn = grep{length($_)>2 && $_!~/(www|net|ddl)/i}split(/[\s\.]+/, $fname);
   $ses->{page_title} = $ses->{lang}->{lng_download_watch}." ".join(' ',@fn);
   $ses->{meta_descr} = $ses->{lang}->{lng_download_watch_video}." ".join(' ',@fn);
   $ses->{meta_keywords} = lc join(', ',@fn);

   return $ses->PrintTemplate("download1_deleted.html",%$reason) if $reason;
   return $ses->PrintTemplate("download1_no_file.html") unless $file;

   SSD_P2P_Logic($file) if $c->{m_y} || $c->{p2p_on};

   return $ses->message("This server is in maintenance mode. Refresh this page in some minutes.") if $file->{srv_status} eq 'OFF';

   my $udlist = $db->SelectARefCached("SELECT * FROM UserData WHERE usr_id=?",$file->{usr_id});
   $file->{$_->{name}}=$_->{value} for @$udlist;
   return $ses->message($ses->{lang}->{lng_download_watch_embed_only}) if $file->{usr_embed_access_only};
   # if($file->{banned_countries})
   # {
   # 		my $country = $ses->getMyCountry;
   # 		return $ses->message("Video error: RC1$country"."RC") if $country=~/^($file->{banned_countries})$/i;
   # }
   return $ses->message("Video error: RC1".$ses->getMyCountry."RC") if $file->{banned_countries} && XUtils::isBannedCountry($ses->getMyCountry, $file->{banned_countries});
   return $ses->message("Video error: RI1RI") if $file->{banned_ips} && XUtils::isBannedIP($ses->getIP, $file->{banned_ips});

   $file->{file_title} ||= $fname2;

   $file->{download_link} = $ses->makeFileLink($file);

   if($f->{op} eq 'download1' && $c->{pre_download} && $f->{hash})
   {
      $f->{hash}='' unless $ses->HashCheck($f->{hash},$file->{file_id});
   }

   if($f->{op} eq 'download1' && $c->{pre_download} && !$f->{hash})
   {
      my $hash = $ses->HashSave($file->{file_id},$c->{download_countdown});
      return $ses->PrintTemplate("download0.html", 
                                 %{$file},
                                 m_j_hide  => $c->{m_j_hide} && $c->{m_j},
                                 countdown => $c->{download_countdown},
                                 hash      => $hash,
                                 aff       => $file->{usr_id},
                                 referer   => $f->{referer} );
   }

   &Download2('no_checks') if  $premium &&
                               !$c->{captcha} &&
                               !$c->{download_countdown} &&
                               $ses->getUser->{usr_direct_downloads};

   my $category = $db->SelectRowCached(300,"SELECT * FROM Categories WHERE cat_id=?",$file->{cat_id}) if $file->{cat_id};
   $file->{category} = $file->{category2} = $category->{cat_name};
   $file->{category2} =~ s/\s+/+/g;
   $file->{cat_premium} = $category->{cat_premium};

   $file = &Download1Checks($file);
   if($file->{message})
   {
       $file->{video_wait}=1;
       $file->{msg2}=$file->{message};
       $file->{message}='';
   }

   $file->{ophash} = $ses->HashSave($file->{file_id},0);

   $file->{file_descr}=~s/\n/<br>/gs;

   my @plans;
   if($c->{payment_plans} && !$premium && $c->{enabled_prem})
   {
      for( split(/,/,$c->{payment_plans}) )
      {
         /([\d\.]+)=(\d+)/;
         push @plans, { amount=>$1, days=>$2, site_url=>$c->{site_url} };
      }
   }
   if($c->{enable_file_comments} && !$c->{highload_mode})
   {
      $file->{comments} = &CommentsList(1,$file->{file_id});
   }
   if($c->{show_more_files} && !$c->{highload_mode})
   {
      $file->{more_files} = getMoreFiles($file,$c->{more_files_number});

      $ses->processVideoList($file->{more_files});
      $file->{files} = $file->{more_files};
   }

   if($ENV{QUERY_STRING}=~/list=(\w+)/i && !$c->{highload_mode})
   {
      $file->{playlist} = $1;
      my $pl = $db->SelectRow("SELECT * FROM Playlists WHERE pls_code=?",$file->{playlist});
      my $curr = $db->SelectRow("SELECT * FROM Files2Playlists f2p WHERE f2p.pls_id=? AND file_id=?", $pl->{pls_id}, $file->{file_id} );
      if($pl && $curr)
      {
          my $prev = $db->SelectRow("SELECT * FROM Files f, Files2Playlists f2p 
                                      WHERE f2p.pls_id=? 
                                      AND f2p.created<? 
                                      AND f2p.file_id=f.file_id
                                      ORDER BY created DESC
                                      LIMIT 1", $pl->{pls_id}, $curr->{created} );
          my $next = $db->SelectRow("SELECT * FROM Files f, Files2Playlists f2p 
                                      WHERE f2p.pls_id=? 
                                      AND f2p.created>? 
                                      AND f2p.file_id=f.file_id
                                      ORDER BY created
                                      LIMIT 1", $pl->{pls_id}, $curr->{created} );
          if($prev)
          {
            $file->{"playlist_prev_title"} = $ses->shortenString($prev->{file_title},32);
            $file->{"playlist_prev"} = $ses->makeFileLink($prev)."?list=$file->{playlist}";
          }
          if($next)
          {
            $file->{"playlist_next_title"} = $ses->shortenString($next->{file_title},32);
            $file->{"playlist_next"} = $ses->makeFileLink($next)."?list=$file->{playlist}";
          }
      }
   }

   $file->{embed_code} = $ses->makeEmbedCode($file);

   $file->{add_to_account}=1 if $ses->getUser && $c->{file_cloning};# && $file->{usr_id}!=$ses->getUserId;
   $c->{ads}=0 if $c->{bad_ads_words} && ($file->{file_name}=~/$c->{bad_ads_words}/is || $file->{file_descr}=~/$c->{bad_ads_words}/is);
   #$file->{video_ads}=1 if $c->{m_ads} && $c->{ads};
   $file->{video_ads}=1 if $c->{ads};
   $file->{video_embed_code}=1 if $c->{video_embed};

   playerMakeCode($file);

   my $tags = $db->SelectARefCached("SELECT * FROM Tags t, Tags2Files t2f WHERE t2f.file_id=? AND t2f.tag_id=t.tag_id",$file->{file_id}) if !$c->{highload_mode};
   for(@$tags)
   {
      $_->{tag_value2}=$_->{tag_value};
      $_->{tag_value2}=~s/ /\+/g;
   }

   $file->{voted} = $db->SelectOneCached(10,"SELECT vote FROM Votes WHERE file_id=? AND usr_id=?",$file->{file_id},$ses->getUserId) if $ses->getUserId;
   $file->{"voted_".{-1 => 'down', 1 => 'up'}->{$file->{voted}}} = ' active';
   #my $show_vote = 1 if $ses->getUserId && !$file->{voted};
   my $votes = $db->SelectARefCached(30,"SELECT vote, COUNT(*) as num FROM Votes WHERE file_id=? GROUP BY vote",$file->{file_id});
   for(@$votes)
   {
      $file->{likes}=$_->{num} if $_->{vote}==1;
      $file->{dislikes}=$_->{num} if $_->{vote}==-1;
   }
   $file->{likes}||=0;
   $file->{dislikes}||=0;
   $file->{likes_percent}=sprintf("%.1f",100*$file->{likes}/($file->{likes}+$file->{dislikes})) if $file->{likes} || $file->{dislikes};
   $file->{likes_percent}=50 unless $file->{likes} || $file->{dislikes};

   $file->{edit_ok}=1 if ($file->{usr_id} && $file->{usr_id}==$ses->getUserId) || $ses->getUser && $ses->getUser->{usr_adm};
   $file->{download_original}=1 if $c->{download} && !$file->{no_dl_btn};

   $file->{download_original}=0 unless $file->{file_size_o} || $file->{file_size_n} || $file->{file_size_h} || $file->{file_size_l};

   if($ses->getUser && $ses->getUser->{usr_adm})
   {
       $file->{featured}=1 if $db->SelectOneCached("SELECT file_id FROM FilesFeatured WHERE file_id=?",$file->{file_id});
   }

    $file->{extra_data} = $db->SelectARefCached("SELECT * FROM FilesData WHERE file_id=?",$file->{file_id}) if $c->{file_data_fields};
    for(@{$file->{extra_data}})
    {
        $_->{value2} = $_->{value};
        $_->{value2} =~ s/\s+/+/g;
    }

    # if($ses->getUserId)
    # {
    #     $file->{favorited}=1 if $db->SelectOne("SELECT file_id FROM Favorites WHERE usr_id=? AND file_id=?",$ses->getUserId,$file->{file_id});
    # }
    # else
    unless($ses->getUserId)
    {
        $file->{favorited}=1 if $ses->getCookie("fav")=~/$file->{file_code}/i;
    }


    $file->{deurl} = $ses->shortenURL($file->{file_id}) if $c->{m_j};

    $file->{versions} = getVideoVersions($file) if $file->{download_original};

    $file->{downloads}=1 if $file->{download_original};

    $file->{playlists} = $db->SelectARefCached("SELECT p.*, COUNT(f.file_id) as num
                                               FROM Playlists p
                                               LEFT JOIN Files2Playlists f ON p.pls_id=f.pls_id
                                               WHERE p.usr_id=? 
                                               AND p.pls_name <> 'Watch later'
                                               GROUP BY p.pls_id", $ses->getUserId ) if $ses->getUserId && !$c->{highload_mode};

    $file->{playlist_watch_later} = $db->SelectOneCached("SELECT COUNT(f.file_id) as num
                                               FROM Playlists p
                                               LEFT JOIN Files2Playlists f ON p.pls_id=f.pls_id
                                               WHERE p.usr_id=? 
                                               AND p.pls_name = 'Watch later'
                                               GROUP BY p.pls_id", $ses->getUserId )||0 if $ses->getUserId && !$c->{highload_mode};

    $file->{usr_channel_name}||=$file->{file_usr_login};
    $file->{user_avatar_url} = "$c->{site_url}/upload-data/avatar_$file->{usr_id}.jpg" if -e "$c->{site_path}/upload-data/avatar_$file->{usr_id}.jpg";
    $file->{usr_disable_adb} = $c->{force_disable_adb}==2 ? $file->{usr_disable_adb} : $c->{force_disable_adb};

    # template for mobiles
    my $tmpl = $ses->isMobile ? "download1_mobile.html" : "download1.html";

    return $ses->PrintTemplate($tmpl,
                       %{$file},
                       %{$c},
                       'msg'           => $f->{msg}||$file->{message},
                       'site_name'     => $c->{site_name},
                       'countdown'     => $c->{download_countdown},
                       'premium'       => $premium,
                       'aff'           => $file->{usr_id},
                       'referer'       => $f->{referer},
                       #'more_files'    => $more_files,
                       'cmt_type'      => 1,
                       'cmt_ext_id'    => $file->{file_id},
                       'rnd1'          => $ses->randchar(6),
                       #'show_vote'     => $show_vote,
                       'tags'          => $tags,
                       "comments_$c->{enable_file_comments}" => 1,
                       #'facebook_like_on' => $c->{facebook_like_on},
                       #'hash'          => $hash,
                      );
}

sub playerMakeCode
{
    my ($file) = @_;

	#$file->{message} = "$ses->{lang}->{lng_download_video_processing_now}" if $c->{noplay_from_uploader_encoder};

    if(!$c->{noplay_from_uploader_encoder} &&
	 	(
			$file->{file_size_n} || 
			$file->{file_size_h} || 
			$file->{file_size_l} || 
			($file->{file_size_p} && $c->{m_p_show}) || 
			webPlayable($file)
      )  # play original while encoding
      #|| ($c->{show_divx_player} && divxPlayable($file)) # play avi/mkv while encoding
     )
    {
      $file = $file->{message}||$file->{msg2} ? VideoMakeCode($file,'info') : VideoMakeCode($file);
    }
    else
    {
      my $enc = $db->SelectRow("SELECT * FROM QueueEncoding WHERE file_real_id=? ORDER BY status DESC LIMIT 1",$file->{file_real_id}||$file->{file_id});
      if($enc && $enc->{error})
      {
        $file->{msg2} = "Video encoding error.";
        $file = VideoMakeCode($file,'info'); # just get info & snapshot
        $file->{video_wait}=1;
      }
      else
      {
        # if( webPlayable($file) ) # play original video while encoding
        # {
        #   $file = $file->{message}||$file->{msg2} ? VideoMakeCode($file,'info') : VideoMakeCode($file);
        # }
        # else
        # {
          $file->{msg2} = "$ses->{lang}->{lng_download_video_processing_now} <span id='enc_pp'>...</span>";
          $file = VideoMakeCode($file,'info'); # just get info & snapshot
          $file->{video_wait}=1;
          $file->{enc_status}=1; # ajax status update
        # }
      }
    }
}

sub DownloadOriginal
{
   return $ses->message($c->{maintenance_download_msg}||"Downloads are temporarily disabled due to site maintenance","Site maintenance") if $c->{maintenance_download};
   return $ses->message("Video pages disabled") if $c->{video_page_disabled};
   my $no_checks = shift;
   my $usr_id = $ses->getUser ? $ses->getUserId : 0;
   my $file = $db->SelectRow("SELECT *, INET_NTOA(file_ip) as file_ip, u.usr_premium_dl_only
                              FROM (Files f, Servers s)
                              LEFT JOIN Users u ON f.usr_id=u.usr_id 
                              WHERE f.file_code=? 
                              AND f.srv_id=s.srv_id",$f->{id});
   return $ses->message("No such file=$f->{id}") unless $file;
   #my $premium = $usr_id && $ses->getUser->{premium};

#  unless($no_checks)
#  {
#     #return &UploadForm unless $ENV{REQUEST_METHOD} eq 'POST';
#     #return &Download1 unless $ses->HashCheck($f->{hash},$file->{file_id});
#     #return &Download1 unless $ses->SecCheck( $f->{'rand'}, $file->{file_id}, $f->{code} );
#  }


   $file = DownloadOriginalChecks($file);

   if($file->{message})
   {
      my $hash = $ses->HashSave($file->{file_id},1);
      return $ses->PrintTemplate("download_original_error.html", 
                                 msg => $file->{message}, 
                                 %$file,
                                 mode => $f->{mode},
                                 hash => $hash,
                                );
      #$f->{msg} = $file->{message};
      #return Download1;
      #return $ses->message($file->{message});
   }
   
   my $mode = $f->{mode};
   $file->{file_size} = $file->{"file_size_$mode"};
   $file->{file_name}.='.mp4' if $mode ne 'o' && $file->{file_name}!~/\.mp4$/i;
   $file->{file_name}=~s/\s+/_/g;

   $file->{direct}=$f->{direct}=1;
   $file->{file_name}=~s/\s+/_/g;
   $file->{direct_link} = genDirectLink($file,$mode,0,$file->{file_name}); #DownloadGenLink($file,'',$mode)||return;

   #$file->{download}=1;
   TrackDownload($file);

   $file->{fsize} = $ses->makeFileSize($file->{file_size});

   return $ses->PrintTemplate("download_original.html",
                       %{$file},
                       %$c,
                       symlink_expire   => $c->{symlink_expire},
                       ip               => $ses->getIP,
                      );
}

# sub DownloadGenLink
# {
#    my ($file,$fname,$mode) = @_;
#    $fname ||= $file->{file_name};
#    # $mode='' if $mode && !$file->{"file_size_$mode"} && $mode ne 'o';
#    # $mode ||= 'n' if $file->{file_size_n};
#    # $mode ||= 'h' if $file->{file_size_h};
#    # $mode ||= 'l' if $file->{file_size_l};
#    return $ses->message("Video version not available") unless $file->{"file_size_$mode"};

#    #TrackView($file,$mode);

#    my ($ext) = $file->{"file_spec_$mode"}=~/\|(mp4|flv)$/;
#    $ext||='mp4';
#    #$fname.=".$ext" unless $mode eq 'o';
#    $fname.=".$ext" unless $f->{op} eq 'download_orig';

   
#    #else
#    #{
#        return genDirectLink($file,$mode,$c->{symlink_expire}*60,$fname);
#    #}
# }

sub genDirectLink
{
   my ( $file, $quality, $expire, $fname, $hash_only )=@_;
   require HCE_MD5;
   my $hce = HCE_MD5->new($c->{dl_key},"XVideoSharing");
   my $usr_id = $ses->getUser ? $ses->getUserId : 0;
   my $dx = sprintf("%d",($file->{file_real_id}||$file->{file_id})/$c->{files_per_folder});
   my $watch_speed = $c->{"watch_speed_$quality"} || $c->{watch_speed_h} || $c->{watch_speed_n};
   if($c->{"watch_speed_auto_$quality"} && $file->{file_length})
   {
      $watch_speed = int 1.4*$file->{"file_size_$quality"}/$file->{file_length}/1024;
   }
   my $speed = $file->{direct} ? $c->{down_speed} : $watch_speed;
   $expire ||= $c->{symlink_expire}*60;
   my $flags;
   $flags |= 1 if $f->{direct}; # Dowload
   $flags |= 2 if $f->{embed};  # Embedded
   #$flags |= 4 if $f->{embed};  # Transfer
   $flags |= 8 if $c->{no_video_ip_check}; # Disable IP check

   #my $ip = $c->{no_video_ip_check} ? '0.0.0.0' : $ses->getIP;
   my $ip = $ses->getIP;
   $expire=-600 if $ses->{badlink}; # expired link for banned IP

   my $hash = &encode32( $hce->hce_block_encrypt(pack("SCLLSA12ASC4LC",
                                                       $c->{video_time_limit}||0,
                                                       $file->{disk_id},
                                                       $file->{file_id},
                                                       $usr_id,
                                                       $dx,
                                                       $file->{file_real},
                                                       $quality,
                                                       $speed,
                                                       split(/\./,$ip),
                                                       time+60*$expire,
                                                       $flags)) );
   #$file->{file_name}=~s/%/%25/g;
   return $hash if $hash_only;
   $fname||=$file->{file_name};
   #$file->{srv_htdocs_url}="http://xis.tt/cgi-bin/r.cgi/$file->{srv_id}";
   return "$file->{srv_htdocs_url}/$hash/$fname";
}

# Transfers special link
sub genDirectLink2
{
   my ($file,$mode,$fname)=@_;
   my $speed = $file->{host_transfer_speed} || $c->{server_transfer_speed} || 25000; # KB, 15000 = 150 mbit/s
   require HCE_MD5;
   my $hce = HCE_MD5->new($c->{dl_key},"XVideoSharing");
   my $usr_id = 0;
   my $dx = sprintf("%d",($file->{file_real_id}||$file->{file_id})/$c->{files_per_folder});
   my $flags=4; # transfer flag
   my $hash = &encode32( $hce->hce_block_encrypt(pack("SCLLSA12ASC4LC",
                                                       0,
                                                       $file->{disk_id},
                                                       $file->{file_id},
                                                       $usr_id,
                                                       $dx,
                                                       $file->{file_real},
                                                       $mode,
                                                       $speed,
                                                       0,0,0,0,
                                                       time+60*9200,
                                                       $flags)) );
   $fname ||= $file->{file_real};
   return "$file->{srv_htdocs_url}/$hash/$fname";
}

sub genRTMPsmil
{
    $f->{h} = $ses->decode32($f->{h});
    require HCE_MD5;
    my $hce = HCE_MD5->new($c->{dl_key},"XVideoSharing");
    my ($srv_id,$disk_id,$file_id,$usr_id,$dx,$id,$dmode,$speed,$i1,$i2,$i3,$i4,$expire,$flags) = unpack("SCLLSA12ASC4LC", $hce->hce_block_decrypt($f->{h}) );

    print("Content-type:text/html\n\nExpired($expire)".time),return if $expire<time;
    print("Content-type:text/html\n\nBad IP"),return unless $ses->getIP=~/^$i1\.$i2\./ || $c->{no_video_ip_check};

    my $file = $db->SelectRowCached("SELECT * FROM Files f, Servers s WHERE f.file_id=? AND f.srv_id=s.srv_id",$file_id);

    $dx = sprintf("%05d",($file->{file_real_id}||$file->{file_id})/$c->{files_per_folder});

    my $videos;
    for my $q ('h','n','l')
    {
        next unless $file->{"file_size_$q"};
        next if $q eq 'h' && !$c->{vid_play_h};
        #next if $q eq 'o' && $videos;
        my $vinfo = $ses->vInfo($file,$q);
        my $hash = genDirectLink($file, $q, 0, "v", 'hash_only');
        my $bitrate = int $file->{"file_size_$q"}/$vinfo->{vid_length};
        $videos.=qq[      <video src="$vinfo->{vid_container}:$file->{disk_id}/$dx/$file->{file_real}\_$q?h=$hash" height="$vinfo->{vid_height}" system-bitrate="$bitrate" width="$vinfo->{vid_width}" />\n];
    }

    my $srv_url = $file->{srv_htdocs_url};
    $srv_url=~s/:(\d+)$//;
    $srv_url=~s/http:\/\///;
    my $streamer = "rtmp://$srv_url:$c->{m_q_port}/vod/";

    print"Content-type:text/smil\n\n";
    print <<EOP
<smil>
  <head>
    <meta base="$streamer" />
  </head>
  <body>
    <switch>
$videos
    </switch>
  </body>
</smil>
EOP
;
}

sub VideoMakeCode
{
   my ($file,$info) = @_;

   $ses->getVideoInfo($file);
   my $vx = $ses->vInfo($file,'n');

   $vx->{vid_width}  ||= $file->{vid_width}||640;
   $vx->{vid_height} ||= $file->{vid_height}||360;

   ($file->{play_w},$file->{play_h}) = ( $vx->{vid_width} , $vx->{vid_height} );
   if($c->{m_v_width})
   {
      if($c->{m_v_width} && $c->{m_v_height})
      {
          ($file->{play_w},$file->{play_h}) = ($c->{m_v_width},$c->{m_v_height});
      }
      else # using only player width
      {
          $file->{play_w} = $c->{m_v_width};
          $file->{play_h} = sprintf("%.0f", $c->{m_v_width} * $vx->{vid_height}/$vx->{vid_width} );
      }
   }

   # Embed override
   $file->{play_w}=$f->{w} if $f->{w};
   $file->{play_h}=$f->{h} if $f->{h};

   return $file if $info;

   ###############

   #$c->{vid_play_h}=0 if $ses->isMobile; # don't show HD for mobiles

   my $quality;
   #$quality = 'l' if $ses->isMobile && $file->{file_size_l};
   $quality = 'p' if $file->{preview} && $file->{file_size_p};
   $quality  ||= 'n' if $file->{file_size_n};
   $quality  ||= 'l' if $file->{file_size_l};
   $quality  ||= 'h' if $file->{file_size_h};
   $quality  ||= 'o' if $file->{file_size_o} && webPlayable($file);

   if($quality)
   { 
       my $vid_play_h = $c->{vid_play_h};
       $vid_play_h=0 if $c->{overload_no_hd} && $file->{host_out} > $file->{host_net_speed}*0.9;
       $vid_play_h=0 if $f->{embed} && $c->{embed_no_hd};
       my $preview = $file->{file_size_p} && $c->{m_p_show} && $c->{m_p} ? 1 : 0;
       # if($c->{m_q} && $c->{m_q_streaming} && !$ses->isMobile && !$f->{direct} && $quality ne 'o' && !$preview) # RTMP
       # {
       #     my $ext = lc($ses->vInfo($file,$quality)->{vid_container}) || 'mp4';
       #     $file->{http_fallback} = genDirectLink( $file, $quality, 0, "v.$ext" ) if $c->{m_q_http_fallback};

       #     if($c->{m_q_smil} && $c->{player}=~/^(jw6|jw7|clappr)$/i) # SMIL multiple qualities
       #     {
       #         my $hash = genDirectLink($file, 'a', 0, '', 'hash_only');
       #         $file->{direct_link} = "$c->{site_url}/$hash.smil";
       #         $file->{smil} = 1;
       #     }
       #     else # single RTMP file
       #     {
       #         my $hash = genDirectLink( $file, $quality, 0, '', 'hash_only' );
       #         my $dx = sprintf("%05d",($file->{file_real_id}||$file->{file_id})/$c->{files_per_folder});
       #         $file->{direct_link} = "mp4:$file->{disk_id}/$dx/$file->{file_real}_$quality?h=$hash";
       #         $file->{rtmp} = 1;
       #     }
       # }
       if($preview)
       {
       		$file->{direct_link} = genDirectLink($file,'p',0,"p.mp4");
       }
       else
       {
           my $ext = lc $ses->vInfo($file,$quality)->{vid_container} || 'mp4';
           $file->{direct_link} = genDirectLink($file,$quality,0,"v.$ext");

           if($file->{file_size_h} && $vid_play_h && $quality ne 'h')
           {
              my $exth = lc $ses->vInfo($file,'h')->{vid_container} || 'mp4';
              $file->{direct_link_hd} = genDirectLink($file,'h',0,"v.$exth");
           }

           if($file->{file_size_l} && $quality ne 'l')
           {
              my $exth = lc $ses->vInfo($file,'l')->{vid_container} || 'mp4';
              $file->{direct_link_lq} = genDirectLink($file,'l',0,"v.$exth");
           }
       }

       if($c->{m_r} && !$preview)
       {
           $file->{hash_l} = genDirectLink( $file, 'l', $c->{symlink_expire}*60, '', 'hash_only') if $file->{file_size_l} && $ses->vInfo($file,'l')->{vid_container} eq 'mp4';
           $file->{hash_n} = genDirectLink( $file, 'n', $c->{symlink_expire}*60, '', 'hash_only') if $file->{file_size_n} && $ses->vInfo($file,'n')->{vid_container} eq 'mp4';
           $file->{hash_h} = genDirectLink( $file, 'h', $c->{symlink_expire}*60, '', 'hash_only') if $file->{file_size_h} && $ses->vInfo($file,'h')->{vid_container} eq 'mp4' && $vid_play_h;
           $file->{hash_o} = genDirectLink( $file, 'o', $c->{symlink_expire}*60, '', 'hash_only') if $file->{file_size_o} && $ses->vInfo($file,'o')->{vid_container} eq 'mp4';
           my @arr;
           push @arr, $file->{hash_l} if $file->{hash_l};
           push @arr, $file->{hash_n} if $file->{hash_n};
           push @arr, $file->{hash_h} if $file->{hash_h};
           push @arr, $file->{hash_o} if $file->{hash_o};
           my ($pre,@sources) = makeURLSet(@arr);
           #$file->{dash_direct} = "$file->{srv_htdocs_url}/dash/$hash_n/manifest.mpd";
           $file->{hls_pre} = $pre;
           $file->{dash_direct} = "$file->{srv_htdocs_url}/dash/$pre,".join(",",@sources).",.urlset/manifest.mpd" if $c->{m_r_dash} && @sources;
           $file->{hls_direct} = "$file->{srv_htdocs_url}/hls/$pre,".join(",",@sources).",.urlset/master.m3u8" if $c->{m_r_hls} && @sources;
       }
   }

   my $player = $c->{player};

   return $file unless $file->{direct_link};

   ( $file->{video_code_html}, $file->{video_code_js} ) = $ses->getPlugins('Player')->makePlayerCode( $f, $file, $c, $player );
   $file->{video_code_js} = encodeJS( $file->{video_code_js} );

   return $file;
}

sub makeURLSet
{
  my (@l) = @_;
  my $i=0;
  for my $k (0..length($l[0]))
  {
     for (1..$#l){
      $i=$k if substr($l[0],$k,1) ne substr($l[$_],$k,1);
     }
     last if $i;
  }
  my $pre = substr($l[0],0,$i);
  substr($_,0,$i)='' for @l;
  return ($pre,@l);
}

sub encodeJS
{
  my ($s) = @_;
  require Pack;
  $s = &Pack::pack($s,36,0,0) if $c->{player_js_encode};
  return "<script type='text/javascript'>$s</script>";
}

sub checkRecaptchaHash
{
	my $passed=0;
	my $ip = join '', (split(/\./, $ses->getIP))[0,1,2];
	if($f->{'g-recaptcha-response'} && $ENV{REQUEST_METHOD} eq 'POST')
	{
		if($ses->checkRecaptcha)
		{
			$passed=1;
			require Digest::SHA;
			my $exp = time + $c->{watch_require_recaptcha_expire}*60;
	 		my $hash = Digest::SHA::sha1_hex("$exp-$ip-$c->{dl_key}-$c->{user_agent}");
			$ses->setCookie("vcap$ip","$exp-$hash","+$c->{watch_require_recaptcha_expire}m");
		}
	}
	if(!$passed && $ses->getCookie("vcap$ip"))
	{
		my ($exp,$hash) = $ses->getCookie("vcap$ip")=~/^(\d+)-(.+)$/;
		if($exp > time)
		{
		 	require Digest::SHA;
		 	my $hash2 = Digest::SHA::sha1_hex("$exp-$ip-$c->{dl_key}-$c->{user_agent}");
		 	$passed=1 if $hash eq $hash2;
		}
	}
	return $passed;
}

sub Embed
{
   $ses->{xframe}=1;
   $ses->{form}->{no_hdr}=1;
   return $ses->message("Embeds disabled")  if $c->{embed_disabled};
   return $ses->message("Embeds disabled2") if $c->{embed_disable_noref} && !$ENV{HTTP_REFERER};
   return $ses->message("Embeds disabled3") if $c->{embed_disable_except_domains} && $ses->getDomain($ENV{HTTP_REFERER})!~/^($c->{embed_disable_except_domains})$/i;
   return $ses->message("Embeds disabled4") if $c->{embed_disable_only_domains} && $ses->getDomain($ENV{HTTP_REFERER})=~/^($c->{embed_disable_only_domains})$/i;
   if($c->{m_7} && $c->{m_7_video_embed} && ($c->{m_7_video_noserver}||$c->{m_7_video_noproxy}||$c->{m_7_video_notor}))
   {
   		my $is_server = XUtils::getIPBlockedStatus( $ses->db, 'ipserver', $ses->getIP ) if $c->{m_7_video_noserver};
   		my $is_proxy  = XUtils::getIPBlockedStatus( $ses->db, 'ipproxy', $ses->getIP ) if $c->{m_7_video_noproxy} && !$is_server;
   		my $is_tor    = XUtils::getIPBlockedStatus( $ses->db, 'iptor', $ses->getIP ) if $c->{m_7_video_notor} && !$is_server && !$is_proxy;
   		if( $is_server || $is_proxy || $is_tor )
   		{
   			my $is_white = XUtils::getIPBlockedStatus( $ses->db, 'ipwhite', $ses->getIP );
   			$db->Exec("INSERT INTO StatsMisc
		              SET usr_id=0, day=CURDATE(), name='ipblock_blocked', value=1
		              ON DUPLICATE KEY 
		              UPDATE value=value+1") if $c->{m_7_stats} && !$is_white;
   			if($is_white)
   			{
   				# do nothing
   				#return $ses->message('white');
   			}
   			elsif($c->{m_7_video_action} eq 'redirect')
   			{
   				return $ses->redirect($c->{site_url});
   			}
   			elsif($c->{m_7_video_action} eq 'message' && $c->{m_7_video_action_message_txt})
   			{
   				return $ses->message($c->{m_7_video_action_message_txt});
   			}
   			elsif($c->{m_7_video_action} eq 'badlink')
   			{
   				$ses->{badlink}=1;
   			}
   		}
   }
   if($c->{watch_require_recaptcha})
   {
   	 unless(checkRecaptchaHash())
   	 {
   	 	return $ses->PrintTemplate("video_embed_recaptcha.html", file_code => $f->{file_code}, recaptcha => $ses->genRecaptcha('auto') );
   	 }
   }
   my $file = $db->SelectRow("SELECT f.*, s.*, h.*, u.usr_id, UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec
                              FROM (Files f, Servers s, Hosts h)
                              LEFT JOIN Users u ON f.usr_id = u.usr_id
                              WHERE f.file_code=?
                              AND f.srv_id=s.srv_id
                              AND s.host_id=h.host_id",$f->{file_code});
   #return print("Content-type:text/html\n\nFile was deleted") unless $file;
   return $ses->PrintTemplate("video_embed_deleted.html") unless $file;
   my $utype2 = $file->{usr_id} ? ($file->{exp_sec}>0 ? 'prem' : 'reg') : 'anon';
   return print("Content-type:text/html\n\nVideo embed restricted for this user") unless $c->{"video_embed_$utype2"};
   return print("Content-type:text/html\n\nThis server is in maintenance mode. Refresh this page in some minutes.") if $file->{srv_status} eq 'OFF';
   $file->{autostart}=1 if $ENV{REQUEST_URI}=~/auto=1/;

   my (undef,undef,undef,$hh,undef,undef) = $ses->getTime;
   if($c->{m_y} && $file->{srv_id_copy} && $c->{ssd_hours} && $hh=~/^($c->{ssd_hours})$/)
   {
     my $ssd = $db->SelectRowCached("SELECT * FROM Servers WHERE srv_id=?",$file->{srv_id_copy});
     if($ssd->{srv_status} ne 'OFF')
     {
        $file->{$_}=$ssd->{$_} for keys %$ssd;
     }
   }
   
   my $udlist = $db->SelectARefCached("SELECT * FROM UserData WHERE usr_id=?",$file->{usr_id});
   $file->{$_->{name}}=$_->{value} for @$udlist;

   if($file->{embed_domain_allowed})
   {
     my $dhash;
     $dhash->{$_}=1 for split /\s*,\s*/, $file->{embed_domain_allowed};
     my ($domain) = $ENV{HTTP_REFERER}=~/\/\/(.+?)(\/|$)/i;
     $domain=~s/www\.//;
     return print("Content-type:text/html\n\nVideo embed restricted for this domain") if $domain && !$dhash->{lc($domain)};
   }
   # if($file->{banned_countries})
   # {
   # 		my $country = $ses->getMyCountry;
   # 		return print("Content-type:text/html\n\nVideo error: RC2$country"."RC") if $country=~/^($file->{banned_countries})$/i;
   # }
   return print("Content-type:text/html\n\nVideo error: RC2".$ses->getMyCountry."RC") if $file->{banned_countries} && XUtils::isBannedCountry($ses->getMyCountry, $file->{banned_countries});
   return print("Content-type:text/html\n\nVideo error: RI2RI") if $file->{banned_ips} && XUtils::isBannedIP($ses->getIP, $file->{banned_ips});
   $f->{embed}=$file->{embed}=1;
   $file = Download1Checks($file);
   if($file->{message})
   {
       $file->{video_wait}=1;
       $file->{msg2}=$file->{message};
       $file->{message}='';
   }

   SSD_P2P_Logic($file) if $c->{m_y} || $c->{p2p_on};

   $file->{ophash} = $ses->HashSave($file->{file_id},0);

   $file->{embed_code} = $ses->makeEmbedCode($file);

   playerMakeCode($file);

   #return print("Content-type:text/html\n\nCan't create video code") unless $file->{video_code};
   $file->{video_ads} = $c->{ads} ? 1 : 0;
   $file->{video_ads} = 0 if $file->{usr_notes}=~/NOADS/i;
   
   $file->{referer}||=$ENV{HTTP_REFERER};
   $file->{'aff'} = $file->{usr_id};
   $file->{usr_disable_adb} = $c->{force_disable_adb}==2 ? $file->{usr_disable_adb} : $c->{force_disable_adb};

   my $tmpl = $ses->isMobile ? "video_embed_mobile.html" : "video_embed.html";

   return $ses->PrintTemplate($tmpl,
                              %$file,
                             );
}

sub View
{
  print"Content-type:text/html\n\n";
  my $file = $db->SelectRow("SELECT *, INET_NTOA(file_ip) as file_ip FROM Files WHERE file_code=?",$f->{file_code});
  return unless $file;
  return unless $ses->HashCheck($f->{hash},$file->{file_id});
  TrackView($file);
  #my $views = $db->SelectOne("SELECT file_views FROM Files WHERE file_id=?",$file->{file_id});
  $file->{file_views}++;
  print"$file->{file_views}";
  return;
}

sub View2
{
  print"Content-type:text/html\n\n";

  # my ($file_id,$i1,$i2,$tmin,$md5) = split(/-/,$f->{hash});
  # my $dt = time - $tmin;

  # return unless $ses->HashCheck($f->{hash});

  # my $ip = $ses->getIP;
  # open(FILE,">>logs/views.txt");
  # print FILE "$ip:$file_id:$dt:$f->{embed}\n";
  # close FILE;

  print"OK";
}

sub TrackView
{
    my ($file) = @_;

    my $referer = $ses->getCookie('ref_url') || '';
    $referer='' if $referer=~/$c->{site_url}/i;
    $referer=~s/^https?:\/\///i;
    $referer=~s/^www\.//i;
    my $premium = $ses->getUser && $ses->getUser->{premium};

    $db->Exec("INSERT INTO TmpFiles
               SET file_id=?, views=1
               ON DUPLICATE KEY UPDATE views=views+1
              ", $file->{file_id} );

    $db->Exec("INSERT IGNORE INTO Views
               SET file_id=?,
                   owner_id=?,
                   ip=INET_ATON(?),
                   referer=?,
                   created=NOW(),
                   embed=?,
                   adb=?,
                   premium=?
                   ",
                     $file->{file_id},
                     $file->{usr_id}||0,
                     $ses->getIP,
                     $referer,
                     $f->{embed}||0,
                     $f->{adb}||0,
                     $premium||0,
                     );
}

sub TrackDownload
{
   my ($file) = @_;
   my $usr_id = $ses->getUser ? $ses->getUserId : 0;

   if(!$db->SelectOne("SELECT file_id FROM Downloads WHERE file_id=? AND ip=INET_ATON(?) AND usr_id=?",$file->{file_id},$ses->getIP,$usr_id))
   {
      $f->{referer}||= $ses->getCookie('ref_url') || $ENV{HTTP_REFERER};
      $f->{referer}=~s/$c->{site_url}//i;
      $f->{referer}=~s/^https?:\/\///i;
      $f->{referer}=~s/^www\.//i;
      $f->{referer}=~s/^\/$file->{file_code}//ie;

      $db->Exec("INSERT IGNORE INTO Downloads 
                 SET file_id=?, 
                     usr_id=?, 
                     owner_id=?, 
                     ip=INET_ATON(?), 
                     size=?, 
                     referer=?",$file->{file_id},
                                $usr_id,
                                $file->{usr_id}||0,
                                $ses->getIP,
                                $file->{file_size},
                                $f->{referer}||''
                                );
      my ($dl,$dl_prem) = $ses->{utype} eq 'prem' ? (0,1) : (1,0);
      $db->Exec("INSERT INTO Stats2
                 SET usr_id=?, day=CURDATE(),
                     downloads=$dl, downloads_prem=$dl_prem
                 ON DUPLICATE KEY UPDATE
                     downloads=downloads+$dl, downloads_prem=downloads_prem+$dl_prem
                ",$file->{usr_id}) if $file->{usr_id};
   }

   $db->Exec("UPDATE LOW_PRIORITY Files 
              SET file_downloads=file_downloads+1,
                  file_last_download=NOW() 
              WHERE file_id=?",$file->{file_id});

   $db->Exec("INSERT INTO Stats 
              SET day=CURDATE(), 
                  downloads=1
              ON DUPLICATE KEY UPDATE 
                  downloads=downloads+1");
}

sub CommentsList
{
   my ($cmt_type,$cmt_ext_id) = @_;
   my $list = $db->SelectARefCached(15,"SELECT *, INET_NTOA(cmt_ip) as ip, DATE_FORMAT(created,'%M %e, %Y at %r') as date
                               FROM Comments 
                               WHERE cmt_type=? 
                               AND cmt_ext_id=?
                               ORDER BY created",$cmt_type,$cmt_ext_id);
   for (@$list)
   {
      $_->{cmt_text}=~s/\n/<br>/gs;
      $_->{cmt_name} = "<a href='$_->{cmt_website}'>$_->{cmt_name}</a>" if $_->{cmt_website};
      if($ses->getUser && $ses->getUser->{usr_adm})
      {
         $_->{email} = $_->{cmt_email};
         $_->{adm} = 1;
      }
   }
   return $list;
}

sub encode32
{			
    $_=shift;
    my($l,$e);
    $_=unpack('B*',$_);
    s/(.....)/000$1/g;
    $l=length;
    if($l & 7)
    {
    	$e=substr($_,$l & ~7);
    	$_=substr($_,0,$l & ~7);
    	$_.="000$e" . '0' x (5-length $e);
    }
    $_=pack('B*', $_);
    tr|\0-\37|A-Z2-7|;
    lc($_);
}

sub EncStatus
{
   print"Content-type:text/html\n\n";
   my $enc = $db->SelectRow("SELECT *, UNIX_TIMESTAMP()-UNIX_TIMESTAMP(started) as started2
                             FROM QueueEncoding 
                             WHERE file_real_id=? 
                             ORDER BY progress DESC",$f->{id});
   unless($enc)
   {
      my $file = $db->SelectRow("SELECT * FROM Files f, Servers s WHERE f.file_id=? AND f.srv_id=s.srv_id",$f->{id});

      print("\$('#enc_pp').html('Transferring')"),return if $c->{noplay_from_uploader_encoder} && $file->{srv_type}=~/^(UPLOADER|ENCODER)$/;
      
      my $qq = $db->SelectRow("SELECT * FROM QueueTransfer WHERE file_real_id=?",$f->{id});
      print("\$('#enc_pp').html('Transferring to other server')"),return if $qq->{srv_id2};

      print("window.setTimeout('window.location.reload()',3000);"),return if $file && ($file->{file_size_n} || $file->{file_size_l} || $file->{file_size_h});

      print("\$('#enc_pp').html('Internal problem')");

      return;
   }
   if($enc->{error})
   {
       print"\$('#enc_pp').html('Encoding failed')";
   }
   elsif($enc->{status} eq 'PENDING')
   {
      my $prem="AND premium=1" if $enc->{premium};
      my $qq = $db->SelectOne("SELECT COUNT(DISTINCT file_real_id) FROM QueueEncoding WHERE srv_id=? AND created<? AND file_real_id>0 $prem",$enc->{srv_id},$enc->{created});
      $qq++;
      print"\$('#enc_pp').html('$ses->{lang}->{lng_download_pending_in_queue} #$qq')";
   }
   else
   {
      my $left = int $enc->{started2} * (100 / $enc->{progress} - 1) if $enc->{progress}>1;

      my $out = $enc->{quality} eq 'p' ? "Generating preview" : "$ses->{lang}->{lng_download_encoding_done_prc}: $enc->{progress}%<br>$left $ses->{lang}->{lng_download_seconds_left}";
      print"\$('#enc_pp').html('$out')";
   }
   return;
}

sub getVideoVersions
{
    my ($file) = @_;
    #my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?",$f->{file_code});    
    my $hash = $ses->HashSave($file->{file_id},1);
    my @versions;
    for my $mode ('o','n','h','l','p')
    {
      next unless $file->{"file_size_$mode"};
      next if $mode eq 'h' && !$c->{vid_play_h};
      my $x = $ses->vInfo($file,$mode);
      $x->{vid_title} = {'o'=>'Original', 'n'=>'Normal quality', 'h'=>'High quality', 'l'=>'Low quality', 'p'=>'Preview'}->{$mode};
      $x->{vid_mode} = $mode||'o';
      $x->{hash} = $hash;
      $x->{file_code} = $file->{file_code};
      $x->{not_available}=1 if $mode eq 'o' && !$c->{download_orig};
      push @versions, $x;
    }
    #$ses->{form}->{no_hdr}=1;
    #$ses->PrintTemplate("download1_versions.html", versions => \@versions);
    return \@versions;
}

sub checkSpecialMod
{
    my ($mod,$mod_db) = @_;
    return undef unless $c->{"m_$mod"};
    if($c->{"m_$mod\_users"} eq 'admin' && $ses->getUser)
    {
        return 1 if $ses->getUser->{usr_adm};
    }
    elsif($c->{"m_$mod\_users"} eq 'special' && $ses->getUser)
    {
        return 1 if $db->SelectOne("SELECT value FROM UserData WHERE usr_id=? AND name=?",$ses->getUserId,$mod_db);
    }
    elsif($c->{"m_$mod\_users"} eq 'premium' && $ses->getUser)
    {
        return 1 if $ses->getUser->{premium};
    }
    elsif($c->{"m_$mod\_users"} eq 'registered' && $ses->getUser)
    {
        return 1;
    }
    elsif($c->{"m_$mod\_users"} eq 'all')
    {
        return 1;
    }
    return undef;
}

sub DeURL
{
    $ses->{form}->{no_hdr}=1;
    $ses->PrintTemplate("deurl.html", msg => "Invalid link ID") unless $f->{id}=~/^\w+$/;
    my $file_id = $ses->decode_base36($f->{id});
    my $file = $db->SelectRow("SELECT * FROM Files WHERE file_id=?",$file_id);
    $ses->PrintTemplate("deurl.html", msg => "File was deleted") unless $file;
    $ses->PrintTemplate("deurl.html", 
                        %$file, 
                        m_j_hide    => $c->{m_j_hide},
                        m_j_instant => $c->{m_j_instant},
                       );
}

sub divxPlayable
{
    my ($file) = @_;
    return 1 if $file->{file_size_o} && $file->{file_name}=~/\.(avi|mkv|mp4|mov|m4v|divx)$/i;
}

sub webPlayable
{
    my ($file) = @_;
    my $spec = $file->{file_spec_o};
    return 1 if $file->{file_size_o} && $spec=~/(flv|mp4)$/i && $spec=~/h264/i && $spec=~/(aac|mp3)/i;
    return 0;
}

sub formatTime
{
   my $l = shift;
   my $tt = sprintf("%02d:%02d:%02d", $l/3600, ($l%3600)/60, $l%60, );
   #$tt=~s/^00:(\d\d:\d\d)$/$1/;
}

sub GetSlides
{
    print"Content-type: text/vtt\n\n";
    # if($c->{m_u})
    # {
    #   my $res = $ses->db->cacheDB->get("s-$f->{file_code}");
    #   print($res),return if $res;
    # }
    #my $file = $db->SelectRowCached("SELECT * FROM Files f, Servers s WHERE f.file_code=? AND f.srv_id=s.srv_id",$f->{file_code});
    #return unless $file;

    #$ses->getVideoInfo($file);

    my $out="WEBVTT\n\n";

    #my ($fw,$fh) = (108,60);
    my ($fw,$fh) = ($c->{thumb_width},$c->{thumb_height});
    my $frames = $c->{m_z_cols}*$c->{m_z_rows};
    my $dt = $f->{length}/$frames;
    my $url = $f->{url};
    for my $i (0..$frames-1)
    {
        my $x = $fw * ($i % $c->{m_z_cols});
        my $y = $fh * int($i / $c->{m_z_cols});
        my $x2 = $fw;
        my $y2 = $fh;
        #my $url = "$file->{video_img_folder}/$file->{file_real}0000.jpg";
        my $t1 = formatTime( $i*$dt );
        my $t2 = formatTime( ($i+1)*$dt );
        $out.="$t1.000 --> $t2.000\n$url#xywh=$x,$y,$x2,$y2\n\n";
    }
    
    $ses->db->cacheDB->set("s-$f->{file_code}", $out, 60*60) if $c->{m_u};

    print $out;
}

sub QueueEncNext
{
   print"Content-type:text/html\n\n";
   return unless $f->{dl_key} eq $c->{dl_key};
   my $IP = $ses->getIP;
   my $filter = $f->{host_id}=~/^\d+$/ ? "host_id='$f->{host_id}'" : "srv_ip='$IP'";
   my $list = $db->SelectARefCached("SELECT srv_id FROM Servers WHERE $filter");
   my $servers = join ',', map{$_->{srv_id}} @$list;
   return unless $servers;

   my $queue_ids = $db->SelectARef("SELECT file_real_id FROM QueueTransfer WHERE status='MOVING' AND srv_id1 IN ($servers)");
   my $active_ids = join(',', map{$_->{file_real_id}} @$queue_ids) || 0;
   my $not_transferring_now="AND q.file_real_id NOT IN ($active_ids)" if $active_ids;

   my $per_user_limit;
   if($c->{fair_encoding_slots})
   {
     my $usersall = $db->SelectOne("SELECT COUNT(DISTINCT usr_id) FROM QueueEncoding WHERE srv_id IN ($servers) AND status='PENDING'");

     my $users = $db->SelectARef("SELECT usr_id, COUNT(*) as x
                                  FROM QueueEncoding 
                                  WHERE srv_id IN ($servers) 
                                  AND status='ENCODING' 
                                  AND error='' 
                                  AND updated > NOW()-INTERVAL 30 SECOND
                                  GROUP BY usr_id");
     
     if($usersall>1 && $#$users>-1)
     {
        my $host_max_enc = $db->SelectOneCached("SELECT host_max_enc FROM Hosts WHERE host_id=?",$f->{host_id});
        my $limit = int $host_max_enc/$usersall;
        my @ulimit;
        for(@$users)
        {
          push @ulimit, $_->{usr_id} if $_->{x}>=$limit;
        }
        $per_user_limit = "AND usr_id NOT IN (".join(',',@ulimit).")" if @ulimit;
     }
   }

   my $encode_priority = "WHEN 'n' THEN 4 WHEN 'h' THEN 2 WHEN 'l' THEN 1 WHEN 'p' THEN 0.95" if $c->{m_h_enc_order} eq 'nhl';
      $encode_priority = "WHEN 'l' THEN 4 WHEN 'n' THEN 2 WHEN 'h' THEN 1 WHEN 'p' THEN 0.95" if $c->{m_h_enc_order} eq 'lnh';
      $encode_priority = "WHEN 'h' THEN 4 WHEN 'n' THEN 2 WHEN 'l' THEN 1 WHEN 'p' THEN 0.95" if $c->{m_h_enc_order} eq 'hnl';
      $encode_priority = "WHEN 'h' THEN 1 WHEN 'n' THEN 1 WHEN 'l' THEN 1 WHEN 'p' THEN 1" if $c->{m_h_enc_order} eq 'nnn';
   #my $premium_priority = "+dt*premium*5" if $c->{enc_queue_premium_priority};
   my $premium_priority = "+dt*premium*priority" if $c->{enc_queue_premium_priority} || $c->{enc_queue_notmp4_priority};

   my $next = $db->SelectRow("SELECT q.* ,
                                     CASE quality $encode_priority END as priority,
                                     UNIX_TIMESTAMP()-UNIX_TIMESTAMP(created) as dt
                              FROM QueueEncoding q
                              WHERE srv_id IN ($servers) 
                              AND status='PENDING' 
                              AND q.created < NOW()-INTERVAL 5 SECOND
                              $not_transferring_now
                              $per_user_limit
                              ORDER BY dt * priority $premium_priority DESC
                              LIMIT 1");
   
   return unless $next;

   $db->Exec("UPDATE QueueEncoding SET status='ENCODING', started=NOW() WHERE file_real_id=? AND quality=?",$next->{file_real_id},$next->{quality});
   
   require JSON;
   if($next->{file_real} eq 'RESTART')
   {
      $db->Exec("DELETE FROM QueueEncoding WHERE file_real_id=? AND srv_id=?",$next->{file_real_id},$next->{srv_id});
      print JSON::encode_json( { file_real=>$next->{file_real} } );
      return;
   }
   my $disk_id = $db->SelectOneCached("SELECT disk_id FROM Servers WHERE srv_id=?",$next->{srv_id});

   my $settings;
   my @sett = qw(vid_resize
                 vid_quality_mode
                 vid_quality
                 vid_bitrate
                 vid_audio_bitrate
                 vid_audio_rate
                 vid_audio_channels
                 vid_preset
                 vid_fps
                 vid_crf_bitrate_max
                 vid_container
                 vid_mobile_support
                );
   $settings->{$_} = $c->{"$_\_$next->{quality}"} for @sett;
   $settings->{$_} = $c->{$_} for 
   	qw( vid_resize_method 
   		srt_burn
   		srt_burn_font
		srt_burn_size
		srt_burn_margin
		srt_burn_color
		srt_burn_coloroutline
		srt_burn_blackbox
   		);
   if($next->{quality} eq 'p')
   {
      $settings->{$_} = $c->{"$_\_$c->{m_p_source}"} for @sett;
      $settings->{$_} = $c->{$_} for qw(m_p_parts m_p_length m_p_source);
   }
   for(split(/\|/,$next->{extra}))
   {
      /^(.+?)=(.+)$/;
      $settings->{$1} = $2;
   }

   if($c->{m_v}) # watermark mod
   {
       my $file = $db->SelectRow("SELECT * FROM Files WHERE file_id=?",$next->{file_id});
       my $user = $db->SelectRow("SELECT *, UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec FROM Users WHERE usr_id=?",$file->{usr_id});
       my $usr_id_dat = $c->{m_v_users} eq 'admin' ? $db->SelectOne("SELECT usr_id FROM Users WHERE usr_adm=1 LIMIT 1") : $file->{usr_id};
       my $stt = $db->SelectARefCached("SELECT * FROM UserData WHERE usr_id=?",$usr_id_dat);
       my $dat;
       $dat->{$_->{name}} = $_->{value} for @$stt;

       $settings->{usr_id} = $usr_id_dat; #$user->{usr_id};

       my $pass=1 if $c->{m_v_users} eq 'admin'; # && $user->{usr_adm};
       $pass=1 if $c->{m_v_users} eq 'premium' && $user->{exp_sec} > 0;
       $pass=1 if $c->{m_v_users} eq 'special' && $dat->{usr_watermark};
       $pass=1 if $c->{m_v_users} eq 'registered' && $usr_id_dat;
       $pass=0 unless $dat->{watermark_mode};
       if($pass)
       {
           if($dat->{watermark_mode} eq 'image')
           {
               my $wsize = -s "$c->{site_path}/upload-data/watermark_$usr_id_dat.png";
               if($wsize)
               {
                   $dat->{watermark_image_url} = "$c->{site_url}/upload-data/watermark_$usr_id_dat.png";
                   $dat->{watermark_image_size} = $wsize;
               }
           }
           $settings->{$_} = $dat->{$_} for grep {/^watermark_/} keys %$dat;
           $settings->{watermark_padding}||=0;
           #my $sett = join '|', map{"$_=$dat->{$_}"} grep {/^watermark_/} keys %$dat;
           #$quality.="|$sett" if $sett;
       }
   }

   if($c->{alt_preset_max_queues})
   {
      $settings->{vid_preset} = $c->{"vid_preset\_$next->{quality}\_alt"} if $db->SelectOne("SELECT COUNT(*) FROM QueueEncoding WHERE srv_id IN ($servers) AND status='PENDING'") > $c->{alt_preset_max_queues};
   }
   
   print JSON::encode_json( { disk_id       => $disk_id, 
                              file_real_id  => $next->{file_real_id}, 
                              file_real     => $next->{file_real}, 
                              type          => $next->{quality}, 
                              settings      => $settings } );
}

sub QueueURLNext
{
   print"Content-type:text/html\n\n";
   return unless $f->{dl_key} eq $c->{dl_key};

   # Skip users with X+ working uploads
   my $users_use = $db->SelectARef("SELECT usr_id, SUM(premium) as premium, COUNT(*) as x
                                    FROM QueueUpload
                                    WHERE status='WORKING'
                                    AND updated>NOW()-INTERVAL 30 MINUTE
                                    GROUP BY usr_id");
   my @usr_exclude;
   for(@$users_use)
   {
      my $max = $_->{premium} ? $c->{queue_url_working_max_prem} : $c->{queue_url_working_max_reg};
      push @usr_exclude, $_->{usr_id} if $_->{x}>=$max;
   }
   my $exclude_usr_ids = join ',', @usr_exclude;
   $exclude_usr_ids||=0;

   my $next = $db->SelectRow("SELECT *,INET_NTOA(ip) as ip 
                              FROM QueueUpload 
                              WHERE status='PENDING' 
                              AND usr_id NOT IN ($exclude_usr_ids)
                              ORDER BY premium, created 
                              LIMIT 1");
   return unless $next;

   my $active_list;
   if($c->{optimize_hdd_perfomance})
   {
       # Avoid 2 parallel url uploads to same HDD
       my $active = $db->SelectARef("SELECT srv_id FROM QueueUpload
                                     WHERE status='WORKING'
                                     AND UNIX_TIMESTAMP()-UNIX_TIMESTAMP(updated) < 60");
       $active_list = join ',', map{$_->{srv_id}} @$active; # current active targets
   }
   $active_list||=0;
   my $IP = $ses->getIP;
   my $filter = $f->{host_id}=~/^\d+$/ ? "h.host_id='$f->{host_id}'" : "h.host_ip='$IP'";
   my $filter_load = $c->{overload_no_upload} ? "AND host_out <= host_net_speed*0.9" : "";
   my $server = $db->SelectRow("SELECT * 
   								FROM Servers s, Hosts h
                                WHERE $filter
                                $filter_load
                                AND srv_status='ON'
                                AND s.host_id=h.host_id
                                AND srv_id NOT IN ($active_list)
                                AND srv_disk<srv_disk_max*0.95
                                AND srv_users_only LIKE '%,$next->{usr_id},%'
                                ORDER BY RAND()
                                LIMIT 1");

   $server ||= $db->SelectRow("SELECT * 
   								FROM Servers s, Hosts h
                                WHERE $filter
                                $filter_load
                                AND srv_status='ON'
                                AND s.host_id=h.host_id
                                AND srv_id NOT IN ($active_list)
                                AND srv_disk<srv_disk_max*0.95
                                AND srv_users_only=''
                                ORDER BY RAND()
                                LIMIT 1");
   return unless $server;

   $db->Exec("UPDATE QueueUpload SET status='WORKING', srv_id=?, started=NOW() WHERE id=?",$server->{srv_id},$next->{id});

   # my ($host) = $next->{url}=~/^https?:\/\/([^\/]+)/;
   # $host =~ s/^www\.//g;
   # my $ss = {
   #            'megaupload.com'  => 'mu',
   #            'megavideo.com'   => 'mv',
   #            'mediafire.com' => 'mf',
   #            '4shared.com' => 'fs',
   #            'depositfiles.com'=> 'df',
   #            'uploading.com' => 'ug',
   #            'fileserve.com' => 'fe',
   #            'filesonic.com' => 'sm',
   #          }->{$host};
   # my $data = $db->SelectARef("SELECT * FROM UserData WHERE usr_id=?",$next->{usr_id});
   # my $udata;
   # $udata->{$_->{name}}=$_->{value} for @$data;
   # my $logins = $udata->{"$ss\_logins"} || $c->{"$ss\_logins"};

   print"$next->{id}\n$next->{usr_id}\n$next->{ip}\n$server->{srv_id}\n$server->{disk_id}\n$next->{url}\n";
}

sub QueueTransferNext
{
   print"Content-type:text/html\n\n";
   return unless $f->{dl_key} eq $c->{dl_key};
   #my $filter_no_ro2="AND srv_status<>'READONLY2'" unless $f->{ssd};
   my $IP = $ses->getIP;
   my $filter = $f->{host_id}=~/^\d+$/ ? "host_id='$f->{host_id}'" : "srv_ip='$IP'";
   my $list = $db->SelectARef("SELECT srv_id FROM Servers 
                               WHERE $filter
                               AND (srv_status<>'READONLY2' OR srv_ssd=1)
                               AND srv_status<>'OFF'
                               AND srv_disk<srv_disk_max*0.95");
   my $servers = join ',', map{$_->{srv_id}} @$list; # target servers
   return unless $servers;

   my $active_list;
   if($c->{optimize_hdd_perfomance})
   {
       # Avoid 2 parallel transfers to same HDD
       my $active = $db->SelectARef("SELECT srv_id2 FROM QueueTransfer
                                     WHERE status='MOVING'
                                     AND UNIX_TIMESTAMP()-UNIX_TIMESTAMP(updated) < 60");
       $active_list = join ',', map{$_->{srv_id2}} @$active; # current active targets
   }
   $active_list||=0;

   my $srv_id1 = $db->SelectOne("SELECT srv_id1 
                                 FROM QueueTransfer 
                                 WHERE srv_id2 IN ($servers) 
                                 AND status='PENDING' 
                                 GROUP BY srv_id1 
                                 ORDER BY RAND() 
                                 LIMIT 1");
   return unless $srv_id1;

   my $queue_ids = $db->SelectARef("SELECT file_real_id FROM QueueEncoding WHERE status='ENCODING'");
   my $active_ids = join(',', map{$_->{file_real_id}} @$queue_ids) || 0;

   my $next = $db->SelectRow("SELECT * FROM QueueTransfer
                              WHERE srv_id2 IN ($servers) 
                              AND srv_id1=$srv_id1
                              AND status='PENDING' 
                              AND srv_id2 NOT IN ($active_list)
                              AND file_real_id NOT IN ($active_ids)
                              ORDER BY premium DESC, created 
                              LIMIT 1");
   return unless $next;
   $db->Exec("UPDATE QueueTransfer SET status='MOVING', started=NOW() WHERE file_real_id=?",$next->{file_real_id});

   my $srv1 = $db->SelectRow("SELECT * FROM Servers WHERE srv_id=?",$next->{srv_id1});
   my $srv2 = $db->SelectRow("SELECT * FROM Servers s, Hosts h WHERE s.srv_id=? AND s.host_id=h.host_id",$next->{srv_id2});

   my $file = $db->SelectRow("SELECT * 
                              FROM Files f, Servers s
                              WHERE f.file_id=? 
                              AND f.srv_id=s.srv_id",$next->{file_id});

   $file->{host_transfer_speed} = $srv2->{host_transfer_speed};

   my $dx = sprintf("%05d",($file->{file_real_id}||$file->{file_id})/$c->{files_per_folder});
   my @links;
   push @links, "ORIG=".genDirectLink2($file,'o') if $file->{file_size_o} && !$next->{copy};
   push @links, "ENC=".genDirectLink2($file,'n',"$file->{file_real}_n") if $file->{file_size_n};
   push @links, "ENC=".genDirectLink2($file,'h',"$file->{file_real}_h") if $file->{file_size_h};
   push @links, "ENC=".genDirectLink2($file,'l',"$file->{file_real}_l") if $file->{file_size_l};
   push @links, "ENC=".genDirectLink2($file,'p',"$file->{file_real}_p") if $file->{file_size_p};
   
   push @links, "IMG=$file->{srv_htdocs_url}/i/$file->{disk_id}/$dx/$file->{file_real}.jpg";
   push @links, "IMG=$file->{srv_htdocs_url}/i/$file->{disk_id}/$dx/$file->{file_real}_t.jpg";
   push @links, "IMG=$file->{srv_htdocs_url}/i/$file->{disk_id}/$dx/$file->{file_real}0000.jpg" if $c->{m_z};
   #push @links, "IMG=$file->{srv_htdocs_url}/i/$file->{disk_id}/$dx/$file->{file_real}_p.jpg" if $c->{m_z};
   push @links, "IMG=$file->{srv_htdocs_url}/i/$file->{disk_id}/$dx/$file->{file_real}_x.jpg"  if $c->{m_x};
   push @links, "IMG=$file->{srv_htdocs_url}/i/$file->{disk_id}/$dx/$file->{file_real}_xt.jpg" if $c->{m_x};

   print"$srv2->{disk_id}:$next->{file_real_id}:$next->{file_real}\n".join("\n",@links);
}

sub sendBack
{
    print"Content-type:text/html\n\n";
    print shift;
}

sub EncProgress
{
   $f->{progress}=100 if $f->{progress}>100;
   $db->Exec("UPDATE QueueEncoding SET progress=?, fps=? WHERE file_real_id=? AND quality=?",$f->{progress},$f->{fps},$f->{file_real_id},$f->{quality}) if $f->{file_real_id};
   return sendBack("OK");
}

sub UploadProgress
{
   $f->{speed}=65535 if $f->{speed}>65535;
   $db->Exec("UPDATE QueueUpload SET updated=NOW(), size_full=?, size_dl=?, speed=? WHERE id=?",$f->{size_full},$f->{size_dl},$f->{speed},$f->{id});
   return sendBack("OK");
}

sub TransferProgress
{
   $f->{speed}=65535 if $f->{speed}>65535;
   $db->Exec("UPDATE QueueTransfer SET transferred=?,speed=? WHERE file_real_id=?",$f->{transferred},$f->{speed},$f->{file_real_id});
   sendBack("OK");
}

sub getMoreFiles
{
      my ($file,$more_files_number) = @_;
      $more_files_number ||= $c->{more_files_number};
      my @more_files;
      if($file->{file_fld_id})
      {
          my $more_files1 = $db->SelectARefCached(600,"SELECT f.*, s.*, u.usr_login as usr_login_v
                                        FROM (Files f, Servers s)
                                        LEFT JOIN Users u ON f.usr_id=u.usr_id
                                        WHERE f.usr_id=?
                                        AND file_fld_id=?
                                        AND file_public=1
                                        AND (file_size_n>0 OR file_size_p>0)
                                        AND file_title>?
                                        AND file_id<>?
                                        AND f.srv_id=s.srv_id
                                        ORDER BY file_title
                                        LIMIT ?", $file->{usr_id}, $file->{file_fld_id}, $file->{file_title}, $file->{file_id}, $more_files_number-1 );
          my $limit_post = $more_files_number - $#$more_files1 - 1;
          my $more_files2 = $db->SelectARefCached(600,"SELECT f.*, s.*, u.usr_login as usr_login_v
                                                FROM (Files f, Servers s)
                                                LEFT JOIN Users u ON f.usr_id=u.usr_id
                                                WHERE f.usr_id=?
                                                AND file_fld_id=?
                                                AND file_public=1
                                                AND (file_size_n>0 OR file_size_p>0)
                                                AND file_title<?
                                                AND file_id<>?
                                                AND f.srv_id=s.srv_id
                                                ORDER BY file_title
                                                LIMIT ?", $file->{usr_id}, $file->{file_fld_id}, $file->{file_title}, $file->{file_id}, $limit_post );
          push @more_files, @$more_files1;
          push @more_files, @$more_files2;
          return \@more_files if @more_files;
      }

        my ($core) = $file->{file_title}=~/^(.+?)\s(EP\d+|E\d+|S\d+E\d+)/i;
        $core=~s/[\'\"]+//g;
        if($core)
        {
         my $more_files1 = $db->SelectARefCached("SELECT f.*, s.*, u.usr_login as usr_login_v
                                        FROM (Files f, Servers s)
                                        LEFT JOIN Users u ON f.usr_id=u.usr_id
                                        WHERE f.usr_id=?
                                        AND file_size_n>0
                                        AND file_title LIKE \"$core %\"
                                        AND file_id>?
                                        AND f.srv_id=s.srv_id
                                        ORDER BY file_id
                                        LIMIT ?",$file->{usr_id},$file->{file_id},$more_files_number-1);

        my $limit_pre = $more_files_number - $#$more_files1 - 1;
        my $more_files_pre = $db->SelectARefCached("SELECT f.*, s.*, u.usr_login as usr_login_v
                                          FROM (Files f, Servers s)
                                          LEFT JOIN Users u ON f.usr_id=u.usr_id
                                          WHERE f.usr_id=?
                                          AND file_size_n>0
                                          AND file_title LIKE \"$core %\"
                                          AND file_id<?
                                          AND f.srv_id=s.srv_id
                                          ORDER BY file_id DESC
                                          LIMIT ?",$file->{usr_id},$file->{file_id},$limit_pre);
        @$more_files_pre = reverse @$more_files_pre;
        #unshift @$more_files, @$more_files_pre;
        push @more_files, @$more_files_pre;
        push @more_files, @$more_files1;
        return \@more_files if @more_files;
       }


         my $more_files1 = $db->SelectARefCached(600,"SELECT f.*, s.*, u.usr_login as usr_login_v
                                        FROM (Files f, Servers s)
                                        LEFT JOIN Users u ON f.usr_id=u.usr_id
                                        WHERE f.usr_id=?
                                        AND file_public=1
                                        AND file_size_n>0
                                        AND cat_id=?
                                        AND file_id>?
                                        AND f.srv_id=s.srv_id
                                        ORDER BY file_id
                                        LIMIT ?",$file->{usr_id},$file->{cat_id},$file->{file_id},$more_files_number-1);

        my $limit_pre = $more_files_number - $#$more_files1 - 1;
        my $more_files_pre = $db->SelectARefCached(600,"SELECT f.*, s.*, u.usr_login as usr_login_v
                                          FROM (Files f, Servers s)
                                          LEFT JOIN Users u ON f.usr_id=u.usr_id
                                          WHERE f.usr_id=?
                                          AND file_public=1
                                          AND file_size_n>0
                                          AND cat_id=?
                                          AND file_id<?
                                          AND f.srv_id=s.srv_id
                                          ORDER BY file_id DESC
                                          LIMIT ?",$file->{usr_id},$file->{cat_id},$file->{file_id},$limit_pre);
        @$more_files_pre = reverse @$more_files_pre;
        #unshift @$more_files, @$more_files_pre;
        push @more_files, @$more_files_pre;
        push @more_files, @$more_files1;
        return \@more_files;

      # for(@more_files)
      # {
      #    $_->{file_title_txt} = $ses->shortenString( $_->{file_title}||$_->{file_name}, $c->{display_max_filename} );
      #    $_->{download_link} = $ses->makeFileLink($_);
      #    $_->{file_name} =~ s/_/ /g;
      #    $ses->getVideoInfo($_);
      # }
      #return \@more_files;
}

sub Related
{
     print"Content-type:application/rss+xml\n\n";
     return unless $c->{player_related};
     return if $c->{highload_mode};
     my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?",$f->{code});
     return $ses->message("No file") unless $file;
     my $more_files = getMoreFiles($file,$c->{player_related});
     $ses->processVideoList($more_files);
      
      print qq[<rss version="2.0" xmlns:media="http://search.yahoo.com/mrss/"><channel>\n];
      for(@$more_files)
      {
      	$_->{file_title}=~s/\&/\&amp;/g;
        print qq[<item>
<title>$_->{file_title}</title>
<link>$_->{download_link}</link>
<media:thumbnail url="$_->{video_thumb_url}"/></item>];
      }
      print qq[</channel></rss>];
}

# https://github.com/tknorris/script.module.urlresolver/tree/master/lib/urlresolver/plugins
sub Pair
{
	$ses->{form}->{no_hdr}=1;
	if($ENV{REQUEST_URI}=~/file_code=(\w{12})\&check/i)
	{
		$f->{file_code} = $1;
		require JSON;
		print"Content-type:text/plain\n\n";
		print(JSON::encode_json({"status"=>"false", "response"=>"Not paired or expired"})),return unless $db->SelectOne("SELECT ip FROM Pairs WHERE ip=INET_ATON(?) AND created>NOW()-INTERVAL ? HOUR", $ses->getIP, $c->{m_5_hours} );
		my $file = $db->SelectRow("SELECT * FROM Files f, Servers s WHERE f.file_code=? AND f.srv_id=s.srv_id",$f->{file_code});
		print(JSON::encode_json({"status"=>"false", "response"=>"File not found"})),return unless $file;
		my $hh;
		my $name_n=$c->{vid_resize_n};
		my $name_h=$c->{vid_resize_h};
		my $name_l=$c->{vid_resize_l};
		$name_n="$1p" if $name_n=~/x(\d+)$/i;
		$name_h="$1p" if $name_h=~/x(\d+)$/i;
		$name_l="$1p" if $name_l=~/x(\d+)$/i;
		$hh->{$name_n} = genDirectLink2($file,'n',"$file->{file_real}_n.mp4") if $file->{file_size_n};
   		$hh->{$name_h} = genDirectLink2($file,'h',"$file->{file_real}_h.mp4") if $file->{file_size_h};
   		$hh->{$name_l} = genDirectLink2($file,'l',"$file->{file_real}_l.mp4") if $file->{file_size_l};
   		print JSON::encode_json( { "status"=>"true", "response"=>$hh } );
   		return;
	}
	if($f->{pair})
	{
		return $ses->redirect_msg('/pair',"Invalid captcha") if $c->{m_5_captcha} && !$ses->checkRecaptcha;
		my $paired = $db->SelectOne("SELECT ip FROM Pairs WHERE ip=INET_ATON(?) AND created>NOW()-INTERVAL ? HOUR", $ses->getIP, $c->{m_5_hours} );
		$db->Exec("INSERT INTO Pairs SET ip=INET_ATON(?), created=NOW()",$ses->getIP) unless $paired;
		return $ses->PrintTemplate("pair.html", ip => $ses->getIP, pair_hours => $c->{m_5_hours}, paired => 1 );
	}
	my $captcha = $c->{m_5_captcha} ? $ses->genRecaptcha : '';
	return $ses->PrintTemplate("pair.html", ip => $ses->getIP, pair_hours => $c->{m_5_hours}, captcha => $captcha );
}

sub StreamPage
{
	my $stream = $db->SelectRowCached("SELECT * FROM Streams s, Users u 
										WHERE s.stream_code=?
										AND s.usr_id=u.usr_id",$f->{stream_code});
	return $ses->message("Stream was deleted or stream code is wrong") unless $stream;
	$stream->{stream_descr}=~s/\n/<br>/g;
	return $ses->PrintTemplate("stream_page.html",
								%$stream,
								);
}

sub StreamPlayer
{
	$ses->{form}->{no_hdr}=1;
	my $stream = $db->SelectRowCached("SELECT *, UNIX_TIMESTAMP()-UNIX_TIMESTAMP(started) as dt
										FROM Streams s, Hosts h, Users u 
										WHERE s.stream_code=?
										AND s.usr_id=u.usr_id
										AND s.host_id=h.host_id",$f->{stream_code});
	print("Content-type:text/html\n\nStream not found") unless $stream;
	print(qq|Content-type:text/html\n\n<html><meta http-equiv="refresh" content="5"><body>Starting the stream in a few seconds...</body></html>|),return if $stream->{dt}<15;
	print(qq|Content-type:text/html\n\n<html><meta http-equiv="refresh" content="15"><body>Stream is OFFLINE</body></html>|),return if $stream->{stream_live}==0;
	$stream->{m_q_stop_invis_after}=$c->{m_q_stop_invis_after};
	return $ses->PrintTemplate("stream_player.html",
								%$stream,
								);
}

sub StreamPing
{
	print("Content-type:application/javascript\n\n");
	return unless $f->{stream_id}=~/^\d+$/;

	unless($f->{check})
	{
		$db->Exec("INSERT INTO Stream2IP 
					SET stream_id=?, ip=INET_ATON(?), created=NOW()
					ON DUPLICATE KEY UPDATE created=NOW()", 
					$f->{stream_id}, $ses->getIP );
		return;
	}
	my $online = $db->SelectOne("SELECT COUNT(*) FROM Stream2IP WHERE stream_id=? AND created>NOW()-INTERVAL 60 SECOND", $f->{stream_id});
	print"\$('#online').text('$online');";
}

sub IProxy
{
	my ($code) = $f->{name}=~/(\w{12})[\.\_]/i;
	#return $ses->redirect("$c->{site_url}/images/default.jpg") 
	print($ses->{cgi_query}->header(-status => 404)),return unless $c->{m_i} && $code;

	my $file = $db->SelectRowCached("SELECT * FROM Files f, Servers s WHERE f.file_real=? AND f.srv_id=s.srv_id LIMIT 1",$code);
	return $ses->redirect("$c->{site_url}/images/default.jpg") unless $file;
	
	my $dx = sprintf("%05d",$file->{file_real_id}/$c->{files_per_folder});
	return $ses->redirect("$file->{srv_htdocs_url}/i/$file->{disk_id}/$dx/$f->{name}");
}

1;
