#!/usr/bin/perl
use strict;
use lib '.';
use XFileConfig;

my $ok = "<br><b style='background:#1a1;color:#fff;padding:2px;'>OK</b>";
eval {require DBD::mysql;require DBI;};
if($@)
{
   print"Content-type:text/html\n\nInstall DBI & DBD::mysql perl packages.";
   exit;
}

eval {require HTML::Template::Pro;};
if($@)
{
   print"Content-type:text/html\n\nInstall HTML::Template::Pro perl package.";
   exit;
}

eval {require Session;};
if($@)
{
   print"Content-type:text/html\n\nSession.pm doesn't work on this server architecture<br>Contact support\@sibsoft.net to get one for your server.";
   exit;
}

use CGI::Carp qw(fatalsToBrowser);
use DBI;

$c->{no_lng_sql}=1;
my $ses = Session->new;
my $f = $ses->f;

my $sub={
    save_site_settings      => \&saveSiteSettings,
    save_sql_settings       => \&saveSQLSettings,
    save_sql_tables         => \&saveSQLTables,
    remove_install_files    => \&removeInstallFiles,
         }->{ $f->{op} };

if($sub)
{
   &$sub;
}
else
{
   &InstallationProgress;
}

sub InstallationProgress
{
    print"Content-type:text/html\n\n";
    print"<HTML><BODY style='font:13px Arial;'><h2>XFileSharingPro Installation Script</h2>";

    &testPermissions;

    print"<hr>";

    &testSiteSettings;

    print"<hr>";

    &testSQLSettings;

    print"<hr>";

    &testSQLTables;

    print"<hr>";

print<<EOP
<b>5) Clean install</b>
<form method="POST">
<input type="hidden" name="op" value="remove_install_files">
<input type="submit" value="Remove install files">
</form>
EOP
;

    exit;
}

sub saveSiteSettings
{
   my @fields = qw(cgi_path site_path site_url site_cgi license_key pasword_salt dl_key user_agent);
   my $conf;
   open(F,"XFileConfig.pm")||$ses->message("Can't read XFileConfig.pm");
   $conf.=$_ while <F>;
   close F;

   $f->{pasword_salt} = $c->{pasword_salt}||$ses->randchar(12);
   $f->{dl_key}       = $c->{dl_key}||$ses->randchar(10);
   $f->{user_agent}	  = $c->{user_agent}||'XVS'.$ses->randchar(6);

   for my $x (@fields)
   {
      my $val = $f->{$x};
      $val=~s/\s+$//g;
      $val=~s/^\s+//g;
      $conf=~s/$x\s*=>\s*(\S+)\s*,/"$x => '$val',"/e;
   }
   open(F,">XFileConfig.pm")||$ses->message("Can't write XFileConfig.pm");
   print F $conf;
   close F;
   $ses->redirect('install.cgi');
}

sub saveSQLSettings
{
   my @fields = qw(db_host db_login db_passwd db_name);
   my $conf;
   open(F,"XFileConfig.pm")||$ses->message("Can't read XFileConfig");
   $conf.=$_ while <F>;
   close F;
   for my $x (@fields)
   {
      my $val = $f->{$x};
      $val=~s/\s+$//g;
      $val=~s/^\s+//g;
      $conf=~s/$x\s*=>\s*.+?\s*,/"$x => '$val',"/e;
   }
   open(F,">XFileConfig.pm")||$ses->message("Can't write XFileConfig");
   print F $conf;
   close F;
   $ses->redirect('install.cgi');
}

sub saveSQLTables
{
   my $db = $ses->db;
   open(FILE,"install.sql")||$ses->message("Can't open install.sql: $!");
   my $sql;
   $sql.=$_ while <FILE>;
   close FILE;
   $sql=~s/CREATE TABLE/CREATE TABLE IF NOT EXISTS/gis;
   $sql=~s/AUTO_INCREMENT=\d+ //gis; 
   while($sql=~/(CREATE TABLE IF NOT EXISTS.+?);/gis)
   {
      $db->Exec($1) if length($1)>17;
   }

   my $passwd_hash = $ses->genPasswdHash( $f->{usr_password} );
   $db->Exec("INSERT INTO Users (usr_login,usr_email,usr_password,usr_created,usr_adm) VALUES (?,?,?,NOW(),1)",$f->{usr_login},$f->{usr_email},$passwd_hash,$c->{pasword_salt});

   # Import languages now
   open(FILE,"install_lang.sql")||$ses->message("Can't open install_lang.sql: $!");
   $sql = join '', <FILE>;
   while($sql=~/(INSERT INTO `.+?);/gis)
   {
      $db->Exec($1) if length($1)>17;
   }

   # install crontabs
   add_cronjob("*/5  *  *  *  *\tcd $c->{cgi_path};./cron_static_update.pl >/dev/null 2>&1");
   add_cronjob("*/30 *  *  *  *\tcd $c->{cgi_path};./cron.pl >/dev/null 2>&1");
   add_cronjob("10   0  *  *  *\tcd $c->{cgi_path};./cron_expire.pl >/dev/null 2>&1");
   add_cronjob("40   0  *  *  *\tcd $c->{cgi_path};./cron_daily.pl >/dev/null 2>&1");
   add_cronjob("*/5  *  *  *  *\tcd $c->{cgi_path};./cron_temp_db.pl >/dev/null 2>&1");
   #add_cronjob("*/3  *  *  *  *\tcd $c->{cgi_path};./cron_parse_views.pl >/dev/null 2>&1");

   $ses->redirect('install.cgi');
}

sub add_cronjob
{
   my ($spec) = @_;

   local *getCmd = sub {
      my @chunks = split(/\s+/, $_[0], 6);
      return $chunks[5];
   };

   my $crontext_old = `crontab -l`;
   my $existing = grep { getCmd($spec) eq getCmd($_) } split(/\n/, $crontext_old);
   return if $existing;

   open(CRONTAB, "| crontab -");
   print CRONTAB $crontext_old;
   print CRONTAB "$spec\n";
   close(CRONTAB);
}

sub removeInstallFiles
{
   print"Content-type:text/html\n\n";
   unlink('install_fs.sh');
   unlink('install_main.sh');
   unlink('install.cgi');
   print"Can't delete <u>install.cgi</u>, remove it manually<br><br>" if -e 'install.cgi';
   unlink('install.sql');
   unlink('install_lang.sql');
   print"Can't delete <u>install.sql</u>, remove it manually<br><br>" if -e 'install.sql';
   print qq[<br><input type='button' value='Go to Login page' onClick="window.location='$c->{site_url}/?op=login&redirect=$c->{site_url}';">];
   exit;
}

#######

sub testPermissions
{
    print"<b>1) Permissions Checks</b><br><br>";  
    my $perms = {
                   'logs.txt'    => 0666,
                   'ipn_log.txt' => 0666,
                   'fs.log'      => 0666,
                   'fs.cgi'      => 0755,
                   'index.cgi'   => 0755,
                   'index_dl.cgi'=> 0755,
                   'ipn.cgi'     => 0755,
                   'cron.pl'     => 0755,
                   'cron_static_update.pl' => 0755,
                   'cron_deleted_email.pl' => 0755,
                   'XFileConfig.pm'        => 0666,
                   "Templates/static"      => 0777,
                   "$c->{site_path}/captchas"       => 0777,
                   "$c->{site_path}/catalogue.rss"  => 0666,
                   "$c->{site_path}/sitemap.txt"    => 0666,
                   "$c->{site_path}/sitemap.txt.gz" => 0666,
                };
    my @arr;
    for(sort keys %{$perms})
    {
       next unless -e $_;
       next if /^\/\w+$/;
       chmod $perms->{$_}, $_;
       my $chmod = (stat($_))[2] & 07777;
       my $chmod_txt = sprintf("%04o", $chmod);
       push @arr, "<b>$_</b> : $chmod_txt : ".( $chmod == $perms->{$_} ? 'OK' : "<u>ERROR: should be ".sprintf("%04o",$perms->{$_})."</u>" );
    }
    
    #chmod 0666, "$c->{site_path}/.htaccess" if -f "$c->{site_path}/.htaccess";
    print join '<br>', @arr;
    if( grep{/ERROR/}@arr )
    {
       print"<br><br><font color='red'>Fix permissions above and refresh this page</font>";
    }
    else
    {
       print"<br><br>All permissions are correct.$ok";
    }
}

sub testSiteSettings
{
    print"<b>2) Site URL / Path Settings / License Key</b><br><br>";
    if($c->{site_url} && $c->{site_cgi} && $c->{site_path} && $c->{cgi_path})
    {
       print"Settings are correct.$ok";
    }
    else
    {
       my $path = $ENV{DOCUMENT_ROOT};
       my ($cgipath) = $ENV{SCRIPT_FILENAME}=~/^(.+)\//;
       my $scheme=$ENV{REQUEST_SCHEME}||'http';
       my $url_cgi = "$scheme://".$ENV{HTTP_HOST}.$ENV{REQUEST_URI};
       $url_cgi=~s/\/[^\/]+$//;
       my $url = "$scheme://".$ENV{HTTP_HOST};
       
       $url = $c->{site_url}||$url;
       $url_cgi = $c->{site_cgi}||$url_cgi;
       $path = $c->{site_path}||$path;
       $path=~s/\/$//;
    print<<EOP
<form method="POST">
<input type="hidden" name="op" value="save_site_settings">
Site URL:<br>
<input type="text" name="site_url" value="$url" size=48> <small>No trailing slash</small><br>
cgi-bin URL:<br>
<input type="text" name="site_cgi" value="$url_cgi" size=48> <small>No trailing slash</small><br>
cgi-bin disk path:<br>
<input type="text" name="cgi_path" value="$cgipath" size=48> <small>No trailing slash</small><br>
htdocs(public_html) disk path:<br>
<input type="text" name="site_path" value="$path" size=48> <small>No trailing slash</small><br>
License Key:<br>
<input type="text" name="license_key" value="$c->{license_key}" size=48><br>
<br>
<input type="submit" value="Save site settings">
</form>
EOP
;
    }
}

sub testSQLSettings
{
    print"<b>3) MySQL Settings</b><br><br>";
    my $dbh=DBI->connect("DBI:mysql:database=$c->{db_name};host=$c->{db_host}",$c->{db_login},$c->{db_passwd}) if $c->{db_name} && $c->{db_host};
    if($dbh)
    {
       print"MySQL Settings are correct. Can connect to DB.$ok";
    }
    else
    {
    print<<EOP
<font color="red">Can't connect to DB with current settings. $DBI::errstr</font><br><br>
<Form method="POST">
<input type="hidden" name="op" value="save_sql_settings">
MySQL Host:<br>
<input type="text" name="db_host" value="$c->{db_host}"><br>
MySQL DB Name:<br>
<input type="text" name="db_name" value="$c->{db_name}"><br>
MySQL DB Username:<br>
<input type="text" name="db_login" value="$c->{db_login}"><br>
MySQL DB Password:<br>
<input type="text" name="db_passwd" value="$c->{db_passwd}"><br><br>
<input type="submit" value="Save MySQL Settings">
</Form>
EOP
;
    }
}

sub testSQLTables
{
    print"<b>4) MySQL tables create & Admin account</b><br><br>";
    my $dbh=DBI->connect("DBI:mysql:database=$c->{db_name};host=$c->{db_host}",$c->{db_login},$c->{db_passwd}) if $c->{db_name} && $c->{db_host};
    if(!$dbh)
    {
       print"<font color=red>Fix MySQL settings above first.</font>";
    }
    else
    {
       my $sth=$dbh->prepare("DESC Files");
       my $rc=$sth->execute();
       if($rc)
       {
          print"Tables created successfully.$ok";
       }
       else
       {
    print<<EOP
<form method="POST">
<input type="hidden" name="op" value="save_sql_tables">
Admin login:<br><input type="text" name="usr_login"><br>
Admin password:<br><input type="text" name="usr_password"><br>
Admin E-mail:<br><input type="text" name="usr_email"><br><br>
<input type="submit" value="Create MySQL Tables & Admin Account">
</form>
EOP
;
       }
    }
}
