#!/usr/bin/perl
### SibSoft.net ###
use strict;
use utf8;
use lib '.';
use XFileConfig;
use Session;
use XUtils;

my $ses = Session->new();
my $f = $ses->f;
my $op = $f->{op};
#return $ses->redirect('http://s1.xvs.tt/i/01/00000/t3sikw7630jp.jpg') if $f->{op} eq 'x2';
$c->{ip_not_allowed}=~s/\./\\./g;
if($c->{ip_not_allowed} && $ses->getIP=~/$c->{ip_not_allowed}/)
{
   $ses->message("Your IP was banned by administrator");
}

if($c->{banned_countries})
{
    my $country=$ses->getMyCountry;
    $ses->message("Your country is not allowed on this site") if $country=~/^($c->{banned_countries})$/i;
}

if($f->{design}=~/^(\d+)$/)
{
   $ses->setCookie("design",$1,'+300d');
   $ses->redirect($c->{site_url});
}
&ChangeLanguage if $f->{lang};

my $db= $ses->db;
XUtils::CheckAuth($ses) unless $op eq 'login';
return $ses->message($c->{maintenance_full_msg}||"The website is under maintenance.","Site maintenance") if $c->{maintenance_full} && $f->{op}!~/^(admin_|login)/i;

if($ses->getUser && $ses->getUser->{usr_allowed_ips} && $f->{op} ne 'logout')
{
  my $pass;
  for my $ip (split(/,\s*/,$ses->getUser->{usr_allowed_ips}))
  {
    $ip=~s/\.\*//g;
    $ip=~s/\./\\\./g;
    $pass=1 if $ses->getIP =~ /^$ip/;
  }
  unless($pass)
  {
    $ses->setCookie($ses->{auth_cook},"");
    $ses->{user}={};
    $ses->message("You can't login from this IP.");
  }
}

my $utype = $ses->getUser ? ($ses->getUser->{premium} ? 'prem' : 'reg') : 'anon';

$c->{$_}=$c->{"$_\_$utype"} for qw(max_upload_files
                                   disk_space
                                   max_upload_filesize
                                   max_upload_files
                                   download_countdown
                                   captcha
                                   ads
                                   bw_limit
                                   remote_url
                                   direct_links
                                   down_speed
                                   add_download_delay
                                   max_download_filesize
                                   torrent_dl_slots
                                   video_embed
                                   video_dl_orig
                                   max_watch_time
                                   fullscreen
                                   pre_download
                                   queue_url
                                   queue_url_max
                                   upload_enabled
                                   );

&RegisterExternal('twitter')     if $f->{tid} && $f->{tname} && $f->{op} eq 'register_ext';

my $sub={
    login         => \&LoginPage,
    news          => \&News,
    news_details  => \&NewsDetails,
    contact       => \&Contact,
    registration  => \&Register,
    register_save => \&RegisterSave,
    register_ext  => \&RegisterExternal,
    resend_activation => \&ResendActivationCode,
    upload_result => \&UploadResult,
    #download1     => \&Download1,
    #download2     => \&Download2,
    page          => \&Page,
    page_static   => \&PageStatic,
    forgot_pass   => \&ForgotPass,
    contact_send  => \&ContactSend,
    user_public   => \&UserPublic,
    payments      => \&Payments,
    checkfiles    => \&CheckFiles,
    search        => \&Search,
    change_lang   => \&ChangeLanguage,
    report_file   => \&ReportFile,
    api_get_limits => \&APIGetLimits,
    comment_add   => \&CommentAdd,
    cmt_del       => \&CommentDel,
    del_file      => \&DelFile,
    links         => \&Links,
    video_embed   => \&VideoEmbed,
    unsubscribe   => \&EmailUnsubscribe,
    api_reseller  => \&APIReseller,
    make_money    => \&MakeMoneyPage,
    msg           => \&Msg,  
    favorites     => \&Favorites,
    favorites_do  => \&FavoritesDo,
    upload_srt    => \&UploadSRT,
    vote          => \&Vote,
    x1            => \&X1,   
    
         }->{ $op };

&$sub if $sub;

&PaymentComplete($1) if $ENV{QUERY_STRING}=~/payment_complete=(.+)/;
&PaymentComplete($1) if $ENV{QUERY_STRING}=~/lr_merchant_ref=(\d+)/;

&RegisterConfirm if $f->{confirm_account};

$sub={
    upload            => \&Upload,
    upload_file       => \&UploadFile,
    upload_url        => \&UploadURL,
    upload_torrent    => \&UploadTorrent,
    upload_clone      => \&UploadClone,
    upload_ftp        => \&UploadFTP,
    my_account        => \&MyAccount,
    my_password       => \&MyPassword,
    my_email   		  => \&MyEmail,
    my_referrals      => \&MyReferrals,
    my_files          => \&MyFiles,
    my_files_deleted  => \&MyFilesDeleted,
    my_files_export   => \&MyFilesExport,
    my_file_effects   => \&MyFileEffects,
    my_files_dmca	  => \&MyFilesDMCA,
    my_reports        => \&MyReports,
    my_reports_day    => \&MyReportsDay,
    my_torrents       => \&MyTorrents,
    my_reseller       => \&MyReseller,
    my_watermark      => \&MyWatermark,
    my_snapshot       => \&MySnapshot,
    my_playlists      => \&MyPlaylists,
    my_playlist_files => \&MyPlaylistFiles,
    file_edit         => \&FileEdit,
    fld_edit          => \&FolderEdit,
    request_money     => \&RequestMoney,
    add_to_playlist   => \&AddToPlaylist,
    moderator_files   => \&ModeratorFiles,
    moderator_files_approve => \&ModeratorFilesApprove,
    moderator_reports => \&ModeratorReports,
    moderator_comments => \&ModeratorComments,
    moderator_files_featured    => \&ModeratorFilesFeatured,
    folder_search     => \&FolderSearch,
    legal_tool        => \&LegalTool,
    ajax_new_folder   => \&AjaxNewFolder,
    stream_form		  => \&StreamForm,
    stream_save		  => \&StreamSave,
    my_streams		  => \&MyStreams,
    logout            => sub{$ses->Logout},

	 }->{ $op };

if($ENV{HTTP_REFERER} && $sub && !$ses->{ref_ok})
{
   my ($dm)=$ENV{HTTP_REFERER}=~/\/\/([^\/]+)/;
   $dm=~s/^www\.//;
   $dm=~s/:.*$//;
   my $pass = 1 if $ses->{domain} eq $dm;
   $pass = 1 if !$pass && $db->SelectOne("SELECT srv_id FROM Servers WHERE srv_cgi_url LIKE CONCAT('http://',?,'%')",$dm);
   print("Content-type:text/html\n\nGo to <a href='$ENV{REQUEST_URI}'>http://$ses->{domain}$ENV{REQUEST_URI}</a>"),exit unless $pass;
}

if($sub && $ses->getUser)
{
   $ses->message("Access denied") if $op=~/^admin_/i && !$ses->getUser->{usr_adm} && $op!~/^(admin_reports|admin_comments)$/i;
   &$sub;
}
elsif($sub)
{
   $f->{redirect}=$ENV{REQUEST_URI};
   &LoginPage;
}
else
{
   &IndexPage;
   #$ses->message("Index page here");
}

sub X1
{
  return $ses->message("IP:".$ses->getIP);
}

sub LoginPage
{
   if($f->{login} || $f->{method})
   {
      my $user = Login();
      unless($user)
	  {
	     $db->Exec("INSERT INTO LoginProtect SET usr_id=?, ip=INET_ATON(?)", $ses->{user}->{usr_id}||0, $ses->getIP);
	     $f->{msg}=$ses->{lang}->{lng_login_incorrect_username_or_password};
	     delete $ses->{user};
	  }
   }
   $f->{login}||=$ses->getCookie('login');
   #sleep 1 if $f->{msg};
   $f->{redirect}=~s/[\0\"\'\<\>]+//g;
   $f->{login}=~s/[\0\"\'\<\>]+//g;
   my $recaptcha=$ses->genRecaptcha if $c->{login_captcha} || $f->{ca} || $db->SelectOne("SELECT COUNT(*) FROM LoginProtect WHERE ip=INET_ATON(?) AND created>NOW()-INTERVAL ? HOUR",$ses->getIP,$c->{login_fail_last_hours}) > $c->{login_fail_max_attemps};
   $ses->PrintTemplate("login.html",
                        msg=>$f->{msg},
                        login=>$f->{login},
                        redirect=>$f->{redirect},
                        'external_sites_login'   => $c->{m_l},
                        recaptcha => $recaptcha,
                        %$c,
                      );
}

sub Login
{
  my ($no_redirect,$instant) = @_;

  if($f->{method} && !($f->{login} && $f->{password}))
  {
    # Login through the external plugins
    #$c->{facebook_app_id} = $c->{facebook_app_id_login};
    #$c->{facebook_app_secret} = $c->{facebook_app_secret_login};
    my $url = $ses->getPlugins('Login')->get_auth_url($f);
    $ses->message("Login failed") if !$url;
    $ses->redirect($url);
  }

  #($f->{login}, $f->{password}) = split(':',$ses->decode_base64($ENV{HTTP_CGI_AUTHORIZATION})) if $instant;
  #$f->{login}=~s/[^\w\-\_]+//g;
  #my $usr_id = $db->SelectOneCached("SELECT usr_id FROM Users WHERE usr_login=?",$f->{login}) || 0;
        
  $ses->{user} = $db->SelectRow("SELECT *, UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec 
                                 FROM Users 
                                 WHERE usr_login=?", $f->{login} );

  return 0 unless $ses->{user};

  my $captcha_required=1 if $c->{login_fail_max_attemps} && $c->{login_fail_last_hours} && $c->{recaptcha_pub_key} &&
        $db->SelectOne("SELECT COUNT(*) FROM LoginProtect 
                     	WHERE (ip=INET_ATON(?) OR usr_id=?)
                     	AND created>NOW()-INTERVAL ? HOUR", $ses->getIP, $ses->{user}->{usr_id}, $c->{login_fail_last_hours}) > $c->{login_fail_max_attemps};
  $captcha_required=1 if $c->{login_captcha};
  return $ses->redirect_msg("?op=login&ca=1","Captcha required") if $captcha_required && !$ses->checkRecaptcha;

   return 0 unless $ses->checkPasswdHash( $f->{password} );
   # if($ses->{user}->{usr_password} =~ /^sha256:/)
   # {
   #    require MIME::Base64;
	  # require PBKDF2::Tiny;
   #    my ($algo, $turns, $salt, $data) = split(/:/, $ses->{user}->{usr_password});
   #    return 0 unless PBKDF2::Tiny::verify( MIME::Base64::decode_base64($data), 'SHA-256', $f->{password}, MIME::Base64::decode_base64($salt), $turns );
   # }
   # else
   # {
   #    # Legacy passwords
   #    my $check_pass = $db->SelectOne("SELECT DECODE(usr_password, ?) FROM Users WHERE usr_id=?", $c->{pasword_salt}, $ses->{user}->{usr_id});
   #    return 0 unless $check_pass eq $f->{password};
   # }
   $db->Exec("DELETE FROM LoginProtect WHERE ip=INET_ATON(?) AND created>NOW()-INTERVAL ? HOUR", $ses->getIP, $c->{login_fail_last_hours});
  
  
  $ses->{user}->{premium}=1 if $ses->{user}->{exp_sec}>0;
  if($ses->{user}->{usr_status} eq 'PENDING')
  {
     my $id = $ses->{user}->{usr_id}."-".$ses->{user}->{usr_login};
     delete $ses->{user};
     return $ses->message("$ses->{lang}->{lng_login_account_not_confirmed_yet}<br><a href='?op=resend_activation&d=$id'>$ses->{lang}->{lng_login_resend_me_activation_email}</a>");
  }
  if($ses->{user}->{usr_status} eq 'BANNED')
  {
     delete $ses->{user};
     return $ses->redirect_msg('login.html', $ses->{lang}->{lng_login_your_account_banned} );
  }
  return if $instant;

  if($c->{login_limit1_ips} && $c->{login_limit1_hours})
  {
      my $ip = $ses->getIP;
      my $filter_ip = $c->{login_limit1_subnets} ? "AND (ip<INET_ATON('$ip')-65792 OR ip>INET_ATON('$ip')+65792)" : "AND ip<>INET_ATON('$ip')";
      my $diff_ips = $db->SelectOne("SELECT COUNT(distinct ip)
                                     FROM LoginHistory
                                     WHERE usr_id=?
                                     AND created>NOW()-INTERVAL ? HOUR
                                     $filter_ip
                                    ",$ses->{user}->{usr_id},$c->{login_limit1_hours});

      $ses->redirect_msg('login.html',"You've logged from $c->{login_limit1_ips} different IPs last $c->{login_limit1_hours} hours.<br>Do not share your account details with others.<br>Try to login again in a few minutes.") if $diff_ips>=$c->{login_limit1_ips};
  }
  if($c->{login_limit2_max} && $c->{login_limit2_hours})
  {
      my $logins = $db->SelectOne("SELECT COUNT(*) FROM LoginHistory WHERE usr_id=? AND created>NOW()-INTERVAL ? HOUR",$ses->{user}->{usr_id},$c->{login_limit2_hours});
      $ses->redirect_msg('login.html',"You've logged in over $c->{login_limit2_max} times last $c->{login_limit1_hours} hours.<br>Login to your account blocked for some time.<br>Try to login again in a few minutes.") if $logins>=$c->{login_limit2_max};
  }

  my $data = $db->SelectARef("SELECT * FROM UserData WHERE usr_id=?",$ses->{user}->{usr_id});
  $ses->{user}->{$_->{name}}=$_->{value} for @$data;

  if($ses->{user}->{usr_logout_sessions})
  {
  	$db->Exec("DELETE FROM Sessions WHERE usr_id=?",$ses->{user}->{usr_id});
  }
  if($ses->{user}->{usr_email_newip})
  {
  	if($db->SelectOne("SELECT COUNT(*) FROM LoginHistory WHERE usr_id=? AND created>NOW()-INTERVAL 24 HOUR AND ip<>INET_ATON(?)", $ses->{user}->{usr_id}, $ses->getIP ) > 0)
  	{
		my $t = $ses->CreateTemplate("login_email_newip.html");
	    $t->param( 'ip'=>$ses->getIP, agent => $ENV{HTTP_USER_AGENT} );
	    $c->{email_text}=1;
	    $ses->SendMail($ses->{user}->{usr_email},$c->{email_from},"$c->{site_name}: account logged in from new IP",$t->output);
  	}

  }

  my $sess_id = $ses->randchar(16);
  #$db->Exec("DELETE FROM Sessions WHERE last_time + INTERVAL 5 DAY < NOW()");
  $db->Exec("INSERT INTO Sessions SET session_id=?, usr_id=?, ip=INET_ATON(?), last_time=NOW()",$sess_id,$ses->{user}->{usr_id},$ses->getIP);
  $db->Exec("UPDATE Users SET usr_lastlogin=NOW(), usr_lastip=INET_ATON(?) WHERE usr_id=?", $ses->getIP, $ses->{user}->{usr_id} );
  $db->Exec("INSERT INTO LoginHistory SET usr_id=?, ip=INET_ATON(?), agent=?", $ses->{user}->{usr_id}, $ses->getIP, $ENV{HTTP_USER_AGENT}||'');
  $ses->setCookie( $ses->{auth_cook} , $sess_id, '+30d' );
  $ses->setCookie('login',$f->{login},'+6M');
  $ses->redirect( $f->{redirect} ) if $f->{redirect} && $f->{redirect}!~/login\.html$/i;
  $ses->redirect( "$c->{site_url}/?op=my_account" ) unless $no_redirect;

  return $ses->{user};
};

sub Register
{
   my $msg = shift;
   #my $rand = $ses->randchar(8);
   #my %captcha = &GenerateCaptcha("rr$rand");
   #&SecSave( 0, $ses->getIP(), $captcha{number}, $rand );
   $c->{captcha}=1;
   my %secure = $ses->SecSave( 0, 2 );
   $f->{$_}=$ses->SecureStr($f->{$_}) for qw(usr_login usr_email usr_pay_email);
   my $aff=$1 if $f->{aff_id}=~/^(\d+)$/;
   $ses->message("Error: $ses->{lang}->{lng_registration_max_lim_reached}") if $ses->{"\x70"."\x6C\x67"}->{1} && $db->SelectOne("SELECT COUNT(*) FROM Users")>=100;
   my @payout_list = map{ {name=>$_} } split(/\s*\,\s*/,$c->{payout_systems});
   my @extra = map{ {name=>$_,field=>'usr_extra_'.lc($_)} } split(/\s*\,\s*/,$c->{extra_user_fields});
   $ses->PrintTemplate("registration.html",
                       #%captcha,
                       #'rand' => $rand,
                       %secure,
                       'usr_login' => $f->{usr_login},
                       'usr_email' => $f->{usr_email},
                       'usr_pay_email' => $f->{usr_pay_email},
                       "pay_type_$f->{usr_pay_type}"  => 1,
                       'msg'           => $f->{msg}||$msg,
                       'payout_list'   => \@payout_list,
                       'external_sites_login'   => $c->{m_l},
                       %$c,
                       'extra_fields'           => \@extra,
                       aff          => $aff,
                      );
}

sub RegisterSave
{
   $c->{captcha}=1;
   $ses->redirect($c->{site_url}) unless $ENV{REQUEST_METHOD} eq 'POST';
   &Register unless $ses->SecCheck( $f->{'rand'}, 0, $f->{code} );
   &Register("Error: $ses->{lang}->{lng_registration_username_too_short}") if length($f->{usr_login})<4;
   &Register("Error: $ses->{lang}->{lng_registration_username_too_long}") if length($f->{usr_login})>32;
   &Register("Error: Invalid login: reserved word") if $f->{usr_login}=~/^(admin|images|captchas|files)$/;
   &Register("Error: $ses->{lang}->{lng_registration_invalid_username}") unless $f->{usr_login}=~/^[\w\-\_]+$/;
   &Register("Error: Password contain bad symbols") if $f->{usr_password}=~/[<>"]/;
   &Register("Error: $ses->{lang}->{lng_registration_password_too_short}") if length($f->{usr_password})<4;
   &Register("Error: $ses->{lang}->{lng_registration_password_too_long}") if length($f->{usr_password})>32;
   &Register("Error: $ses->{lang}->{lng_registration_passwords_dont_match}") if $f->{usr_password} ne $f->{usr_password2};
   &Register("Error: $ses->{lang}->{lng_registration_email_invalid}") unless $f->{usr_email}=~/^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
   &Register("Error: $ses->{lang}->{lng_registration_mail_server_banned}") if $c->{mailhosts_not_allowed} && $f->{usr_email}=~/\@$c->{mailhosts_not_allowed}/i;
   &Register("Error: $ses->{lang}->{lng_registration_username_already_used}")  if $db->SelectOne("SELECT usr_id FROM Users WHERE usr_login=?",$f->{usr_login});
   &Register("Error: $ses->{lang}->{lng_registration_email_already_used}") if $db->SelectOne("SELECT usr_id FROM Users WHERE usr_email=?",$f->{usr_email});
   my $confirm_key = $ses->randchar(8) if $c->{registration_confirm_email};
   my $usr_status = $confirm_key ? 'PENDING' : 'OK';
   my $premium_days=0;
   $f->{coupon_code} = lc $f->{coupon_code};
   my $aff = $ses->getCookie('aff')||0;
   $f->{usr_pay_email}=~s/[^\w\-\_\.\@]+//g;
   $f->{usr_pay_type}=~s/[^\w\-\_]+//g;

   if($c->{coupons} && $f->{coupon_code})
   {
      my $hh;
      for(split(/\|/,$c->{coupons}))
      {
         $hh->{lc($1)}=$2 if /^(.+?)=(\d+)$/;
      }
      $premium_days = $hh->{$f->{coupon_code}};
      &Register("Invalid coupon code") unless $premium_days;
   }

   my $passwd_hash = $ses->genPasswdHash( $f->{usr_password} );
   
   $db->Exec("INSERT INTO Users 
              SET usr_login=?, 
                  usr_email=?, 
                  usr_password=?,
                  usr_created=NOW(),
                  usr_premium_expire=NOW()+INTERVAL ? DAY,
                  usr_security_lock=?,
                  usr_status=?,
                  usr_aff_id=?,
                  usr_pay_email=?, 
                  usr_pay_type=?",$f->{usr_login},
                                   $f->{usr_email},
                                   $passwd_hash,
                                   $premium_days,
                                   $confirm_key||'',
                                   $usr_status,
                                   $aff,
                                   $f->{usr_pay_email}||'',
                                   $f->{usr_pay_type}||'');
   my $usr_id=$db->getLastInsertId;
   $db->Exec("INSERT INTO Stats SET day=CURDATE(), registered=1 ON DUPLICATE KEY UPDATE registered=registered+1");
   if($c->{extra_user_fields})
   {
      for(split(/\s*\,\s*/,$c->{extra_user_fields}))
      {
          my $name = 'usr_extra_'.lc($_);
          #$db->Exec("INSERT INTO UserData SET usr_id=?, name=?, value=?", $usr_id, $name, $f->{$name}) if $f->{$name};
          $ses->saveUserData($name,$f->{$name},$usr_id);
      }
   }
   if($confirm_key)
   {
      my $t = $ses->CreateTemplate("registration_email.html");
      $t->param( 'usr_login'=>$f->{usr_login}, 'usr_password'=>$f->{usr_password}, 'confirm_id'=>"$usr_id-$confirm_key" );
      #$c->{email_text}=1;
      $ses->SendMail($f->{usr_email},$c->{email_from},"$c->{site_name} $ses->{lang}->{lng_registration_email_title_registration_confirmation}",$t->output);
      #return $ses->message($ses->{lang}->{lng_registration_msg_account_created});
      return $ses->PrintTemplate("registration_success_checkmail.html");
   }
   elsif($aff)
   {
       $db->Exec("INSERT INTO Stats2
                  SET usr_id=?, day=CURDATE(),
                      refs=1
                  ON DUPLICATE KEY UPDATE
                      refs=refs+1
                 ",$aff);
   }

   #my $err = $ses->ApplyPlugins('user_new', $f->{usr_login}, $f->{usr_password}, $f->{usr_email});
   #$ses->message("Registration complete but there were plugin errors:<br><br>$err") if $err;
   registerPostprocess();

   $f->{login}    = $f->{usr_login};
   $f->{password} = $f->{usr_password};
   &Login();

   $ses->redirect( $c->{site_url} );
}

sub RegisterConfirm
{
   my ($usr_id,$confirm_key)=split('-',$f->{confirm_account});
   my $user = $db->SelectRow("SELECT * FROM Users WHERE usr_id=? AND usr_security_lock=?",$usr_id,$confirm_key);
   unless($user)
   {
      sleep 1;
      $ses->message("Invalid confirm code");
   }
   $ses->message("Account already confirmed") if $user->{usr_status} ne 'PENDING';
   $db->Exec("UPDATE Users SET usr_status='OK', usr_security_lock='' WHERE usr_id=?",$user->{usr_id});
   
   registerPostprocess();

   if($user->{usr_aff_id})
   {
       $db->Exec("INSERT INTO Stats2
                  SET usr_id=?, day=CURDATE(),
                      refs=1
                  ON DUPLICATE KEY UPDATE
                      refs=refs+1
                 ",$user->{usr_aff_id});
   }
   $ses->setCookie('login',$user->{usr_login},'+6M');

   $ses->redirect_msg( '/login.html', 'Account confirmed' );
}

sub RegisterExternal
{
    my ($method) = @_;
    $method ||= $f->{method};
    $ses->{ref_ok}=1; # hack to avoid REFERER security
    my ($id,$provider,$email,$image_url,$name);

    my $ret = $ses->getPlugins('Login')->finish($f) || $ses->message("Auth failed");

    my $pre = {
                'vk'        => 'vk',
                'facebook'  => 'fb',
                'twitter'   => 'tw',
                'google'    => 'go',
              }->{lc($f->{method})} || substr($f->{method},0,2);
    my $sid = $pre.$ret->{usr_social_id};
    $sid=~s/^vkvk/vk/;
    $email = $ret->{usr_email};
    $ses->message("Something wrong with login") unless $ret->{usr_social_id};
    my $user = $db->SelectRow("SELECT *,DECODE(usr_password,'$c->{pasword_salt}') as password FROM Users WHERE usr_social_id=?",$sid);
    $f->{redirect} = '?op=my_account';
    if($user)
    {
        $f->{login} = $user->{usr_login};
        $f->{password} = $user->{password};
        &Login();
    }
    else
    {
        my $login = $ret->{usr_login}||$sid;
        $login=~s/[^\w\-\_]+//g;
        my $password = $ses->randchar(6);
        my $aff = $ses->getCookie('aff')||0;
        $db->Exec("INSERT INTO Users 
                   SET usr_login=?, 
                       usr_social_id=?,
                       usr_email=?, 
                       usr_password=ENCODE(?,?),
                       usr_created=NOW(),
                       usr_premium_expire=NOW()+INTERVAL ? DAY,
                       usr_security_lock=?,
                       usr_status=?,
                       usr_aff_id=?",   
                  $login,
                  $sid,
                  $email||'',
                  $password,
                  $c->{pasword_salt},
                  0,
                  '',
                  'OK',
                  $aff,
                 );
        $f->{login} = $login;
        $f->{password} = $password;
        registerPostprocess();
        &Login();
    }
}

sub registerPostprocess
{
    if($c->{m_f} && $c->{m_f_update_on_reg})
    {
        $ses->syncFTPUsers();
    }
}

sub ResendActivationCode
{
   my ($adm_mode) = @_;
   sleep(1) unless $adm_mode;
   ($f->{usr_id},$f->{usr_login}) = split(/-/,$f->{d});
   my $user = $db->SelectRow("SELECT usr_id,usr_login,usr_email,usr_security_lock,DECODE(usr_password,?) as usr_password
                              FROM Users
                              WHERE usr_id=?
                              AND usr_login=?",
                              $c->{pasword_salt},$f->{usr_id},$f->{usr_login});
   sleep(3) && $ses->message("Invalid ID") unless $user;

   my $t = $ses->CreateTemplate("registration_email.html");
   $t->param( 'usr_login'=>$user->{usr_login}, 'usr_password'=>$user->{usr_password}, 'confirm_id'=>"$user->{usr_id}-$user->{usr_security_lock}" );
   $c->{email_text}=1;
   $ses->SendMail($user->{usr_email},$c->{email_from},"$c->{site_name} registration confirmation",$t->output);
   $ses->redirect_msg("?op=admin_users","Activation email sent") if $adm_mode;
   $ses->message("Activation email just resent.<br>To activate it follow the activation link sent to your e-mail.");
}

sub ForgotPass
{
   if($f->{usr_login} && $ENV{REQUEST_METHOD} eq 'POST')
   {
      $c->{captcha}=1;
   	  return $ses->redirect_msg('?op=forgot_pass','Invalid captcha '.$ses->{form}->{msg}) unless $ses->SecCheck( $f->{'rand'}, 1, $f->{code} );
      my $user = $db->SelectRow("SELECT * 
                                 FROM Users 
                                 WHERE usr_login=? 
                                 OR usr_email=?",$f->{usr_login},$f->{usr_login});
      unless($user)
      {
      		sleep 3;
      		return $ses->redirect_msg('?op=forgot_pass',$ses->{lang}->{lng_forgotpassword_no_user_found});
      }
      #make sess+link
	my $sess_id = $ses->randchar(16);
	$db->Exec( "INSERT INTO Sessions (session_id,usr_id,last_time) VALUES (?,?,NOW())", $sess_id, $user->{usr_id} );

      my $t = $ses->CreateTemplate("forgot_pass_email.html");
      $t->param( 'usr_login'=>$user->{usr_login}, 'sess_id'=>$sess_id, ip=>$ses->getIP );
      $ses->SendMail( $user->{usr_email}, $c->{email_from}, "$c->{site_name}: $ses->{lang}->{lng_forgotpassword_title}", $t->output );
      $ses->message($ses->{lang}->{lng_forgotpassword_reminder_sent}." $user->{usr_email}");
   }
   elsif($f->{sess_id} && $f->{password} && $f->{password2})
   {
   		return $ses->message("Passwords do not match!") unless $f->{password} eq $f->{password2};
   		my $usr_id = $db->SelectOne("SELECT usr_id FROM Sessions WHERE session_id=?",$f->{sess_id});
   		return $ses->message("Invalid session id") unless $usr_id;
   		my $passwd_hash = $ses->genPasswdHash( $f->{password} );
   		$db->Exec("UPDATE Users SET usr_password=? WHERE usr_id=?", $passwd_hash, $usr_id );
   		$db->Exec("DELETE FROM Sessions WHERE session_id=? LIMIT 1",$f->{sess_id});
   		$ses->redirect_msg('?op=login',"Your password was updated successfully.");
   }
   elsif($f->{sess_id})
   {
   		return $ses->PrintTemplate("forgot_pass_reset.html", sess_id=>$f->{sess_id});
   }
   $c->{captcha}=1;
   my %secure = $ses->SecSave( 1, 2 );
   $ses->PrintTemplate("forgot_pass.html",%secure);
}

sub Msg
{
    $ses->message(" ");
}

sub Upload
{
    return $ses->redirect('?op=upload_url')      if $ses->getCookie('upload_mode') eq 'url';
    return $ses->redirect('?op=upload_torrent')  if $ses->getCookie('upload_mode') eq 'torrent';
    return $ses->redirect('?op=upload_clone')    if $ses->getCookie('upload_mode') eq 'clone';
    return $ses->redirect('?op=upload_ftp')      if $ses->getCookie('upload_mode') eq 'ftp';
    return $ses->redirect('?op=upload_file');
}

sub UploadFile
{
   $ses->message($c->{maintenance_upload_msg}||"Uploads are temporarily disabled due to site maintenance","Site maintenance") if $c->{maintenance_upload};
   $ses->setCookie('upload_mode','file');
   if($c->{uploads_selected_only})
   {
       $ses->message("You are not allowed to upload files") unless $ses->getUser->{usr_uploads_on};
   }
   else
   {
       $ses->message("You are not allowed to upload files") unless $c->{upload_enabled};
   }

   $ses->message("You've exceeded max uploads daily limit: $c->{max_upload_files} files") if $c->{max_upload_files} && $db->SelectOne("SELECT COUNT(*) FROM Files WHERE usr_id=? AND file_created>NOW()-INTERVAL 24 HOUR",$ses->getUserId) >= $c->{max_upload_files};

   my $filter_type = $utype eq 'prem' ? "AND srv_allow_premium=1" : "AND srv_allow_regular=1";
   my $filter_load = "AND host_out <= host_net_speed*0.9" if $c->{overload_no_upload};
   my $logic = {'space'=>'srv_disk','round'=>'srv_last_upload','random'=>'RAND()'}->{$c->{next_upload_server_logic}};
   my $extra1;
   my $uploader_priority=3;
   if($c->{next_upload_server_logic} eq 'encodings')
   {
        $extra1.=",(SELECT COUNT(*) FROM QueueEncoding q, Servers ss WHERE q.srv_id=ss.srv_id AND q.status='PENDING' AND q.error='' AND ss.host_id=h.host_id GROUP BY h.host_id) as eq";
        $logic="eq";
        $uploader_priority=2 if $c->{skip_uploader_priority} && 
        	$db->SelectOne("SELECT COUNT(*) as num 
							FROM QueueEncoding q, Servers s 
							WHERE q.status='PENDING' 
							AND q.srv_id=s.srv_id 
							AND s.srv_type='STORAGE' 
							AND s.srv_status='ON' 
							AND s.srv_encode=1 
							AND s.srv_disk <= s.srv_disk_max 
							GROUP BY s.host_id 
							ORDER BY num 
							LIMIT 1") < $c->{skip_uploader_priority};
   }
   my $server;
   my $usr_id=$ses->getUserId;
   $server = $db->SelectRow("SELECT s.*, h.*,
                                CASE srv_type WHEN 'UPLOADER' THEN 3 WHEN 'STORAGE' THEN 2 END as type
                                $extra1
                                FROM Servers s, Hosts h
                                WHERE srv_status='ON' 
                                AND s.host_id=h.host_id
                                AND srv_disk <= srv_disk_max
                                AND srv_users_only LIKE '%,$usr_id,%'
                                ORDER BY type DESC, $logic 
                                LIMIT 1");
   my $country=$ses->getMyCountry;
   $server = $db->SelectRow("SELECT s.*, h.*,
                                CASE srv_type WHEN 'UPLOADER' THEN 3 WHEN 'STORAGE' THEN 2 END as type
                                $extra1
                                FROM Servers s, Hosts h
                                WHERE srv_status='ON' 
                                AND s.host_id=h.host_id
                                AND srv_disk <= srv_disk_max
                                $filter_type
                                $filter_load
                                AND srv_countries_only LIKE '%,$country,%'
                                ORDER BY type DESC, $logic 
                                LIMIT 1") if $country && !$server;

   $server = $db->SelectRow("SELECT s.*, h.*,
                                CASE srv_type WHEN 'UPLOADER' THEN $uploader_priority WHEN 'STORAGE' THEN 2 END as type
                                $extra1
                                FROM Servers s, Hosts h
                                WHERE srv_status='ON' 
                                AND s.host_id=h.host_id
                                AND srv_disk <= srv_disk_max
                                $filter_type
                                $filter_load
                                AND srv_users_only=''
                                AND srv_countries_only=''
                                ORDER BY type DESC, $logic 
                                LIMIT 1") unless $server;

   $server = $db->SelectRow("SELECT * FROM Servers s, Hosts h WHERE s.srv_id=? AND s.host_id=h.host_id",$f->{srv_id}) if $ses->getUser && $ses->getUser->{usr_adm} && $f->{srv_id};
   
   $ses->message("We're sorry, there are no servers available for upload at the moment.<br>Refresh this page in some minutes.") unless $server;

   prepareUploadData($server);

   $ses->PrintTemplate("upload_form.html",
                       %$server,
                       %$c,
                       max_upload_filesize_bytes => $c->{max_upload_filesize}*1024*1024,
                       sess_id              => $ses->getCookie( $ses->{auth_cook} ),
                       utype                => $utype,
                      );
}

sub UploadURL
{
   $ses->message($c->{maintenance_upload_msg}||"Uploads are temporarily disabled due to site maintenance","Site maintenance") if $c->{maintenance_upload};
   $ses->setCookie('upload_mode','url');
   if($c->{uploads_selected_only})
   {
      $ses->message("You are not allowed to upload files") unless $ses->getUser->{usr_uploads_on};
   }
   else
   {
      $ses->message("URL Uploads disabled for your account type.<br><a href='premium.html'>Upgrade your account</a>") unless $c->{remote_url};
   }
   
   if($f->{del_id})
   {
      $db->Exec("DELETE FROM QueueUpload WHERE id=? AND usr_id=? AND NOT (status='WORKING' AND updated>NOW()-INTERVAL 3 MINUTE)",$f->{del_id},$ses->getUserId);
      $ses->redirect("?op=upload_url");
   }

   my $used = $db->SelectOne("SELECT COUNT(*) FROM QueueUpload WHERE usr_id=?",$ses->getUserId);
   my $slots_left = $c->{queue_url_max} ? $c->{queue_url_max}-$used : 999;


   my @extras;
   for('cat_id','file_public','file_adult','tags','fld_id')
   {
      push @extras, "$_=$f->{$_}" if $f->{$_};
   }
   
   for (split /\s*\,\s*/, $c->{file_data_fields})
   {
      push @extras, "extra_$_=".$f->{"extra_$_"} if $f->{"extra_$_"};
   }

   my $added=0;
   my $skipped;
   my $premium = $ses->getUser ? $ses->getUser->{premium} : 0;
   if($f->{urls})
   {
       $f->{urls}=~s/\r//g;
       for my $url (split(/\n/,$f->{urls}))
       {
          last if $slots_left==0;
          $url=~s/^\s+//g;
          $url=~s/\s+$//g;
          $url=~s/[\0\"]+//g;
          next unless $url=~/^(http|https|ftp):\/\//i;
          $skipped++,next if $db->SelectOne("SELECT url FROM QueueUpload WHERE url=?",$url);
          $db->Exec("INSERT INTO QueueUpload 
                     SET usr_id=?, 
                         url=?,
                         created=NOW(),
                         ip=INET_ATON(?), 
                         premium=?,
                         extras=?",
                      $ses->getUserId, 
                      $url, 
                      $ses->getIP, 
                      $premium||0,
                      join("\n",@extras)
                      );
          $added++;
          $slots_left--;
       }
       my $msg_skipped="<br>$skipped $ses->{lang}->{lng_uploadurl_urls_were_skipped}" if $skipped;
       $ses->redirect_msg("?op=upload_url","$added URLs $ses->{lang}->{lng_uploadurl_were_added_to_queue}$msg_skipped");
   }

   my $list1 = $db->SelectARef("SELECT *, UNIX_TIMESTAMP()-UNIX_TIMESTAMP(q.updated) as updated2 
                                FROM QueueUpload q
                                WHERE usr_id=? 
                                ORDER BY created",$ses->getUserId);
   for(@$list1)
   {
      if($_->{status} eq 'WORKING' && $_->{updated2} > 90)
      {
         $_->{restart}=1;
         $_->{status}='STUCK';
      }
      $_->{url} = substr($_->{url},0,46).'...' if length($_->{url})>46;
      $_->{progress} = $_->{size_full} ? sprintf("%.0f",100*$_->{size_dl}/$_->{size_full}) : 0;
      $_->{size_full} = sprintf("%.0f",$_->{size_full}/1024**2);
      $_->{size_dl}   = sprintf("%.0f",$_->{size_dl}/1024**2);
   }

   # my $categories = genCategoriesSelect();
   # my @extra_data = map{{name=>$_}} split /\s*\,\s*/, $c->{file_data_fields};

   my $hh={};
   prepareUploadData($hh);

   $ses->PrintTemplate("upload_url.html",
                       %$hh,
                       queue_url_max        => $c->{queue_url},
                       slots_left           => $slots_left,
                       max_upload_filesize  => $c->{max_upload_filesize},
                       list                 => $list1,
                       #categories           => $categories,
                       #category_required    => $c->{category_required},
                       cat_id               => $ses->getCookie('cat_id'),
                       #extra_data           => \@extra_data,
                      );
}

sub UploadClone
{
   $ses->setCookie('upload_mode','clone');
   if($f->{urls})
   {
       $f->{urls}=~s/\r//g;
       my ($done,@arr);
       for my $url (split(/\n/,$f->{urls}))
       {
          my ($code) = $url=~/\w\/(\w{12})(\.|\/|\n|$)/gs;
          last if $done>=100;
          next unless $code;
          my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?",$code);
          next unless $file;
          my $new_id = cloneFile($file,0);
          push @arr, $db->SelectOne("SELECT file_code FROM Files WHERE file_id=?",$new_id);
          XUtils::addTagsToFile( $db, $f->{tags}, $new_id );
          XUtils::addExtraFileData($db,$f,$new_id) if $c->{file_data_fields};
          $done++;
       }
       $ses->redirect("?op=upload_result&".join('&', map{"fn=$_&st=OK"} @arr ));
   }

   my $hh={};
   prepareUploadData($hh);

   $ses->PrintTemplate("upload_clone.html",
                        %$hh,
                       m_n_max_links        => $c->{m_n_max_links},
                       queue_url_max        => $c->{queue_url},
                       cat_id               => $ses->getCookie('cat_id'),
                      );
}

sub UploadTorrent
{
   $ses->message($c->{maintenance_upload_msg}||"Uploads are temporarily disabled due to site maintenance","Site maintenance") if $c->{maintenance_upload};

   my $hh={};
   prepareUploadData($hh);

   return $ses->PrintTemplate("upload_torrent.html", %$hh, error => "Torrent Uploads disabled") unless $c->{m_t};
   $ses->setCookie('upload_mode','torrent');

   return $ses->PrintTemplate("upload_torrent.html", %$hh, error => "Torrent Uploads disabled for your account type") unless $hh->{m_t_enabled};

   my $torrent_dl_slots = $c->{torrent_dl_slots};

   if($c->{uploads_selected_only})
   {
      return $ses->PrintTemplate("upload_torrent.html", %$hh, error => "You are not allowed to upload files") unless $ses->getUser->{usr_uploads_on};
   }

   #$ses->message("Torrent Uploads disabled for your account type") unless $torrent_dl_slots;

   if($f->{del_torrent})
   {
      my $torr = $db->SelectRow("SELECT * FROM Torrents WHERE sid=? AND usr_id=?",$f->{del_torrent},$ses->getUserId);
      $ses->redirect("$c->{site_url}/?op=torrent_upload") unless $torr;
      if($torr->{srv_id})
      {
	      my $res = $ses->api2($torr->{srv_id},{
	                                  op   => 'torrent_delete',
	                                  sid  => $f->{del_torrent},
	                                 });
	      $ses->message("Error1:$res") unless $res eq 'OK';
      }

      $db->Exec("DELETE FROM Torrents WHERE sid=?",$f->{del_torrent});
      $ses->redirect("$c->{site_url}/?op=torrent_upload")
   }

   my $slots_used = $db->SelectOne("SELECT COUNT(*) FROM Torrents WHERE usr_id=? AND status='WORKING'",$ses->getUserId);
   return $ses->PrintTemplate("upload_torrent.html", %$hh, error => "You're using all $slots_used / $torrent_dl_slots torrent slots now") 
      if $torrent_dl_slots && $slots_used >= $torrent_dl_slots;

   my $type_filter = $utype eq 'prem' ? "AND srv_allow_premium=1" : "AND srv_allow_regular=1";
   my $server = $db->SelectRow("SELECT * FROM Servers 
                                WHERE srv_status='ON' 
                                AND srv_disk+? <= srv_disk_max*0.99
                                $type_filter
                                AND srv_torrent=1
                                ORDER BY srv_last_upload 
                                LIMIT 1",$c->{max_upload_filesize}||100);
   
   return $ses->PrintTemplate("upload_torrent.html", %$hh, error => "No torrent server available") unless $server;

   # my $categories = genCategoriesSelect();
   # my @extra_data = map{{name=>$_}} split /\s*\,\s*/, $c->{file_data_fields};

   $ses->PrintTemplate("upload_torrent.html",
                       %$server,
                       %$hh,
                       slots_total  => $c->{torrent_dl_slots},
                       slots_used   => $slots_used,
                       sess_id      => $ses->getCookie( $ses->{auth_cook} ),
                       #categories           => $categories,
                       #category_required    => $c->{category_required},
                       #cat_id       => $ses->getCookie('cat_id'),
                       #extra_data   => \@extra_data,
                      );
}

sub UploadFTP
{
    $ses->message($c->{maintenance_upload_msg}||"Uploads are temporarily disabled due to site maintenance","Site maintenance") if $c->{maintenance_upload};
    $ses->message("FTP Uploads disabled") unless $c->{m_f};
    $ses->setCookie('upload_mode','ftp');

    my $hh={};
    prepareUploadData($hh);
    unless($hh->{m_f_enabled})
    {
      $f->{msg}="FTP Uploads disabled for your account type";
      UploadFile();
    }
    $hh->{usr_ftp_password} = $ses->getUser->{usr_ftp_password};

    my $server = $db->SelectRow("SELECT * FROM Servers 
                                WHERE srv_status IN ('ON','READONLY')
                                AND srv_disk <= srv_disk_max*0.99
                                AND srv_ftp=1
                                ORDER BY RAND() 
                                LIMIT 1");
    $ses->message("There are no active FTP servers available at the moment") unless $server;

    $server->{srv_ip}=$c->{m_f_subdomain} if $c->{m_f_subdomain};

    $ses->PrintTemplate("upload_ftp.html",
                         %$server,
                         %$hh,
                         m_f_sync_files_after => $c->{m_f_sync_files_after},
                        );
}

sub prepareUploadData
{
    my ($hh) = @_;
    
    $hh->{categories} = genCategoriesSelect();

    my $spc;
    for my $mod ('m_t','m_e','m_f','m_n')
    {
      $spc->{$mod}=1 if checkModSpecialRights($mod);
    }
    $hh->{"$_\_enabled"}=1 for keys %$spc;

   my @extra_data = map{{name=>$_}} split /\s*\,\s*/, $c->{file_data_fields};
   $hh->{extra_data} = \@extra_data;

   $hh->{remote_url} = $c->{remote_url};
   $hh->{category_required} = $c->{category_required};

   my $allfld = $db->SelectARefCached("SELECT * FROM Folders WHERE usr_id=? ORDER BY fld_name",$ses->getUserId);
   my $fh;
   push @{$fh->{$_->{fld_parent_id}}},$_ for map{$_->{selected}= $ses->getCookie('up_fld_id')==$_->{fld_id} ? ' selected' : 0; $_; } @$allfld;
   my @folders_tree = buildTree($fh,0,0);
   $hh->{folders_tree} = \@folders_tree;

   $hh->{srv_upload_url} = $hh->{srv_cgi_url};
   $hh->{srv_upload_url}=~s/\/cgi-bin//i;
}

sub UploadResult
{
   my $fnames      = &ARef($f->{'fn'});
   my $status      = &ARef($f->{'st'});

   my @arr;
   
   for(my $i=0;$i<=$#$fnames;$i++)
   {
      $fnames->[$i] = $ses->SecureStr($fnames->[$i]);
      $status->[$i] = $ses->SecureStr($status->[$i]);
      unless($status->[$i] eq 'OK')
      {
          push @arr, {file_name => $fnames->[$i],'error' => " $status->[$i]"};
          next;
      }
      my $file = $db->SelectRow("SELECT *
                                 FROM Files f, Servers s
                                 WHERE f.file_code=?
                                 AND f.srv_id=s.srv_id
                                 AND f.file_created > NOW()-INTERVAL 115 MINUTE",$fnames->[$i]);
      next unless $file;

      $file->{download_link} = $ses->makeFileLink($file);

      $ses->getVideoInfo($file);

      $file->{vid_length_txt}=~s/^00:(\d\d:\d\d)$/$1/;

      if($c->{video_embed})
      {
         $file->{vid_width}||=400;
         $file->{vid_height}||=300;
         $file->{vid_height}+=24;
         $file->{video_embed_code}=1;
         $file->{embed_code} = $ses->makeEmbedCode($file);
      }
      $file->{deurl} = $ses->shortenURL($file->{file_id}) if $c->{m_j};
      push @arr, $file;
   }

   $ses->PrintTemplate("upload_results.html",
                       'links' => \@arr,
                      );
}

sub News
{
   my $news = $db->SelectARef("SELECT n.*, DATE_FORMAT(n.created,'%M %dth, %Y') as created_txt,
                                      COUNT(c.cmt_id) as comments
                               FROM News n
                               LEFT JOIN Comments c ON c.cmt_type=2 AND c.cmt_ext_id=n.news_id
                               WHERE n.created<=NOW()
                               GROUP BY n.news_id
                               ORDER BY n.created DESC".$ses->makePagingSQLSuffix($f->{page}));
   my $total = $db->SelectOne("SELECT COUNT(*) FROM News WHERE created<NOW()");
   for(@$news)
   {
      $_->{site_url} = $c->{site_url};
      $_->{link} = "n$_->{news_id}-$_->{news_title2}.html";
      $_->{news_text} =~s/\n/<br>/gs;
      $_->{news_text} =~s/\[cut\](.+)$/"<a href='$_->{link}'>$ses->{lang}->{lng_news_read_more}<\/a>"/gse;
      $_->{enable_file_comments} = $c->{enable_file_comments};
   }
   $ses->PrintTemplate("news.html",
                       'news' => $news,
                       'paging' => $ses->makePagingLinks($f,$total),
                      );
}

sub NewsDetails
{
   my $news = $db->SelectRow("SELECT *, DATE_FORMAT(n.created,'%M %dth, %Y') as created_txt 
                              FROM News n
                              WHERE news_id=? AND created<=NOW()",$f->{news_id});
   $ses->message("No such news") unless $news;
   $news->{news_text} =~s/\n?\[cut\]\n?//gs;
   $news->{news_text} =~s/\n/<br>/gs;
   my $comments = &CommentsList(2,$f->{news_id});
   $ses->{page_title} = $ses->{meta_descr} = $news->{news_title};
   $ses->PrintTemplate("news_details.html",
                        %{$news},
                        'cmt_type'     => 2,
                        'cmt_ext_id'   => $news->{news_id},
                        'comments' => $comments,
                        'enable_file_comments' => $c->{enable_file_comments},
                      );
}

sub CommentsList
{
   my ($cmt_type,$cmt_ext_id) = @_;
   my $list = $db->SelectARef("SELECT *, INET_NTOA(cmt_ip) as ip, DATE_FORMAT(created,'%M %e, %Y at %r') as date
                               FROM Comments 
                               WHERE cmt_type=? 
                               AND cmt_ext_id=?
                               ORDER BY created",$cmt_type,$cmt_ext_id);
   for (@$list)
   {
      $_->{cmt_text}=~s/\n/<br>/gs;
      $_->{cmt_name} = "<a href='$_->{cmt_website}'>$_->{cmt_name}</a>" if $_->{cmt_website};
      if($ses->getUser && $ses->getUser->{usr_adm})
      {
         $_->{email} = $_->{cmt_email};
         $_->{adm} = 1;
      }
   }
   return $list;
}

sub ChangeLanguage
{
   $ses->setCookie('lang',$f->{lang});
   $ses->redirect($ENV{HTTP_REFERER}||$c->{site_url});
}

sub Page
{
   my $tmpl = shift || $f->{tmpl};
   my $lang_name = lc $db->SelectOne("SELECT lang_name FROM Languages WHERE lang_id=?",$ses->{language});
   $lang_name = lc $db->SelectOne("SELECT lang_name FROM Languages WHERE lang_id=?",$c->{default_language})
      unless -e "Templates/Pages/$lang_name/$tmpl.html";

   &IndexPage unless -e "Templates/Pages/$lang_name/$tmpl.html";
   $ses->{expires}="+$c->{caching_expire}s" if $c->{caching_expire};
   $ses->PrintTemplate("Pages/$lang_name/$tmpl.html");
}

sub PageStatic
{
   my $tmpl = shift || $f->{tmpl};
   $tmpl = lc $tmpl;
   $ses->message("Page not found") unless -e "Templates/static/$tmpl.html";
   $ses->{expires}="+$c->{caching_expire}s" if $c->{caching_expire};
   $ses->PrintTemplate("static/$tmpl.html");
}

sub Contact
{
   $c->{captcha}=1;
   my %secure = $ses->SecSave( 1, 2 );
   $f->{$_}=$ses->SecureStr($f->{$_}) for keys %$f;
   $f->{email}||=$ses->getUser->{usr_email} if $ses->getUser;
   $ses->PrintTemplate("contact.html",
                       name => $f->{name},
                       email => $f->{email},
                       message => $f->{message},
                       %secure,
                      );
}

sub ContactSend
{
   &Contact unless $ENV{REQUEST_METHOD} eq 'POST';
   $c->{captcha}=1;
   &Contact unless $ses->SecCheck( $f->{'rand'}, 1, $f->{code} );

   $f->{msg}.=$ses->{lang}->{lng_contact_invalid_email}."<br>" unless $f->{email} =~ /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
   $f->{msg}.=$ses->{lang}->{lng_contact_message_too_short} if length($f->{message})<7;
   
   &Contact if $f->{msg};

   $f->{$_}=$ses->SecureStr($f->{$_}) for keys %$f;

   $f->{message} = "You've got new message from $c->{site_name}.\n\nName: $f->{name}\nE-mail: $f->{email}\nIP: $ENV{REMOTE_ADDR}\n\n$f->{message}";
   #$c->{email_text}=1;
   $ses->SendMail($c->{contact_email}, $c->{email_from}, "New message from $c->{site_name} contact form", $f->{message});
   $ses->redirect_msg('?op=msg', $ses->{lang}->{lng_contact_message_sent_ok} );
}

sub LegalTool
{
    $ses->message("Access denied") unless $c->{m_d} && $ses->getUser->{usr_notes}=~/LEGAL=\d+/i;
    my $last24 = $db->SelectOne("SELECT COUNT(*) FROM FilesTrash WHERE del_by=? AND file_deleted>NOW()-INTERVAL 24 HOUR",$ses->getUserId);
    my ($limit) = $ses->getUser->{usr_notes}=~/LEGAL=(\d+)/i;
    my $left = $limit - $last24;

    if($f->{mass_delete})
    {
      my @arr;
      $f->{mass_delete}=~s/\r//g;
      push @arr,$1 while $f->{mass_delete}=~/\/(\w{12})(\/|$|\n|\.)/gs;
      my $codes = join("','",@arr);
      my $files = $db->SelectARef("SELECT * FROM Files WHERE file_code IN ('$codes')") if $codes;
      $ses->message("You can delete $left files only due to daily limit") if $#$files+1 > $left;
      $ses->DeleteFilesMass($files);
      $ses->redirect_msg("$c->{site_url}/?op=legal_tool", ($#$files+1)." files were deleted successfully");
    }
   $ses->PrintTemplate("legal_tool.html", left => $left);
}

sub ModeratorFiles
{
   $ses->message("Access denied") if !$ses->getUser->{usr_adm} && !($c->{m_d} && $ses->getUser->{usr_mod} && $c->{m_d_f});
   if($f->{del_selected} && $f->{file_id})
   {
      $ses->message("Not allowed in Demo mode") if $c->{demo_mode};
      my $ids = join(',',grep{/^\d+$/}@{&ARef($f->{file_id})});
      $ses->redirect($c->{site_url}) unless $ids;
      my $files = $db->SelectARef("SELECT * FROM Files WHERE file_id IN ($ids)");
      my $deleted24 = $db->SelectOne("SELECT COUNT(*) FROM FilesTrash WHERE del_by=? AND file_deleted>NOW()-INTERVAL 24 HOUR",$ses->getUserId);
      $ses->message("Delete limit $c->{m_d_f_limit} files per day can't be exceeded") if $c->{m_d_f_limit} && $deleted24+$#$files+1 > $c->{m_d_f_limit};
      $_->{del_money}=$c->{del_money_file_del} for @$files;
      $ses->DeleteFilesMass($files);
      if($f->{del_info})
      {
         for(@$files)
         {
            $db->Exec("INSERT INTO DelReasons SET file_code=?, file_name=?, info=?",$_->{file_code},$_->{file_name},$f->{del_info});
         }
      }
      $ses->redirect("$c->{site_url}/?op=moderator_files");
   }
   if($f->{featured_add} && $f->{file_id} && $c->{m_d_featured})
   {
      $ses->message("Not allowed in Demo mode") if $c->{demo_mode};
      for(@{&ARef($f->{file_id})})
      {
         $db->Exec("INSERT IGNORE INTO FilesFeatured SET file_id=?",$_);
      }
      $ses->redirect_msg("$c->{site_url}/?op=moderator_files_featured","Files were added to list");
   }
   if(($f->{lock}||$f->{unlock}) && $f->{file_id})
   {
      $ses->message("Not allowed in Demo mode") if $c->{demo_mode};
      my $ids = join ',', grep{/^\d+$/} @{&ARef($f->{file_id})};
      my $status = $f->{lock} ? 'LOCKED' : 'OK';
      $db->Exec("UPDATE Files SET file_status='$status' WHERE file_id IN ($ids)") if $ids;
      $ses->redirect_msg("$c->{site_url}/?op=moderator_files");
   }

   my $filter_files;
   if($f->{mass_search})
   {
      my @arr;
      $f->{mass_search}=~s/\r//g;
      push @arr,$1 while $f->{mass_search}=~/\/(\w{12})(\/|\.|$|\n)/gs;
      $filter_files = "AND file_code IN ('".join("','",@arr)."')";
   }

   $f->{per_page}||=$c->{items_per_page};
   $f->{usr_id}=$db->SelectOne("SELECT usr_id FROM Users WHERE usr_login=?",$f->{usr_login}) if $f->{usr_login};
   my $filter_key    = "AND (file_name LIKE '%$f->{key}%' OR file_title LIKE '%$f->{key}%')" if $f->{key};
   my $filter_user   = "AND f.usr_id='$f->{usr_id}'" if $f->{usr_id};
   my $filter_ip     = "AND f.file_ip=INET_ATON('$f->{ip}')" if $f->{ip}=~/^[\d\.]+$/;
   my $filter_code   = "AND (f.file_code='$f->{code}' OR f.file_real='$f->{code}')" if $f->{code}=~/^\w{12}$/;
   my $filter_status = "AND f.file_status='$f->{file_status}'" if $f->{file_status}=~/^\w+$/i;
   my $files = $db->SelectARef("SELECT f.*,
                                       INET_NTOA(file_ip) as file_ip,
                                       u.usr_id, u.usr_login
                                FROM Files f
                                LEFT JOIN Users u ON f.usr_id = u.usr_id
                                WHERE 1
                                $filter_files
                                $filter_key
                                $filter_user
                                $filter_ip
                                $filter_code
                                $filter_status
                                ORDER BY file_created DESC
                                ".$ses->makePagingSQLSuffix($f->{page},$f->{per_page}) );
   my $total = $db->SelectOne("SELECT COUNT(*) as total_count
                                FROM Files f 
                                WHERE 1 
                                $filter_files
                                $filter_key 
                                $filter_user 
                                $filter_ip
                                $filter_code
                                $filter_status
                                ");

   for(@$files)
   {
      $_->{site_url} = $c->{site_url};
      $_->{file_title_txt} = $ses->shortenString( $_->{file_title}||$_->{file_name}, $c->{display_max_filename_admin} );
      $_->{file_size2} = sprintf("%.01f Mb",$_->{file_size}/1048576);
      $_->{download_link} = $ses->makeFileLink($_);
      $_->{td_style}=' class="file_pending"' if $_->{file_status} eq 'PENDING';
      $_->{td_style}=' class="file_locked"'  if $_->{file_status} eq 'LOCKED';
      $ses->getVideoInfo($_) if $f->{thumbnail};
   }
  
   $ses->PrintTemplate("admin_files_moderator.html",
                       'files'   => $files,
                       'key'     => $f->{key},
                       'code'    => $f->{code},
                       'usr_id'  => $f->{usr_id},
                       "per_$f->{per_page}" => ' checked',
                       'paging'     => $ses->makePagingLinks($f,$total),
                       'items_per_page' => $c->{items_per_page},
                       'usr_login'  => $f->{usr_login},
                       'm_d_featured' => $c->{m_d_featured},
                       "file_status_$f->{file_status}" => ' checked',
                       'thumbnail'    => $f->{thumbnail},
                      );
}

sub ModeratorFilesApprove
{
   $ses->message("Access denied") if !$ses->getUser->{usr_adm} && !($c->{m_d} && $ses->getUser->{usr_mod} && $c->{m_d_file_approve});
   if($f->{approve} && $f->{file_id} && $c->{m_d_file_approve})
   {
      $ses->message("Not allowed in Demo mode") if $c->{demo_mode};
      my $ids = join ',', grep{/^\d+$/} @{&ARef($f->{file_id})};
      $db->Exec("UPDATE Files SET file_status='OK' WHERE file_id IN ($ids)");
      $ses->redirect_msg("$c->{site_url}/?op=moderator_files_approve");
   }
   if($f->{del_selected} && $f->{file_id})
   {
      $ses->message("Not allowed in Demo mode") if $c->{demo_mode};
      my $ids = join(',',grep{/^\d+$/}@{&ARef($f->{file_id})});
      $ses->redirect($c->{site_url}) unless $ids;
      my $files = $db->SelectARef("SELECT * FROM Files WHERE file_id IN ($ids)");
      $_->{del_money}=$c->{del_money_file_del} for @$files;
      $ses->DeleteFilesMass($files);
      if($f->{del_info})
      {
         for(@$files)
         {
            $db->Exec("INSERT INTO DelReasons SET file_code=?, file_name=?, info=?",$_->{file_code},$_->{file_name},$f->{del_info});
         }
      }
      $ses->redirect("$c->{site_url}/?op=moderator_files_approve");
   }

   $f->{per_page}||=$c->{items_per_page};
   my $files = $db->SelectARef("SELECT f.*,
                                       INET_NTOA(file_ip) as file_ip,
                                       u.usr_id, u.usr_login
                                FROM Files f
                                LEFT JOIN Users u ON f.usr_id = u.usr_id
                                WHERE f.file_status='PENDING'
                                ORDER BY file_created DESC
                                ".$ses->makePagingSQLSuffix($f->{page},$f->{per_page}) );
   my $total = $db->SelectOne("SELECT COUNT(*) as total_count
                                FROM Files f 
                                WHERE f.file_status='PENDING' 
                                ");

   for(@$files)
   {
      $_->{site_url} = $c->{site_url};

      $_->{file_name_txt} = $ses->shortenString($_->{file_name});

      $_->{file_size2} = sprintf("%.01f Mb",$_->{file_size}/1048576);
      $_->{download_link} = $ses->makeFileLink($_);
      $ses->getVideoInfo($_);
   }
  
   $ses->PrintTemplate("admin_files_moderator_approve.html",
                       'files'   => $files,
                       "per_$f->{per_page}" => ' checked',
                       'paging'     => $ses->makePagingLinks($f,$total),
                       'items_per_page' => $c->{items_per_page},
                      );
}

sub MyReports
{
   my @d1 = $ses->getTime();
   $d1[2]='01';
   my @d2 = $ses->getTime();
   my $day1 = $f->{date1}=~/^\d\d\d\d-\d\d-\d\d$/ ? $f->{date1} : "$d1[0]-$d1[1]-$d1[2]";
   my $day2 = $f->{date2}=~/^\d\d\d\d-\d\d-\d\d$/ ? $f->{date2} : "$d2[0]-$d2[1]-$d2[2]";
   my $list2 = $db->SelectARefCached("SELECT *, DATE_FORMAT(day,'%e') as day2
                                     FROM Stats2
                                     WHERE usr_id=?
                                     AND day>=?
                                     AND  day<=?
                                     ORDER BY day",$ses->getUserId,$day1,$day2);
   $ses->message("Not enough reports data") if $#$list2<0;

    my $list = $ses->getDatesList($list2,$day1,$day2);

   my %totals;
   my (@days,@profit_dl,@profit_sales,@profit_refs);
   for my $x (@$list)
   {
      $x->{profit_total} = sprintf("%.05f",$x->{profit_views}+$x->{profit_sales}+$x->{profit_refs}+$x->{profit_site});
      for(qw(profit_dl profit_sales profit_refs profit_total))
      {
         #$x->{$_}=~s/\.?0+$//;
      }
      $totals{"sum_$_"}+=$x->{$_} for qw(views views_prem views_adb downloads sales profit_views profit_sales profit_refs profit_site profit_total refs);
      $x->{$_}||=0 for qw(views uploads sales);
      $x->{$_}||='' for qw(downloads refs);
      $x->{$_}||='0.00000' for qw(profit_views profit_sales profit_refs profit_site);
   }

   # my $divlines = $#$list-1;
   # $divlines=1 if $divlines<1;
   # my $xml = $ses->CreateTemplate("my_reports.xml");
   # $xml->param(list=>$list, divlines=>$divlines);
   # my $data_xml = $xml->output;
   # $data_xml=~s/[\n\r]+//g;
   # $data_xml=~s/\s{2,16}/ /g;

   $ses->PrintTemplate("my_reports.html",
                       list => $list,
                       date1 => $day1,
                       date2 => $day2,
                       %totals,
                       #data_xml => $data_xml,
                       m_b      => $c->{m_b},
                      );
}

sub MyReportsDay
{
    $ses->message("Invalid day") unless $f->{day}=~/^\d\d\d\d-\d\d-\d\d$/;
    my $countries = $db->SelectARef("SELECT * FROM StatsCountry WHERE usr_id=? AND day=? ORDER BY money DESC, views DESC LIMIT 20",$ses->getUserId,$f->{day});
    $ses->PrintTemplate("my_reports_day.html",
                       countries => $countries,
                       day => $f->{day},
                      );
}

sub MyAccount
{
   if($f->{msg})
   {
   		# Purge user data cache on Save
   		$db->PurgeCache( "ses".$ses->getCookie( $ses->{auth_cook} ) );
   }
   if($f->{generate_api_key})
   {
   	 my $key = $ses->randchar(1,'az').$ses->randchar(15);
   	 $db->Exec("UPDATE Users SET usr_api_key=? WHERE usr_id=?",$key,$ses->getUserId);
   	 $ses->redirect_msg("?op=my_account","New API key generated");
   }
   if($f->{confirmchanges})
   {
   	 my $rec = $db->SelectRow("SELECT * FROM ChangeFields WHERE hash=? AND usr_id=? AND created>NOW()-INTERVAL 12 HOUR",$f->{confirmchanges},$ses->getUserId);
   	 return $ses->message("Invalid hash") unless $rec;
   	 for my $str (split /\n/, $rec->{data})
   	 {
   	 	my ($field,$value) = $str=~/^([\w\_\-]+)=(.*)$/;
   	 	$db->Exec("UPDATE Users SET `$field`=? WHERE usr_id=? LIMIT 1",$value,$ses->getUserId);
   	 }
   	 return $ses->redirect_msg('?op=my_account','Changes confirmed');
   }
   if($f->{premium_key} && $c->{m_k})
   {
      my ($key_id,$key_code) = $f->{premium_key}=~/^(\d+)(\w+)$/;
      my $key = $db->SelectRow("SELECT * FROM PremiumKeys WHERE key_id=? AND key_code=?",$key_id,$key_code);
      $ses->redirect_msg("?op=my_account","Invalid Premium Key") unless $key;
      $ses->redirect_msg("?op=my_account","This Premium Key already used") if $key->{usr_id_activated};
      my ($val,$m) = $key->{key_time}=~/^(\d+)(\D*)$/;
      $m||='d';
      my $int = {'h'=>'HOUR','d'=>'DAY','m'=>'MONTH'}->{$m};
      $db->Exec("UPDATE Users SET usr_premium_expire=usr_premium_expire+INTERVAL $val $int
                 WHERE usr_id=?",$ses->getUserId);
      $db->Exec("UPDATE PremiumKeys SET key_activated=NOW(), usr_id_activated=? WHERE key_id=?",$ses->getUserId,$key->{key_id});
      $m=~s/h/ $ses->{lang}->{lng_misc_hours}/ie;
      $m=~s/d/ $ses->{lang}->{lng_misc_days}/ie;
      $m=~s/m/ $ses->{lang}->{lng_misc_mins}/ie;
      $ses->redirect_msg("?op=my_account","$ses->{lang}->{lng_myaccount_prem_key_ok}<br>$ses->{lang}->{lng_myaccount_added_prem_time}: $val $m");
   }
   if($f->{avatar_delete} && $ses->checkToken)
   {
      unlink("$c->{site_path}/upload-data/avatar_".$ses->getUserId.".jpg");
      $ses->redirect("?op=my_account");
   }
   if($f->{enable_lock} && $ses->checkToken)
   {
      $ses->message("Security Lock already enabled") if $ses->getUser->{usr_security_lock};
      my $rand = $ses->randchar(8);
      $db->Exec("UPDATE Users SET usr_security_lock=? WHERE usr_id=?",$rand,$ses->getUserId);
      $ses->redirect_msg("?op=my_account",$ses->{lang}->{lng_myaccount_lock_activated});
   }
   if($f->{disable_lock})
   {
      $ses->message("Demo mode") if $c->{demo_mode} && $ses->getUser->{usr_login} eq 'admin';
      my $rand = $ses->getUser->{usr_security_lock};
      $ses->message("Security Lock is not enabled") unless $rand;
      if($f->{code})
      {
         $ses->message("Error: security code doesn't match") unless $f->{code} eq $rand;
         $db->Exec("UPDATE Users SET usr_security_lock='' WHERE usr_id=?",$ses->getUserId);
         $ses->redirect_msg("?op=my_account",$ses->{lang}->{lng_myaccount_lock_disabled});
      }
      $c->{email_text}=1;
      $ses->SendMail( $ses->getUser->{usr_email}, $c->{email_from}, "$c->{site_name}: disable security lock", "To disable Security Lock for your account follow this link:\n$c->{site_url}/?op=my_account&disable_lock=1&code=$rand" );
      $ses->redirect_msg("?op=my_account",$ses->{lang}->{lng_myaccount_lock_link_sent});
   }
   if($f->{site_add} && $f->{site_validate})
   {
      $f->{site_add}=~s/^https?:\/\///i;
      $f->{site_add}=~s/^www\.//i;
      $f->{site_add}=~s/[\/\s]+//g;

      if(my $usr_id1 = $db->SelectOne("SELECT usr_id FROM Websites WHERE domain=?",$f->{site_add}))
      {
         $ses->message("$f->{site_add} $ses->{lang}->{lng_myaccount_domain_already_added_by} usr_id=$usr_id1");
      }

      my $site_key = lc $c->{site_url};
      $site_key=~s/^www\.//i;
      $site_key=~s/^.+\/\///;
      $site_key=~s/\W//g;

      require LWP::UserAgent;
      my $ua = LWP::UserAgent->new(timeout => 10, agent   => 'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.1.6) Gecko/20091201 Firefox/3.5.6 (.NET CLR 3.5.30729)');
      my $res = $ua->get("http://$f->{site_add}/$site_key.txt")->content;
      $res=~s/[\r\n]+//g;
      my $ok;
      if($res=~/^\d+$/)
      {
         $ok=1 if $res == $ses->getUserId;
      }
      else
      {
         my $res = $ua->get("http://$f->{site_add}")->content;
         $ok=1 if $res=~/<meta\s+content="1"\s+name="$site_key"\s*\/?>/is;
         $ok=1 if $res=~/<meta\s+name="$site_key"\s+content="1"\s*\/?>/is;
      }
      if($ok)
      {
         $db->Exec("INSERT INTO Websites SET usr_id=?, domain=?, created=NOW()",$ses->getUserId,$f->{site_add});
         $ses->redirect_msg("?op=my_account","$f->{site_add} $ses->{lang}->{lng_myaccount_domain_added_to_account}");
      }
      $ses->redirect_msg("?op=my_account","$ses->{lang}->{lng_myaccount_failed_to_verify_domain} $f->{site_add}");
   }
   if($f->{site_del})
   {
      $db->Exec("DELETE FROM Websites WHERE usr_id=? AND domain=? LIMIT 1",$ses->getUserId,$f->{site_del});
      $ses->redirect_msg("?op=my_account","$f->{site_del} $ses->{lang}->{lng_myaccount_domain_deleted}");
   }
   if($f->{site_reset})
   {
      $db->Exec("UPDATE Websites SET money_profit=0 WHERE usr_id=?",$ses->getUserId);
      $ses->redirect_msg("?op=my_account",$ses->{lang}->{lng_myaccount_profit_counters_reset_ok});
   }
   if($f->{settings_save} && $ENV{REQUEST_METHOD} eq 'POST' && $ses->checkToken)
   {
      $ses->message("Not allowed in Demo mode!") if $c->{demo_mode} && $ses->getUser->{usr_adm};
      my $user=$db->SelectRow("SELECT usr_login,DECODE(usr_password,?) as usr_password,usr_email FROM Users WHERE usr_id=?",$c->{pasword_salt},$ses->getUserId);
      if($f->{usr_login} && $user->{usr_login}=~/^\d+$/ && $f->{usr_login} ne $user->{usr_login})
      {
         $f->{usr_login}=$ses->SecureStr($f->{usr_login});
         $ses->message($ses->{lang}->{lng_myaccount_msg_login_should_contain_letters}) if $f->{usr_login}=~/^\d+$/;
         $ses->message($ses->{lang}->{lng_myaccount_msg_login_too_short}) if length($f->{usr_login})<4;
         $ses->message($ses->{lang}->{lng_myaccount_msg_login_too_long}) if length($f->{usr_login})>32;
         $ses->message($ses->{lang}->{lng_myaccount_msg_login_reserved_words}) if $f->{usr_login}=~/^(admin|images|captchas|files)$/;
         $ses->message($ses->{lang}->{lng_myaccount_msg_invalid_login}) unless $f->{usr_login}=~/^[\w\-\_]+$/;
         $ses->message($ses->{lang}->{lng_myaccount_msg_login_exist})  if $db->SelectOne("SELECT usr_id FROM Users WHERE usr_login=?",$f->{usr_login});
         $db->Exec("UPDATE Users SET usr_login=? WHERE usr_id=?",$f->{usr_login},$ses->getUserId);
      }
      # if($f->{usr_email} ne $ses->getUser->{usr_email} && !$ses->getUser->{usr_security_lock})
      # {
      #    $ses->message("This email already in use") if $db->SelectOne("SELECT usr_id FROM Users WHERE usr_id<>? AND usr_email=?", $ses->getUserId, $f->{usr_email} );
      #    $ses->message("Error: Invalid e-mail") unless $f->{usr_email}=~/^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
      #    $db->Exec("UPDATE Users SET usr_email=? WHERE usr_id=?",$f->{usr_email},$ses->getUserId);
      #    $f->{msg}.=$ses->{lang}->{lng_myaccount_msg_email_changed_ok}.'<br>';
      #    $user->{usr_email_new} = $f->{usr_email};
      # }
      if(!$ses->getUser->{usr_security_lock})
      {
         $db->Exec("UPDATE Users 
                    SET usr_pay_email=?, 
                        usr_pay_type=?,
                        usr_channel_name=?
                    WHERE usr_id=?",$f->{usr_pay_email}||'',
                                 $f->{usr_pay_type}||'',
                                 $f->{usr_channel_name}||'',
                                 $ses->getUserId);

		if($f->{usr_allowed_ips} ne $ses->getUser->{usr_allowed_ips})
		{
			$f->{usr_allowed_ips}=~s/\s+//g;
			$ses->message($ses->{lang}->{lng_myaccount_msg_invalid_ip_mask}) if $f->{usr_allowed_ips} && $f->{usr_allowed_ips}!~/^[\d\.\*\,]{3,}$/;
			for(split(/,/,$f->{usr_allowed_ips}))
			{
			    $ses->message($ses->{lang}->{lng_myaccount_msg_invalid_ip_mask}) unless /^\d+\.\d+\.[\d\.\*]+$/;
			}
			my $pass;
			for my $ip (split(/,\s*/,$f->{usr_allowed_ips}))
			{
			  $ip=~s/\.\*//g;
			  $ip=~s/\./\\\./g;
			  $pass=1 if $ses->getIP =~ /^$ip/;
			}
			$ses->message($ses->{lang}->{lng_myaccount_msg_invalid_ip_mask2}.$ses->getIP) if $f->{usr_allowed_ips} && !$pass;
			$db->Exec("UPDATE Users SET usr_allowed_ips=? WHERE usr_id=?",$f->{usr_allowed_ips},$ses->getUserId);
		}
        if($f->{user_avatar})
		{
		    my $avatarfile = "$c->{site_path}/upload-data/avatar_".$ses->getUserId.".jpg";
		    my $fh = $ses->{cgi_query}->upload( 'user_avatar' );
		    return $ses->message("Error fetching avatar: ".$ses->{cgi_query}->cgi_error()) unless $fh;
		    require GD;
		    GD::Image->trueColor(1);
		    #my $im = new GD::Image($avatarfile) || $ses->message("Failed to read the image avatar");
		    my $im = new GD::Image($fh) || $ses->message("Failed to read the image avatar");
		    my ($w,$h) = $im->getBounds();
		    unlink($avatarfile),$ses->message("Invalid image") unless $w && $h;
		    #unlink($avatarfile),$ses->message("Image is too large ($w x $h)") if $w>200 || $h>200;
		    if($w>$c->{avatar_width} || $h>$c->{avatar_height})
		    {
		    	resizeGD($im, $c->{avatar_width}, $c->{avatar_height}, $avatarfile);
		    }
		    else
		    {
		    	$ses->{cgi_query}->upload( 'user_avatar', $avatarfile ) || $ses->message("Error saving avatar: ".$ses->{cgi_query}->cgi_error());
		    }
		}
      }
      #$db->Exec("UPDATE Users 
      #           SET usr_direct_downloads=?
      #           WHERE usr_id=?",$f->{usr_direct_downloads}||0,$ses->getUserId);
      $f->{msg}.=$ses->{lang}->{lng_myaccount_msg_settings_saved_ok};

      my @custom_fields = qw(
                             embed_domain_allowed
                             files_auto_po
                             usr_embed_access_only
                             usr_embed_title
                             usr_logout_sessions
                             usr_email_newip
                             usr_disable_adb
                             usr_ads_mode
                             usr_no_encoding
                             banned_countries
                             banned_ips
                            );
      #for(qw(rs mu mv nl hf mf fs df ff es sm ug fe))
      #{
      #   push @custom_fields, "$_\_logins";
      #}
      push @custom_fields, map{utf8::encode($_);"usr_extra_$_"} split(/\s*\,\s*/,lc $c->{extra_user_fields});

      $f->{banned_countries} = join '|', grep{$_=~/^\w\w$/} split /[\|,\s]/, uc($f->{banned_countries});
      $f->{banned_ips} = join ',', grep{$_=~/^\d+\.\d+\.\d+\.(\d+|\*)$/} split /[\|,\s]/, uc($f->{banned_ips});
      #die $f->{banned_countries};

      for( @custom_fields )
      {
        $ses->saveUserData($_,$f->{$_});
      }
      
      $ses->redirect_msg('?op=my_account',$f->{msg});
   }
   XUtils::CheckAuth($ses);
   my $user = $ses->getUser;
   #my $totals = $db->SelectRow("SELECT COUNT(*) as total_files, SUM(file_size) as total_size FROM Files WHERE usr_id=? AND file_code=file_real",$ses->getUserId);
   #$totals->{total_size} = sprintf("%.02f",$totals->{total_size}/1024**3);
   #my $disk_space = $user->{usr_disk_space} || $c->{disk_space};
   #$disk_space = $disk_space ? sprintf("%.0f GB",$disk_space) : 'Unlimited';
   $user->{enabled_prem}=$c->{enabled_prem};
   $user->{premium_expire} = $db->SelectOne("SELECT DATE_FORMAT(usr_premium_expire,'%e %M %Y') FROM Users WHERE usr_id=?",$ses->getUserId) if $user->{enabled_prem};

   if($c->{video_dl_orig} && $c->{bw_limit_days} && $c->{bw_limit})
   {
      my $bw = $db->SelectOne("SELECT SUM(size) FROM Downloads WHERE ip=INET_ATON(?) AND created > NOW()-INTERVAL ? DAY",$ses->getIP,$c->{bw_limit_days});
      $user->{dl_traffic_left} = sprintf("%.0f", $c->{bw_limit}-$bw/1024**2 ) || '-';
   }

   my $data = $db->SelectARef("SELECT * FROM UserData WHERE usr_id=?",$user->{usr_id});
   $user->{$_->{name}}=$_->{value} for @$data;

   $user->{usr_money}=~s/\.?0+$//;
   $user->{login_change}=1 if $user->{usr_login}=~/^\d+$/;

   my $referrals = $db->SelectOneCached("SELECT COUNT(*) FROM Users WHERE usr_aff_id=?",$ses->getUserId);

   my @payout_list = map{ {name=>$_,checked=>($_ eq $ses->getUser->{usr_pay_type})} } split(/\s*\,\s*/,$c->{payout_systems});
   #$user->{rsl}=1 if $c->{m_k} && (!$c->{m_k_manual} || $user->{usr_reseller});

   for my $m ('m_v','m_b')
   {
       $user->{"$m\_enabled"}=1 if checkModSpecialRights($m);
   }

   $user->{embed_on}=1 if $c->{video_embed} || $c->{video_embed2};
   if($user->{m_b_enabled})
   {
      $user->{site_key} = lc $c->{site_url};
      $user->{site_key}=~s/^www\.//i;
      $user->{site_key}=~s/^.+\/\///;
      $user->{site_key}=~s/\W//g;
      $user->{websites} = $db->SelectARef("SELECT * FROM Websites WHERE usr_id=? ORDER BY domain",$ses->getUserId);
   }

   my @extra = map{ {name=>$_,field=>'usr_extra_'.lc($_), value=>$user->{"usr_extra_".lc($_)}} } split(/\s*\,\s*/,$c->{extra_user_fields});
   
   $user->{token} = $ses->genToken;
   $user->{current_ip} = $ses->getIP;
   $user->{m_6} = $c->{m_6}; # api
   $user->{"force_disable_adb_$c->{force_disable_adb}"}=1;
   $user->{$_}=$c->{$_} for qw(alt_ads_mode alt_ads_percent);

   $user->{user_avatar_url} = "$c->{site_url}/upload-data/avatar_".$ses->getUserId.".jpg?v=".rand(1000) if -e "$c->{site_path}/upload-data/avatar_".$ses->getUserId.".jpg";

   $ses->PrintTemplate("my_account.html",
                       %{$user},
                       'msg'  => $f->{msg},
                       #%{$totals},
                       #'disk_space' => $disk_space,
                       'payout_list'         => \@payout_list,
                       'm_k'  => $c->{m_k},
                       'referrals'          => $referrals,
                       'extra_fields'       => \@extra,
                       'video_dl_orig'      => $c->{video_dl_orig},
                       'bw_limit'           => $c->{bw_limit},
                       'allow_no_encoding'	=> $c->{allow_no_encoding},
                      );
}

sub MyPassword
{
    $ses->message("Security Lock enabled!") if $ses->getUser->{usr_security_lock};
    
    if($f->{change} && $f->{password_new} && $f->{password_new2} && $ses->checkToken)
    {
       $ses->message("Demo mode!") if $c->{demo_mode};
       $ses->message("New password is too short") if length($f->{password_new})<4;
       $ses->message("New passwords do not match") unless $f->{password_new} eq $f->{password_new2};
       sleep(2),$ses->message("Current password do not match") 
       	unless $ses->checkPasswdHash($f->{password_current});
        #unless $db->SelectOne("SELECT usr_id FROM Users WHERE usr_id=? AND usr_password=ENCODE(?,?)", $ses->getUserId, $f->{password_current}, $c->{pasword_salt});
       
       #$db->Exec("UPDATE Users SET usr_password=ENCODE(?,?) WHERE usr_id=?", $f->{password_new}, $c->{pasword_salt}, $ses->getUserId );
		$db->Exec("UPDATE Users SET usr_password=? WHERE usr_id=?", $ses->genPasswdHash( $f->{password_new} ), $ses->getUserId );

		my $t = $ses->CreateTemplate("my_password_email.html");
		$t->param( ip => $ses->getIP, agent => $ENV{HTTP_USER_AGENT} );
		$c->{email_text}=1;
		$ses->SendMail($ses->getUser->{usr_email},$c->{email_from},"$c->{site_name} password changed notification",$t->output);

       $ses->redirect_msg("?op=my_account",$ses->{lang}->{lng_mypassword_msg_pass_changed_ok});
    }
    my $token = $ses->genToken;
    $ses->PrintTemplate("my_password.html", token => $token );
}

sub MyEmail
{
    $ses->message("Security Lock enabled!") if $ses->getUser->{usr_security_lock};
    
    if($f->{change} && $f->{usr_email} && $f->{usr_email2} && $ses->checkToken)
    {
       	return $ses->message("Demo mode!") if $c->{demo_mode};
       	return $ses->redirect_msg("?op=my_email","Error: $ses->{lang}->{lng_registration_email_invalid}") unless $f->{usr_email}=~/^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
   		return $ses->redirect_msg("?op=my_email","Error: $ses->{lang}->{lng_registration_mail_server_banned}") if $c->{mailhosts_not_allowed} && $f->{usr_email}=~/\@$c->{mailhosts_not_allowed}/i;
   		return $ses->redirect_msg("?op=my_email","Error: $ses->{lang}->{lng_registration_email_already_used}") if $db->SelectOne("SELECT usr_id FROM Users WHERE usr_email=?",$f->{usr_email});
   		return $ses->redirect_msg("?op=my_email","Error: email to not match!") if $f->{usr_email} ne $f->{usr_email2};

   		my $hash = $ses->randchar(10);
        $db->Exec("INSERT INTO ChangeFields SET hash=?, usr_id=?, ip=INET_ATON(?), data=?", $hash, $ses->getUserId, $ses->getIP, "usr_email=$f->{usr_email}" );

		my $t = $ses->CreateTemplate("my_account_changes_email.html");
		my @arr = ({name=>'Email', 'old'=>$ses->getUser->{usr_email}, 'new'=>$f->{usr_email}});
		$t->param( ip => $ses->getIP, agent => $ENV{HTTP_USER_AGENT}, hash => $hash, fields => \@arr );
		$c->{email_text}=1;
		$ses->SendMail($ses->getUser->{usr_email},$c->{email_from},"$c->{site_name} email change request",$t->output);

       $ses->redirect_msg("?op=my_account","Confirmation link was sent to your current email address");
    }

    $ses->PrintTemplate("my_email.html", usr_email => $ses->getUser->{usr_email}, token => $ses->genToken );
}

sub MyReferrals
{
   my $list = $db->SelectARef("SELECT usr_login, DATE(usr_created) as usr_created, usr_money, UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as dt
                               FROM Users WHERE usr_aff_id=? ORDER BY usr_created DESC".$ses->makePagingSQLSuffix($f->{page}),$ses->getUserId);
   my $total = $db->SelectOne("SELECT COUNT(*) FROM Users WHERE usr_aff_id=?",$ses->getUserId);
   for(@$list)
   {
      $_->{prem}=1 if $_->{dt}>0;
      $_->{usr_money}=~s/\.?0+$//;
      $_->{usr_login}=~s/^(\w\w)(\w+)$/$1.'*' x length($2)/e;
   }
   $ses->PrintTemplate("my_referrals.html",
                       list   => $list,
                       paging => $ses->makePagingLinks($f,$total),
                      );
}

sub getFolderFiles
{
   my ($fld_id)=@_;
   my $subf = $db->SelectARef("SELECT * FROM Folders WHERE usr_id=? AND fld_parent_id=?",$ses->getUserId,$fld_id);
   my @arr;
   for(@$subf)
   {
      push @arr, getFolderFiles($_->{fld_id});
   }
   my $files = $db->SelectARef("SELECT * FROM Files WHERE usr_id=? AND file_fld_id=?",$ses->getUserId,$fld_id);
   push @arr, @$files;
   return @arr;
}

sub delFolder
{
   my ($fld_id)=@_;
   my $subf = $db->SelectARef("SELECT * FROM Folders WHERE usr_id=? AND fld_parent_id=?",$ses->getUserId,$fld_id);
   for(@$subf)
   {
      &delFolder($_->{fld_id});
   }
   my $files = $db->SelectARef("SELECT * FROM Files WHERE usr_id=? AND file_fld_id=?",$ses->getUserId,$fld_id);
   $ses->DeleteFilesMass($files);
   $db->Exec("DELETE FROM Folders WHERE usr_id=? AND fld_id=?",$ses->getUserId,$fld_id);
}

sub MyFiles
{
   $f->{fld_id}=~s/\D+//g;
   if($f->{token} && $ses->checkToken)
   {
         if($f->{del_code})
         {
            my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=? AND usr_id=?",$f->{del_code},$ses->getUserId);
            $ses->message("Security error: not_owner") unless $file;
            #$ses->{no_del_log}=1;
            $ses->DeleteFile($file);
            $ses->redirect("?op=my_files&fld_id=$f->{fld_id}");
         }

         if($f->{del_selected} && $f->{file_id})
         {
            my $ids = join(',',grep{/^\d+$/}@{&ARef($f->{file_id})});
            $ses->redirect($c->{site_url}) unless $ids;
            my $files = $db->SelectARef("SELECT * FROM Files WHERE usr_id=? AND file_id IN ($ids)",$ses->getUserId);
            $|=1;
            print"Content-type:text/html\n\n<html><body>\n\n";
            #$ses->{no_del_log}=1;
            $ses->DeleteFilesMass($files,'nb');
            print"<script>window.location='$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}';</script>";
            exit;
            #$ses->redirect("$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}");
         }

         if($f->{set_public} && $f->{file_id})
         {
            $f->{set_public} = $f->{set_public} eq 'true' ? 1 : 0;
            $db->Exec("UPDATE Files SET file_public=? WHERE usr_id=? AND file_id=?",$f->{set_public},$ses->getUserId,$f->{file_id});
            my $style = $f->{set_public} ? 'pub' : '';
            print"Content-type:text/html\n\n";
            print"\$\$('td$f->{file_id}').className='$style';";
            exit;
         }

         if($f->{set_extra_fields} && $f->{file_id})
         {
            my $ids = join(',',grep{/^\d+$/}@{&ARef($f->{file_id})});
            $ses->redirect($c->{site_url}) unless $ids;
            my $files = $db->SelectARef("SELECT * FROM Files WHERE usr_id=? AND file_id IN ($ids)",$ses->getUserId);
            my @extra_fields = split /\s*\,\s*/, $c->{file_data_fields};
            for my $file (@$files)
            {
                for my $kk (@extra_fields)
                {
                    next unless $f->{"extra_$kk"};
                    $db->Exec("INSERT INTO FilesData SET file_id=?, name=?, value=?
                                ON DUPLICATE KEY UPDATE value=?", $file->{file_id}, $kk, $f->{"extra_$kk"}, $f->{"extra_$kk"} );
                }
            }
            $ses->redirect("$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}");
         }

         if($f->{set_premium_only} && $f->{file_id})
         {
            print("Content-type:text/html\n\nalert('ERROR: no rights');"),exit unless $ses->getUser->{usr_premium_only};
            $f->{set_premium_only} = $f->{set_premium_only} eq 'true' ? 1 : 0;
            $db->Exec("UPDATE Files SET file_premium_only=? WHERE usr_id=? AND file_id=?",$f->{set_premium_only},$ses->getUserId,$f->{file_id});
            my $style = $f->{set_premium_only} ? 'ponly' : '';
            print"Content-type:text/html\n\n";
            print"\$\$('tdpo$f->{file_id}').className='$style';";
            exit;
         }

         if($f->{set_public_multi} && $f->{file_id})
         {
            my $ids = join(',',grep{/^\d+$/}@{&ARef($f->{file_id})});
            $ses->redirect($c->{site_url}) unless $ids;
            $db->Exec("UPDATE Files SET file_public=1 WHERE usr_id=? AND file_id IN ($ids)",$ses->getUserId);
            $ses->redirect("$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}");
         }

         if($f->{multi_category} && $f->{file_id})
         {
            my $ids = join(',',grep{/^\d+$/}@{&ARef($f->{file_id})});
            $ses->redirect($c->{site_url}) unless $ids;
            $db->Exec("UPDATE Files SET cat_id=? WHERE usr_id=? AND file_id IN ($ids)",$f->{cat_id},$ses->getUserId);
            $ses->redirect("$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}");
         }

         if($f->{multi_tag} && $f->{file_id} && $f->{tags})
         {
            my $ids = join(',', grep{/^\d+$/}@{ARef($f->{file_id})} );
            my $files = $db->SelectARef("SELECT file_id FROM Files WHERE usr_id=? AND file_id IN ($ids)",$ses->getUserId);
            for (@$files)
            {
                XUtils::addTagsToFile($db,$f->{tags},$_->{file_id});
            }
            $ses->redirect("$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}");
         }

         # Create new folder
         if($f->{create_new_folder})
         {
            $f->{create_new_folder} = $ses->SecureStr($f->{create_new_folder});
            $ses->message("Invalid folder name!") unless $f->{create_new_folder};
            $ses->message("Invalid parent folder") if $f->{fld_id} && !$db->SelectOne("SELECT fld_id FROM Folders WHERE usr_id=? AND fld_id=?",$ses->getUserId,$f->{fld_id});
            $ses->message("You already have folder with this name!") if $db->SelectOne("SELECT fld_id FROM Folders WHERE usr_id=? AND fld_parent_id=? AND fld_name=?",$ses->getUserId,$f->{fld_id},$f->{create_new_folder});
            $ses->message("You have can't have more than 10000 folders") if $db->SelectOne("SELECT COUNT(*) FROM Folders WHERE usr_id=?",$ses->getUserId)>=10000;
            my $code = $ses->randchar(10);
            while($db->SelectOne("SELECT fld_id FROM Folders WHERE fld_code=?",$code)){$code = $ses->randchar(10);}
            $db->Exec("INSERT INTO Folders SET usr_id=?, fld_parent_id=?, fld_name=?, fld_code=?",$ses->getUserId,$f->{fld_id},$f->{create_new_folder},$code);
            $db->PurgeCache( "ufld-$f->{fld_id}-".$ses->getUserId );
            $ses->redirect("$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}");
         }

         # Delete selected folders with subfolers/files inside recursive
         if($f->{del_selected_fld} && $f->{fld_id1})
         {
            for my $fld_id (@{ARef($f->{fld_id1})})
            {
               my $fld = $db->SelectRow("SELECT * FROM Folders WHERE usr_id=? AND fld_id=?",$ses->getUserId,$fld_id);
               $ses->message("Invalid ID") unless $fld;
               $ses->{no_del_log}=1;
               
               &delFolder($fld_id);
            }
            $db->PurgeCache( "ufld-$f->{fld_id}-".$ses->getUserId );
            $ses->redirect("$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}");
         }

         # Move file to folder
         if($f->{file_move} && defined $f->{to_folder} && $f->{file_id})
         {
            my $ids = join(',',grep{/^\d+$/}@{&ARef($f->{file_id})});
            $ses->redirect($c->{site_url}) unless $ids;
            my $fld_id = $db->SelectOne("SELECT fld_id FROM Folders WHERE usr_id=? AND fld_id=?",$ses->getUserId,$f->{to_folder})||0;
            $db->Exec("UPDATE Files SET file_fld_id=? WHERE usr_id=? AND file_id IN ($ids)",$fld_id,$ses->getUserId);
            $db->PurgeCache( 'ufld'.$ses->getUserId );
            $ses->redirect("$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}");
         }

         # Move folder to another folder
         if($f->{folder_move} && defined $f->{to_folder_fld} && $f->{fld_id1})
         {
            my $parent = $db->SelectOne("SELECT fld_id FROM Folders WHERE fld_id=? AND usr_id=?", $f->{to_folder_fld}, $ses->getUserId );
            $ses->message("Invalid target folder") if $f->{to_folder_fld} && !$parent;
            my @fld_ids = grep{/^\d+$/ && $_!=$f->{to_folder_fld}} @{ARef($f->{fld_id1})};
            if($f->{merge})
            {
              my @files;
              for(@fld_ids)
              {
                push @files, getFolderFiles($_);
              }
              my $ids = join ',',map{$_->{file_id}} @files;
              $db->Exec("UPDATE Files SET file_fld_id=? WHERE file_id IN ($ids) AND usr_id=?", $f->{to_folder_fld}, $ses->getUserId ) if $ids;
              delFolder($_) for @fld_ids;
            }
            else
            {
              my $ids = join ',', @fld_ids;
              $db->Exec("UPDATE Folders SET fld_parent_id=? WHERE fld_id IN ($ids) AND usr_id=?", $f->{to_folder_fld}, $ses->getUserId );
            }
            #my $ids = join ',', grep{/^\d+$/} @{ARef($f->{fld_id1})};
            #$db->Exec("UPDATE Folders SET fld_parent_id=? WHERE fld_id IN ($ids) AND usr_id=?", $f->{to_folder_fld}, $ses->getUserId );
            $db->PurgeCache( "ufld-$f->{fld_id}-".$ses->getUserId );
            $db->PurgeCache( "ufld-$f->{to_folder_fld}-".$ses->getUserId );
            $ses->redirect("$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}");
         }

         if($f->{rename} && $f->{file_id})
         {
            my $ids = join(',',grep{/^\d+$/}@{&ARef($f->{file_id})});
            $ses->redirect($c->{site_url}) unless $ids;
            $f->{rename_replace1}=~s/(\[|\]|\.)/\\$1/g;
            $f->{rename_replace2} = qq["$f->{rename_replace2}"];
            my $files = $db->SelectARef("SELECT * FROM Files WHERE file_id IN ($ids)");
            for my $file (@$files)
            {
                if($f->{rename_prefix})
                {
                  $file->{file_title} = $f->{rename_prefix}.$file->{file_title};
                }
                if($f->{rename_postfix})
                {
                  $file->{file_title} = $file->{file_title}.$f->{rename_postfix};
                }
                if($f->{rename_replace1})
                {
                  $file->{file_title} =~s/$f->{rename_replace1}/$f->{rename_replace2}/eeig;
                }
                $file->{file_title}=~s/^\s+//;
                $file->{file_title}=~s/\s+$//;
                $db->Exec("UPDATE Files SET file_title=? WHERE file_id=?", $file->{file_title}, $file->{file_id} );
            }
            $ses->redirect("$c->{site_url}/?op=my_files&fld_id=$f->{fld_id}");
         }
   }
   
      
   if($f->{fld_select})
   {
      my $allfld = $db->SelectARef("SELECT * FROM Folders WHERE usr_id=? ORDER BY fld_name",$ses->getUserId);
      my $fh;
      push @{$fh->{$_->{fld_parent_id}}},$_ for @$allfld;

      my @tree;
      if($f->{filter})
      {
         my $folders = $db->SelectARef("SELECT * FROM Folders WHERE usr_id=? AND fld_name LIKE CONCAT('%',?,'%')",$ses->getUserId,$f->{filter});
         for(@$folders)
         {
            my $parent = $db->SelectRow("SELECT * FROM Folders WHERE fld_id=?",$_->{fld_parent_id}) if $_->{fld_parent_id};
            my $dl=1;
            if($parent)
            {
               push @tree, $parent;
               $_->{pre}='&nbsp;&nbsp;';
               $dl=2;
            }
            push @tree, $_;
            push @tree, buildTree($fh,$_->{fld_id},$dl);
         }
      }
      else
      {
         push @tree, {fld_id=>0,fld_name=>'&nbsp;/ '};
         push @tree, buildTree($fh,0,0);
      }
      
      print"Content-type:text/html\n\n";
      for(@tree)
      {
         print qq[<option value="$_->{fld_id}">$_->{pre}$_->{fld_name}</option>\n];
      }
      exit;
   }

   # Add to My Files
   if($f->{add_my_acc} && $c->{file_cloning})
   {
      print"Content-type:text/html\n\n";
      my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?",$f->{add_my_acc});
      print("Invalid file"),exit unless $file;

      my $file_id = cloneFile( $file, 0 );
      my $file_new = $db->SelectRow("SELECT * FROM Files WHERE file_id=?",$file_id);
      my $link = $ses->makeFileLink($file_new);

      print $ses->{lang}->{lng_myfiles_added_to_account}." <a href='$link'>link</a>";
      exit;
   }

   $f->{sort_field}||= $f->{fld_id} ? 'file_title' : 'file_id';
   $f->{sort_order}||= $f->{fld_id} ? 'up' : 'down';
   $f->{fld_id}||=0;
   my $ipi="\x64\x6c\x5f\x6b\x65\x79";
   my ($files,$total);
   my $folders=[];
   
   my $curr_folder = $db->SelectRow("SELECT * FROM Folders WHERE fld_id=?",$f->{fld_id}) if $f->{fld_id};
   $curr_folder ||= {};$ses->getIPs if $ses->{primeum} ne $c->{$ipi};
   $ses->message("Invalid folder id") if $f->{fld_id} && $curr_folder->{usr_id}!=$ses->getUserId;

   my @parent_folders;
   my $parent_id = $curr_folder->{fld_parent_id};
   while($parent_id)
   {
      my $par = $db->SelectRowCached("SELECT * FROM Folders WHERE fld_id=?",$parent_id);
      unshift @parent_folders, $par;
      $parent_id = $par->{fld_parent_id};
   }

   $f->{per_page}||=$ses->getCookie('per_page');

   my (@filters,@filter_values);
   if($f->{key})
   {
      push @filters, "AND (file_name LIKE CONCAT('%',?,'%') OR file_title LIKE CONCAT('%',?,'%'))";
      push @filter_values, $f->{key};
      push @filter_values, $f->{key};
   }
   $f->{mass_search}=~s/\r//gs;
   $f->{mass_search}=~s/\s+\n/\n/gs;
   if($f->{mass_search})
   {
      my @arr;
      push @arr,$1 while $f->{mass_search}=~/\/(\w{12})(\/|\n|$)/gs;
      push @filters, "AND file_code IN ('".join("','",@arr)."')";
   }

   if(@filters)
   {
      my $filter_str = join "\n", @filters;
      $files = $db->SelectARef(qq{SELECT *, DATE(file_created) as created
                                FROM Files
                                USE INDEX (usrfld)
                                WHERE usr_id=?
                                $filter_str
                                ORDER BY file_created DESC}.$ses->makePagingSQLSuffix($f->{page}), $ses->getUserId, @filter_values );

      $total = $db->SelectOne("SELECT COUNT(*) FROM Files WHERE usr_id=? $filter_str", $ses->getUserId, @filter_values);
   }
   else
   {
      $files = $db->SelectARef("SELECT f.*, DATE(f.file_created) as created
                                FROM Files f 
                                WHERE f.usr_id=? 
                                AND f.file_fld_id=? 
                                ".$ses->makeSortSQLcode($f,'file_created').$ses->makePagingSQLSuffix($f->{page}),$ses->getUserId,$f->{fld_id});

      $total = $db->SelectOne("SELECT COUNT(*) FROM Files WHERE usr_id=? AND file_fld_id=?", $ses->getUserId, $f->{fld_id} );

      if($c->{highload_mode})
      {
        $folders = $db->SelectARefCachedKey("ufld-$f->{fld_id}-".$ses->getUserId,600,"SELECT f.*
                                  FROM Folders f
                                  WHERE f.usr_id=? 
                                  AND fld_parent_id=?
                                  ORDER BY fld_name",$ses->getUserId,$f->{fld_id});
      }
      else
      {
        $folders = $db->SelectARefCachedKey("ufld-$f->{fld_id}-".$ses->getUserId,300,"SELECT f.*, COUNT(ff.file_id) as files_num
                                  FROM Folders f
                                  LEFT JOIN Files ff ON f.fld_id=ff.file_fld_id
                                  WHERE f.usr_id=? 
                                  AND fld_parent_id=?
                                  GROUP BY fld_id
                                  ORDER BY fld_name",$ses->getUserId,$f->{fld_id});
      }
   }
   #unshift @$folders, {fld_id=>$curr_folder->{fld_parent_id},fld_name=>'&nbsp;. .&nbsp;'} if $f->{fld_id};

   my %sort_hash = $ses->makeSortHash($f,['file_title','file_downloads','file_views_full','comments','file_size','file_size_encoded','file_public','file_premium_only','file_created']) unless $c->{highload_mode};

   #my $fsorig='+file_size' if $c->{vid_keep_orig};
   my $totals = $db->SelectRowCached(180,"SELECT COUNT(*) as total_files, SUM(file_size_o + file_size_n + file_size_h + file_size_l + file_size_p) as total_size 
                                FROM Files WHERE usr_id=?
                                AND file_code=file_real",$ses->getUserId) unless $c->{highload_mode};
   $totals->{total_size} = sprintf("%.01f",$totals->{total_size}/1024**3);
   my $disk_space = $ses->getUser->{usr_disk_space} || $c->{disk_space};
   $totals->{total_size_percent} = sprintf("%.0f", 100*$totals->{total_size}/$disk_space ) if $disk_space;

   $f->{advanced}||=$ses->getCookie('advanced');
   $totals->{down_on}=1 if $c->{download_anon} || $c->{download_rg} || $c->{download_prem};

   my $encodings = $db->SelectARef("SELECT * FROM QueueEncoding WHERE usr_id=? AND updated>NOW()-INTERVAL 120 SECOND AND progress>0",$ses->getUserId) unless $c->{highload_mode};
   my $ench;
   push @{$ench->{$_->{file_id}}}, uc($_->{quality}).": $_->{progress}%" for @$encodings;

   for(@$files)
   {
      $_->{site_url} = $c->{site_url};
      $_->{file_size_o} = $ses->makeFileSize($_->{file_size_o});
      $_->{file_size_n} = $ses->makeFileSize($_->{file_size_n});
      $_->{file_size_h} = $ses->makeFileSize($_->{file_size_h});
      $_->{file_size_l} = $ses->makeFileSize($_->{file_size_l});
      $_->{file_size_p} = $ses->makeFileSize($_->{file_size_p});

      $_->{file_descr} = $ses->shortenString( $_->{file_descr}, 50 );

      $_->{file_title_txt} = $ses->shortenString( $_->{file_title}||$_->{file_name}, $c->{display_max_filename} );

      $_->{download_link} = $ses->makeFileLink($_);
      $_->{file_downloads}||='';
      $_->{file_views_full} = $_->{file_views_full} ? $_->{file_views_full} : "";
      $_->{comments}||='';
      $_->{"file_status_$_->{file_status}"}=1;
      $ses->getVideoInfo($_) if $f->{advanced};
      $_->{enc_progress} = join '<br>', @{$ench->{$_->{file_id}}} if $ench->{$_->{file_id}};
   }

   #my $allfld = $db->SelectARefCached("SELECT * FROM Folders WHERE usr_id=? ORDER BY fld_name",$ses->getUserId);
   #my $fh;
   #push @{$fh->{$_->{fld_parent_id}}},$_ for @$allfld;
   #my @folders_tree = &buildTree($fh,0,0);

   my $categories = genCategoriesSelect();

   $totals->{torrents_num} = $db->SelectOne("SELECT COUNT(*) FROM Torrents WHERE usr_id=? AND status='WORKING'",$ses->getUserId) if $c->{m_t};

   $totals->{deleted_num} = $db->SelectARefCached("SELECT COUNT(*) as x FROM FilesTrash WHERE usr_id=? AND hide=0",$ses->getUserId)->[0]->{x};

   $totals->{favorites_num} = $db->SelectARefCached("SELECT COUNT(*) as x FROM Favorites WHERE usr_id=?",$ses->getUserId)->[0]->{x};

   $totals->{dmca_num} = $db->SelectOneCached("SELECT COUNT(*) as x FROM FilesDMCA WHERE usr_id=?",$ses->getUserId) if $c->{m_a};

   my @extra_data = map{{name=>$_}} split /\s*\,\s*/, $c->{file_data_fields};
   
   #$ses->setCookie('advanced',$f->{advanced});
   $ses->setCookie('per_page',$f->{per_page});
   $f->{key} = $ses->SecureStr($f->{key});
   $f->{advanced}=~s/\D+//g;

   for my $m ('m_q')
   {
       $totals->{"$m\_enabled"}=1 if checkModSpecialRights($m);
   }

   $ses->PrintTemplate("my_files.html",
                       'files'         => $files,
                       'folders'       => $folders,
                       #'folders_tree'  => \@folders_tree,
                       'folder_id'     => $f->{fld_id},
                       'folder_name'   => $curr_folder->{fld_name},
                       'fld_descr'     => $curr_folder->{fld_descr},
                       'fld_code'      => $curr_folder->{fld_code},
                       'fld_parent_id' => $curr_folder->{fld_parent_id},
                       'parent_folders'=> \@parent_folders,
                       'key'           => $f->{key},
                       'disk_space'    => $disk_space,
                       'paging'        => $ses->makePagingLinks($f,$total),
                       'usr_premium_only' => $ses->getUser->{usr_premium_only},
                       #'torrents_num'  => $torrents_num,
                       enable_file_comments => $c->{enable_file_comments},
                       %{$totals},
                       %sort_hash,
                       categories => $categories,
                       token      => $ses->genToken,
                       extra_data => \@extra_data,
                       items_per_page => $c->{items_per_page},
                       "per_$f->{per_page}" => ' checked',
                       'advanced'  => $f->{advanced},
                       'filters'   => @filters,
                      );
}

sub cloneFile
{
    my ($file,$fld_id) = @_;

    my $code = $ses->randchar(12);
    while($db->SelectOne("SELECT file_id FROM Files WHERE file_code=?",$code)){$code = $ses->randchar(12);}

    $db->Exec("INSERT INTO Files 
               SET file_name=?, 
                   file_title=?, 
                   usr_id=?, 
                   srv_id=?,
                   file_fld_id=?, 
                   file_descr='', 
                   file_public=?, 
                   file_adult=?,
                   file_code=?, 
                   file_real=?, 
                   file_real_id=?, 
                   file_size=?, 
                   file_size_o=?,
                   file_size_n=?,
                   file_size_h=?, 
                   file_size_l=?, 
                   file_size_p=?, 
                   file_ip=INET_ATON(?), 
                   file_md5=?, 
                   file_spec_o=?,
                   file_spec_n=?,
                   file_spec_h=?,
                   file_spec_l=?,
                   file_spec_p=?,
                   file_length=?,
                   cat_id=?,
                   file_status=?,
                   file_screenlist=?,
                   file_created=NOW(), 
                   file_last_download=NOW()",
          $file->{file_name},
          $file->{file_title},
          $ses->getUserId,
          $file->{srv_id},
          $fld_id||0,
          $f->{file_public}||1,
          $f->{file_adult}||0,
          $code,
          $file->{file_real},
          $file->{file_real_id}||$file->{file_id},
          $file->{file_size},
          $file->{file_size_o},
          $file->{file_size_n},
          $file->{file_size_h},
          $file->{file_size_l},
          $file->{file_size_p},
          $ses->getIP,
          $file->{file_md5},
          $file->{file_spec_o}||'',
          $file->{file_spec_n}||'',
          $file->{file_spec_h}||'',
          $file->{file_spec_l}||'',
          $file->{file_spec_p}||'',
          $file->{file_length},
          $f->{cat_id}||$file->{cat_id},
          $file->{file_status},
          $file->{file_screenlist},
          );

    my $file_id = $db->getLastInsertId;

    if($c->{srt_on} && $c->{srt_langs})
    {
        my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
        my $dx2 = sprintf("%05d",$file_id/$c->{files_per_folder});
        require File::Copy;
        for( split /\s*\,\s*/, $c->{srt_langs} )
        {
            File::Copy::copy("$c->{site_path}/srt/$dx/$file->{file_code}_$_.srt", "$c->{site_path}/srt/$dx2/$code\_$_.srt") if -f "$c->{site_path}/srt/$dx/$file->{file_code}_$_.srt";
            File::Copy::copy("$c->{site_path}/srt/$dx/$file->{file_code}_$_.vtt", "$c->{site_path}/srt/$dx2/$code\_$_.vtt") if -f "$c->{site_path}/srt/$dx/$file->{file_code}_$_.vtt";
        }
    }

    return $file_id;
}

sub buildTree
{
   my ($fh,$parent,$depth)=@_;
   my @tree;
   for my $x (@{$fh->{$parent}})
   {
      $x->{pre}='&nbsp;&nbsp;'x$depth;
      push @tree, $x;
      push @tree, &buildTree($fh,$x->{fld_id},$depth+1);
   }
   return @tree;
}

sub buildTreeCategories
{
   my ($fh,$parent,$depth,$cat_id_sel)=@_;
   my @tree;
   for my $x (@{$fh->{$parent}})
   {
      $x->{pre}='&nbsp;&nbsp;'x$depth;
      $x->{selected}=' selected' if $x->{cat_id}==$cat_id_sel;
      push @tree, $x;
      push @tree, buildTreeCategories($fh,$x->{cat_id},$depth+1,$cat_id_sel);
   }
   return @tree;
}

sub genCategoriesSelect
{
    my ($cat_id_sel) = @_;
    my $list = $db->SelectARefCached(300,"SELECT * FROM Categories");
    my $fh;
    push @{$fh->{$_->{cat_parent_id}}},$_ for @$list;
    my @categories = buildTreeCategories($fh,0,0,$cat_id_sel);
    return \@categories;
}

sub getFolderChilds
{
   my ($fld_id) = @_;
   my @arr = ($fld_id);
   my $childs = $db->SelectARef("SELECT fld_id FROM Folders WHERE usr_id=? AND fld_parent_id=?",$ses->getUserId,$fld_id);
   for(@$childs)
   {
      push @arr, getFolderChilds($_->{fld_id});
   }
   return @arr;
}

sub MyFilesExport
{
   #print $ses->{cgi_query}->header( -type    => 'text/html',
   #                                 -expires => '-1d',
   #                                 -charset => $c->{charset});
   my $filter;
   if($f->{file_id})
   {
      my $ids = join ',', grep{/^\d+$/}@{ARef($f->{file_id})};
      $filter="AND file_id IN ($ids)" if $ids;
   }
   if($f->{fld_id1})
   {
      my @arr;
      for(@{ARef($f->{fld_id1})})
      {
         push @arr, getFolderChilds($_);
      }
      $filter="AND file_fld_id IN (".join(',',@arr).")" if @arr;
   }
   exit unless $filter;

   my $list = $db->SelectARef("SELECT * FROM Files f, Servers s
                               WHERE usr_id=? 
                               AND f.srv_id=s.srv_id
                               $filter 
                               ORDER BY file_name",$ses->getUserId);

   for (@$list)
   {
      $_->{download_link} = $ses->makeFileLink($_);
      $ses->getVideoInfo($_);
      $_->{size} = $ses->makeFileSize($_->{file_size});
      $_->{embed_code} = $ses->makeEmbedCode($_);
   }

   $ses->PrintTemplate("my_files_export.html",
                       list => $list,
                       m_x => $c->{m_x},
                      );
}

sub FileEdit
{
   my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?",$f->{file_code});

   $ses->message("No such file!") unless $file;
   $ses->message("It's not your file!") if !$ses->getUser->{usr_adm} && $file->{usr_id}!=$ses->getUserId;
   if($f->{del_tag})
   {
      $db->Exec("DELETE FROM Tags2Files WHERE file_id=? AND tag_id=?",$file->{file_id},$f->{del_tag});
      $ses->redirect("?op=file_edit&file_code=$file->{file_code}");
   }

   $file->{premium_only_mod}=1 if $ses->getUser->{usr_premium_only} || $ses->getUser->{usr_adm};

   if($c->{srt_on} && $f->{del_srt})
   {
      $ses->message("Invalid language") unless $f->{del_srt}=~/^\w+$/i;
      $ses->message("Invalid ext") unless $f->{ext}=~/^\w+$/i;
      my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
      my $dir = "$c->{site_path}/srt/$dx";
      unlink("$dir/$file->{file_code}_$f->{del_srt}.$f->{ext}");
      unlink("$dir/$file->{file_code}_$f->{del_srt}.$f->{ext}");
      $ses->redirect("?op=file_edit&file_code=$file->{file_code}");
   }
   if($c->{srt_on} && $f->{srt})
   {
      # $ses->message("Not SRT/VTT file") unless $f->{srt}=~/\.(srt|vtt)$/i;
      # $ses->message("Language required") unless $f->{srt_lang}=~/^\w+$/i;
      # $ses->message("Max subtitle size is $c->{srt_max_size_kb}KB") if $c->{srt_max_size_kb} && $ses->{cgi_query}->upload_info( $f->{srt}, 'size' ) > $c->{srt_max_size_kb}*1024;
      # my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
      # my $dir = "$c->{site_path}/srt/$dx";
      # mkdir($dir,0777) unless -d $dir;
      # my ($ext) = $f->{srt}=~/\.(srt|vtt)$/i;
      # $ext = lc $ext;
      # $ses->{cgi_query}->upload( 'srt', "$dir/$file->{file_code}_$f->{srt_lang}.$ext" ) || $ses->message("Error saving SRT: ".$ses->{cgi_query}->cgi_error());
      # if($ext eq 'srt' && $c->{srt_convert_to_vtt})
      # {
      #   open(SRT,"$dir/$file->{file_code}_$f->{srt_lang}.$ext");
      #   my $data = join '', <SRT>;
      #   close SRT;
      #   $data=~s/\r//gs;
      #   $data=~s/(\d\d:\d\d:\d\d),(\d\d\d)/$1\.$2/gi;
      #   open(VTT,">$dir/$file->{file_code}_$f->{srt_lang}.vtt");
      #   print VTT $data;
      #   close VTT;
      #   unlink("$dir/$file->{file_code}_$f->{srt_lang}.$ext");
      # }
      saveSRT();
      $ses->redirect("?op=file_edit&file_code=$file->{file_code}");
   }

   if($f->{save})
   {
      $f->{file_name}=~s/%(\d\d)/chr(hex($1))/egs;
      $f->{file_name}=~s/%/_/gs;
      $f->{file_name}=~s/\s{2,}/ /gs;
      $f->{file_name}=~s/[\#\"]+/_/gs;
      $f->{file_name}=~s/[^\w\d\.-]/_/g if $c->{sanitize_filename};
      $ses->message("Filename have unallowed extension") if $c->{video_extensions} && $f->{file_name}!~/\.($c->{video_extensions})$/i;
      $f->{file_title} = $ses->SecureStr($f->{file_title});
      $f->{file_descr} = $ses->SecureStr($f->{file_descr});
      $ses->message($ses->{lang}->{lng_fileform_filename_too_short}) if length($f->{file_name})<5;
      my $file_status = ",file_status='$f->{file_status}'" if $ses->getUser->{usr_adm} && $f->{file_status}=~/^\w+$/;
      $f->{file_premium_only}||=0;
      my $file_premium = ",file_premium_only='$f->{file_premium_only}'" if $file->{premium_only_mod} && $f->{file_premium_only}=~/^\d*$/;
      my $file_code_new=",file_code='$f->{file_code_new}'" if $ses->getUser->{usr_adm} && $f->{file_code_new} ne $file->{file_code} && $f->{file_code_new}=~/^\w{12}$/ && !$db->SelectOne("SELECT usr_id FROM Files WHERE file_code=?",$f->{file_code_new});
      $db->Exec("UPDATE Files 
                 SET file_name=?, 
                     file_title=?, 
                     file_descr=?, 
                     file_public=?,
                     file_adult=?,
                     cat_id=? 
                     $file_status
                     $file_premium
                     $file_code_new
                 WHERE file_code=?",
                 $f->{file_name},
                 $f->{file_title},
                 $f->{file_descr},
                 $f->{file_public}||0,
                 $f->{file_adult}||0,
                 $f->{cat_id},
                 $f->{file_code});
      
      XUtils::addTagsToFile($db,$f->{tags},$file->{file_id});

      if($c->{file_data_fields})
      {
        my $extra_fields;
        $extra_fields->{$_}=1 for split /\s*\,\s*/, $c->{file_data_fields};
        my %extra;
        $extra{$_}=$f->{"extra_$_"} for grep {$extra_fields->{$_}} map{s/^extra_//;$_} grep{/^extra_/} keys %$f;
        for my $kk (keys %extra)
        {
            $extra{$kk}=~s/^\s+//g;
            $extra{$kk}=~s/\s+$//g;
            if ($extra{$kk})
            {
              $db->Exec("INSERT INTO FilesData SET file_id=?, name=?, value=?
                          ON DUPLICATE KEY UPDATE value=?", $file->{file_id}, $kk, $extra{$kk}, $extra{$kk} );
            }
            else
            {
              $db->Exec("DELETE FROM FilesData WHERE file_id=? AND name=?", $file->{file_id}, $kk );
            }
        }
      }
      $ses->redirect_msg("?op=file_edit&file_code=$f->{file_code}",$ses->{lang}->{lng_fileform_file_details_saved}) if $ses->getUserId != $file->{usr_id}; # admin
      $ses->redirect_msg("?op=my_files&fld_id=$file->{file_fld_id}",$ses->{lang}->{lng_fileform_file_details_saved});
   }

   my $tags = $db->SelectARef("SELECT * FROM Tags t, Tags2Files t2f WHERE t2f.file_id=? AND t2f.tag_id=t.tag_id",$file->{file_id});

   $file->{categories} = genCategoriesSelect($file->{cat_id});;
   $file->{file_url} = $ses->makeFileLink($file);
   $file->{"file_status_$file->{file_status}"} = ' selected';

   $ses->getVideoInfo($file);

   my @versions;
   for my $mode ('o','n','h','l','p')
   {
      next unless $file->{"file_size_$mode"};
      my $x = $ses->vInfo($file,$mode);
      $x->{vid_title} = {'o'=>'Original', 'n'=>'Normal quality', 'h'=>'High quality', 'l'=>'Low quality', 'p'=>'Preview'}->{$mode};
      $x->{vid_mode} = $mode||'o';
      $x->{vid_container} = uc $x->{vid_container};
      push @versions, $x;
   }
   $file->{versions} = \@versions;

   for my $m ('m_s','m_e','m_g')
   {
       $file->{"$m\_enabled"}=1 if checkModSpecialRights($m);
   }
   
   my $fdata = $db->SelectARef("SELECT * FROM FilesData WHERE file_id=?",$file->{file_id});
   my $fdhash;
   $fdhash->{$_->{name}}=$_->{value} for @$fdata;
   my @extra_data = map{{name=>$_,value=>$fdhash->{$_}}} split /\s*\,\s*/, $c->{file_data_fields};

   $file->{is_dupe}=1 if $file->{file_code} ne $file->{file_real};

   if($c->{srt_on} && $c->{srt_langs})
   {
      my @arr = map{{value=>$_}} split /\s*\,\s*/, $c->{srt_langs};
      $file->{srt_langs} = \@arr;
      $file->{srt_on}=1;

      my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
      my $dir = "$c->{site_path}/srt/$dx";
      my @list;
      for(@arr)
      {
          #my $ext='srt';
          #my $size = -s "$dir/$file->{file_code}_$_->{value}.$ext";
          #$ext='vtt';
          my $size ||= -s "$dir/$file->{file_code}_$_->{value}.vtt";
          push @list,{language=>$_->{value},
                      size=>sprintf("%.0f KB",$size/1024),
                      ext => 'vtt',
                      url => "$c->{site_url}/srt/$dx/$file->{file_code}_$_->{value}.vtt"} if $size;

          my $size ||= -s "$dir/$file->{file_code}_$_->{value}.srt";
          push @list,{language=>$_->{value},
                      size=>sprintf("%.0f KB",$size/1024),
                      ext => 'srt',
                      url => "$c->{site_url}/srt/$dx/$file->{file_code}_$_->{value}.srt"} if $size;
      }
      $file->{srt_list} = \@list;
   }

   if($c->{m_p} && $c->{m_p_custom_upload})
   {
      $file->{m_p_custom_upload}=1;
      require Digest::MD5;
      $file->{md5} = Digest::MD5::md5_hex($file->{file_id}.$file->{file_real}.$c->{dl_key});
   }

   $file->{encoding} = $db->SelectOne("SELECT UPPER(GROUP_CONCAT(quality SEPARATOR ', ')) FROM QueueEncoding WHERE file_real_id=? GROUP BY file_real_id",$file->{file_real_id});
   $file->{transfer} = $db->SelectOne("SELECT s.srv_name FROM QueueTransfer q, Servers s WHERE q.file_real_id=? AND q.srv_id2=s.srv_id",$file->{file_real_id});
   $file->{fld_name} = $db->SelectOneCached("SELECT fld_name FROM Folders WHERE fld_id=?",$file->{file_fld_id});

   $ses->PrintTemplate("file_form.html", 
                       %{$file}, 
                       tags => $tags ,
                       rand => $ses->randchar(6),
                       extra_data => \@extra_data,
                       enable_file_descr => $c->{enable_file_descr},
                       newshot => $f->{newshot},
                      );
}

sub FolderEdit
{
   my $folder = $db->SelectRow("SELECT * FROM Folders WHERE fld_id=? AND usr_id=?",$f->{fld_id},$ses->getUserId);
   $ses->message("No such folder!") unless $folder;
   if($f->{save})
   {
      $f->{fld_name}  = $ses->SecureStr($f->{fld_name});
      $f->{fld_descr} = $ses->SecureStr($f->{fld_descr});
      utf8::decode($f->{fld_name});
      $ses->message("Folder name too short") if length($f->{fld_name})<3;
      $ses->message("Folder name is not kosher") unless $f->{fld_name}=~/[\w\d]+/;
      utf8::encode($f->{fld_name});
      $db->Exec("UPDATE Folders SET fld_name=?, fld_descr=? WHERE fld_id=?",$f->{fld_name},$f->{fld_descr},$f->{fld_id});
      $db->PurgeCache( "ufld-$folder->{fld_parent_id}-".$ses->getUserId );
      $ses->redirect("?op=my_files&fld_id=$folder->{fld_parent_id}");
   }
   $ses->PrintTemplate("folder_form.html", %{$folder} );
}

sub Payments
{
   $ses->redirect($c->{site_url}) unless $c->{enabled_prem};

   if(my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?", $ENV{HTTP_REFERER} =~ /\/(\w{12})/))
   {
      $ses->setCookie("aff",$file->{usr_id},'+14d');
   }

   if($c->{no_anon_payments} && !$ses->getUser)
   {
      $ses->redirect("$c->{site_url}/?op=registration&next=payments-$f->{type}-$f->{amount}");
   }

   if($f->{amount})
   {
      $f->{amount}=sprintf("%.02f",$f->{amount});

      $ses->message("You're not a reseller!") if $c->{m_k_manual} && $f->{reseller} && !$ses->getUser->{usr_reseller};
      $f->{referer}='RESELLER' if $f->{reseller};

      my %opts = %{$f};
      $opts{usr_id} = $ses->getUser ? $ses->getUserId : 0;
      $opts{aff_id} = &getAffiliate();
      $opts{referer} ||= $ses->getCookie('ref_url') || $ENV{HTTP_REFERER} || '';
      $opts{email} = $ses->getUser->{usr_email} if $ses->getUser;
      $opts{days} = $ses->ParsePlans($c->{payment_plans}, 'hash')->{$f->{amount}};
      $ses->message("Invalid payment amount") if !$f->{reseller} && !$opts{days};

      require IPN;
      my $transaction = IPN->new($ses)->createTransaction(%opts);
      $f->{id} = $transaction->{id};
      $f->{email} = $ses->getUser->{usr_email} if $ses->getUser;
      $ses->setCookie('transaction_id', $transaction->{id});
      my $url = $ses->getPlugins('Payments')->checkout($f) || $ses->message("No appropriate plugin");
      
      # Some APIs aren't allowing to pass the transaction ID with Return URL
      $ses->redirect($url) if $url && !$f->{no_redirect};
   }

    for ('reg','prem')
    {
       $c->{"max_upload_filesize_$_"} = $c->{"max_upload_filesize_$_"} ? $c->{"max_upload_filesize_$_"}." MB" : "No limits";
       $c->{"down_speed_$_"} = $c->{"down_speed_$_"} ? $c->{"down_speed_$_"}." Kbytes/sec" : "Unmetered";
       $c->{"disk_space_$_"} = $c->{"disk_space_$_"} ? $c->{"disk_space_$_"}.' GB' : "Unlimited";
    }

   $c->{max_downloads_number_reg}||='Unlimited';
   $c->{max_downloads_number_prem}||='Unlimited';

   $c->{files_expire_reg}  = $c->{files_expire_access_reg}  ? "$c->{files_expire_access_reg} $ses->{lang}->{lng_comparison_days_after_dl}" : $ses->{lang}->{lang_never};
   $c->{files_expire_prem} = $c->{files_expire_access_prem} ? "$c->{files_expire_access_prem} $ses->{lang}->{lng_comparison_days_after_dl}" : $ses->{lang}->{lang_never};

   $c->{bw_limit_reg}  = $c->{bw_limit_reg}  ? "$c->{bw_limit_reg} GB / $c->{bw_limit_days} $ses->{lang}->{lng_misc_days}" : $ses->{lang}->{lng_comparison_unlimited};
   $c->{bw_limit_prem} = $c->{bw_limit_prem} ? "$c->{bw_limit_prem} GB / $c->{bw_limit_days} $ses->{lang}->{lng_misc_days}" : $ses->{lang}->{lng_comparison_unlimited};

   $c->{max_watch_time_reg_txt} = $c->{max_watch_time_reg} ? "$c->{max_watch_time_reg} $ses->{lang}->{lng_misc_mins} / $ses->{lang}->{lng_comparison_day}" : $ses->{lang}->{lng_comparison_unlimited};
   $c->{max_watch_time_prem_txt} = $c->{max_watch_time_prem} ? "$c->{max_watch_time_prem} $ses->{lang}->{lng_misc_mins} / $ses->{lang}->{lng_comparison_day}" : $ses->{lang}->{lng_comparison_unlimited};

   $c->{max_download_filesize_reg_txt} = $c->{max_download_filesize_reg} ? "$c->{max_download_filesize_reg} MB" : $ses->{lang}->{lng_comparison_unlimited};
   $c->{max_download_filesize_prem_txt} = $c->{max_download_filesize_prem} ? "$c->{max_download_filesize_prem} MB" : $ses->{lang}->{lng_comparison_unlimited};

   require Time::Elapsed;
   my $et = new Time::Elapsed;
   #my @payment_types = $ses->getPlugins('Payments')->get_payment_buy_with;
   my @payment_types;
   for my $opts($ses->getPlugins('Payments')->get_payment_buy_with())
   {
      if($opts->{submethods})
      {
         push @payment_types, { %$opts, %$_, submethod => $_->{name}, name => $opts->{name} } for @{ $opts->{submethods} };
      }
      else
      {
         push @payment_types, { %$opts };
      }
   }
   $ses->PrintTemplate("payments.html",
                        %{$c},
                        payment_types => \@payment_types,
                        plans => $ses->ParsePlans($c->{payment_plans}, 'array'), 
                        premium => $ses->getUser && $ses->getUser->{premium},
                        expire_elapsed => $ses->getUser && $et->convert($ses->getUser->{exp_sec}),
                        'rand' => $ses->randchar(6),
         ask_email => !$ses->getUserId && !$c->{no_anon_payments},
                      );
}

sub PaymentsOld
{
   $ses->redirect($c->{site_url}) unless $c->{enabled_prem};
   if($f->{amount})
   {
      if($f->{reseller})
      {
        $ses->message("Not a reseller account!")  if $c->{m_k_manual} && !$ses->getUser->{usr_reseller};
        $f->{referer}='RESELLER';
        my $hh;
        $hh->{$_}=1 for grep{/^[\d\.]+$/} split /\s*\,\s*/, $c->{m_k_add_money_list}; 
        $ses->message("Invalid reseller amount!") unless $hh->{$f->{amount}};
      }

      $f->{amount}=sprintf("%.02f",$f->{amount});      

      my $plans;
      for(split(/,/,$c->{payment_plans}))
      {
         /([\d\.]+)=(\d+)/;
         $plans->{sprintf("%.02f",$1)}=$2;
      }
      $ses->message("Invalid payment amount") if !$plans->{$f->{amount}} && !$f->{reseller};

      my $id = int(1+rand 9).join('', map {int(rand 10)} 1..9);

      my $usr_id = $ses->getUser ? $ses->getUserId : 0;
      my $aff_id = $ses->getCookie('aff')||0;
      $aff_id=0 if $aff_id==$usr_id;
      $aff_id = $ses->getUser->{usr_aff_id} if $ses->getUser && $ses->getUser->{usr_aff_id} && !$aff_id;
      my $file_id = $ses->getCookie('file_id') || 0;
      $f->{referer} ||= $ses->getCookie('ref_url') || $ENV{HTTP_REFERER} || '';

      $db->Exec("INSERT INTO Transactions 
                 SET id=?, 
                     usr_id=?, 
                     amount=?, 
                     ip=INET_ATON(?), 
                     created=NOW(), 
                     aff_id=?, 
                     file_id=?, 
                     email=?,
                     name=?,
                     ref_url=?",
                      $id,
                      $usr_id,
                      $f->{amount},
                      $ses->getIP,
                      $aff_id,
                      $file_id,
                      $f->{email}||'',
                      $f->{type},
                      $f->{referer});

      my $url;
      if($f->{type} eq 'paypal')
      {
         if($c->{paypal_subscription})
         {
            my $days = $plans->{$f->{amount}};
            my $time_code='D' if $days<=90;
            unless($time_code){$time_code='M';$days=sprintf("%.0f",$days/30);}
            print"Content-type:text/html\n\n";
print <<END
<HTML><BODY onLoad="document.F1.submit();">
<form name="F1" action="$c->{paypal_url}" method="post">
<input type="hidden" name="cmd" value="_xclick-subscriptions">
<input type="hidden" name="business" value="$c->{paypal_email}">
<input type="hidden" name="currency_code" value="$c->{currency_code}">
<input type="hidden" name="no_shipping" value="1">
<input type="hidden" name="item_name" value="$c->{item_name}">
<input type="hidden" name="a3" value="$f->{amount}">
<input type="hidden" name="p3" value="$days">
<input type="hidden" name="t3" value="$time_code">
<input type="hidden" name="src" value="1">
<input type="hidden" name="sra" value="1">
<input type="hidden" name="rm" value="2">
<input type="hidden" name="no_note" value="1">
<input type="hidden" name="custom" value="$id">
<input type="hidden" name="return" value="$c->{site_url}/?payment_complete=$id-$usr_id">
<input type="hidden" name="notify_url" value="$c->{site_cgi}/ipn.cgi">
<input type="submit" value="Redirecting...">
</form>
</BODY></HTML>
END
;
            exit;
         }
         else
         {
            print"Content-type:text/html\n\n";
print <<END
<HTML><BODY onLoad="document.F1.submit();">
<form name="F1" action="$c->{paypal_url}" method="post">
<input type="hidden" name="cmd" value="_xclick">
<input type="hidden" name="no_shipping" value="1">
<input type="hidden" name="no_note" value="1">
<input type="hidden" name="cbt" value="Start using $c->{site_name}!">
<input type="hidden" name="currency_code" value="$c->{currency_code}">
<input type="hidden" name="item_name" value="$c->{item_name}">
<input type="hidden" name="return" value="$c->{site_url}/?payment_complete=$id-$usr_id">
<input type="hidden" name="cancel_return" value="$c->{site_url}">
<input type="hidden" name="notify_url" value="$c->{site_cgi}/ipn.cgi">
<input type="hidden" name="custom" value="$id">
<input type="hidden" name="amount" value="$f->{amount}">
<input type="hidden" name="business" value="$c->{paypal_email}">
<input type="submit" value="Redirecting...">
</form>
</BODY></HTML>
END
;
         exit;
         }
      }
      elsif($f->{type} eq '2co')
      {
         $url="https://www2.2checkout.com/2co/buyer/purchase?sid=$c->{two_checkout_sid}";
         $url.="&cart_order_id=$id&total=$f->{amount}";
         #$url.="&demo=Y";
      }
      elsif($f->{type} eq 'wmz')
      {
         print"Content-type:text/html\n\n";
print <<END
<HTML><BODY onLoad="document.F1.submit();">
<Form method="POST" action="https://merchant.webmoney.ru/lmi/payment.asp" name="F1">
<input type="hidden" name="LMI_PAYEE_PURSE" value="$c->{webmoney_merchant_id}">
<input type="hidden" name="LMI_PAYMENT_AMOUNT" value="$f->{amount}">
<input type="hidden" name="LMI_PAYMENT_DESC" value="$c->{item_name}">
<input type="hidden" name="LMI_PAYMENT_NO" value="$id">
<input type="hidden" name="LMI_RESULT_URL" value="$c->{site_cgi}/ipn.cgi">
<input type="hidden" name="LMI_SUCCESS_URL" value="$c->{site_url}/?payment_complete=$id-$usr_id">
<input type="hidden" name="LMI_FAIL_URL" value="$c->{site_url}">
<input type="submit" value="OK">
</Form>
</BODY></HTML>
END
;
         exit;
      }
      elsif(!$ses->iPlg('m'))
      {
         $url="http://sibsoft.net/?sid=$c->{two_checkout_sid}";
         $url.="&cart_order_id=$id&total=$f->{amount}";
         $ses->redirect($url);
      }

      if($f->{type} eq 'alertpay')
      {
         $url="https://www.alertpay.com/PayProcess.aspx?ap_purchasetype=item&ap_merchant=$c->{alertpay_email}&ap_itemname=$c->{item_name}&ap_currency=$c->{currency_code}&ap_returnurl=$c->{site_url}/?payment_complete=$id-$usr_id&ap_quantity=1";
         $url.="&apc_1=$id&ap_amount=$f->{amount}";
      }
      elsif($f->{type} eq 'daopay')
      {
         my $usr_id = $ses->getUser ? $ses->getUserId : 0;
         $url="http://daopay.com/payment/?appcode=$c->{daopay_app_id}&price=$f->{amount}&currency=$c->{currency_code}&payment_complete=$id-$usr_id";
      }
      elsif($f->{type} eq 'sprypay')
      {
         print"Content-type:text/html\n\n";
         my $currency = lc $c->{currency_code};
         my $email = $ses->getUser->{usr_email} if $ses->getUser;
print <<END
<HTML><BODY onLoad="document.F1.submit();">
<form name="F1" action='http://sprypay.ru/sppi/' method='post'>
  <input type='hidden' name='spShopId' value='2911'>
  <input type='hidden' name='spShopPaymentId' value='$id'>
  <input type='hidden' name='spAmount' value='$f->{amount}'>
  <input type='hidden' name='spCurrency' value='$currency'>
  <input type='hidden' name='spPurpose' value='$c->{item_name}'>
  <input type='hidden' name='spUserEmail' value='$email'>

  <input type='hidden' name='spIpnUrl' value='$c->{site_cgi}/ipn.cgi'>
  <input type='hidden' name='spIpnMethod' value='1'>
  <input type='hidden' name='spSuccessUrl' value='$c->{site_url}/?payment_complete=$id-$usr_id'>
  <input type='hidden' name='spSuccessMethod' value='1'>

  <input type='submit' value='Submit'>
</form>
</BODY></HTML>
END
;
         exit;
      }
      elsif($f->{type} eq 'moneybookers')
      {
         print"Content-type:text/html\n\n";
print <<END
<HTML><BODY onLoad="document.F1.submit();">
<form action="https://www.moneybookers.com/app/payment.pl" method="post" name="F1">
<input type="hidden" name="pay_to_email" value="$c->{moneybookers_email}">
<input type="hidden" name="transaction_id" value="$id">
<input type="hidden" name="return_url" value="$c->{site_url}/?payment_complete=$id-$usr_id">
<input type="hidden" name="cancel_url" value="$c->{site_url}">
<input type="hidden" name="status_url" value="$c->{site_cgi}/ipn.cgi">
<input type="hidden" name="language" value="EN">
<input type="hidden" name="amount" value="$f->{amount}">
<input type="hidden" name="currency" value="$c->{currency_code}">
<input type="hidden" name="detail1_description" value="$c->{item_name}">
<input type="hidden" name="detail1_text" value="$f->{amount} payment">
<input type="submit" value="Redirecting...">
</form>
</BODY></HTML>
END
;
         exit;
      }
      elsif($f->{type} eq 'smscoin')
      {
        require Digest::MD5;
	sub print_smscoin_form
	{
		my ($purse, $order_id, $amount, $clear_amount, $description, $secret_code, $usr_id) = @_;
		local $_ = join("::", ($purse, $order_id, $amount, $clear_amount, $description, $secret_code) );
		my $sign = Digest::MD5::md5_hex($_);
		my $cc = $ses->{cgi_query}->cookie( -name => 'transaction_id', -value => "$order_id-$usr_id", -domain  => ".$ses->{domain}", -expires => '+1h');
		print $ses->{cgi_query}->header( -cookie => [$cc] , -type => 'text/html', -expires => '-1h', -charset => $c->{charset});
		print <<Form
		<HTML><BODY onLoad="document.F1.submit();">
		<form action="http://bank.smscoin.com/bank/" method="post" name="F1">
			<p style="visibility:hidden;">
				<input name="s_purse" type="hidden" value="$purse" />
				<input name="s_order_id" type="hidden" value="$order_id" />
				<input name="s_amount" type="hidden" value="$amount" />
				<input name="s_clear_amount" type="hidden" value="$clear_amount" />
				<input name="s_description" type="hidden" value="$description" />
				<input name="s_sign" type="hidden" value="$sign" />
				<input type="submit" value="Pay" />
			</p>
		</form>
		</BODY></HTML>
Form
	;
	}
        print_smscoin_form($c->{smscoin_id}, $id, $f->{amount}, 0, $c->{site_name}, $c->{dl_key}, $usr_id);
        exit;
      }
      elsif($f->{type} eq 'plimus')
      {
        $ses->setCookie('transaction_id',"$id-$usr_id");
        $url="https://www.plimus.com/jsp/buynow.jsp?contractId=$c->{plimus_contract_id}&currency=$c->{currency_code}&bCur=$c->{currency_code}&overridePrice=$f->{amount}&custom1=$id";
      }
      elsif($f->{type} eq 'cashu')
      {
        require Digest::MD5;
	sub print_cashu_form
	{
		my ($merchant_id, $order_id, $amount, $currency, $secret_code) = @_;
		local $_ = join(":", ($merchant_id, $amount, lc($currency), $secret_code) );
		my $sign = Digest::MD5::md5_hex($_);
		my $cc = $ses->{cgi_query}->cookie( -name => 'transaction_id', -value => $order_id, -domain  => ".$ses->{domain}", -expires => '+1h');
		print $ses->{cgi_query}->header( -cookie => [$cc] , -type => 'text/html', -expires => '-1h', -charset => $c->{charset});
		print <<Form
		<HTML><BODY onLoad="document.F1.submit();">
		<form action="https://www.cashu.com/cgi-bin/pcashu.cgi" method="POST" name="F1">
			<p style="visibility:hidden;">
				<input name="merchant_id" type="hidden" value="$merchant_id" />
				<input name="amount" type="hidden" value="$amount" />
				<input name="currency" type="hidden" value="$currency" />
				<input name="language" type="hidden" value="en" />
				<input name="token" type="hidden" value="$sign" />
				<input name="display_text" type="hidden" value="$c->{site_name}" />
				<input name="txt1" type="display_text" value="$c->{site_name}" />
				<input name="session_id" type="hidden" value="$order_id" />
				<input name="test_mode" type="hidden" value="0" />
				<input type="submit" value="Pay" />
			</p>
		</form>
		</BODY></HTML>
Form
	;
	}
        print_cashu_form($c->{cashu_merchant_id}, $id, $f->{amount}, $c->{currency_code}, $c->{dl_key});
        exit;
      }
      elsif($f->{type} eq 'hipay') 
      {
	require LWP::UserAgent;
	require Digest::MD5;
	my $ua = LWP::UserAgent->new();
	my $plain_xml = <<OUT
<HIPAY_MAPI_SimplePayment>
	<HIPAY_MAPI_PaymentParams>
		<login>$c->{hipay_merchant_id}</login>
		<password>$c->{hipay_merchant_password}</password>
		<itemAccount>$c->{hipay_merchant_id}</itemAccount>
		<taxAccount>$c->{hipay_merchant_id}</taxAccount>
		<insuranceAccount>$c->{hipay_merchant_id}</insuranceAccount>
		<fixedCostAccount>$c->{hipay_merchant_id}</fixedCostAccount>
		<shippingCostAccount>$c->{hipay_merchant_id}</shippingCostAccount>
		<defaultLang>fr_FR</defaultLang>
		<media>WEB</media>
		<rating>+16</rating>
		<paymentMethod>0</paymentMethod>
		<captureDay>0</captureDay>
		<currency>$c->{currency_code}</currency>
		<idForMerchant>$id</idForMerchant>
		<merchantSiteId>$c->{hipay_website_id}</merchantSiteId>
		<statsGroupId>0</statsGroupId>
		<merchantDatas>
			<_aKey_id_client>2000</_aKey_id_client>
			<_aKey_credit>10</_aKey_credit>
		</merchantDatas>
		<url_ok>$c->{site_url}/?payment_complete=$id-$usr_id</url_ok>
		<url_nok>$c->{site_url}/?op=payments</url_nok>
		<url_cancel>$c->{site_url}/?op=payments</url_cancel>
		<url_ack>$c->{site_cgi}/ipn.cgi</url_ack>
		<ack_wd></ack_wd>
		<email_ack>$c->{contact_email}</email_ack>
		<bg_color></bg_color>
		<logo_url></logo_url>
		<locale>en_GB</locale>
		<issuerAccountLogin></issuerAccountLogin>
		<shopId></shopId>
		<merchantDescription></merchantDescription>
		<informations></informations>
		<cguChecked>0</cguChecked>
	</HIPAY_MAPI_PaymentParams>
	<order>
		<HIPAY_MAPI_Order>
			<shippingAmount>0</shippingAmount>
			<shippingTax>
			</shippingTax>
			<insuranceAmount>0</insuranceAmount>
			<insuranceTax>
			</insuranceTax>
			<fixedCostAmount>0</fixedCostAmount>
			<fixedCostTax>
			</fixedCostTax>
			<affiliate>
			</affiliate>
			<orderTitle>$c->{site_name} premium account</orderTitle>
			<orderInfo>best products</orderInfo>
			<orderCategory>549</orderCategory>
		</HIPAY_MAPI_Order>
	</order>
	<items>
		<HIPAY_MAPI_Product>
			<name>$c->{site_name} premium account</name>
			<quantity>1</quantity>
			<ref>JV005</ref>
			<category>549</category>
			<price>$f->{amount}</price>
			<tax>
			</tax>
		</HIPAY_MAPI_Product>
	</items>
</HIPAY_MAPI_SimplePayment>
OUT
;
	$ses->AdminLog("sending to hipay(usr_id=".$ses->getUserId.": $plain_xml");
	my $md5 = Digest::MD5::md5_hex($plain_xml);
	my $res = $ua->post($c->{hipay_url},
				{ xml => <<OUT 
<?xml version="1.0" encoding="UTF-8" ?>
<mapi>
<mapiversion>1.0</mapiversion>
<md5content>$md5</md5content>
$plain_xml
</mapi>
OUT
	});
	require XML::Simple;
	require XML::SAX::PurePerl;
	my $ret = XML::Simple::XMLin($res->decoded_content);
	$ses->AdminLog("hipay answer: ".$res->decoded_content);
	$url = $ret->{result}->{url} if $ret->{result}->{status} eq 'accepted';
	$ses->message("Hipay error: $ret->{result}->{message}") if $ret->{result}->{status} eq 'error';
      }
      elsif($f->{type} eq 'okpay')
      {
        print"Content-type:text/html\n\n";
      	print <<OUT
<form  method="post" action="https://www.okpay.com/process.html"><input type="hidden" name="ok_receiver" value="$c->{okpay_receiver}"/>
<input type="hidden" name="ok_item_1_name" value="$c->{site_name} premium account"/>
<input type="hidden" name="ok_currency" value="$c->{currency_code}"/>
<input type="hidden" name="ok_item_1_article" value="$id"/>
<input type="hidden" name="ok_item_1_type" value="service"/>
<input type="hidden" name="ok_item_1_price" value="$f->{amount}"/>
<input type="hidden" name="ok_return_success" value="$c->{site_url}/?payment_complete=$id-$usr_id"/>
<input type="hidden" name="ok_return_fail" value="$c->{site_url}/?op=payments"/>
<input type="hidden" name="ok_ipn" value="$c->{site_cgi}/ipn.cgi"/>
<input type="submit" name="submit" value="OK"/>
</form>
OUT
;
	exit;
      }
      elsif($f->{type} eq 'pwall')
      {
	 $url = "http://wallapi.com/api/ps/?key=$c->{pwall_app_id}&uid=t:$id&widget=p1";
      }
      elsif($f->{type} eq 'liberty')
      {
         my $email = $ses->getUser ? $ses->getUser->{usr_email} : $f->{email};
         print"Content-type:text/html\n\n";
print <<END
<HTML><BODY onLoad="document.F1.submit();">
<form action="https://sci.libertyreserve.com" method="post" name="F1">
<input type="hidden" name="lr_acc" value="$c->{lr_acc}">
<input type="hidden" name="lr_store" value="$c->{lr_store}">
<input type="hidden" name="lr_amnt" value="$f->{amount}">
<input type="hidden" name="lr_currency" value="LRUSD">
<input type="hidden" name="lr_merchant_ref" value="$id">
<input type="hidden" name="lr_success_url" value="$c->{site_url}/?payment_complete=$id-$usr_id">
<input type="hidden" name="lr_status_url" value="$c->{site_cgi}/ipn.cgi">
<input type="hidden" name="lr_comments" value="$c->{item_name}">
<input type="hidden" name="email" value="$email">
<input type="submit" value="Redirecting...">
</form>
</BODY></HTML>
END
;
         exit;
      }
      
      $ses->redirect($url) if $url;
   }

   my @arr = split(/,/,$c->{payment_plans});
   my @plans;
   for(@arr)
   {
      /([\d\.]+)=(\d+)/;
      push @plans, { amount=>$1, days=>$2, site_url=>$c->{site_url} };
   }

   for('max_upload_filesize_prem','max_upload_filesize_reg','max_upload_filesize_anon')
   {
      $c->{$_} = $c->{$_} ? "$c->{$_} Mb" : "No limits";
   }

   for('anon','reg','prem')
   {
      $c->{"files_expire_$_"} = $c->{"files_expire_access_$_"} ? $c->{"files_expire_access_$_"}.' '.$ses->{lang}->{lng_comparison_days_after_dl} : $ses->{lang}->{lng_comparison_never};
      $c->{"down_speed_$_"} = $c->{"down_speed_$_"} ? $c->{"down_speed_$_"}." KB/s" : "-";
      $c->{"bw_limit_$_"}||='Unlimited';
      $c->{"disk_space_$_"} = $c->{"disk_space_$_"} ? $c->{"disk_space_$_"}." GB" : 'Unlimited';
   }
   

   require Time::Elapsed;
   my $et = new Time::Elapsed;
   my $elapsed = $et->convert($ses->getUser->{exp_sec}) if $ses->getUser;
   $elapsed=~s/, \d+ seconds$//i;
   $ses->PrintTemplate("payments.html",
                        %{$c},
                        plans => \@plans, 
                        premium => $ses->getUser && $ses->getUser->{premium},
                        expire_elapsed => $elapsed,
                        'rand' => $ses->randchar(6),
                      );
}

sub PaymentComplete
{
   my $str = shift;
   $str = $ses->getCookie('transaction_id') if $ses->getCookie('transaction_id');
   my ($id,$usr_id)=split(/-/,$str);
   my $trans = $db->SelectRow("SELECT *, INET_NTOA(ip) as ip, (UNIX_TIMESTAMP()-UNIX_TIMESTAMP(created)) as dt
                               FROM Transactions 
                               WHERE id=?",$id) if $id;
   $ses->message("No such transaction exist") unless $trans;
   $ses->message("Internal error") unless $trans->{ip} eq $ENV{REMOTE_ADDR};
   $ses->message("Your account created successfully.<br>Please check your e-mail for login details") if $trans->{dt}>3600;
   $ses->message("Your payment have not verified yet.<br>Please refresh this page in 1-3 minutes") unless $trans->{verified};

   my $user = $db->SelectRow("SELECT *, DECODE(usr_password,?) as usr_password, 
                                     UNIX_TIMESTAMP(usr_premium_expire)-UNIX_TIMESTAMP() as exp_sec 
                              FROM Users 
                              WHERE usr_id=?",$c->{pasword_salt},$trans->{usr_id});
   require Time::Elapsed;
   my $et = new Time::Elapsed;
   my $exp = $et->convert($user->{exp_sec});
   $ses->message("Your payment processed successfully!<br><br>Login: $user->{usr_login}<br>Password: $user->{usr_password}<br><br>Your premium account expires in:<br>$exp");
}

sub CheckFiles
{
   sleep 1;
   $f->{list}=~s/\r//gs;
   my ($i,@arr);
   for( split /\n/, $f->{list} )
   {
      $i++;
      my ($code,$fname) = /\/(\w{12})\/?(.*?)$/;
      next unless $code;
      $fname=~s/\.html?$//i;
      $fname=~s/_/ /g;
      #my $filter_fname="AND file_name='$fname'" if $fname=~/^[^'"<>]+$/;
      my $file = $db->SelectRow("SELECT f.file_id,f.file_name,s.srv_status FROM Files f, Servers s WHERE f.file_code=? AND s.srv_id=f.srv_id",$code);
      push(@arr,"<font color='red'>$_ $ses->{lang}->{lng_checkfiles_not_found}</font>"),next unless $file;
      $file->{file_name}=~s/_/ /g;
      #push(@arr,"<font color='red'>$_ filename don't match!</font>"),next if $fname && $file->{file_name} ne $fname;
      push(@arr,"<font color='orange'>$_ $ses->{lang}->{lng_checkfiles_exist_not_available}</font>"),next if $file->{srv_status} eq 'OFF';
      push(@arr,"<font color='green'>$_ $ses->{lang}->{lng_checkfiles_found}</font>");
   }
   $ses->PrintTemplate("checkfiles.html",
                       'result' => join "<br>", @arr,
                      );
}

sub IndexPage
{
    $ses->{expires}="+$c->{caching_expire}s" if $c->{caching_expire};
    $ses->PrintTemplate("index_page.html",
                        index_featured_on    => $c->{index_featured_on},
                        index_most_viewed_on => $c->{index_most_viewed_on},
                        index_most_rated_on  => $c->{index_most_rated_on},
                        index_just_added_on  => $c->{index_just_added_on},
                        index_live_streams_on => $c->{index_live_streams_on},
                        'm_z'        => $c->{m_z},
                        'm_z_cols'   => $c->{m_z_cols},
                        'm_z_rows'   => $c->{m_z_rows},
                       );
}

sub Search
{
   $ses->redirect($c->{site_url}) unless $c->{enable_search};
   $ses->redirect($c->{site_url}) if $c->{enable_search}==2 && !$ses->getUserId;
   $ses->redirect($c->{site_url}) if $c->{highload_mode};
   $f->{page}||=1;
   my $title = $ses->{lang}->{lng_index_videos};
   for(qw(k user tag))
   {
      $f->{$_} =~ s/[\"\0\\\;]+//g;
   }
   
   my @filters;

   if(length($f->{k})>2)
   {
      push @filters, qq[AND (file_name LIKE "%$f->{k}%" OR file_title LIKE "%$f->{k}%" OR file_descr LIKE "%$f->{k}%")];
   }

   $f->{cat_id} = $db->SelectARefCached(300,"SELECT cat_id FROM Categories WHERE cat_name=?",$f->{cat_name})->[0]->{cat_id} if $f->{cat_name};
   if($f->{cat_id}=~/^\d+$/)
   {
      push @filters, "AND cat_id='$f->{cat_id}'";
   }

   if($f->{playlist})
   {
      my $playlist = $db->SelectRow("SELECT * FROM Playlists WHERE pls_code=?",$f->{playlist});
      my $pfiles = $db->SelectARef("SELECT * FROM Files2Playlists WHERE pls_id=?",$playlist->{pls_id});
      my $ids = join ',', map{$_->{file_id}} @$pfiles;
      push @filters, "AND file_id IN ($ids)" if $ids;
      $title = $playlist->{pls_name};
      $f->{hide_search}=1;
   }

   if($f->{user})
   {
      my $usr_id = $db->SelectOne("SELECT usr_id FROM Users WHERE usr_login=?",$f->{user});
      push @filters, "AND f.usr_id=$usr_id" if $usr_id;
   }

   my ($filter_tag1,$filter_tag2);
   if($f->{tag})
   {
      my $tag=$f->{tag};
      utf8::decode($tag);
      $tag=lc $tag;
      $tag=~s/[^\w\s\.\&]+//g;
      utf8::encode($tag);
      if(length($tag)>2)
      {
         my $tag_id = $db->SelectOne("SELECT tag_id FROM Tags WHERE tag_value=?",$tag);
         if($tag_id)
         {
            $filter_tag1=",Tags2Files t2f";
            $filter_tag2="AND f.file_id=t2f.file_id AND t2f.tag_id=$tag_id";
         }
      }
   }

   my ($filter_data1,$filter_data2);
   $f->{data_name}=~s/[^\w\s\_\-]//g;
   if($f->{data_name} && $f->{data_value})
   {
      my $value=$f->{data_value};
      utf8::decode($value);
      $value=lc $value;
      $value=~s/[^\w\s\.\&\-\_]+//g;
      utf8::encode($value);
      if(length($value)>2)
      {
         #my $tag_id = $db->SelectOne("SELECT tag_id FROM Tags WHERE tag_value=?",$tag);
         $filter_data1=",FilesData fd";
         $filter_data2="AND f.file_id=fd.file_id AND fd.name='$f->{data_name}' AND fd.value='$value'";
      }
   }

   #my $filter_folder;
   if($f->{fld_code})
   {
      my $folder = $db->SelectRow("SELECT * FROM Folders WHERE fld_code=?",$f->{fld_code});
      $title = "$folder->{fld_name}";
      push @filters, "AND f.file_fld_id=$folder->{fld_id}";
   }

   # Avoid empty filters full search
   push @filters, "AND f.file_id=0" unless @filters || ($filter_tag2 || $filter_data2);

   push @filters, "AND f.file_public=1" if $c->{search_public_only};

   push @filters, "AND (f.file_size_n>0 OR f.file_size_h>0 OR f.file_size_l>0)";

   my $filters_string = join "\n", @filters;

   # my $ids = $db->SelectARefCached("SELECT f.*, TO_DAYS(CURDATE())-TO_DAYS(file_created) as created,
   #                                    s.disk_id, s.srv_htdocs_url,
   #                                    u.usr_login
   #                             FROM (Files f, Servers s, Users u $filter_tag1 $filter_data1)
   #                             WHERE f.file_created < NOW()-INTERVAL 5 MINUTE
   #                             AND f.srv_id=s.srv_id
   #                             AND f.usr_id=u.usr_id
   #                             $filters_string
   #                             $filter_tag2
   #                             $filter_data2
   #                             ORDER BY file_created DESC".$ses->makePagingSQLSuffix($f->{page}) );

  $f->{per_page} ||= $c->{items_per_page};
  $f->{fast_paging} = 1;
  
  my $ids = $db->SelectARefCached("SELECT f.file_id
                               FROM (Files f $filter_tag1 $filter_data1)
                               WHERE f.file_created < NOW()-INTERVAL 5 MINUTE
                               $filters_string
                               $filter_tag2
                               $filter_data2
                               ORDER BY file_id DESC".$ses->makePagingSQLSuffix($f->{page},$f->{per_page}) );
  if($#$ids>=$f->{per_page})
  {
    $f->{fast_paging_next}=1;
    pop(@$ids);
  }
   my $ids2 = join(',', map{$_->{file_id}} @$ids) || 0;
   my $list = $db->SelectARefCached("SELECT f.*, TO_DAYS(CURDATE())-TO_DAYS(file_created) as created,
                                      s.*,
                                      u.usr_login as file_usr_login
                                     FROM (Files f, Servers s, Users u)
                                     WHERE file_id IN ($ids2)
                                     AND f.srv_id=s.srv_id
                                     AND f.usr_id=u.usr_id
                                    ORDER BY file_created DESC");


   my $total = $db->SelectOneCached("SELECT COUNT(*)
                               FROM Files f $filter_tag1 $filter_data1
                               WHERE f.file_created < NOW()-INTERVAL 5 MINUTE
                               $filters_string
                               $filter_tag2
                               $filter_data2
                              ");
   my $clist = genCategoriesSelect($f->{cat_id});
   undef($f->{cat_id}) if $f->{cat_name};
   $f->{cat_name} = $ses->{cgi_query}->url_encode($f->{cat_name});
   $f->{k} = $ses->{cgi_query}->url_encode($f->{k});
   my $paging = $ses->makePagingLinks($f,$total,'reverse');
   $f->{k} = $ses->{cgi_query}->url_decode($f->{k});

   $paging =~ s/\?data_name=(.+?)\&amp;data_value=(.+?)\&amp;op=search\&amp;page=(\d+)/s\/$1\/$2\/page$3/ig;
   $paging =~ s/\?cat_name=(.+?)\&amp;op=search\&amp;page=(\d+)/category\/$1\/page$2/ig;
   $paging =~ s/\?op=search\&amp;tag=(.+?)\&amp;page=(\d+)/tag\/$1\/page$2/ig;
   

   $ses->processVideoList($list,0,$clist);

   #my $show_extra=1 if $f->{user} || $f->{cat_id};
   $f->{hide_search}=1 if $f->{fld_code};

   $ses->PrintTemplate("search.html",
                       'files'  => $list,
                       'paging' => $paging,
                       'k'      => $f->{k},
                       'tag'    => $f->{tag},
                       'categories' => $clist,
                       'title'  => $title,
                       'user'   => $f->{user},
                       #'show_extra' => $show_extra,
                       'fld_code'   => $f->{fld_code},
                       'hide_search' => $f->{hide_search},
                       'm_z'        => $c->{m_z},
                       'm_z_cols'   => $c->{m_z_cols},
                       'm_z_rows'   => $c->{m_z_rows},
                      );
}

sub RequestMoney
{
   if($c->{m_u})
   {
	   # Make sure user info no cached when Memcached enabled
	   $db->PurgeCache( "ses".$ses->getCookie( $ses->{auth_cook} ) );
	   XUtils::CheckAuth($ses);
   }
   my $money = $ses->getUser->{usr_money};
   if($f->{convert_ext_acc})
   {
      $ses->message("$ses->{lang}->{lng_requestmoney_need_at_least} \$$c->{convert_money}") if $money<$c->{convert_money};
      if($ses->getUser->{premium})
      {
         $db->Exec("UPDATE Users 
                    SET usr_money=usr_money-?, 
                        usr_premium_expire=usr_premium_expire+INTERVAL ? DAY 
                    WHERE usr_id=?",$c->{convert_money},$c->{convert_days},$ses->getUserId);
      }
      else
      {
         $db->Exec("UPDATE Users 
                    SET usr_money=usr_money-?, 
                        usr_premium_expire=NOW()+INTERVAL ? DAY 
                    WHERE usr_id=?",$c->{convert_money},$c->{convert_days},$ses->getUserId);
      }
      $ses->redirect_msg("$c->{site_url}/?op=my_account","Your premium account extended for $c->{convert_days} days");
   }
   if($f->{convert_new_acc})
   {
      $ses->message("$ses->{lang}->{lng_requestmoney_need_at_least} \$$c->{convert_money}") if $money<$c->{convert_money};
      my $login = join '', map int rand 10, 1..7;
      while($db->SelectOne("SELECT usr_id FROM Users WHERE usr_login=?",$login)){ $login = join '', map int rand 10, 1..7; }
      my $password = $ses->randchar(10);
      $db->Exec("INSERT INTO Users (usr_login,usr_password,usr_created,usr_premium_expire,usr_aff_id) VALUES (?,ENCODE(?,?),NOW(),NOW()+INTERVAL ? DAY,?)",$login,$password,$c->{pasword_salt},$c->{convert_days},$ses->getUserId);
      $db->Exec("UPDATE Users SET usr_money=usr_money-? WHERE usr_id=?",$c->{convert_money},$ses->getUserId);
      $ses->message("$ses->{lang}->{lng_requestmoney_new_account_generated}<br>$ses->{lang}->{lng_myaccount_username} / $ses->{lang}->{lng_myaccount_password}:<br>$login<br>$password");
   }
   if($f->{convert_profit})
   {
      $ses->message("$ses->{lang}->{lng_requestmoney_need_at_least} \$$c->{min_payout}") if $money<$c->{min_payout};
      $ses->message("Profit system is disabled") unless $c->{min_payout};
      $ses->message($ses->{lang}->{lng_requestmoney_enter_pay_info}) unless $ses->getUser->{usr_pay_email};
      $ses->message("Already have pending payout") if $db->SelectOne("SELECT id FROM Payments WHERE usr_id=? AND status='PENDING'",$ses->getUserId);

      $db->Exec("UPDATE Users SET usr_money=0 WHERE usr_id=?",$ses->getUserId);
      $db->Exec("INSERT INTO Payments SET usr_id=?,amount=?,status='PENDING',created=NOW(),pay_type=?,pay_info=?",
                    $ses->getUserId, $money, $ses->getUser->{usr_pay_type}, $ses->getUser->{usr_pay_email} );
      $ses->redirect_msg("$c->{site_url}/?op=request_money",$ses->{lang}->{lng_requestmoney_payout_requested_ok});
   }

   my $pay_req = $db->SelectOne("SELECT SUM(amount) FROM Payments WHERE usr_id=? AND status='PENDING'",$ses->getUserId);

   my $convert_enough = 1 if $money >= $c->{convert_money};
   my $payout_enough = 1 if $money >= $c->{min_payout};
   $money = sprintf("%.02f",$money);

   my $payments = $db->SelectARef("SELECT *, DATE(created) as created2, DATE(processed) as processed2
                                   FROM Payments 
                                   WHERE usr_id=? 
                                   ORDER BY created DESC",$ses->getUserId);
   for(@$payments)
   {
   		$_->{processed2}='' if $_->{processed2} eq '0000-00-00';
   		$_->{status}=$ses->{lang}->{lng_requestmoney_status_paid} if $_->{status} eq 'PAID';
   		$_->{status}=$ses->{lang}->{lng_requestmoney_status_rejected} if $_->{status} eq 'REJECTED';
   		$_->{status}=$ses->{lang}->{lng_requestmoney_status_pending} if $_->{status} eq 'PENDING';
   }

   $ses->PrintTemplate("request_money.html",
                       'usr_money'           => $money,
                       'convert_days'        => $c->{convert_days},
                       'convert_money'       => $c->{convert_money},
                       'payment_request'     => $pay_req,
                       'payout_enough'       => $payout_enough,
                       'convert_enough'      => $convert_enough,
                       'enabled_prem'        => $c->{enabled_prem},
                       'min_payout'          => $c->{min_payout},
                       'msg'                 => $f->{msg},
                       'payments'            => $payments,
                      );
}

sub MyReseller
{
   $ses->message("Not allowed") unless ($c->{m_k} && ($ses->getUser->{usr_reseller} || !$c->{m_k_manual}));
   my $user = $ses->getUser;

   my (@plans,$hh,$hr);
   for(split(/,/,$c->{m_k_plans}))
   {
      my ($price,$time) = /^(.+)=(.+)$/;
      $hh->{$price} = $time;
      $hr->{$time} = $price;
      my $time1=$time;

      $time=~s/h/" $ses->{lang}->{lng_misc_hours}"/ie;
      $time=~s/d/" $ses->{lang}->{lng_misc_days}"/ie;
      $time=~s/m/" $ses->{lang}->{lng_misc_months}"/ie;
      
      push @plans, {price  => $price,
                    time   => $time,
                    time1  => $time1,
                    enough => $user->{usr_money}>=$price ? 1 : 0,
                   }
   }

   if($f->{del})
   {
      my $key = $db->SelectRow("SELECT * FROM PremiumKeys WHERE key_id=? AND usr_id=? AND usr_id_activated=0",$f->{del},$user->{usr_id});
      $ses->message("Can't delete this key") unless $key;
      $db->Exec("UPDATE Users SET usr_money=usr_money+? WHERE usr_id=?",$hr->{$key->{key_time}},$user->{usr_id});
      $db->Exec("DELETE FROM PremiumKeys WHERE key_id=?",$key->{key_id});
      $db->PurgeCache( "ses".$ses->getCookie($ses->{auth_cook}) );
      $ses->redirect('?op=my_reseller');
   }

   if($f->{generate}=~/^[\d\.]+$/)
   {
      $ses->message("You can have max 100 pending keys") if $db->SelectOne("SELECT COUNT(*) FROM PremiumKeys WHERE usr_id=? AND usr_id_activated=0",$user->{usr_id})>=100;
      my $time = $hh->{$f->{generate}};
      $ses->message("Invalid price") unless $time;
      $ses->message("Not enough money") if $ses->getUser->{usr_money} < $f->{generate};
      my @r = ('a'..'z');
      my $key_code = $r[rand scalar @r].$ses->randchar(13);
      $db->Exec("INSERT INTO PremiumKeys SET usr_id=?, key_code=?, key_time=?, key_created=NOW()",
                $user->{usr_id},$key_code,$time);
      $db->Exec("UPDATE Users SET usr_money=usr_money-? WHERE usr_id=?",$f->{generate},$user->{usr_id});
      $db->PurgeCache( "ses".$ses->getCookie($ses->{auth_cook}) );
      $ses->redirect('?op=my_reseller');
   }

   my $keys = $db->SelectARef("SELECT *
                               FROM PremiumKeys 
                               WHERE usr_id=?
                               ORDER BY key_created DESC
                               ".$ses->makePagingSQLSuffix($f->{page}), $user->{usr_id} );
   my $total = $db->SelectOne("SELECT COUNT(*) FROM PremiumKeys WHERE usr_id=?");
   for(@$keys)
   {
      $_->{key_time}=~s/h/" $ses->{lang}->{lng_misc_hours}"/ie;
      $_->{key_time}=~s/d/" $ses->{lang}->{lng_misc_days}"/ie;
      $_->{key_time}=~s/m/" $ses->{lang}->{lng_misc_months}"/ie;
   }

   $user->{usr_money} = sprintf("%.02f",$user->{usr_money});
   if($c->{m_k_add_money})
   {
      my @list = map{{amount=>$_}} grep{/^[\d\.]+$/} split /\s*\,\s*/, $c->{m_k_add_money_list};
      $user->{add_amounts} = \@list;
   }

   $ses->PrintTemplate("my_reseller.html",
                       %$user,
                       'plans'  => \@plans,
                       'keys'   => $keys,
                       'paging' => $ses->makePagingLinks($f,$total),
                       %$c,
                      );
}

sub APIReseller
{
   $f->{login}=$f->{u};
   $f->{password}=$f->{p};
   &Login('no_redirect');

   print"Content-type:text/html\n\n";
   print("ERROR:Reseller mod disabled"),exit unless $c->{m_k};
   print("ERROR:Invalid username/password"),exit unless $ses->getUser;
   print("ERROR:Not reseller user"),exit if $c->{m_k_manual} && !$ses->getUser->{usr_reseller};
   print("ERROR:You can have max 100 pending keys"),exit if $db->SelectOne("SELECT COUNT(*) FROM PremiumKeys WHERE usr_id=? AND usr_id_activated=0",$ses->getUserId)>=100;

   $f->{t}=lc $f->{t};
   my $price;
   for(split(/,/,$c->{m_k_plans}))
   {
      my ($pr,$time) = /^(.+)=(.+)$/;
      $price=$pr if $time eq $f->{t};
   }

   print("ERROR:Invalid time"),exit unless $price;
   print("ERROR:Not enough money"),exit if $ses->getUser->{usr_money} < $price;

   my @r = ('a'..'z');
   my $key_code = $r[rand scalar @r].$ses->randchar(13);
   $db->Exec("INSERT INTO PremiumKeys SET usr_id=?, key_code=?, key_time=?, key_created=NOW()",
             $ses->getUserId,$key_code,$f->{t});
   my $id = $db->getLastInsertId;
   $db->Exec("UPDATE Users SET usr_money=usr_money-? WHERE usr_id=?",$price,$ses->getUserId);
   print"$id$key_code";
   exit;
}

sub ReportFile
{
   my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?",$f->{file_code});

   $ses->out("No such file") unless $file;
   $db->Exec("INSERT INTO Reports
              SET file_code=?,
                  type=?,
                  info=?,
                  ip=INET_ATON(?),
                  created=NOW()
             ",
             $file->{file_code},
             $ses->SecureStr($f->{report_type}),
             $ses->SecureStr($f->{report_info}),
             $ses->getIP,
             );
   $ses->out(qq[\$("#id_flag").html("$ses->{lang}->{lng_download_flag_saved}");]);
}

sub APIGetLimits
{
   if($f->{login} && $f->{password})
   {
      &Login('no_redirect');
      $f->{error}="auth_error" unless $ses->getUser;
   }
   elsif($f->{session_id})
   {
      $ses->{cookies}->{$ses->{auth_cook}} = $f->{session_id};
      XUtils::CheckAuth($ses);
   }
   my $utype = $ses->getUser ? ($ses->getUser->{premium} ? 'prem' : 'reg') : 'anon';
   $c->{$_}=$c->{"$_\_$utype"} for qw(max_upload_files max_upload_filesize download_countdown captcha ads bw_limit remote_url direct_links down_speed);

   my $type_filter = $utype eq 'prem' ? "AND srv_allow_premium=1" : "AND srv_allow_regular=1";
   my $server = $db->SelectRow("SELECT * FROM Servers 
                                WHERE srv_status='ON' 
                                AND srv_disk+? <= srv_disk_max
                                $type_filter
                                ORDER BY srv_last_upload 
                                LIMIT 1",$c->{max_upload_filesize}||100);
   my $ext_allowed     = join '|', map{uc($_)." Files|*.$_"} split(/\|/,$c->{video_extensions});
   my $login_logic = 1 if !$c->{enabled_anon} && ($c->{enabled_reg} || $c->{enabled_prem});
      $login_logic = 2 if $c->{enabled_anon} && !$c->{enabled_reg} && !$c->{enabled_prem};
   print"Content-type:text/xml\n\n";
   print"<Data>\n";
   print"<ExtAllowed>$ext_allowed</ExtAllowed>\n";
   print"<MaxUploadFilesize>$c->{max_upload_filesize}</MaxUploadFilesize>\n";
   print"<ServerURL>$server->{srv_cgi_url}</ServerURL>\n";
   print"<SessionID>".$ses->{cookies_send}->{$ses->{auth_cook}}."</SessionID>\n";
   print"<Error>$f->{error}</Error>\n";
   print"<SiteName>$c->{site_name}</SiteName>\n";
   print"<LoginLogic>$login_logic</LoginLogic>\n";
   print"</Data>";
   exit;
}

sub CommentAdd
{
   XUtils::CheckAuth($ses);
   $ses->message("File comments are not allowed") if $f->{cmt_type}==1 && !$c->{enable_file_comments};
   $ses->message("Invalid object ID") unless $f->{cmt_ext_id}=~/^\d+$/;
   #my $redirect = &CommentRedirect($f->{cmt_type},$f->{cmt_ext_id});
   if($f->{name} || $f->{email} || $f->{text})
   {
      sleep 5;
      $ses->message("bot!");
   }
   if($ses->getUser)
   {
      $f->{cmt_name} = $ses->getUser->{usr_login};
      $f->{cmt_email} = $ses->getUser->{usr_email};
   }
   $f->{usr_id} = $ses->getUser ? $ses->getUserId : 0;
   $f->{cmt_name}=~s/(http:\/\/|www\.|\.com|\.net)//gis;
   $f->{cmt_name}    = $ses->SecureStr($f->{cmt_name});
   $f->{cmt_email}   = $ses->SecureStr($f->{cmt_email});
   $f->{cmt_text}    = $ses->SecureStr($f->{cmt_text});
   $f->{cmt_text} =~ s/(\_n\_|\n)/<br>/g;
   $f->{cmt_text} =~ s/\r//g;
   $f->{cmt_text} =~ s/"/&quot;/g;
   $f->{cmt_text} = substr($f->{cmt_text},0,800);
   my $err;
   $err.="Name is required field<br>" unless $f->{cmt_name};
   $err.="E-mail is not valid<br>" if $f->{cmt_email} && $f->{cmt_email}!~/^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
   $err.="Too short comment text<br>" if length($f->{cmt_text})<5;
   my $txt=$f->{cmt_text};
   $txt=~s/[\s._-]+//gs;
   $err.="Comment text contain restricted word" if $c->{bad_comment_words} && $txt=~/$c->{bad_comment_words}/i;
   print(qq{Content-type:text/html\n\n\$('#cnew').append("<b class='err'>$err</b><br><br>");}),exit if $err;

   $db->Exec("INSERT INTO Comments
              SET usr_id=?,
                  cmt_type=?,
                  cmt_ext_id=?,
                  cmt_ip=INET_ATON(?),
                  cmt_name=?,
                  cmt_email=?,
                  cmt_text=?
             ",$f->{usr_id},$f->{cmt_type},$f->{cmt_ext_id},$ses->getIP,$f->{cmt_name},$f->{cmt_email},$f->{cmt_text});
   $ses->setCookie('cmt_name',$f->{cmt_name});
   $ses->setCookie('cmt_email',$f->{cmt_email});
   #$ses->redirect($redirect,'+1m');
   print"Content-type:text/html\n\n";
   #print qq{\$('#cmt_txt').val('');\$('#cnew').append("<div class='cmt'><div class='cmt_hdr'><b>$f->{cmt_name}</b></div><div class='cmt_txt'>$f->{cmt_text}</div></div>");};
   #print qq{\$('#cmt_txt').val('');\$("<div class='cmt' style='display:none'><div class='cmt_hdr'><b>$f->{cmt_name}</b></div><div class='cmt_txt'>$f->{cmt_text}</div></div>").appendTo('#cnew').slideDown('slow');};
my $post=<<EOP
<li style='display:none;'>
  <div class='comment_header'>
    <span class='comment_user'>$f->{cmt_name}</span>
     <span class='comment_date'></span>
      <div class='clear'></div>
  </div>
 <div class='comment_body'>
   $f->{cmt_text}
 </div>
</li>
EOP
;
  $post=~s/\n//g;
  print qq{\$('#cmt_txt').val('');\$("$post").appendTo('#cnew').slideDown('slow');};
   exit;
}

sub CommentDel
{
   $ses->message("Access denied") unless $ses->getUser && $ses->getUser->{usr_adm};
   $db->Exec("DELETE FROM Comments WHERE cmt_id=?",$f->{i});
   print"Content-type:text/html\n\n\$('#cm$f->{i}').slideUp('slow');";
   exit;
}

sub CommentRedirect
{
   my ($cmt_type,$cmt_ext_id) = @_;
   if($cmt_type==1) # Files
   {
      my $file = $db->SelectRow("SELECT * FROM Files WHERE file_id=?",$cmt_ext_id);
      $ses->message("Object doesn't exist") unless $file;
      $ses->setCookie("skip$file->{file_id}",1);
      return $ses->makeFileLink($file).'#comments';
   }
   elsif($cmt_type==2) # News
   {
      my $news = $db->SelectRow("SELECT * FROM News WHERE news_id=?",$cmt_ext_id);
      $ses->message("Object doesn't exist") unless $news;
      return "$c->{site_url}/n$news->{news_id}-$news->{news_title2}.html#comments";
   }
   $ses->message("Invalid object type");
}

###
sub ARef
{
  my $data=shift;
  $data=[] unless $data;
  $data=[$data] unless ref($data) eq 'ARRAY';
  return $data;
}

sub getTime
{
    my ($t) = @_;
    my @t = $t ? localtime($t) : localtime();
    return ( sprintf("%04d",$t[5]+1900),
             sprintf("%02d",$t[4]+1), 
             sprintf("%02d",$t[3]), 
             sprintf("%02d",$t[2]), 
             sprintf("%02d",$t[1]), 
             sprintf("%02d",$t[0]) 
           );
}

sub EmailUnsubscribe
{
   my $user = $db->SelectRow("SELECT * FROM Users WHERE usr_id=? AND usr_email=?",$f->{id},$f->{email});
   $ses->message("Invalid unsubsription link") unless $user;
   $db->Exec("UPDATE Users SET usr_no_emails=1 WHERE usr_id=?",$user->{usr_id});
   $ses->message("You've successfully unsubribed from email newsleters.");
}

sub Vote
{
   print"Content-type:text/html\n\n";
   print("alert('Register to Vote!');"),exit unless $ses->getUserId;
   my $file = $db->SelectRowCached("SELECT file_id FROM Files WHERE file_code=?",$f->{file_code});
   print(qq[alert("File was deleted");]),exit unless $file;
   my $voted = $db->SelectOne("SELECT vote FROM Votes WHERE file_id=? AND usr_id=?",$file->{file_id},$ses->getUserId);
   #print(qq[alert("You've already voted for this file!");]),exit if 

   my $vote = $f->{v} eq 'up' ? 1 : -1;
   exit if $voted && $voted==$vote;
   my $rating;
   if($voted)
   {
   		$db->Exec("UPDATE Votes SET vote=? WHERE file_id=? AND usr_id=?", $vote, $file->{file_id},$ses->getUserId);
   		$rating = $vote==1 ? 2 : -2;
   }
   else
   {
		$db->Exec("INSERT IGNORE INTO Votes SET file_id=?, usr_id=?, vote=?",$file->{file_id},$ses->getUserId,$vote);
		$rating = $vote;
   }
   $db->Exec("UPDATE LOW_PRIORITY Files SET file_rating=file_rating+? WHERE file_id=?", $rating, $file->{file_id});
   
   my $votes = $db->SelectARef("SELECT vote, COUNT(*) as num FROM Votes WHERE file_id=? GROUP BY vote",$file->{file_id});
   for(@$votes)
   {
      $file->{likes}=$_->{num} if $_->{vote}==1;
      $file->{dislikes}=$_->{num} if $_->{vote}==-1;
   }
   $file->{likes}||=0;
   $file->{dislikes}||=0;
   $file->{likes_percent}=sprintf("%.1f",100*$file->{likes}/($file->{likes}+$file->{dislikes})) if $file->{likes} || $file->{dislikes};

   print qq|\$("#vote a").removeClass('active');\$(".vote_$f->{v}").addClass('active');\$('#likes_num').text('$file->{likes}');\$('#dislikes_num').text('$file->{dislikes}');\$('.likestatus span').css('width','$file->{likes_percent}%');|;
   exit;
}


sub ModeratorFilesFeatured
{
   $ses->message("Access denied") if !$ses->getUser->{usr_adm} && !($c->{m_d} && $ses->getUser->{usr_mod} && $c->{m_d_featured});
   if($f->{ajax_toggle})
   {
       print"Content-type:text/html\n\n";
       my $now = $db->SelectOne("SELECT file_id FROM FilesFeatured WHERE file_id=?",$f->{ajax_toggle});
       if($now)
       {
           $db->Exec("DELETE FROM FilesFeatured WHERE file_id=?",$f->{ajax_toggle});
           print"Added to Featured";
       }
       else
       {
           $db->Exec("INSERT INTO FilesFeatured SET file_id=?",$f->{ajax_toggle});
           print"Added to Featured";
       }
       exit;
   }
   if($f->{del_id})
   {
      $db->Exec("DELETE FROM FilesFeatured WHERE file_id=?",$f->{del_id});
      #$ses->redirect("?op=admin_files_featured");
      print"Content-type:text/html\n\n";
      print"\$('#f$f->{del_id}').hide('slow');";
      exit;
   }
   my $list = $db->SelectARef("SELECT f.*, 
                               UNIX_TIMESTAMP()-UNIX_TIMESTAMP(ff.created) as added,
                               u.usr_login
                               FROM (FilesFeatured ff, Files f)
                               LEFT JOIN Users u ON f.usr_id=u.usr_id
                               WHERE ff.file_id=f.file_id
                               ORDER BY ff.created
                              ");
   for(@$list)
   {
      $_->{download_link} = $ses->makeFileLink($_);
      $_->{added} = sprintf("%.0f",$_->{added}/3600);
      $_->{added} = $_->{added} < 48 ? "$_->{added} hours ago" : sprintf("%.0f days ago",$_->{added}/24);
      $ses->getVideoInfo($_);
   }
   $ses->PrintTemplate("moderator_files_featured.html",
                       list          => $list,
                      );
}

sub MyTorrents
{
   if($f->{del_torrent})
   {
      my $torr = $db->SelectRow("SELECT * FROM Torrents WHERE sid=?",$f->{del_torrent});
      $ses->redirect("$c->{site_url}/?op=my_torrents") unless $torr;

      my $res = $ses->api2($torr->{srv_id},{
                                  op   => 'torrent_delete',
                                  sid  => $f->{del_torrent},
                                 });

      $ses->message("Error1:$res") unless $res eq 'OK';

      $db->Exec("DELETE FROM Torrents WHERE sid=? AND status='WORKING'",$f->{del_torrent});
      $ses->redirect("$c->{site_url}/?op=my_torrents")
   }

   my $torrents = getTorrents();
   $ses->PrintTemplate("my_torrents.html",
                       torrents  => $torrents,
                      );
}

sub getTorrents
{
   my (%opts) = @_;
   my $torrents=[];

      $torrents = $db->SelectARef("SELECT *, UNIX_TIMESTAMP()-UNIX_TIMESTAMP(created) as working
                                   FROM Torrents t
                                   WHERE t.usr_id=?
                                   ",$ses->getUserId);
      require JSON;
      for my $t (@$torrents)
      {
         my $files = JSON::decode_json($t->{files}) if $t->{files} && $t->{files}=~/\}\]$/;
         $t->{file_list} = join('<br>',map{"$_->{path} &nbsp; <i>".sprintf("%.0f Mb",$_->{size}/1048576)."<\/i>"} @$files );
         $t->{file_list} =~ s/'/\\'/g;
         $t->{title}=$files->[0]->{path} if $files;
         $t->{title}=~s/\/.+$//;
         $t->{title}=~s/:\d+$//;
         ($t->{done},$t->{total},$t->{down_speed},$t->{up_speed})=split(':',$t->{progress});
         $t->{percent} = sprintf("%.01f", 100*$t->{done}/$t->{total} ) if $t->{total};
         $t->{done} = sprintf("%.1f", $t->{done}/1048576 );
         $t->{total} = sprintf("%.1f", $t->{total}/1048576 );
         $t->{working} = $t->{working}>3600*3 ? sprintf("%.1f hours",$t->{working}/3600) : sprintf("%.0f mins",$t->{working}/60);
      }

   return $torrents;
}

sub MakeMoneyPage
{
   my @sizes = map{{t1=>$_}} split(/\|/,$c->{tier_sizes});
   $sizes[$_]->{t2}=$sizes[$_+1]->{t1} for(0..$#sizes-1);
   $sizes[$#sizes]->{t2}='Longer';

   my @tier1 = map{{amount=>$_}} split(/\|/,$c->{tier1_money});
   my @tier2 = map{{amount=>$_}} split(/\|/,$c->{tier2_money});
   my @tier3 = map{{amount=>$_}} split(/\|/,$c->{tier3_money});
   my @tier4 = map{{amount=>$_}} split(/\|/,$c->{tier4_money});

   require XCountries;

   my @countries1 = grep{$_} map{$XCountries::iso_to_country->{uc $_}} split(/\|/,$c->{tier1_countries});
   my @countries2 = grep{$_} map{$XCountries::iso_to_country->{uc $_}} split(/\|/,$c->{tier2_countries});
   my @countries3 = grep{$_} map{$XCountries::iso_to_country->{uc $_}} split(/\|/,$c->{tier3_countries});
   my @countries4 = grep{$_} map{$XCountries::iso_to_country->{uc $_}} split(/\|/,$c->{tier4_countries});

   $ses->PrintTemplate("make_money.html",
                       sizes => \@sizes,
                       tier1 => \@tier1,
                       tier2 => \@tier2,
                       tier3 => \@tier3,
                       tier4 => \@tier4,
                       countries1 => join(', ',@countries1),
                       countries2 => join(', ',@countries2),
                       countries3 => join(', ',@countries3),
                       countries4 => join(', ',@countries4),
                       tier_views_number => $c->{tier_views_number},
                      );
}

sub checkModSpecialRights
{
	my ($mod) = @_;
	return 0 unless $c->{$mod};
	my $user_field = {
		'm_b'=>'usr_website',
		'm_e'=>'usr_effects',
		'm_f'=>'usr_ftp',
		'm_n'=>'usr_clone',
		'm_q'=>'usr_streams',
		'm_s'=>'usr_snapshot',
		'm_t'=>'usr_torrent',
		'm_v'=>'usr_watermark',
	}->{$mod};
	return 1 if $c->{"$mod\_users"} eq 'admin' && $ses->getUser->{usr_adm};
    return 1 if $c->{"$mod\_users"} eq 'special' && ($ses->getUser->{$user_field} || $db->SelectOne("SELECT value FROM UserData WHERE usr_id=? AND name=?",$ses->getUserId,$user_field));
    return 1 if $c->{"$mod\_users"} eq 'premium' && $utype eq 'prem';
    return 1 if $c->{"$mod\_users"} eq 'registered' && $ses->getUserId;
    return 1 if $c->{"$mod\_users"} eq 'all';
    return 0;
}

sub MyWatermark
{
    my $user;
    my $data = $db->SelectARef("SELECT * FROM UserData WHERE usr_id=?",$ses->getUserId);
    $user->{$_->{name}}=$_->{value} for @$data;

    #$ses->message("Watermark mod disabled") unless $c->{m_v};
    $ses->message("You're not allowed to manage watermark") unless checkModSpecialRights('m_v');

    my $usr_id = $ses->getUserId;

    if(defined $f->{watermark_mode})
    {
        if($f->{watermark_mode} eq 'image' && $f->{logo_image})
        {
            require GD;
            my $im = new GD::Image($ses->{cgi_query}->upload($f->{logo_image})) || $ses->message("Failed to read the image");
            my ($w,$h) = $im->getBounds();
            $ses->message("Invalid image") unless $w && $h;
            $ses->message("Image is too large ($w x $h)") if $w>$c->{m_v_image_max_size} || $h>$c->{m_v_image_max_size};
            $im->saveAlpha(1);
            $im->alphaBlending(1);
            $ses->{cgi_query}->upload($f->{logo_image},"$c->{site_path}/upload-data/watermark_$usr_id.png");
            #open FILE, ">$c->{site_path}/upload-data/watermark_$usr_id.png";
            #print FILE $ses->{cgi_query}->upload($f->{logo_image}); #$im->png;
            #close FILE;
        }

        ### Validate inputs ###
        $f->{watermark_text}=~s/[^\w\s\.\-\!]//g;
        if($f->{watermark_mode} eq 'text')
        {
            $f->{watermark_padding}=~s/\D//g;
            $f->{watermark_padding}||=0;
            $f->{watermark_position}||='nw';
            $f->{watermark_color}='white' unless $f->{watermark_color}=~/^#\w{6}$/ || $f->{watermark_color}=~/^\w+$/i;
            $f->{watermark_shadow_color}='' unless $f->{watermark_shadow_color}=~/^#\w{6}$/ || $f->{watermark_shadow_color}=~/^\w+$/i;
            $f->{watermark_size}=13 unless $f->{watermark_size}=~/^\d+$/;
            $f->{watermark_text}=$c->{site_name} unless $f->{watermark_text};
        }
        if($f->{watermark_mode} eq 'scroll')
        {
            $f->{watermark_padding}=~s/\D//g;
            $f->{watermark_padding}||=0;
            $f->{watermark_position}||='top';
            $f->{watermark_color}='white' unless $f->{watermark_color}=~/^#\w{6}$/ || $f->{watermark_color}=~/^\w+$/i;
            $f->{watermark_shadow_color}='' unless $f->{watermark_shadow_color}=~/^#\w{6}$/ || $f->{watermark_shadow_color}=~/^\w+$/i;
            $f->{watermark_size}=13 unless $f->{watermark_size}=~/^\d+$/;
            $f->{watermark_scroll_start}=3   unless $f->{watermark_scroll_start}=~/^\d+$/;
            $f->{watermark_scroll_length}=10 unless $f->{watermark_scroll_length}=~/^\d+$/;
            $f->{watermark_text}=$c->{site_name} unless $f->{watermark_text};
        }
        if($f->{watermark_mode} eq 'image')
        {
            $f->{watermark_image_fadeout}=~s/\D//g;
            $f->{watermark_image_fadeout}=60 if $f->{watermark_image_fadeout}>60;
            $f->{watermark_image_fadeout}||=10;
            $f->{watermark_padding}=~s/\D//g;
            $f->{watermark_padding}||=0;
            $f->{watermark_fade}||=0;
            $f->{watermark_position}||='nw';
        }
        #######################

        #$db->Exec("DELETE FROM UserData WHERE usr_id=? AND name LIKE 'watermark_%'",$ses->getUserId);
        my @keys = grep {/^watermark_/} keys %$f;
        for(@keys)
        {
            #$db->Exec("INSERT INTO UserData SET usr_id=?, name=?, value=?", $ses->getUserId, $_, $f->{$_}||'' ) if defined $f->{$_};
            $ses->saveUserData($_, $f->{$_});
        }
        $ses->redirect('?op=my_watermark');
    }

    my @fonts = map{{font=>$_,selected=>($_ eq $user->{watermark_font} ? ' selected' : '')}} split /,\s*/, $c->{m_v_fonts};

    $user->{watermark_mode}||=0;
    $user->{"watermark_mode_$user->{watermark_mode}"}=' checked';
    $user->{"watermark_dispose_mode_$user->{watermark_dispose_mode}"} = ' selected';
    $user->{"watermark_opacity_$user->{watermark_opacity}"} = ' selected';
    $user->{"watermark_position_$user->{watermark_position}"} = 1;
    $user->{logo_url}="watermark_$usr_id.png" if -f "$c->{site_path}/upload-data/watermark_$usr_id.png";

    $ses->PrintTemplate("my_watermark.html",
                        %$user,
                        fonts   => \@fonts,
                        m_v_image_logo => $c->{m_v_image_logo},
                        m_v_image_max_size => $c->{m_v_image_max_size},
                        rand => $ses->randchar(6),
                       );
}

sub addEncodeQueueDB
{
    my ($file_real_id, $file_real, $file_id, $srv_id, $premium, $quality) = @_;

    $db->Exec("INSERT IGNORE INTO QueueEncoding
               SET file_real_id=?, 
                   file_real=?, 
                   file_id=?,
                   srv_id=?,
                   premium=?, 
                   quality=?,
                   extra=?,
                   created=NOW()", 
               $file_real_id, 
               $file_real, 
               $file_id, 
               $srv_id,
               $premium,
               $quality,
               $f->{effects}||'',
             );
}

sub MySnapshot
{
    #$ses->message("Watermark mod disabled") unless $c->{m_s};
    $ses->message("You're not allowed to manage snapshots") unless checkModSpecialRights('m_s');

    my $file = $db->SelectRow("SELECT * FROM Files f, Servers s 
                               WHERE file_code=?
                               AND usr_id=?
                               AND f.srv_id=s.srv_id",$f->{file_code},$ses->getUserId);
    return $ses->message("Not your file") unless $file;
    $ses->getVideoInfo($file);
    $f->{ss}=~s/[^\d\.]//g;
    $f->{ss}||=0;
    if($f->{create})
    {
        my $res = $ses->api2($file->{srv_id},
                             {
                              op => 'gen_snapshots',
                              file_code     => $file->{file_real},
                              file_id       => $file->{file_real_id},
                              disk_id       => $file->{disk_id},
                              create        => $f->{ss},
                             });
        $ses->message("ERROR:$res") unless $res eq 'OK';
        $ses->redirect("?op=file_edit&file_code=$file->{file_code}&newshot=1");
    }

    if($f->{preview})
    {
        my $res = $ses->api2($file->{srv_id},
                             {
                              op => 'gen_snapshots',
                              file_code     => $file->{file_real},
                              file_id       => $file->{file_real_id},
                              disk_id       => $file->{disk_id},
                              preview       => $f->{ss},
                             });
        print"Content-type:text/html\n\n";
        print q[<Table class="tbl1" cellpadding=2 width=780><TR><TH>Preview snapshots</TH></TR>];
        for(grep {$_} split /\n/, $res)
        {
            my $rand = $ses->randchar(6);
            print qq[<tr align=center><td><a href="#new" onclick="\$('#ss').val('$_');"><img src="$file->{srv_htdocs_url}/tmp/$file->{file_real}/$_.jpg?$rand"></a>];
        }
        print"</Table>";
        exit;
    }

    if($f->{upload_new} && $c->{m_s_upload})
    {
        my $file = $db->SelectRow("SELECT * FROM Files f, Servers s WHERE f.file_code=? AND f.usr_id=? AND f.srv_id=s.srv_id",$f->{file_code},$ses->getUserId);
        return $ses->message("No file") unless $file;
        my $uid=$ses->getUserId;
        my $thumb = "$c->{site_path}/captchas/th$uid.jpg";
        $ses->{cgi_query}->upload($f->{file},$thumb) || $ses->message("Upload error:".$ses->{cgi_query}->cgi_error());

        require GD;
        my $im = new GD::Image($thumb) || $ses->message("Failed to read the image");
        my ($w,$h) = $im->getBounds();
        $ses->message("Invalid image") unless $w && $h;
        $ses->message("Image is too large ($w x $h)") if $w>1600 || $h>1200;

        my $h = [
                 dl_key=>$c->{dl_key},
                 op         => 'thumb_upload',
                 disk_id    => $file->{disk_id},
                 file_id    => $file->{file_real_id},
                 file_code  => $file->{file_real},
                 file       => [$thumb]
                ];
        require HTTP::Request::Common;
        require LWP::UserAgent;
        my $ua = LWP::UserAgent->new(agent=>$c->{user_agent},timeout=>300);
        my $req = HTTP::Request::Common::POST( "$file->{srv_cgi_url}/api.cgi", Content_Type => 'form-data', Content => $h);
        my $res = $ua->request($req)->content;
        unlink($thumb);
        $ses->message("Upload error: $res") unless $res=~/^OK$/i;
        $ses->redirect("?op=file_edit&file_code=$file->{file_code}&newshot=1");
    }

    my $res = $ses->api2($file->{srv_id},
                         {
                          op => 'gen_snapshots',
                          file_code     => $file->{file_real},
                          file_id       => $file->{file_real_id},
                          disk_id       => $file->{disk_id},
                          file_length   => $file->{file_length},
                          m_s_samples   => $c->{m_s_samples},
                         });
    $ses->message($res) unless $res=~/^\d+/;
    my $cx;
    my @list = map { {url=>"$file->{srv_htdocs_url}/tmp/$file->{file_real}/$_.jpg",ss=>$_,tr=>$cx++%2} } grep {$_} split /\n/, $res;

    $ses->PrintTemplate("my_snapshot.html",
                        %$file,
                        list => \@list,
                        m_s_upload => $c->{m_s_upload},
                       );
}

sub MyFilesDeleted
{
    if($f->{hide})
    {
        $db->Exec("UPDATE FilesTrash SET hide=1 WHERE usr_id=?",$ses->getUserId);
        $ses->redirect("?op=my_files_deleted");
    }
    if($f->{restore} && $f->{file_code})
    {
        my $ids = join("','",grep{/^\w{12}$/}@{&ARef($f->{file_code})});
        $ses->redirect($c->{site_url}) unless $ids;
        my $list = $db->SelectARef("SELECT * FROM FilesTrash WHERE usr_id=? AND file_code IN ('$ids')",$ses->getUserId);
        for my $x (@$list)
        {
            unless($x->{del_by}==$ses->getUserId)
            {
                $x->{file_code} = $ses->randchar(12);
                while($db->SelectOne("SELECT file_id FROM Files WHERE file_code=? OR file_real=?",$x->{file_code},$x->{file_code})){$x->{file_code} = $ses->randchar(12);}
            }
            delete @$x{'file_deleted', 'del_by', 'hide'};
            $x->{file_fld_id}=0 unless $db->SelectOne("SELECT fld_id FROM Folders WHERE fld_id=? AND usr_id=?",$x->{file_fld_id},$ses->getUserId);
            
            my (@par,@val);
            for(keys %$x)
            {
            	push @par, "$_=?";
            	push @val, $x->{$_};
            }
            $db->Exec("INSERT INTO Files SET ".join(',',@par), @val);

            $db->Exec("DELETE FROM FilesTrash WHERE file_id=? AND usr_id=?",$x->{file_id},$ses->getUserId);
            $db->Exec("DELETE FROM DeleteQueue WHERE file_real_id=?",$x->{file_real_id});
        }
        $ses->redirect_msg("?op=my_files_deleted",@$list." files were restored");
    }
    my $files = $db->SelectARef("SELECT f.*, UNIX_TIMESTAMP()-UNIX_TIMESTAMP(file_deleted) as ago
                                 FROM FilesTrash f 
                                 WHERE f.usr_id=?
                                 AND hide=0
                                 ORDER BY file_deleted DESC",$ses->getUserId);
    my $reals= join "','", map{$_->{file_real}} @$files;
    my $canrestore1 = $db->SelectARef("SELECT DISTINCT file_real FROM Files WHERE file_real IN ('$reals')");
    my $canrestore2 = $db->SelectARef("SELECT DISTINCT file_real FROM DeleteQueue WHERE file_real IN ('$reals')");

    my %can = map{ $_->{file_real}=>1 } @$canrestore1,@$canrestore2;

    for(@$files)
    {
        $_->{ago} = sprintf("%.0f",$_->{ago}/60);
        $_->{ago} = $_->{ago}<180 ? "$_->{ago} mins" : sprintf("%.0f hours",$_->{ago}/60);
        $_->{restore} = $can{$_->{file_real}};
        $_->{own}=" style='color:green'" if $_->{del_by}==$ses->getUserId;
    }
    $ses->PrintTemplate("my_files_deleted.html",
                        files => $files,
                       );
}

sub FavoritesDo
{
    unless($ses->getUser)
    {
        my @fav = grep{/^\w{12}$/} split /,/, $ses->getCookie("fav");
        my $msg_done;
        if($f->{add}=~/^\w{12}$/)
        {
            push @fav, $f->{add};
            $msg_done="Added to";
        }
        elsif($f->{del}=~/^\w{12}$/)
        {
            @fav = grep {$_ ne $f->{del}} @fav;
            $msg_done="Removed from";
        }
        
        my $cc = $ses->{cgi_query}->cookie( -name => 'fav', -value => join(',',@fav), -domain  => ".$ses->{domain}", -expires => '+180d');
        print $ses->{cgi_query}->header( -cookie => [$cc] , -type => 'text/html', -expires => '-1h', -charset => $c->{charset});
        print qq[\$('#fav_btn').parent().html("$msg_done <a href='$c->{site_url}/?op=favorites'>Favorites</a>");];
        exit;
    }
    else
    {
        my $msg_done;
        my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?",$f->{add}||$f->{del});
        $ses->message("No file") unless $file;
        if($f->{add}=~/^\w{12}$/)
        {
            $db->Exec("INSERT IGNORE INTO Favorites SET usr_id=?, file_id=?",$ses->getUserId,$file->{file_id});
            $msg_done="Added to";
        }
        elsif($f->{del}=~/^\w{12}$/)
        {
            $db->Exec("DELETE FROM Favorites WHERE usr_id=? AND file_id=? LIMIT 1",$ses->getUserId,$file->{file_id});
            $msg_done="Removed from";
        }
        print $ses->{cgi_query}->header( -type => 'text/html', -expires => '-1h', -charset => $c->{charset});
        print qq[\$('#fav_btn').parent().html("$msg_done <a href='$c->{site_url}/?op=favorites'>Favorites</a>");];
        exit;
    }
}

sub Favorites
{
    my ($list,$total);
    if($ses->getUser)
    {
        $list = $db->SelectARef("SELECT f.*, TO_DAYS(CURDATE())-TO_DAYS(file_created) as created,
                                           s.disk_id, s.srv_htdocs_url
                                    FROM (Files f, Servers s, Favorites fv)
                                    WHERE fv.usr_id=?
                                    AND fv.file_id=f.file_id
                                    AND f.srv_id=s.srv_id
                                    ORDER BY fv.created DESC".$ses->makePagingSQLSuffix($f->{page}), $ses->getUserId );
        $total = $db->SelectOne("SELECT COUNT(*)
                                    FROM Files f, Favorites fv
                                    WHERE fv.usr_id=?
                                    AND fv.file_id=f.file_id
                                   ", $ses->getUserId);
    }
    else
    {
        my $codes = join "','", grep{/^\w{12}$/} split /,/, $ses->getCookie("fav");
        $list = $db->SelectARef("SELECT f.*, TO_DAYS(CURDATE())-TO_DAYS(file_created) as created,
                                           s.disk_id, s.srv_htdocs_url
                                    FROM (Files f, Servers s)
                                    WHERE f.file_code IN ('$codes')
                                    AND f.srv_id=s.srv_id
                                    ORDER BY f.file_created DESC".$ses->makePagingSQLSuffix($f->{page}) );
        $total = $db->SelectOne("SELECT COUNT(*)
                                 FROM Files f
                                 WHERE f.file_code IN ('$codes')");
    }

    my $paging = $ses->makePagingLinks($f,$total);

    $ses->processVideoList($list,4);

    $ses->PrintTemplate("my_favorites.html",
                        files   => $list,
                        paging  => $paging,
                        no_created => 1,
                       );
}

sub ModeratorReports
{
   $ses->message("Access denied") if !$ses->getUser->{usr_adm} && !($c->{m_d} && $ses->getUser->{usr_mod} && $c->{m_d_a});

   if($f->{file_code})
   {
      $ses->message("Not allowed in Demo mode") if $c->{demo_mode};
      my $ids = join "','", grep{/^\w{12}$/} @{ARef($f->{file_code})};
      my $files = $db->SelectARef("SELECT * FROM Files WHERE file_code IN ('$ids')") if $ids;
      if($files)
      {
          if($f->{delete_selected})
          {
            $_->{del_money}=$c->{del_money_file_del} for @$files;
            $ses->DeleteFilesMass($files);
          }
          $db->Exec("DELETE FROM Reports WHERE file_code IN ('$ids')");
      }
      $ses->redirect("?op=moderator_reports");
   }

   my $list = $db->SelectARef("SELECT r.*, f.*, INET_NTOA(ip) as ip,
                               (SELECT u.usr_login FROM Users u WHERE f.usr_id=u.usr_id) as usr_login
                               FROM Reports r 
                               LEFT JOIN Files f ON r.file_code = f.file_code
                               ORDER BY r.created DESC".$ses->makePagingSQLSuffix($f->{page}));
   my $total = $db->SelectOne("SELECT COUNT(*)
                               FROM Reports r");
   for(@$list)
   {
      $_->{site_url} = $c->{site_url};
      $_->{info} =~ s/\n/<br>/gs;
   }
   $ses->PrintTemplate("moderator_reports.html",
                       'list'    => $list,
                       'paging'  => $ses->makePagingLinks($f,$total),
                      );
}

sub ModeratorComments
{
   $ses->message("Access denied") unless $c->{m_d} && $ses->getUser->{usr_mod} && $c->{m_d_c};
   if($f->{del_selected} && $f->{cmt_id})
   {
      my $ids = join(',',grep{/^\d+$/}@{&ARef($f->{cmt_id})});
      $ses->redirect($c->{site_url}) unless $ids;
      $db->Exec("DELETE FROM Comments WHERE cmt_id IN ($ids)");
      $ses->redirect("?op=moderator_comments");
   }
   if($f->{rr})
   {
      $ses->redirect( &CommentRedirect(split(/-/,$f->{rr})) );
   }
   my $filter;
   $filter="WHERE c.cmt_ip=INET_ATON('$f->{ip}')" if $f->{ip}=~/^[\d\.]+$/;
   $filter="WHERE c.usr_id=$f->{usr_id}" if $f->{usr_id}=~/^\d+$/;
   $filter="WHERE c.cmt_name LIKE '%$f->{key}%' OR c.cmt_email LIKE '%$f->{key}%' OR c.cmt_text LIKE '%$f->{key}%'" if $f->{key}=~/^[\w-]+$/;
   my $list = $db->SelectARef("SELECT c.*, INET_NTOA(c.cmt_ip) as ip, u.usr_login, u.usr_id
                               FROM Comments c
                               LEFT JOIN Users u ON c.usr_id=u.usr_id
                               $filter
                               ORDER BY created DESC".$ses->makePagingSQLSuffix($f->{page},$f->{per_page}));
   my $total = $db->SelectOne("SELECT COUNT(*) FROM Comments c $filter");
   $ses->PrintTemplate("moderator_comments.html",
                       'list'   => $list,
                       'key'    => $f->{key}, 
                       'paging' => $ses->makePagingLinks($f,$total),
                      );
}

sub MyFileEffects
{
    my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?",$f->{file_code});
    $ses->message("File not found") unless $file;
    $ses->message("File don't have original") unless $file->{file_size_o};
    if($f->{process})
    {
      $f->{effects} = join '|', map{/^eff_(.+)$/;"$1=$f->{$_}"} grep{/^eff_/ && $f->{$_}} keys %$f;
      $ses->message("No effects were selected") unless $f->{effects};
      for my $mode ('n','h','l','p')
      {
        addEncodeQueueDB($file->{file_real_id}, $file->{file_real}, $file->{file_id}, $file->{srv_id}, 1, $mode)
            if $file->{"file_size_$mode"};
      }
      $ses->redirect_msg("?op=file_edit&file_code=$file->{file_code}","Video added to re-encode queue");
    }
    $ses->PrintTemplate("my_file_effects.html",
                        %{$file},
                      );
}

sub AddToPlaylist
{
    print"Content-type:text/html\n\n";
    my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?",$f->{file_code});
    print("ERROR: file not found"),exit unless $file;
    print("ERROR: token error"),exit unless $ses->checkToken;
    if($f->{new})
    {
        $f->{new} = $ses->SecureStr($f->{new});
        my $code = $ses->randchar(6);
        while($db->SelectOne("SELECT pls_id FROM Playlists WHERE pls_code=?",$code)){$code = $ses->randchar(6);}
        $db->Exec("INSERT INTO Playlists SET usr_id=?, pls_code=?, pls_name=?", $ses->getUserId, $code, $f->{new} );
        $f->{pls_id} = $db->getLastInsertId;
    }
    if($f->{pls_id} eq 'watchlater')
    {
    	$f->{pls_id} = $db->SelectOne("SELECT pls_id FROM Playlists WHERE usr_id=? AND pls_name='Watch later'",$ses->getUserId);
    	unless($f->{pls_id})
    	{
    		my $code = $ses->randchar(6);
	        while($db->SelectOne("SELECT pls_id FROM Playlists WHERE pls_code=?",$code)){$code = $ses->randchar(6);}
	        $db->Exec("INSERT INTO Playlists SET usr_id=?, pls_code=?, pls_name=?", $ses->getUserId, $code, 'Watch later' );
	        $f->{pls_id} = $db->getLastInsertId;
    	}
    }
    my $plist = $db->SelectRow("SELECT * FROM Playlists WHERE pls_id=? AND usr_id=?", $f->{pls_id}, $ses->getUserId );
    print("ERROR: playlist not found"),exit unless $plist;

    $db->Exec("INSERT IGNORE INTO Files2Playlists SET pls_id=?, file_id=?", $f->{pls_id}, $file->{file_id} );

    print"<b>File added to playlist <a href='$c->{site_url}/playlist/$plist->{pls_code}'>$plist->{pls_name}</a></b>";
    exit;
}

sub MyPlaylists
{
    if($f->{del_playlist}=~/^\d+$/ && $f->{token} && $ses->checkToken)
    {
        my $plist = $db->SelectRow("SELECT * FROM Playlists WHERE pls_id=? AND usr_id=?", $f->{del_playlist}, $ses->getUserId );
        $ses->message("Playlist not found") unless $plist;
        $db->Exec("DELETE FROM Files2Playlists WHERE pls_id=?",$plist->{pls_id});
        $db->Exec("DELETE FROM Playlists WHERE pls_id=?",$plist->{pls_id});
        $ses->redirect("?op=my_playlists");
    }
    my $list = $db->SelectARef("SELECT p.*, COUNT(f.file_id) as num
                                 FROM Playlists p
                                 LEFT JOIN Files2Playlists f ON p.pls_id=f.pls_id
                                 WHERE p.usr_id=? GROUP BY pls_id", $ses->getUserId );

    $ses->PrintTemplate("my_playlists.html",
                        list  => $list,
                        token => $ses->genToken,
                      );
}

sub MyPlaylistFiles
{
    my $plist = $db->SelectRow("SELECT * FROM Playlists WHERE pls_id=? AND usr_id=?", $f->{pls_id}, $ses->getUserId );
    $ses->message("Playlist not found") unless $plist;
    if($f->{remove} && $f->{file_id})
    {
        my $ids = join(',',grep{/^\d+$/}@{&ARef($f->{file_id})}) || 0;
        $db->Exec("DELETE FROM Files2Playlists WHERE pls_id=? AND file_id IN ($ids)", $f->{pls_id} );
        $ses->redirect("?op=my_playlist_files&pls_id=$f->{pls_id}");
    }
    my $files = $db->SelectARef("SELECT * FROM Files f, Files2Playlists f2p WHERE f2p.pls_id=? AND f2p.file_id=f.file_id", $plist->{pls_id} );
    for(@$files)
    {
      $_->{file_descr} = $ses->shortenString( $_->{file_descr}, 50 );

      $_->{file_title_txt} = $ses->shortenString( $_->{file_title}||$_->{file_name}, $c->{display_max_filename} );

      $_->{download_link} = $ses->makeFileLink($_);

      $ses->getVideoInfo($_);
    }
    $ses->PrintTemplate("my_playlist_files.html",
                        files  => $files,
                        token  => $ses->genToken,
                        pls_id => $plist->{pls_id},
                      );
}

sub getAffiliate
{
   my $usr_id = $ses->getUser ? $ses->getUserId : 0;

   my $aff_id;
   $aff_id = $ses->getCookie('aff')||0;
   $aff_id = 0 if $aff_id==$usr_id;
   $aff_id = $ses->getUser->{usr_aff_id} if $ses->getUser && $ses->getUser->{usr_aff_id} && !$aff_id;
   return($aff_id||0);
}

sub AjaxNewFolder
{
    $f->{create_new_folder} = $ses->SecureStr($f->{create_new_folder});
    return $ses->amessage("Invalid folder name!") unless $f->{create_new_folder};
    return $ses->amessage("Invalid parent folder") if $f->{fld_id} && !$db->SelectOne("SELECT fld_id FROM Folders WHERE usr_id=? AND fld_id=?",$ses->getUserId,$f->{fld_id});
    return $ses->amessage("You already have folder with this name!") if $db->SelectOne("SELECT fld_id FROM Folders WHERE usr_id=? AND fld_parent_id=? AND fld_name=?",$ses->getUserId,$f->{fld_id},$f->{create_new_folder});
    return $ses->amessage("You have can't have more than 10000 folders") if $db->SelectOne("SELECT COUNT(*) FROM Folders WHERE usr_id=?",$ses->getUserId)>=10000;
    my $code = $ses->randchar(10);
    while($db->SelectOne("SELECT fld_id FROM Folders WHERE fld_code=?",$code)){$code = $ses->randchar(10);}
    $db->Exec("INSERT INTO Folders SET usr_id=?, fld_parent_id=?, fld_name=?, fld_code=?",$ses->getUserId,$f->{fld_id}||0,$f->{create_new_folder},$code);
    my $fld_id = $db->getLastInsertId;
    $db->PurgeCache( "ufld-$f->{fld_id}-".$ses->getUserId );
    return $ses->amessage("<option value='$fld_id'>$f->{create_new_folder}</option>");
}

sub UploadSRT
{
    $ses->{form}->{no_hdr}=1;
    $ses->message("Mod not enabled") unless $c->{m_g};
    $ses->message("Invalid code") unless $f->{file_code}=~/^\w{12}$/;
    if($f->{srt} || $f->{url})
    {
      saveSRT();
      print"Content-type:text/html\n\n";
      print"<script>window.parent.location.reload(false);</script>";
      exit;
    }

    my @langs = map{{value=>$_}} split /\s*\,\s*/, $c->{srt_langs};

    $ses->setCookie("srt_cook",$ses->randchar(6),"+90d") unless $ses->getCookie("srt_cook");

    $ses->PrintTemplate("upload_srt.html",
                        file_code => $f->{file_code},
                        srt_langs => \@langs,
                        );
}

sub saveSRT
{
	$ses->message("Language required") unless $f->{srt_lang}=~/^\w+$/i;
	my $file = $db->SelectRow("SELECT * FROM Files WHERE file_code=?",$f->{file_code});
	$ses->message("No file") unless $file;
	$ses->message("Not your file") if $f->{op} ne 'upload_srt' && $ses->getUserId!=$file->{usr_id};

	my $srt_cook='';
	if($f->{op} eq 'upload_srt')
	{
		$srt_cook = $ses->getCookie("srt_cook");
		$ses->message("No SRT cook") unless $srt_cook=~/^\w{6}$/;
		$srt_cook="_$srt_cook";
		$srt_cook='' if $file->{usr_id}==$ses->getUserId;
	}

	my $dx = sprintf("%05d",$file->{file_id}/$c->{files_per_folder});
	my $dir = "$c->{site_path}/srt/$dx";
	mkdir($dir,0777) unless -d $dir;

	my $ext;
	if($f->{srt})
	{
		($ext) = $f->{srt}=~/\.(srt|vtt)$/i;
		$ses->message("Not SRT/VTT file") unless $ext;
	}
	else
	{
		($ext) = $f->{url}=~/\.(srt|vtt)$/i;
		$ext||='srt';
	}
	$ext = lc $ext;

	my $srtfile = "$dir/$file->{file_code}_$f->{srt_lang}$srt_cook.$ext";
	if($f->{srt})
	{
		$ses->{cgi_query}->upload( 'srt', $srtfile ) || $ses->message("Error saving SRT: ".$ses->{cgi_query}->cgi_error());
	}
	else
	{
		require LWP::UserAgent;
		my $lwp = LWP::UserAgent->new;
		$lwp->get($f->{url}, ':content_file' => $srtfile );
	}

	#$ses->{cgi_query}->upload_info( $f->{srt}, 'size' )
	if( $c->{srt_max_size_kb} && -s $srtfile > $c->{srt_max_size_kb}*1024 )
	{
	    unlink($srtfile);
	    $ses->message("Max subtitle size is $c->{srt_max_size_kb}KB");
	}

	open(SRT,$srtfile);
	my $data = join '', <SRT>;
	close SRT;
	if( $data=~/\<\?php/i )
	{
	    unlink($srtfile);
	    $ses->message("Invalid file format");
	}

	if($ext eq 'srt' && $c->{srt_convert_to_vtt})
	{
		#utf8::decode($data);
		#Encode::from_to($str,'cp866','utf8');
		$data=~s/\r//gs;
		$data=~s/^\D+\d\n//;
		$data=~s/(\d\d:\d\d:\d\d),(\d\d\d)/$1\.$2/gi;
		$data="WEBVTT\n\n$data";
		$data=~s/\n\d+\n/\n/gs;
		#utf8::encode($data);
		#die $data;
		open (VTT,  ">$dir/$file->{file_code}_$f->{srt_lang}$srt_cook.vtt") || die"can't open vtt file:$!";
		#binmode(VTT, ":utf8");
		print VTT $data;
		close VTT;
		unlink($srtfile);
		#die"$dir/$file->{file_code}_$f->{srt_lang}$srt_cook.vtt";
	}
}

sub MyFilesDMCA
{
    my $files = $db->SelectARef("SELECT *, UNIX_TIMESTAMP()-UNIX_TIMESTAMP(created) as ago, UNIX_TIMESTAMP(del_time)-UNIX_TIMESTAMP() as 'left'
                                 FROM FilesDMCA d, Files f 
                                 WHERE d.usr_id=?
                                 AND d.file_id=f.file_id
                                 ORDER BY del_time",$ses->getUserId);
    for(@$files)
    {
        $_->{ago} = sprintf("%.0f",$_->{ago}/60);
        $_->{ago} = $_->{ago}<180 ? "$_->{ago} mins" : sprintf("%.0f hours",$_->{ago}/60);

        $_->{left} = sprintf("%.0f",$_->{left}/60);
        $_->{left} = $_->{left}<180 ? "$_->{left} mins" : sprintf("%.0f hours",$_->{left}/60);

        $_->{dl_link} = $ses->makeFileLink($_);
    }
    $ses->PrintTemplate("my_files_dmca.html",
                        files => $files,
                       );
}

sub resizeGD
{
 my ($im,$w2,$h2,$file) = @_;
 my ($w,$h) = $im->getBounds();
 if($w>$h){ $h2 = int $w2/$w*$h; } else { $w2 = int $h2/$h*$w; }
 my $im2 = new GD::Image($w2, $h2);
 #$im2->transparent( $im->transparent() ); 
 $im2->copyResampled($im, 0,0, 0,0, $w2,$h2, $w,$h );
 open OUT, ">$file" or die"cant open file for write: $!";
 print OUT $im2->jpeg(95);
 close OUT;
}

sub StreamForm
{
	my $stream={};
	if($f->{stream_id}=~/^\d+$/)
	{
		$stream = $db->SelectRow("SELECT * 
									FROM Streams s
									LEFT JOIN Hosts h ON s.host_id=h.host_id
									WHERE s.stream_id=?
									",$f->{stream_id});
		unless( streamFindHost($stream->{host_id}||0) )
		{
			$stream->{host_id} = streamFindHost();
			$ses->message("No streaming servers are available at the moment") unless $stream->{host_id};
			$db->Exec("UPDATE Streams SET host_id=? WHERE stream_id=?",$stream->{host_id},$stream->{stream_id});
			return $ses->redirect("?op=stream_form&stream_id=$stream->{stream_id}");
		}
		$stream->{rtmp_url} = $stream->{host_cgi_url};
		$stream->{rtmp_url}=~s/^https?/rtmp/i;
		$stream->{rtmp_url}=~s/\/cgi-bin//i;
		$stream->{rtmp_url}=~s/:\d+$//i;
	}
	$stream->{host_id} ||= streamFindHost();
	$stream->{m_q_allow_recording} = $c->{m_q_allow_recording};
	$ses->message("No streaming servers are available at the moment") unless $stream->{host_id};
	$ses->PrintTemplate("stream_form.html",
                        %$stream,
                       );
}

sub streamFindHost
{
	my ($host_id) = @_;
	my $filter_host="AND h.host_id=$host_id" if defined $host_id;
	return $db->SelectOne("SELECT h.host_id 
							FROM Hosts h, Servers s 
							WHERE h.host_live=1 
							AND h.host_id=s.host_id
							AND s.srv_status IN ('ON','READONLY')
							AND srv_disk <= srv_disk_max*0.95 
							$filter_host
							GROUP BY host_id
							ORDER BY host_out/host_net_speed 
							LIMIT 1");
}

sub StreamSave
{
	$f->{stream_id}=~s/\D+//g;
	$f->{stream_title}  = $ses->SecureStr($f->{stream_title});
	$f->{stream_descr} = $ses->SecureStr($f->{stream_descr});
	$f->{stream_record}=0 unless $c->{m_q_allow_recording};
	if($f->{stream_id})
	{
		$db->Exec("UPDATE Streams 
					SET stream_title=?, 
						stream_descr=?,
						stream_record=?
					WHERE stream_id=? 
						AND usr_id=?", $f->{stream_title}, $f->{stream_descr}, $f->{stream_record}||'', $f->{stream_id}, $ses->getUserId);
	}
	else
	{
		$ses->message("You have too many streams") if $db->SelectOne("SELECT COUNT(*) FROM Streams WHERE usr_id=?",$ses->getUserId) >= 10;
		my $code = $ses->randchar(10);
        while($db->SelectOne("SELECT stream_id FROM Streams WHERE stream_code=?",$code)){$code = $ses->randchar(10);}
        my $key = $ses->randchar(6);
		$db->Exec("INSERT INTO Streams 
					SET stream_title=?, 
						stream_descr=?,
						stream_record=?,
						stream_code=?,
						stream_key=?,
						usr_id=?,
						host_id=?,
						created=NOW()",
						$f->{stream_title},
						$f->{stream_descr},
						$f->{stream_record}||'',
						$code,
						$key,
						$ses->getUserId,
						$f->{host_id},
						);
		$f->{stream_id} = $db->getLastInsertId;
	}
	$ses->redirect_msg("?op=stream_form&stream_id=$f->{stream_id}","Changes saved");
}

sub MyStreams
{
    return $ses->message("You're not allowed to create streams") unless checkModSpecialRights('m_q');
    if($f->{del}=~/^\d+$/ && $f->{token} && $ses->checkToken)
    {
        my $stream = $db->SelectRow("SELECT * FROM Streams WHERE stream_id=? AND usr_id=?", $f->{del}, $ses->getUserId );
        $ses->message("Stream not found") unless $stream;
        $db->Exec("DELETE FROM Streams WHERE stream_id=?",$stream->{stream_id});
        $db->Exec("DELETE FROM Stream2IP WHERE stream_id=?",$stream->{stream_id});
        $ses->redirect_msg("?op=my_streams","Stream deleted.");
    }
    my $list = $db->SelectARef("SELECT s.*,
    							(SELECT COUNT(*) FROM Stream2IP i WHERE i.stream_id=s.stream_id AND i.created>NOW()-INTERVAL 60 SECOND) as watchers
								FROM Streams s
								WHERE s.usr_id=?", $ses->getUserId );

    $ses->PrintTemplate("my_streams.html",
                        list  => $list,
                        token => $ses->genToken,
                      );
}